package com.cecilia.common.util;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.NoSuchBeanDefinitionException;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class SpringUtils {

    private static SpringUtils s_instance;
    private ApplicationContext applicationContext;

    public SpringUtils() {
        s_instance = this;
    }

    public static ApplicationContext getApplicationContext() {
        return s_instance.applicationContext;
    }

    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        this.applicationContext = applicationContext;
    }

    public static <T> T getComponent(Class<T> clz) {
        try {
            return s_instance.applicationContext.getBean(clz);
        } catch (NoSuchBeanDefinitionException var2) {
            log.warn(var2.getMessage());
        } catch (Exception var3) {
            log.warn("Unexpected exception", var3);
        }

        return null;
    }
}
