package com.cecilia.common.util.response;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

@JsonInclude(JsonInclude.Include.NON_NULL)
@Data
public class RestResponse {
    @JsonProperty("response")
    private Object responseObject;
    private String errorScope;
    private Integer code;
    private String errorDescription;
    private String errorDetails;

    public RestResponse() {
        this.code = 200;
    }

    public RestResponse(String errorScope, int errorCode, String errorDescription) {
        this.errorScope = errorScope;
        this.code = errorCode;
        this.errorDescription = errorDescription;
    }

    public RestResponse(Object responseObject) {
        this.responseObject = responseObject;
        this.code = 200;
    }
}
