package com.cecilia.engine.kafkademo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;

@Service
public class KafkaDemoService {

    @Autowired
    private KafkaTemplate<String, String> kafkaTemplate;

    public void sendMessage(String topic, String message) {
        kafkaTemplate.send(topic, message).addCallback(
                success -> System.out.println("Message sent successfully!"),
                failure -> System.err.println("Failed to send message: " + failure.getMessage())
        );
    }

    @KafkaListener(topics = "my-topic", groupId = "cecilia-group")
    public void consume(String message) {
        System.out.println("Received message: " + message);
    }
}

