/*
 * This file is generated by jOOQ.
 */
package com.cecilia.pojo.entity.tables;


import com.cecilia.pojo.entity.Darkness;
import com.cecilia.pojo.entity.Indexes;
import com.cecilia.pojo.entity.Keys;
import com.cecilia.pojo.entity.tables.records.BaseDataHolidayRecord;

import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row15;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * 节假日数据表
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class BaseDataHoliday extends TableImpl<BaseDataHolidayRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>darkness.base_data_holiday</code>
     */
    public static final BaseDataHoliday BASE_DATA_HOLIDAY = new BaseDataHoliday();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<BaseDataHolidayRecord> getRecordType() {
        return BaseDataHolidayRecord.class;
    }

    /**
     * The column <code>darkness.base_data_holiday.id</code>. 唯一id
     */
    public final TableField<BaseDataHolidayRecord, Integer> ID = createField(DSL.name("id"), SQLDataType.INTEGER.nullable(false).identity(true), this, "唯一id");

    /**
     * The column <code>darkness.base_data_holiday.date</code>. 日期
     */
    public final TableField<BaseDataHolidayRecord, LocalDate> DATE = createField(DSL.name("date"), SQLDataType.LOCALDATE, this, "日期");

    /**
     * The column <code>darkness.base_data_holiday.week</code>. 周几
     */
    public final TableField<BaseDataHolidayRecord, String> WEEK = createField(DSL.name("week"), SQLDataType.VARCHAR(255), this, "周几");

    /**
     * The column <code>darkness.base_data_holiday.nonglinian</code>. 农历年份
     */
    public final TableField<BaseDataHolidayRecord, Integer> NONGLINIAN = createField(DSL.name("nonglinian"), SQLDataType.INTEGER, this, "农历年份");

    /**
     * The column <code>darkness.base_data_holiday.nongliyue</code>. 农历月
     */
    public final TableField<BaseDataHolidayRecord, String> NONGLIYUE = createField(DSL.name("nongliyue"), SQLDataType.VARCHAR(255), this, "农历月");

    /**
     * The column <code>darkness.base_data_holiday.nongliri</code>. 农历日
     */
    public final TableField<BaseDataHolidayRecord, String> NONGLIRI = createField(DSL.name("nongliri"), SQLDataType.VARCHAR(255), this, "农历日");

    /**
     * The column <code>darkness.base_data_holiday.nianganzhi</code>.
     */
    public final TableField<BaseDataHolidayRecord, String> NIANGANZHI = createField(DSL.name("nianganzhi"), SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>darkness.base_data_holiday.shuxiang</code>. 生肖
     */
    public final TableField<BaseDataHolidayRecord, String> SHUXIANG = createField(DSL.name("shuxiang"), SQLDataType.VARCHAR(255), this, "生肖");

    /**
     * The column <code>darkness.base_data_holiday.str_descrip</code>. 描述
     */
    public final TableField<BaseDataHolidayRecord, String> STR_DESCRIP = createField(DSL.name("str_descrip"), SQLDataType.VARCHAR(255), this, "描述");

    /**
     * The column <code>darkness.base_data_holiday.towork</code>. 调休（0 正常上班  1放假  2周末调休）
     */
    public final TableField<BaseDataHolidayRecord, Integer> TOWORK = createField(DSL.name("towork"), SQLDataType.INTEGER.defaultValue(DSL.inline("0", SQLDataType.INTEGER)), this, "调休（0 正常上班  1放假  2周末调休）");

    /**
     * The column <code>darkness.base_data_holiday.gonglijieri</code>. 公历节日
     */
    public final TableField<BaseDataHolidayRecord, String> GONGLIJIERI = createField(DSL.name("gonglijieri"), SQLDataType.VARCHAR(255), this, "公历节日");

    /**
     * The column <code>darkness.base_data_holiday.nonglijieri</code>. 农历节日
     */
    public final TableField<BaseDataHolidayRecord, String> NONGLIJIERI = createField(DSL.name("nonglijieri"), SQLDataType.VARCHAR(255), this, "农历节日");

    /**
     * The column <code>darkness.base_data_holiday.jieqi</code>. 节气
     */
    public final TableField<BaseDataHolidayRecord, String> JIEQI = createField(DSL.name("jieqi"), SQLDataType.VARCHAR(255), this, "节气");

    /**
     * The column <code>darkness.base_data_holiday.teshujieri</code>. 特殊节日
     */
    public final TableField<BaseDataHolidayRecord, String> TESHUJIERI = createField(DSL.name("teshujieri"), SQLDataType.VARCHAR(10), this, "特殊节日");

    /**
     * The column <code>darkness.base_data_holiday.runyue</code>. 润月
     */
    public final TableField<BaseDataHolidayRecord, Integer> RUNYUE = createField(DSL.name("runyue"), SQLDataType.INTEGER, this, "润月");

    private BaseDataHoliday(Name alias, Table<BaseDataHolidayRecord> aliased) {
        this(alias, aliased, null);
    }

    private BaseDataHoliday(Name alias, Table<BaseDataHolidayRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment("节假日数据表"), TableOptions.table());
    }

    /**
     * Create an aliased <code>darkness.base_data_holiday</code> table reference
     */
    public BaseDataHoliday(String alias) {
        this(DSL.name(alias), BASE_DATA_HOLIDAY);
    }

    /**
     * Create an aliased <code>darkness.base_data_holiday</code> table reference
     */
    public BaseDataHoliday(Name alias) {
        this(alias, BASE_DATA_HOLIDAY);
    }

    /**
     * Create a <code>darkness.base_data_holiday</code> table reference
     */
    public BaseDataHoliday() {
        this(DSL.name("base_data_holiday"), null);
    }

    public <O extends Record> BaseDataHoliday(Table<O> child, ForeignKey<O, BaseDataHolidayRecord> key) {
        super(child, key, BASE_DATA_HOLIDAY);
    }

    @Override
    public Schema getSchema() {
        return Darkness.DARKNESS;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.BASE_DATA_HOLIDAY_IDX_DATE);
    }

    @Override
    public Identity<BaseDataHolidayRecord, Integer> getIdentity() {
        return (Identity<BaseDataHolidayRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<BaseDataHolidayRecord> getPrimaryKey() {
        return Keys.KEY_BASE_DATA_HOLIDAY_PRIMARY;
    }

    @Override
    public List<UniqueKey<BaseDataHolidayRecord>> getKeys() {
        return Arrays.<UniqueKey<BaseDataHolidayRecord>>asList(Keys.KEY_BASE_DATA_HOLIDAY_PRIMARY);
    }

    @Override
    public BaseDataHoliday as(String alias) {
        return new BaseDataHoliday(DSL.name(alias), this);
    }

    @Override
    public BaseDataHoliday as(Name alias) {
        return new BaseDataHoliday(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public BaseDataHoliday rename(String name) {
        return new BaseDataHoliday(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public BaseDataHoliday rename(Name name) {
        return new BaseDataHoliday(name, null);
    }

    // -------------------------------------------------------------------------
    // Row15 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row15<Integer, LocalDate, String, Integer, String, String, String, String, String, Integer, String, String, String, String, Integer> fieldsRow() {
        return (Row15) super.fieldsRow();
    }
}
