/*
 * This file is generated by jOOQ.
 */
package com.cecilia.pojo.entity.tables;


import com.cecilia.pojo.entity.Darkness;
import com.cecilia.pojo.entity.Keys;
import com.cecilia.pojo.entity.tables.records.BaseDicTypeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row11;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * 字典类型表
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class BaseDicType extends TableImpl<BaseDicTypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>darkness.base_dic_type</code>
     */
    public static final BaseDicType BASE_DIC_TYPE = new BaseDicType();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<BaseDicTypeRecord> getRecordType() {
        return BaseDicTypeRecord.class;
    }

    /**
     * The column <code>darkness.base_dic_type.id</code>. 主键
     */
    public final TableField<BaseDicTypeRecord, Long> ID = createField(DSL.name("id"), SQLDataType.BIGINT.nullable(false).identity(true), this, "主键");

    /**
     * The column <code>darkness.base_dic_type.type_code</code>. 类型编码
     */
    public final TableField<BaseDicTypeRecord, String> TYPE_CODE = createField(DSL.name("type_code"), SQLDataType.VARCHAR(50), this, "类型编码");

    /**
     * The column <code>darkness.base_dic_type.type_name</code>. 名称
     */
    public final TableField<BaseDicTypeRecord, String> TYPE_NAME = createField(DSL.name("type_name"), SQLDataType.VARCHAR(20), this, "名称");

    /**
     * The column <code>darkness.base_dic_type.order</code>. 排序
     */
    public final TableField<BaseDicTypeRecord, Integer> ORDER = createField(DSL.name("order"), SQLDataType.INTEGER, this, "排序");

    /**
     * The column <code>darkness.base_dic_type.creator_uid</code>. 创建者用户id
     */
    public final TableField<BaseDicTypeRecord, Long> CREATOR_UID = createField(DSL.name("creator_uid"), SQLDataType.BIGINT, this, "创建者用户id");

    /**
     * The column <code>darkness.base_dic_type.create_time</code>. 记录创建时间
     */
    public final TableField<BaseDicTypeRecord, LocalDateTime> CREATE_TIME = createField(DSL.name("create_time"), SQLDataType.LOCALDATETIME(0), this, "记录创建时间");

    /**
     * The column <code>darkness.base_dic_type.operator_uid</code>. 更新人用户id
     */
    public final TableField<BaseDicTypeRecord, Long> OPERATOR_UID = createField(DSL.name("operator_uid"), SQLDataType.BIGINT, this, "更新人用户id");

    /**
     * The column <code>darkness.base_dic_type.update_time</code>. 记录更新时间
     */
    public final TableField<BaseDicTypeRecord, LocalDateTime> UPDATE_TIME = createField(DSL.name("update_time"), SQLDataType.LOCALDATETIME(0), this, "记录更新时间");

    /**
     * The column <code>darkness.base_dic_type.delete_flag</code>. 是否删除标识位(0未删除，1已删除)
     */
    public final TableField<BaseDicTypeRecord, Byte> DELETE_FLAG = createField(DSL.name("delete_flag"), SQLDataType.TINYINT, this, "是否删除标识位(0未删除，1已删除)");

    /**
     * The column <code>darkness.base_dic_type.app_id</code>. 多应用的应用id
     */
    public final TableField<BaseDicTypeRecord, String> APP_ID = createField(DSL.name("app_id"), SQLDataType.VARCHAR(255), this, "多应用的应用id");

    /**
     * The column <code>darkness.base_dic_type.namespace_id</code>. 域空间id
     */
    public final TableField<BaseDicTypeRecord, Integer> NAMESPACE_ID = createField(DSL.name("namespace_id"), SQLDataType.INTEGER, this, "域空间id");

    private BaseDicType(Name alias, Table<BaseDicTypeRecord> aliased) {
        this(alias, aliased, null);
    }

    private BaseDicType(Name alias, Table<BaseDicTypeRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment("字典类型表"), TableOptions.table());
    }

    /**
     * Create an aliased <code>darkness.base_dic_type</code> table reference
     */
    public BaseDicType(String alias) {
        this(DSL.name(alias), BASE_DIC_TYPE);
    }

    /**
     * Create an aliased <code>darkness.base_dic_type</code> table reference
     */
    public BaseDicType(Name alias) {
        this(alias, BASE_DIC_TYPE);
    }

    /**
     * Create a <code>darkness.base_dic_type</code> table reference
     */
    public BaseDicType() {
        this(DSL.name("base_dic_type"), null);
    }

    public <O extends Record> BaseDicType(Table<O> child, ForeignKey<O, BaseDicTypeRecord> key) {
        super(child, key, BASE_DIC_TYPE);
    }

    @Override
    public Schema getSchema() {
        return Darkness.DARKNESS;
    }

    @Override
    public Identity<BaseDicTypeRecord, Long> getIdentity() {
        return (Identity<BaseDicTypeRecord, Long>) super.getIdentity();
    }

    @Override
    public UniqueKey<BaseDicTypeRecord> getPrimaryKey() {
        return Keys.KEY_BASE_DIC_TYPE_PRIMARY;
    }

    @Override
    public List<UniqueKey<BaseDicTypeRecord>> getKeys() {
        return Arrays.<UniqueKey<BaseDicTypeRecord>>asList(Keys.KEY_BASE_DIC_TYPE_PRIMARY);
    }

    @Override
    public BaseDicType as(String alias) {
        return new BaseDicType(DSL.name(alias), this);
    }

    @Override
    public BaseDicType as(Name alias) {
        return new BaseDicType(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public BaseDicType rename(String name) {
        return new BaseDicType(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public BaseDicType rename(Name name) {
        return new BaseDicType(name, null);
    }

    // -------------------------------------------------------------------------
    // Row11 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row11<Long, String, String, Integer, Long, LocalDateTime, Long, LocalDateTime, Byte, String, Integer> fieldsRow() {
        return (Row11) super.fieldsRow();
    }
}
