/*
 Navicat Premium Data Transfer

 Source Server         : localhost-php-study
 Source Server Type    : MySQL
 Source Server Version : 50726 (5.7.26)
 Source Host           : localhost:3306
 Source Schema         : cecilia

 Target Server Type    : MySQL
 Target Server Version : 50726 (5.7.26)
 File Encoding         : 65001

 Date: 08/01/2025 16:44:32
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for base_data_holiday
-- ----------------------------
DROP TABLE IF EXISTS `base_data_holiday`;
CREATE TABLE `base_data_holiday`  (
                                      `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '唯一id',
                                      `date` date NULL DEFAULT NULL COMMENT '日期',
                                      `week` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '周几',
                                      `nonglinian` int(11) NULL DEFAULT NULL COMMENT '农历年份',
                                      `nongliyue` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '农历月',
                                      `nongliri` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '农历日',
                                      `nianganzhi` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
                                      `shuxiang` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '生肖',
                                      `str_descrip` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '描述',
                                      `towork` int(11) NULL DEFAULT 0 COMMENT '调休（0 正常上班  1放假  2周末调休）',
                                      `gonglijieri` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '公历节日',
                                      `nonglijieri` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '农历节日',
                                      `jieqi` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '节气',
                                      `teshujieri` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '特殊节日',
                                      `runyue` int(11) NULL DEFAULT NULL COMMENT '润月',
                                      PRIMARY KEY (`id`) USING BTREE,
                                      INDEX `IDX_DATE`(`date`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 10394 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '节假日数据表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of base_data_holiday
-- ----------------------------
INSERT INTO `base_data_holiday` VALUES (1, '2020-01-01', '星期三', 2019, '腊月', '初七', '己亥', '猪', '元旦', 1, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2, '2020-01-02', '星期四', 2019, '腊月', '初八', '己亥', '猪', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3, '2020-01-03', '星期五', 2019, '腊月', '初九', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4, '2020-01-04', '星期六', 2019, '腊月', '初十 ', '己亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5, '2020-01-05', '星期日', 2019, '腊月', '十一', '己亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6, '2020-01-06', '星期一', 2019, '腊月', '十二', '己亥', '猪', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (7, '2020-01-07', '星期二', 2019, '腊月', '十三', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8, '2020-01-08', '星期三', 2019, '腊月', '十四', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9, '2020-01-09', '星期四', 2019, '腊月', '十五', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10, '2020-01-10', '星期五', 2019, '腊月', '十六', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (11, '2020-01-11', '星期六', 2019, '腊月', '十七', '己亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (12, '2020-01-12', '星期日', 2019, '腊月', '十八', '己亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (13, '2020-01-13', '星期一', 2019, '腊月', '十九', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (14, '2020-01-14', '星期二', 2019, '腊月', '二十', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (15, '2020-01-15', '星期三', 2019, '腊月', '廿一', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (16, '2020-01-16', '星期四', 2019, '腊月', '廿二', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (17, '2020-01-17', '星期五', 2019, '腊月', '廿三', '己亥', '猪', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (18, '2020-01-18', '星期六', 2019, '腊月', '廿四', '己亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (19, '2020-01-19', '星期日', 2019, '腊月', '廿五', '己亥', '猪', '春节前调休', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (20, '2020-01-20', '星期一', 2019, '腊月', '廿六', '己亥', '猪', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (21, '2020-01-21', '星期二', 2019, '腊月', '廿七', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (22, '2020-01-22', '星期三', 2019, '腊月', '廿八', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (23, '2020-01-23', '星期四', 2019, '腊月', '廿九', '己亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (24, '2020-01-24', '星期五', 2019, '腊月', '三十', '己亥', '猪', '除夕', 1, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (25, '2020-01-25', '星期六', 2020, '正月', '初一', '庚子', '鼠', '初一', 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (26, '2020-01-26', '星期日', 2020, '正月', '初二', '庚子', '鼠', '初二', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (27, '2020-01-27', '星期一', 2020, '正月', '初三', '庚子', '鼠', '初三', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (28, '2020-01-28', '星期二', 2020, '正月', '初四', '庚子', '鼠', '初四', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (29, '2020-01-29', '星期三', 2020, '正月', '初五', '庚子', '鼠', '初五', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (30, '2020-01-30', '星期四', 2020, '正月', '初六', '庚子', '鼠', '初六', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (31, '2020-01-31', '星期五', 2020, '正月', '初七', '庚子', '鼠', '初七', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (32, '2020-02-01', '星期六', 2020, '正月', '初八', '庚子', '鼠', '初八', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (33, '2020-02-02', '星期日', 2020, '正月', '初九', '庚子', '鼠', '初九', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (34, '2020-02-03', '星期一', 2020, '正月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (35, '2020-02-04', '星期二', 2020, '正月', '十一', '庚子', '鼠', NULL, 0, '', '', '立春', '', 4);
INSERT INTO `base_data_holiday` VALUES (36, '2020-02-05', '星期三', 2020, '正月', '十二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (37, '2020-02-06', '星期四', 2020, '正月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (38, '2020-02-07', '星期五', 2020, '正月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (39, '2020-02-08', '星期六', 2020, '正月', '十五', '庚子', '鼠', NULL, 1, '', '元宵节', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (40, '2020-02-09', '星期日', 2020, '正月', '十六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (41, '2020-02-10', '星期一', 2020, '正月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (42, '2020-02-11', '星期二', 2020, '正月', '十八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (43, '2020-02-12', '星期三', 2020, '正月', '十九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (44, '2020-02-13', '星期四', 2020, '正月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (45, '2020-02-14', '星期五', 2020, '正月', '廿一', '庚子', '鼠', NULL, 0, '情人节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (46, '2020-02-15', '星期六', 2020, '正月', '廿二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (47, '2020-02-16', '星期日', 2020, '正月', '廿三', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (48, '2020-02-17', '星期一', 2020, '正月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (49, '2020-02-18', '星期二', 2020, '正月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (50, '2020-02-19', '星期三', 2020, '正月', '廿六', '庚子', '鼠', NULL, 0, '', '', '雨水', '', 4);
INSERT INTO `base_data_holiday` VALUES (51, '2020-02-20', '星期四', 2020, '正月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (52, '2020-02-21', '星期五', 2020, '正月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (53, '2020-02-22', '星期六', 2020, '正月', '廿九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (54, '2020-02-23', '星期日', 2020, '二月', '初一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (55, '2020-02-24', '星期一', 2020, '二月', '初二', '庚子', '鼠', NULL, 0, '', '龙抬头', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (56, '2020-02-25', '星期二', 2020, '二月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (57, '2020-02-26', '星期三', 2020, '二月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (58, '2020-02-27', '星期四', 2020, '二月', '初五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (59, '2020-02-28', '星期五', 2020, '二月', '初六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (60, '2020-02-29', '星期六', 2020, '二月', '初七', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (61, '2020-03-01', '星期日', 2020, '二月', '初八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (62, '2020-03-02', '星期一', 2020, '二月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (63, '2020-03-03', '星期二', 2020, '二月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (64, '2020-03-04', '星期三', 2020, '二月', '十一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (65, '2020-03-05', '星期四', 2020, '二月', '十二', '庚子', '鼠', NULL, 0, '', '', '惊蛰', '', 4);
INSERT INTO `base_data_holiday` VALUES (66, '2020-03-06', '星期五', 2020, '二月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (67, '2020-03-07', '星期六', 2020, '二月', '十四', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (68, '2020-03-08', '星期日', 2020, '二月', '十五', '庚子', '鼠', NULL, 1, '妇女节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (69, '2020-03-09', '星期一', 2020, '二月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (70, '2020-03-10', '星期二', 2020, '二月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (71, '2020-03-11', '星期三', 2020, '二月', '十八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (72, '2020-03-12', '星期四', 2020, '二月', '十九', '庚子', '鼠', NULL, 0, '植树节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (73, '2020-03-13', '星期五', 2020, '二月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (74, '2020-03-14', '星期六', 2020, '二月', '廿一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (75, '2020-03-15', '星期日', 2020, '二月', '廿二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (76, '2020-03-16', '星期一', 2020, '二月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (77, '2020-03-17', '星期二', 2020, '二月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (78, '2020-03-18', '星期三', 2020, '二月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (79, '2020-03-19', '星期四', 2020, '二月', '廿六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (80, '2020-03-20', '星期五', 2020, '二月', '廿七', '庚子', '鼠', NULL, 0, '', '', '春分', '', 4);
INSERT INTO `base_data_holiday` VALUES (81, '2020-03-21', '星期六', 2020, '二月', '廿八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (82, '2020-03-22', '星期日', 2020, '二月', '廿九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (83, '2020-03-23', '星期一', 2020, '二月', '三十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (84, '2020-03-24', '星期二', 2020, '三月', '初一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (85, '2020-03-25', '星期三', 2020, '三月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (86, '2020-03-26', '星期四', 2020, '三月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (87, '2020-03-27', '星期五', 2020, '三月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (88, '2020-03-28', '星期六', 2020, '三月', '初五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (89, '2020-03-29', '星期日', 2020, '三月', '初六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (90, '2020-03-30', '星期一', 2020, '三月', '初七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (91, '2020-03-31', '星期二', 2020, '三月', '初八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (92, '2020-04-01', '星期三', 2020, '三月', '初九', '庚子', '鼠', NULL, 0, '愚人节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (93, '2020-04-02', '星期四', 2020, '三月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (94, '2020-04-03', '星期五', 2020, '三月', '十一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (95, '2020-04-04', '星期六', 2020, '三月', '十二', '庚子', '鼠', '清明节', 1, '', '', '清明', '', 4);
INSERT INTO `base_data_holiday` VALUES (96, '2020-04-05', '星期日', 2020, '三月', '十三', '庚子', '鼠', '清明节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (97, '2020-04-06', '星期一', 2020, '三月', '十四', '庚子', '鼠', '清明节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (98, '2020-04-07', '星期二', 2020, '三月', '十五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (99, '2020-04-08', '星期三', 2020, '三月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (100, '2020-04-09', '星期四', 2020, '三月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (101, '2020-04-10', '星期五', 2020, '三月', '十八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (102, '2020-04-11', '星期六', 2020, '三月', '十九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (103, '2020-04-12', '星期日', 2020, '三月', '二十', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (104, '2020-04-13', '星期一', 2020, '三月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (105, '2020-04-14', '星期二', 2020, '三月', '廿二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (106, '2020-04-15', '星期三', 2020, '三月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (107, '2020-04-16', '星期四', 2020, '三月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (108, '2020-04-17', '星期五', 2020, '三月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (109, '2020-04-18', '星期六', 2020, '三月', '廿六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (110, '2020-04-19', '星期日', 2020, '三月', '廿七', '庚子', '鼠', NULL, 1, '', '', '谷雨', '', 4);
INSERT INTO `base_data_holiday` VALUES (111, '2020-04-20', '星期一', 2020, '三月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (112, '2020-04-21', '星期二', 2020, '三月', '廿九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (113, '2020-04-22', '星期三', 2020, '三月', '三十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (114, '2020-04-23', '星期四', 2020, '四月', '初一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (115, '2020-04-24', '星期五', 2020, '四月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (116, '2020-04-25', '星期六', 2020, '四月', '初三', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (117, '2020-04-26', '星期日', 2020, '四月', '初四', '庚子', '鼠', '劳动节前调休', 2, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (118, '2020-04-27', '星期一', 2020, '四月', '初五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (119, '2020-04-28', '星期二', 2020, '四月', '初六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (120, '2020-04-29', '星期三', 2020, '四月', '初七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (121, '2020-04-30', '星期四', 2020, '四月', '初八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (122, '2020-05-01', '星期五', 2020, '四月', '初九', '庚子', '鼠', '劳动节', 1, '劳动节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (123, '2020-05-02', '星期六', 2020, '四月', '初十 ', '庚子', '鼠', '劳动节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (124, '2020-05-03', '星期日', 2020, '四月', '十一', '庚子', '鼠', '劳动节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (125, '2020-05-04', '星期一', 2020, '四月', '十二', '庚子', '鼠', '劳动节', 1, '青年节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (126, '2020-05-05', '星期二', 2020, '四月', '十三', '庚子', '鼠', '劳动节', 1, '', '', '立夏', '', 4);
INSERT INTO `base_data_holiday` VALUES (127, '2020-05-06', '星期三', 2020, '四月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (128, '2020-05-07', '星期四', 2020, '四月', '十五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (129, '2020-05-08', '星期五', 2020, '四月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (130, '2020-05-09', '星期六', 2020, '四月', '十七', '庚子', '鼠', '劳动节后调休', 2, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (131, '2020-05-10', '星期日', 2020, '四月', '十八', '庚子', '鼠', NULL, 1, '', '', '', '母亲节', 4);
INSERT INTO `base_data_holiday` VALUES (132, '2020-05-11', '星期一', 2020, '四月', '十九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (133, '2020-05-12', '星期二', 2020, '四月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (134, '2020-05-13', '星期三', 2020, '四月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (135, '2020-05-14', '星期四', 2020, '四月', '廿二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (136, '2020-05-15', '星期五', 2020, '四月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (137, '2020-05-16', '星期六', 2020, '四月', '廿四', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (138, '2020-05-17', '星期日', 2020, '四月', '廿五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (139, '2020-05-18', '星期一', 2020, '四月', '廿六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (140, '2020-05-19', '星期二', 2020, '四月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (141, '2020-05-20', '星期三', 2020, '四月', '廿八', '庚子', '鼠', NULL, 0, '', '', '小满', '', 4);
INSERT INTO `base_data_holiday` VALUES (142, '2020-05-21', '星期四', 2020, '四月', '廿九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (143, '2020-05-22', '星期五', 2020, '四月', '三十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (144, '2020-05-23', '星期六', 2020, '闰四月', '初一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (145, '2020-05-24', '星期日', 2020, '闰四月', '初二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (146, '2020-05-25', '星期一', 2020, '闰四月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (147, '2020-05-26', '星期二', 2020, '闰四月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (148, '2020-05-27', '星期三', 2020, '闰四月', '初五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (149, '2020-05-28', '星期四', 2020, '闰四月', '初六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (150, '2020-05-29', '星期五', 2020, '闰四月', '初七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (151, '2020-05-30', '星期六', 2020, '闰四月', '初八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (152, '2020-05-31', '星期日', 2020, '闰四月', '初九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (153, '2020-06-01', '星期一', 2020, '闰四月', '初十 ', '庚子', '鼠', NULL, 0, '儿童节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (154, '2020-06-02', '星期二', 2020, '闰四月', '十一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (155, '2020-06-03', '星期三', 2020, '闰四月', '十二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (156, '2020-06-04', '星期四', 2020, '闰四月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (157, '2020-06-05', '星期五', 2020, '闰四月', '十四', '庚子', '鼠', NULL, 0, '', '', '芒种', '', 4);
INSERT INTO `base_data_holiday` VALUES (158, '2020-06-06', '星期六', 2020, '闰四月', '十五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (159, '2020-06-07', '星期日', 2020, '闰四月', '十六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (160, '2020-06-08', '星期一', 2020, '闰四月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (161, '2020-06-09', '星期二', 2020, '闰四月', '十八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (162, '2020-06-10', '星期三', 2020, '闰四月', '十九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (163, '2020-06-11', '星期四', 2020, '闰四月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (164, '2020-06-12', '星期五', 2020, '闰四月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (165, '2020-06-13', '星期六', 2020, '闰四月', '廿二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (166, '2020-06-14', '星期日', 2020, '闰四月', '廿三', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (167, '2020-06-15', '星期一', 2020, '闰四月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (168, '2020-06-16', '星期二', 2020, '闰四月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (169, '2020-06-17', '星期三', 2020, '闰四月', '廿六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (170, '2020-06-18', '星期四', 2020, '闰四月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (171, '2020-06-19', '星期五', 2020, '闰四月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (172, '2020-06-20', '星期六', 2020, '闰四月', '廿九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (173, '2020-06-21', '星期日', 2020, '五月', '初一', '庚子', '鼠', NULL, 1, '', '', '夏至', '父亲节', 4);
INSERT INTO `base_data_holiday` VALUES (174, '2020-06-22', '星期一', 2020, '五月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (175, '2020-06-23', '星期二', 2020, '五月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (176, '2020-06-24', '星期三', 2020, '五月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (177, '2020-06-25', '星期四', 2020, '五月', '初五', '庚子', '鼠', '端午节', 1, '', '端午节', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (178, '2020-06-26', '星期五', 2020, '五月', '初六', '庚子', '鼠', '端午节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (179, '2020-06-27', '星期六', 2020, '五月', '初七', '庚子', '鼠', '端午节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (180, '2020-06-28', '星期日', 2020, '五月', '初八', '庚子', '鼠', '端午节后调休', 2, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (181, '2020-06-29', '星期一', 2020, '五月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (182, '2020-06-30', '星期二', 2020, '五月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (183, '2020-07-01', '星期三', 2020, '五月', '十一', '庚子', '鼠', NULL, 0, '建党节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (184, '2020-07-02', '星期四', 2020, '五月', '十二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (185, '2020-07-03', '星期五', 2020, '五月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (186, '2020-07-04', '星期六', 2020, '五月', '十四', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (187, '2020-07-05', '星期日', 2020, '五月', '十五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (188, '2020-07-06', '星期一', 2020, '五月', '十六', '庚子', '鼠', NULL, 0, '', '', '小暑', '', 4);
INSERT INTO `base_data_holiday` VALUES (189, '2020-07-07', '星期二', 2020, '五月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (190, '2020-07-08', '星期三', 2020, '五月', '十八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (191, '2020-07-09', '星期四', 2020, '五月', '十九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (192, '2020-07-10', '星期五', 2020, '五月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (193, '2020-07-11', '星期六', 2020, '五月', '廿一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (194, '2020-07-12', '星期日', 2020, '五月', '廿二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (195, '2020-07-13', '星期一', 2020, '五月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (196, '2020-07-14', '星期二', 2020, '五月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (197, '2020-07-15', '星期三', 2020, '五月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (198, '2020-07-16', '星期四', 2020, '五月', '廿六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (199, '2020-07-17', '星期五', 2020, '五月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (200, '2020-07-18', '星期六', 2020, '五月', '廿八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (201, '2020-07-19', '星期日', 2020, '五月', '廿九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (202, '2020-07-20', '星期一', 2020, '五月', '三十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (203, '2020-07-21', '星期二', 2020, '六月', '初一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (204, '2020-07-22', '星期三', 2020, '六月', '初二', '庚子', '鼠', NULL, 0, '', '', '大暑', '', 4);
INSERT INTO `base_data_holiday` VALUES (205, '2020-07-23', '星期四', 2020, '六月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (206, '2020-07-24', '星期五', 2020, '六月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (207, '2020-07-25', '星期六', 2020, '六月', '初五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (208, '2020-07-26', '星期日', 2020, '六月', '初六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (209, '2020-07-27', '星期一', 2020, '六月', '初七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (210, '2020-07-28', '星期二', 2020, '六月', '初八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (211, '2020-07-29', '星期三', 2020, '六月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (212, '2020-07-30', '星期四', 2020, '六月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (213, '2020-07-31', '星期五', 2020, '六月', '十一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (214, '2020-08-01', '星期六', 2020, '六月', '十二', '庚子', '鼠', NULL, 1, '建军节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (215, '2020-08-02', '星期日', 2020, '六月', '十三', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (216, '2020-08-03', '星期一', 2020, '六月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (217, '2020-08-04', '星期二', 2020, '六月', '十五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (218, '2020-08-05', '星期三', 2020, '六月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (219, '2020-08-06', '星期四', 2020, '六月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (220, '2020-08-07', '星期五', 2020, '六月', '十八', '庚子', '鼠', NULL, 0, '', '', '立秋', '', 4);
INSERT INTO `base_data_holiday` VALUES (221, '2020-08-08', '星期六', 2020, '六月', '十九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (222, '2020-08-09', '星期日', 2020, '六月', '二十', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (223, '2020-08-10', '星期一', 2020, '六月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (224, '2020-08-11', '星期二', 2020, '六月', '廿二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (225, '2020-08-12', '星期三', 2020, '六月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (226, '2020-08-13', '星期四', 2020, '六月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (227, '2020-08-14', '星期五', 2020, '六月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (228, '2020-08-15', '星期六', 2020, '六月', '廿六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (229, '2020-08-16', '星期日', 2020, '六月', '廿七', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (230, '2020-08-17', '星期一', 2020, '六月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (231, '2020-08-18', '星期二', 2020, '六月', '廿九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (232, '2020-08-19', '星期三', 2020, '七月', '初一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (233, '2020-08-20', '星期四', 2020, '七月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (234, '2020-08-21', '星期五', 2020, '七月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (235, '2020-08-22', '星期六', 2020, '七月', '初四', '庚子', '鼠', NULL, 1, '', '', '处暑', '', 4);
INSERT INTO `base_data_holiday` VALUES (236, '2020-08-23', '星期日', 2020, '七月', '初五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (237, '2020-08-24', '星期一', 2020, '七月', '初六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (238, '2020-08-25', '星期二', 2020, '七月', '初七', '庚子', '鼠', NULL, 0, '', '七夕', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (239, '2020-08-26', '星期三', 2020, '七月', '初八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (240, '2020-08-27', '星期四', 2020, '七月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (241, '2020-08-28', '星期五', 2020, '七月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (242, '2020-08-29', '星期六', 2020, '七月', '十一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (243, '2020-08-30', '星期日', 2020, '七月', '十二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (244, '2020-08-31', '星期一', 2020, '七月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (245, '2020-09-01', '星期二', 2020, '七月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (246, '2020-09-02', '星期三', 2020, '七月', '十五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (247, '2020-09-03', '星期四', 2020, '七月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (248, '2020-09-04', '星期五', 2020, '七月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (249, '2020-09-05', '星期六', 2020, '七月', '十八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (250, '2020-09-06', '星期日', 2020, '七月', '十九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (251, '2020-09-07', '星期一', 2020, '七月', '二十', '庚子', '鼠', NULL, 0, '', '', '白露', '', 4);
INSERT INTO `base_data_holiday` VALUES (252, '2020-09-08', '星期二', 2020, '七月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (253, '2020-09-09', '星期三', 2020, '七月', '廿二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (254, '2020-09-10', '星期四', 2020, '七月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (255, '2020-09-11', '星期五', 2020, '七月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (256, '2020-09-12', '星期六', 2020, '七月', '廿五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (257, '2020-09-13', '星期日', 2020, '七月', '廿六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (258, '2020-09-14', '星期一', 2020, '七月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (259, '2020-09-15', '星期二', 2020, '七月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (260, '2020-09-16', '星期三', 2020, '七月', '廿九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (261, '2020-09-17', '星期四', 2020, '八月', '初一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (262, '2020-09-18', '星期五', 2020, '八月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (263, '2020-09-19', '星期六', 2020, '八月', '初三', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (264, '2020-09-20', '星期日', 2020, '八月', '初四', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (265, '2020-09-21', '星期一', 2020, '八月', '初五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (266, '2020-09-22', '星期二', 2020, '八月', '初六', '庚子', '鼠', NULL, 0, '农民丰收节', '', '秋分', '', 4);
INSERT INTO `base_data_holiday` VALUES (267, '2020-09-23', '星期三', 2020, '八月', '初七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (268, '2020-09-24', '星期四', 2020, '八月', '初八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (269, '2020-09-25', '星期五', 2020, '八月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (270, '2020-09-26', '星期六', 2020, '八月', '初十 ', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (271, '2020-09-27', '星期日', 2020, '八月', '十一', '庚子', '鼠', '国庆节前调休', 2, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (272, '2020-09-28', '星期一', 2020, '八月', '十二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (273, '2020-09-29', '星期二', 2020, '八月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (274, '2020-09-30', '星期三', 2020, '八月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (275, '2020-10-01', '星期四', 2020, '八月', '十五', '庚子', '鼠', '中秋节', 1, '国庆节', '中秋节', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (276, '2020-10-02', '星期五', 2020, '八月', '十六', '庚子', '鼠', '国庆节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (277, '2020-10-03', '星期六', 2020, '八月', '十七', '庚子', '鼠', '国庆节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (278, '2020-10-04', '星期日', 2020, '八月', '十八', '庚子', '鼠', '国庆节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (279, '2020-10-05', '星期一', 2020, '八月', '十九', '庚子', '鼠', '国庆节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (280, '2020-10-06', '星期二', 2020, '八月', '二十', '庚子', '鼠', '国庆节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (281, '2020-10-07', '星期三', 2020, '八月', '廿一', '庚子', '鼠', '国庆节', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (282, '2020-10-08', '星期四', 2020, '八月', '廿二', '庚子', '鼠', '国庆节', 1, '', '', '寒露', '', 4);
INSERT INTO `base_data_holiday` VALUES (283, '2020-10-09', '星期五', 2020, '八月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (284, '2020-10-10', '星期六', 2020, '八月', '廿四', '庚子', '鼠', '国庆节后调休', 2, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (285, '2020-10-11', '星期日', 2020, '八月', '廿五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (286, '2020-10-12', '星期一', 2020, '八月', '廿六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (287, '2020-10-13', '星期二', 2020, '八月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (288, '2020-10-14', '星期三', 2020, '八月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (289, '2020-10-15', '星期四', 2020, '八月', '廿九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (290, '2020-10-16', '星期五', 2020, '八月', '三十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (291, '2020-10-17', '星期六', 2020, '九月', '初一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (292, '2020-10-18', '星期日', 2020, '九月', '初二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (293, '2020-10-19', '星期一', 2020, '九月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (294, '2020-10-20', '星期二', 2020, '九月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (295, '2020-10-21', '星期三', 2020, '九月', '初五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (296, '2020-10-22', '星期四', 2020, '九月', '初六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (297, '2020-10-23', '星期五', 2020, '九月', '初七', '庚子', '鼠', NULL, 0, '', '', '霜降', '', 4);
INSERT INTO `base_data_holiday` VALUES (298, '2020-10-24', '星期六', 2020, '九月', '初八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (299, '2020-10-25', '星期日', 2020, '九月', '初九', '庚子', '鼠', NULL, 1, '', '重阳节', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (300, '2020-10-26', '星期一', 2020, '九月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (301, '2020-10-27', '星期二', 2020, '九月', '十一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (302, '2020-10-28', '星期三', 2020, '九月', '十二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (303, '2020-10-29', '星期四', 2020, '九月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (304, '2020-10-30', '星期五', 2020, '九月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (305, '2020-10-31', '星期六', 2020, '九月', '十五', '庚子', '鼠', NULL, 1, '万圣节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (306, '2020-11-01', '星期日', 2020, '九月', '十六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (307, '2020-11-02', '星期一', 2020, '九月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (308, '2020-11-03', '星期二', 2020, '九月', '十八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (309, '2020-11-04', '星期三', 2020, '九月', '十九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (310, '2020-11-05', '星期四', 2020, '九月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (311, '2020-11-06', '星期五', 2020, '九月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (312, '2020-11-07', '星期六', 2020, '九月', '廿二', '庚子', '鼠', NULL, 1, '', '', '立冬', '', 4);
INSERT INTO `base_data_holiday` VALUES (313, '2020-11-08', '星期日', 2020, '九月', '廿三', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (314, '2020-11-09', '星期一', 2020, '九月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (315, '2020-11-10', '星期二', 2020, '九月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (316, '2020-11-11', '星期三', 2020, '九月', '廿六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (317, '2020-11-12', '星期四', 2020, '九月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (318, '2020-11-13', '星期五', 2020, '九月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (319, '2020-11-14', '星期六', 2020, '九月', '廿九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (320, '2020-11-15', '星期日', 2020, '十月', '初一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (321, '2020-11-16', '星期一', 2020, '十月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (322, '2020-11-17', '星期二', 2020, '十月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (323, '2020-11-18', '星期三', 2020, '十月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (324, '2020-11-19', '星期四', 2020, '十月', '初五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (325, '2020-11-20', '星期五', 2020, '十月', '初六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (326, '2020-11-21', '星期六', 2020, '十月', '初七', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (327, '2020-11-22', '星期日', 2020, '十月', '初八', '庚子', '鼠', NULL, 1, '', '', '小雪', '', 4);
INSERT INTO `base_data_holiday` VALUES (328, '2020-11-23', '星期一', 2020, '十月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (329, '2020-11-24', '星期二', 2020, '十月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (330, '2020-11-25', '星期三', 2020, '十月', '十一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (331, '2020-11-26', '星期四', 2020, '十月', '十二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (332, '2020-11-27', '星期五', 2020, '十月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (333, '2020-11-28', '星期六', 2020, '十月', '十四', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (334, '2020-11-29', '星期日', 2020, '十月', '十五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (335, '2020-11-30', '星期一', 2020, '十月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (336, '2020-12-01', '星期二', 2020, '十月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (337, '2020-12-02', '星期三', 2020, '十月', '十八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (338, '2020-12-03', '星期四', 2020, '十月', '十九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (339, '2020-12-04', '星期五', 2020, '十月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (340, '2020-12-05', '星期六', 2020, '十月', '廿一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (341, '2020-12-06', '星期日', 2020, '十月', '廿二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (342, '2020-12-07', '星期一', 2020, '十月', '廿三', '庚子', '鼠', NULL, 0, '', '', '大雪', '', 4);
INSERT INTO `base_data_holiday` VALUES (343, '2020-12-08', '星期二', 2020, '十月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (344, '2020-12-09', '星期三', 2020, '十月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (345, '2020-12-10', '星期四', 2020, '十月', '廿六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (346, '2020-12-11', '星期五', 2020, '十月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (347, '2020-12-12', '星期六', 2020, '十月', '廿八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (348, '2020-12-13', '星期日', 2020, '十月', '廿九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (349, '2020-12-14', '星期一', 2020, '十月', '三十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (350, '2020-12-15', '星期二', 2020, '冬月', '初一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (351, '2020-12-16', '星期三', 2020, '冬月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (352, '2020-12-17', '星期四', 2020, '冬月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (353, '2020-12-18', '星期五', 2020, '冬月', '初四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (354, '2020-12-19', '星期六', 2020, '冬月', '初五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (355, '2020-12-20', '星期日', 2020, '冬月', '初六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (356, '2020-12-21', '星期一', 2020, '冬月', '初七', '庚子', '鼠', NULL, 0, '', '', '冬至', '', 4);
INSERT INTO `base_data_holiday` VALUES (357, '2020-12-22', '星期二', 2020, '冬月', '初八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (358, '2020-12-23', '星期三', 2020, '冬月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (359, '2020-12-24', '星期四', 2020, '冬月', '初十 ', '庚子', '鼠', NULL, 0, '平安夜', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (360, '2020-12-25', '星期五', 2020, '冬月', '十一', '庚子', '鼠', NULL, 0, '圣诞节', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (361, '2020-12-26', '星期六', 2020, '冬月', '十二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (362, '2020-12-27', '星期日', 2020, '冬月', '十三', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (363, '2020-12-28', '星期一', 2020, '冬月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (364, '2020-12-29', '星期二', 2020, '冬月', '十五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (365, '2020-12-30', '星期三', 2020, '冬月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (366, '2020-12-31', '星期四', 2020, '冬月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (367, '2021-01-01', '星期五', 2020, '冬月', '十八', '庚子', '鼠', '元旦', 1, '元旦', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (368, '2021-01-02', '星期六', 2020, '冬月', '十九', '庚子', '鼠', '元旦', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (369, '2021-01-03', '星期日', 2020, '冬月', '二十', '庚子', '鼠', '元旦', 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (370, '2021-01-04', '星期一', 2020, '冬月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (371, '2021-01-05', '星期二', 2020, '冬月', '廿二', '庚子', '鼠', NULL, 0, '', '', '小寒', '', 4);
INSERT INTO `base_data_holiday` VALUES (372, '2021-01-06', '星期三', 2020, '冬月', '廿三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (373, '2021-01-07', '星期四', 2020, '冬月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (374, '2021-01-08', '星期五', 2020, '冬月', '廿五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (375, '2021-01-09', '星期六', 2020, '冬月', '廿六', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (376, '2021-01-10', '星期日', 2020, '冬月', '廿七', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (377, '2021-01-11', '星期一', 2020, '冬月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (378, '2021-01-12', '星期二', 2020, '冬月', '廿九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (379, '2021-01-13', '星期三', 2020, '腊月', '初一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (380, '2021-01-14', '星期四', 2020, '腊月', '初二', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (381, '2021-01-15', '星期五', 2020, '腊月', '初三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (382, '2021-01-16', '星期六', 2020, '腊月', '初四', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (383, '2021-01-17', '星期日', 2020, '腊月', '初五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (384, '2021-01-18', '星期一', 2020, '腊月', '初六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (385, '2021-01-19', '星期二', 2020, '腊月', '初七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (386, '2021-01-20', '星期三', 2020, '腊月', '初八', '庚子', '鼠', NULL, 0, '', '腊八节', '大寒', '', 4);
INSERT INTO `base_data_holiday` VALUES (387, '2021-01-21', '星期四', 2020, '腊月', '初九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (388, '2021-01-22', '星期五', 2020, '腊月', '初十 ', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (389, '2021-01-23', '星期六', 2020, '腊月', '十一', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (390, '2021-01-24', '星期日', 2020, '腊月', '十二', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (391, '2021-01-25', '星期一', 2020, '腊月', '十三', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (392, '2021-01-26', '星期二', 2020, '腊月', '十四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (393, '2021-01-27', '星期三', 2020, '腊月', '十五', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (394, '2021-01-28', '星期四', 2020, '腊月', '十六', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (395, '2021-01-29', '星期五', 2020, '腊月', '十七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (396, '2021-01-30', '星期六', 2020, '腊月', '十八', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (397, '2021-01-31', '星期日', 2020, '腊月', '十九', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (398, '2021-02-01', '星期一', 2020, '腊月', '二十', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (399, '2021-02-02', '星期二', 2020, '腊月', '廿一', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (400, '2021-02-03', '星期三', 2020, '腊月', '廿二', '庚子', '鼠', NULL, 0, '', '', '立春', '', 4);
INSERT INTO `base_data_holiday` VALUES (401, '2021-02-04', '星期四', 2020, '腊月', '廿三', '庚子', '鼠', NULL, 0, '', '小年', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (402, '2021-02-05', '星期五', 2020, '腊月', '廿四', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (403, '2021-02-06', '星期六', 2020, '腊月', '廿五', '庚子', '鼠', NULL, 1, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (404, '2021-02-07', '星期日', 2020, '腊月', '廿六', '庚子', '鼠', '春节前调休', 2, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (405, '2021-02-08', '星期一', 2020, '腊月', '廿七', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (406, '2021-02-09', '星期二', 2020, '腊月', '廿八', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (407, '2021-02-10', '星期三', 2020, '腊月', '廿九', '庚子', '鼠', NULL, 0, '', '', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (408, '2021-02-11', '星期四', 2020, '腊月', '三十', '庚子', '鼠', '除夕', 1, '', '除夕', '', '', 4);
INSERT INTO `base_data_holiday` VALUES (409, '2021-02-12', '星期五', 2021, '正月', '初一', '辛丑', '牛', '初一', 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (410, '2021-02-13', '星期六', 2021, '正月', '初二', '辛丑', '牛', '初二', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (411, '2021-02-14', '星期日', 2021, '正月', '初三', '辛丑', '牛', '初三', 1, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (412, '2021-02-15', '星期一', 2021, '正月', '初四', '辛丑', '牛', '初四', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (413, '2021-02-16', '星期二', 2021, '正月', '初五', '辛丑', '牛', '初五', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (414, '2021-02-17', '星期三', 2021, '正月', '初六', '辛丑', '牛', '初六', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (415, '2021-02-18', '星期四', 2021, '正月', '初七', '辛丑', '牛', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (416, '2021-02-19', '星期五', 2021, '正月', '初八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (417, '2021-02-20', '星期六', 2021, '正月', '初九', '辛丑', '牛', '春节后调休', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (418, '2021-02-21', '星期日', 2021, '正月', '初十 ', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (419, '2021-02-22', '星期一', 2021, '正月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (420, '2021-02-23', '星期二', 2021, '正月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (421, '2021-02-24', '星期三', 2021, '正月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (422, '2021-02-25', '星期四', 2021, '正月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (423, '2021-02-26', '星期五', 2021, '正月', '十五', '辛丑', '牛', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (424, '2021-02-27', '星期六', 2021, '正月', '十六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (425, '2021-02-28', '星期日', 2021, '正月', '十七', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (426, '2021-03-01', '星期一', 2021, '正月', '十八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (427, '2021-03-02', '星期二', 2021, '正月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (428, '2021-03-03', '星期三', 2021, '正月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (429, '2021-03-04', '星期四', 2021, '正月', '廿一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (430, '2021-03-05', '星期五', 2021, '正月', '廿二', '辛丑', '牛', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (431, '2021-03-06', '星期六', 2021, '正月', '廿三', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (432, '2021-03-07', '星期日', 2021, '正月', '廿四', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (433, '2021-03-08', '星期一', 2021, '正月', '廿五', '辛丑', '牛', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (434, '2021-03-09', '星期二', 2021, '正月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (435, '2021-03-10', '星期三', 2021, '正月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (436, '2021-03-11', '星期四', 2021, '正月', '廿八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (437, '2021-03-12', '星期五', 2021, '正月', '廿九', '辛丑', '牛', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (438, '2021-03-13', '星期六', 2021, '二月', '初一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (439, '2021-03-14', '星期日', 2021, '二月', '初二', '辛丑', '牛', NULL, 1, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (440, '2021-03-15', '星期一', 2021, '二月', '初三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (441, '2021-03-16', '星期二', 2021, '二月', '初四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (442, '2021-03-17', '星期三', 2021, '二月', '初五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (443, '2021-03-18', '星期四', 2021, '二月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (444, '2021-03-19', '星期五', 2021, '二月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (445, '2021-03-20', '星期六', 2021, '二月', '初八', '辛丑', '牛', NULL, 1, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (446, '2021-03-21', '星期日', 2021, '二月', '初九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (447, '2021-03-22', '星期一', 2021, '二月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (448, '2021-03-23', '星期二', 2021, '二月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (449, '2021-03-24', '星期三', 2021, '二月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (450, '2021-03-25', '星期四', 2021, '二月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (451, '2021-03-26', '星期五', 2021, '二月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (452, '2021-03-27', '星期六', 2021, '二月', '十五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (453, '2021-03-28', '星期日', 2021, '二月', '十六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (454, '2021-03-29', '星期一', 2021, '二月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (455, '2021-03-30', '星期二', 2021, '二月', '十八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (456, '2021-03-31', '星期三', 2021, '二月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (457, '2021-04-01', '星期四', 2021, '二月', '二十', '辛丑', '牛', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (458, '2021-04-02', '星期五', 2021, '二月', '廿一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (459, '2021-04-03', '星期六', 2021, '二月', '廿二', '辛丑', '牛', '清明节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (460, '2021-04-04', '星期日', 2021, '二月', '廿三', '辛丑', '牛', '清明节', 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (461, '2021-04-05', '星期一', 2021, '二月', '廿四', '辛丑', '牛', '清明节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (462, '2021-04-06', '星期二', 2021, '二月', '廿五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (463, '2021-04-07', '星期三', 2021, '二月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (464, '2021-04-08', '星期四', 2021, '二月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (465, '2021-04-09', '星期五', 2021, '二月', '廿八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (466, '2021-04-10', '星期六', 2021, '二月', '廿九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (467, '2021-04-11', '星期日', 2021, '二月', '三十', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (468, '2021-04-12', '星期一', 2021, '三月', '初一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (469, '2021-04-13', '星期二', 2021, '三月', '初二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (470, '2021-04-14', '星期三', 2021, '三月', '初三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (471, '2021-04-15', '星期四', 2021, '三月', '初四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (472, '2021-04-16', '星期五', 2021, '三月', '初五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (473, '2021-04-17', '星期六', 2021, '三月', '初六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (474, '2021-04-18', '星期日', 2021, '三月', '初七', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (475, '2021-04-19', '星期一', 2021, '三月', '初八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (476, '2021-04-20', '星期二', 2021, '三月', '初九', '辛丑', '牛', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (477, '2021-04-21', '星期三', 2021, '三月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (478, '2021-04-22', '星期四', 2021, '三月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (479, '2021-04-23', '星期五', 2021, '三月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (480, '2021-04-24', '星期六', 2021, '三月', '十三', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (481, '2021-04-25', '星期日', 2021, '三月', '十四', '辛丑', '牛', '劳动节前调休', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (482, '2021-04-26', '星期一', 2021, '三月', '十五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (483, '2021-04-27', '星期二', 2021, '三月', '十六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (484, '2021-04-28', '星期三', 2021, '三月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (485, '2021-04-29', '星期四', 2021, '三月', '十八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (486, '2021-04-30', '星期五', 2021, '三月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (487, '2021-05-01', '星期六', 2021, '三月', '二十', '辛丑', '牛', '劳动节', 1, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (488, '2021-05-02', '星期日', 2021, '三月', '廿一', '辛丑', '牛', '劳动节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (489, '2021-05-03', '星期一', 2021, '三月', '廿二', '辛丑', '牛', '劳动节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (490, '2021-05-04', '星期二', 2021, '三月', '廿三', '辛丑', '牛', '劳动节', 1, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (491, '2021-05-05', '星期三', 2021, '三月', '廿四', '辛丑', '牛', '劳动节', 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (492, '2021-05-06', '星期四', 2021, '三月', '廿五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (493, '2021-05-07', '星期五', 2021, '三月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (494, '2021-05-08', '星期六', 2021, '三月', '廿七', '辛丑', '牛', '劳动节后调休', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (495, '2021-05-09', '星期日', 2021, '三月', '廿八', '辛丑', '牛', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (496, '2021-05-10', '星期一', 2021, '三月', '廿九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (497, '2021-05-11', '星期二', 2021, '三月', '三十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (498, '2021-05-12', '星期三', 2021, '四月', '初一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (499, '2021-05-13', '星期四', 2021, '四月', '初二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (500, '2021-05-14', '星期五', 2021, '四月', '初三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (501, '2021-05-15', '星期六', 2021, '四月', '初四', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (502, '2021-05-16', '星期日', 2021, '四月', '初五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (503, '2021-05-17', '星期一', 2021, '四月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (504, '2021-05-18', '星期二', 2021, '四月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (505, '2021-05-19', '星期三', 2021, '四月', '初八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (506, '2021-05-20', '星期四', 2021, '四月', '初九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (507, '2021-05-21', '星期五', 2021, '四月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (508, '2021-05-22', '星期六', 2021, '四月', '十一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (509, '2021-05-23', '星期日', 2021, '四月', '十二', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (510, '2021-05-24', '星期一', 2021, '四月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (511, '2021-05-25', '星期二', 2021, '四月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (512, '2021-05-26', '星期三', 2021, '四月', '十五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (513, '2021-05-27', '星期四', 2021, '四月', '十六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (514, '2021-05-28', '星期五', 2021, '四月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (515, '2021-05-29', '星期六', 2021, '四月', '十八', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (516, '2021-05-30', '星期日', 2021, '四月', '十九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (517, '2021-05-31', '星期一', 2021, '四月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (518, '2021-06-01', '星期二', 2021, '四月', '廿一', '辛丑', '牛', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (519, '2021-06-02', '星期三', 2021, '四月', '廿二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (520, '2021-06-03', '星期四', 2021, '四月', '廿三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (521, '2021-06-04', '星期五', 2021, '四月', '廿四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (522, '2021-06-05', '星期六', 2021, '四月', '廿五', '辛丑', '牛', NULL, 1, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (523, '2021-06-06', '星期日', 2021, '四月', '廿六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (524, '2021-06-07', '星期一', 2021, '四月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (525, '2021-06-08', '星期二', 2021, '四月', '廿八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (526, '2021-06-09', '星期三', 2021, '四月', '廿九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (527, '2021-06-10', '星期四', 2021, '五月', '初一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (528, '2021-06-11', '星期五', 2021, '五月', '初二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (529, '2021-06-12', '星期六', 2021, '五月', '初三', '辛丑', '牛', '端午节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (530, '2021-06-13', '星期日', 2021, '五月', '初四', '辛丑', '牛', '端午节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (531, '2021-06-14', '星期一', 2021, '五月', '初五', '辛丑', '牛', '端午节', 1, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (532, '2021-06-15', '星期二', 2021, '五月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (533, '2021-06-16', '星期三', 2021, '五月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (534, '2021-06-17', '星期四', 2021, '五月', '初八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (535, '2021-06-18', '星期五', 2021, '五月', '初九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (536, '2021-06-19', '星期六', 2021, '五月', '初十 ', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (537, '2021-06-20', '星期日', 2021, '五月', '十一', '辛丑', '牛', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (538, '2021-06-21', '星期一', 2021, '五月', '十二', '辛丑', '牛', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (539, '2021-06-22', '星期二', 2021, '五月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (540, '2021-06-23', '星期三', 2021, '五月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (541, '2021-06-24', '星期四', 2021, '五月', '十五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (542, '2021-06-25', '星期五', 2021, '五月', '十六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (543, '2021-06-26', '星期六', 2021, '五月', '十七', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (544, '2021-06-27', '星期日', 2021, '五月', '十八', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (545, '2021-06-28', '星期一', 2021, '五月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (546, '2021-06-29', '星期二', 2021, '五月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (547, '2021-06-30', '星期三', 2021, '五月', '廿一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (548, '2021-07-01', '星期四', 2021, '五月', '廿二', '辛丑', '牛', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (549, '2021-07-02', '星期五', 2021, '五月', '廿三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (550, '2021-07-03', '星期六', 2021, '五月', '廿四', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (551, '2021-07-04', '星期日', 2021, '五月', '廿五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (552, '2021-07-05', '星期一', 2021, '五月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (553, '2021-07-06', '星期二', 2021, '五月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (554, '2021-07-07', '星期三', 2021, '五月', '廿八', '辛丑', '牛', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (555, '2021-07-08', '星期四', 2021, '五月', '廿九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (556, '2021-07-09', '星期五', 2021, '五月', '三十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (557, '2021-07-10', '星期六', 2021, '六月', '初一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (558, '2021-07-11', '星期日', 2021, '六月', '初二', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (559, '2021-07-12', '星期一', 2021, '六月', '初三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (560, '2021-07-13', '星期二', 2021, '六月', '初四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (561, '2021-07-14', '星期三', 2021, '六月', '初五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (562, '2021-07-15', '星期四', 2021, '六月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (563, '2021-07-16', '星期五', 2021, '六月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (564, '2021-07-17', '星期六', 2021, '六月', '初八', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (565, '2021-07-18', '星期日', 2021, '六月', '初九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (566, '2021-07-19', '星期一', 2021, '六月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (567, '2021-07-20', '星期二', 2021, '六月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (568, '2021-07-21', '星期三', 2021, '六月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (569, '2021-07-22', '星期四', 2021, '六月', '十三', '辛丑', '牛', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (570, '2021-07-23', '星期五', 2021, '六月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (571, '2021-07-24', '星期六', 2021, '六月', '十五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (572, '2021-07-25', '星期日', 2021, '六月', '十六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (573, '2021-07-26', '星期一', 2021, '六月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (574, '2021-07-27', '星期二', 2021, '六月', '十八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (575, '2021-07-28', '星期三', 2021, '六月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (576, '2021-07-29', '星期四', 2021, '六月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (577, '2021-07-30', '星期五', 2021, '六月', '廿一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (578, '2021-07-31', '星期六', 2021, '六月', '廿二', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (579, '2021-08-01', '星期日', 2021, '六月', '廿三', '辛丑', '牛', NULL, 1, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (580, '2021-08-02', '星期一', 2021, '六月', '廿四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (581, '2021-08-03', '星期二', 2021, '六月', '廿五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (582, '2021-08-04', '星期三', 2021, '六月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (583, '2021-08-05', '星期四', 2021, '六月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (584, '2021-08-06', '星期五', 2021, '六月', '廿八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (585, '2021-08-07', '星期六', 2021, '六月', '廿九', '辛丑', '牛', NULL, 1, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (586, '2021-08-08', '星期日', 2021, '七月', '初一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (587, '2021-08-09', '星期一', 2021, '七月', '初二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (588, '2021-08-10', '星期二', 2021, '七月', '初三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (589, '2021-08-11', '星期三', 2021, '七月', '初四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (590, '2021-08-12', '星期四', 2021, '七月', '初五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (591, '2021-08-13', '星期五', 2021, '七月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (592, '2021-08-14', '星期六', 2021, '七月', '初七', '辛丑', '牛', NULL, 1, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (593, '2021-08-15', '星期日', 2021, '七月', '初八', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (594, '2021-08-16', '星期一', 2021, '七月', '初九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (595, '2021-08-17', '星期二', 2021, '七月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (596, '2021-08-18', '星期三', 2021, '七月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (597, '2021-08-19', '星期四', 2021, '七月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (598, '2021-08-20', '星期五', 2021, '七月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (599, '2021-08-21', '星期六', 2021, '七月', '十四', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (600, '2021-08-22', '星期日', 2021, '七月', '十五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (601, '2021-08-23', '星期一', 2021, '七月', '十六', '辛丑', '牛', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (602, '2021-08-24', '星期二', 2021, '七月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (603, '2021-08-25', '星期三', 2021, '七月', '十八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (604, '2021-08-26', '星期四', 2021, '七月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (605, '2021-08-27', '星期五', 2021, '七月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (606, '2021-08-28', '星期六', 2021, '七月', '廿一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (607, '2021-08-29', '星期日', 2021, '七月', '廿二', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (608, '2021-08-30', '星期一', 2021, '七月', '廿三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (609, '2021-08-31', '星期二', 2021, '七月', '廿四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (610, '2021-09-01', '星期三', 2021, '七月', '廿五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (611, '2021-09-02', '星期四', 2021, '七月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (612, '2021-09-03', '星期五', 2021, '七月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (613, '2021-09-04', '星期六', 2021, '七月', '廿八', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (614, '2021-09-05', '星期日', 2021, '七月', '廿九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (615, '2021-09-06', '星期一', 2021, '七月', '三十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (616, '2021-09-07', '星期二', 2021, '八月', '初一', '辛丑', '牛', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (617, '2021-09-08', '星期三', 2021, '八月', '初二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (618, '2021-09-09', '星期四', 2021, '八月', '初三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (619, '2021-09-10', '星期五', 2021, '八月', '初四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (620, '2021-09-11', '星期六', 2021, '八月', '初五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (621, '2021-09-12', '星期日', 2021, '八月', '初六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (622, '2021-09-13', '星期一', 2021, '八月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (623, '2021-09-14', '星期二', 2021, '八月', '初八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (624, '2021-09-15', '星期三', 2021, '八月', '初九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (625, '2021-09-16', '星期四', 2021, '八月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (626, '2021-09-17', '星期五', 2021, '八月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (627, '2021-09-18', '星期六', 2021, '八月', '十二', '辛丑', '牛', '中秋节前调休', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (628, '2021-09-19', '星期日', 2021, '八月', '十三', '辛丑', '牛', '中秋节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (629, '2021-09-20', '星期一', 2021, '八月', '十四', '辛丑', '牛', '中秋节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (630, '2021-09-21', '星期二', 2021, '八月', '十五', '辛丑', '牛', '中秋节', 1, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (631, '2021-09-22', '星期三', 2021, '八月', '十六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (632, '2021-09-23', '星期四', 2021, '八月', '十七', '辛丑', '牛', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (633, '2021-09-24', '星期五', 2021, '八月', '十八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (634, '2021-09-25', '星期六', 2021, '八月', '十九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (635, '2021-09-26', '星期日', 2021, '八月', '二十', '辛丑', '牛', '国庆节前调休', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (636, '2021-09-27', '星期一', 2021, '八月', '廿一', '辛丑', '牛', '手动修改测试不发短信用', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (637, '2021-09-28', '星期二', 2021, '八月', '廿二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (638, '2021-09-29', '星期三', 2021, '八月', '廿三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (639, '2021-09-30', '星期四', 2021, '八月', '廿四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (640, '2021-10-01', '星期五', 2021, '八月', '廿五', '辛丑', '牛', '国庆节', 1, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (641, '2021-10-02', '星期六', 2021, '八月', '廿六', '辛丑', '牛', '国庆节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (642, '2021-10-03', '星期日', 2021, '八月', '廿七', '辛丑', '牛', '国庆节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (643, '2021-10-04', '星期一', 2021, '八月', '廿八', '辛丑', '牛', '国庆节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (644, '2021-10-05', '星期二', 2021, '八月', '廿九', '辛丑', '牛', '国庆节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (645, '2021-10-06', '星期三', 2021, '九月', '初一', '辛丑', '牛', '国庆节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (646, '2021-10-07', '星期四', 2021, '九月', '初二', '辛丑', '牛', '国庆节', 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (647, '2021-10-08', '星期五', 2021, '九月', '初三', '辛丑', '牛', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (648, '2021-10-09', '星期六', 2021, '九月', '初四', '辛丑', '牛', '国庆节后调休', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (649, '2021-10-10', '星期日', 2021, '九月', '初五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (650, '2021-10-11', '星期一', 2021, '九月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (651, '2021-10-12', '星期二', 2021, '九月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (652, '2021-10-13', '星期三', 2021, '九月', '初八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (653, '2021-10-14', '星期四', 2021, '九月', '初九', '辛丑', '牛', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (654, '2021-10-15', '星期五', 2021, '九月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (655, '2021-10-16', '星期六', 2021, '九月', '十一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (656, '2021-10-17', '星期日', 2021, '九月', '十二', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (657, '2021-10-18', '星期一', 2021, '九月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (658, '2021-10-19', '星期二', 2021, '九月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (659, '2021-10-20', '星期三', 2021, '九月', '十五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (660, '2021-10-21', '星期四', 2021, '九月', '十六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (661, '2021-10-22', '星期五', 2021, '九月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (662, '2021-10-23', '星期六', 2021, '九月', '十八', '辛丑', '牛', NULL, 1, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (663, '2021-10-24', '星期日', 2021, '九月', '十九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (664, '2021-10-25', '星期一', 2021, '九月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (665, '2021-10-26', '星期二', 2021, '九月', '廿一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (666, '2021-10-27', '星期三', 2021, '九月', '廿二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (667, '2021-10-28', '星期四', 2021, '九月', '廿三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (668, '2021-10-29', '星期五', 2021, '九月', '廿四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (669, '2021-10-30', '星期六', 2021, '九月', '廿五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (670, '2021-10-31', '星期日', 2021, '九月', '廿六', '辛丑', '牛', NULL, 1, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (671, '2021-11-01', '星期一', 2021, '九月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (672, '2021-11-02', '星期二', 2021, '九月', '廿八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (673, '2021-11-03', '星期三', 2021, '九月', '廿九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (674, '2021-11-04', '星期四', 2021, '九月', '三十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (675, '2021-11-05', '星期五', 2021, '十月', '初一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (676, '2021-11-06', '星期六', 2021, '十月', '初二', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (677, '2021-11-07', '星期日', 2021, '十月', '初三', '辛丑', '牛', NULL, 1, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (678, '2021-11-08', '星期一', 2021, '十月', '初四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (679, '2021-11-09', '星期二', 2021, '十月', '初五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (680, '2021-11-10', '星期三', 2021, '十月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (681, '2021-11-11', '星期四', 2021, '十月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (682, '2021-11-12', '星期五', 2021, '十月', '初八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (683, '2021-11-13', '星期六', 2021, '十月', '初九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (684, '2021-11-14', '星期日', 2021, '十月', '初十 ', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (685, '2021-11-15', '星期一', 2021, '十月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (686, '2021-11-16', '星期二', 2021, '十月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (687, '2021-11-17', '星期三', 2021, '十月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (688, '2021-11-18', '星期四', 2021, '十月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (689, '2021-11-19', '星期五', 2021, '十月', '十五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (690, '2021-11-20', '星期六', 2021, '十月', '十六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (691, '2021-11-21', '星期日', 2021, '十月', '十七', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (692, '2021-11-22', '星期一', 2021, '十月', '十八', '辛丑', '牛', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (693, '2021-11-23', '星期二', 2021, '十月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (694, '2021-11-24', '星期三', 2021, '十月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (695, '2021-11-25', '星期四', 2021, '十月', '廿一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (696, '2021-11-26', '星期五', 2021, '十月', '廿二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (697, '2021-11-27', '星期六', 2021, '十月', '廿三', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (698, '2021-11-28', '星期日', 2021, '十月', '廿四', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (699, '2021-11-29', '星期一', 2021, '十月', '廿五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (700, '2021-11-30', '星期二', 2021, '十月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (701, '2021-12-01', '星期三', 2021, '十月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (702, '2021-12-02', '星期四', 2021, '十月', '廿八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (703, '2021-12-03', '星期五', 2021, '十月', '廿九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (704, '2021-12-04', '星期六', 2021, '冬月', '初一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (705, '2021-12-05', '星期日', 2021, '冬月', '初二', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (706, '2021-12-06', '星期一', 2021, '冬月', '初三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (707, '2021-12-07', '星期二', 2021, '冬月', '初四', '辛丑', '牛', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (708, '2021-12-08', '星期三', 2021, '冬月', '初五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (709, '2021-12-09', '星期四', 2021, '冬月', '初六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (710, '2021-12-10', '星期五', 2021, '冬月', '初七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (711, '2021-12-11', '星期六', 2021, '冬月', '初八', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (712, '2021-12-12', '星期日', 2021, '冬月', '初九', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (713, '2021-12-13', '星期一', 2021, '冬月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (714, '2021-12-14', '星期二', 2021, '冬月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (715, '2021-12-15', '星期三', 2021, '冬月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (716, '2021-12-16', '星期四', 2021, '冬月', '十三', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (717, '2021-12-17', '星期五', 2021, '冬月', '十四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (718, '2021-12-18', '星期六', 2021, '冬月', '十五', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (719, '2021-12-19', '星期日', 2021, '冬月', '十六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (720, '2021-12-20', '星期一', 2021, '冬月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (721, '2021-12-21', '星期二', 2021, '冬月', '十八', '辛丑', '牛', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (722, '2021-12-22', '星期三', 2021, '冬月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (723, '2021-12-23', '星期四', 2021, '冬月', '二十', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (724, '2021-12-24', '星期五', 2021, '冬月', '廿一', '辛丑', '牛', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (725, '2021-12-25', '星期六', 2021, '冬月', '廿二', '辛丑', '牛', NULL, 1, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (726, '2021-12-26', '星期日', 2021, '冬月', '廿三', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (727, '2021-12-27', '星期一', 2021, '冬月', '廿四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (728, '2021-12-28', '星期二', 2021, '冬月', '廿五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (729, '2021-12-29', '星期三', 2021, '冬月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (730, '2021-12-30', '星期四', 2021, '冬月', '廿七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (731, '2021-12-31', '星期五', 2021, '冬月', '廿八', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (732, '2022-01-01', '星期六', 2021, '冬月', '廿九', '辛丑', '牛', NULL, 1, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (733, '2022-01-02', '星期日', 2021, '冬月', '三十', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (734, '2022-01-03', '星期一', 2021, '腊月', '初一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (735, '2022-01-04', '星期二', 2021, '腊月', '初二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (736, '2022-01-05', '星期三', 2021, '腊月', '初三', '辛丑', '牛', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (737, '2022-01-06', '星期四', 2021, '腊月', '初四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (738, '2022-01-07', '星期五', 2021, '腊月', '初五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (739, '2022-01-08', '星期六', 2021, '腊月', '初六', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (740, '2022-01-09', '星期日', 2021, '腊月', '初七', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (741, '2022-01-10', '星期一', 2021, '腊月', '初八', '辛丑', '牛', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (742, '2022-01-11', '星期二', 2021, '腊月', '初九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (743, '2022-01-12', '星期三', 2021, '腊月', '初十 ', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (744, '2022-01-13', '星期四', 2021, '腊月', '十一', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (745, '2022-01-14', '星期五', 2021, '腊月', '十二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (746, '2022-01-15', '星期六', 2021, '腊月', '十三', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (747, '2022-01-16', '星期日', 2021, '腊月', '十四', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (748, '2022-01-17', '星期一', 2021, '腊月', '十五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (749, '2022-01-18', '星期二', 2021, '腊月', '十六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (750, '2022-01-19', '星期三', 2021, '腊月', '十七', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (751, '2022-01-20', '星期四', 2021, '腊月', '十八', '辛丑', '牛', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (752, '2022-01-21', '星期五', 2021, '腊月', '十九', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (753, '2022-01-22', '星期六', 2021, '腊月', '二十', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (754, '2022-01-23', '星期日', 2021, '腊月', '廿一', '辛丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (755, '2022-01-24', '星期一', 2021, '腊月', '廿二', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (756, '2022-01-25', '星期二', 2021, '腊月', '廿三', '辛丑', '牛', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (757, '2022-01-26', '星期三', 2021, '腊月', '廿四', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (758, '2022-01-27', '星期四', 2021, '腊月', '廿五', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (759, '2022-01-28', '星期五', 2021, '腊月', '廿六', '辛丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (760, '2022-01-29', '星期六', 2021, '腊月', '廿七', '辛丑', '牛', '春节补班', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (761, '2022-01-30', '星期日', 2021, '腊月', '廿八', '辛丑', '牛', '春节补班', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (762, '2022-01-31', '星期一', 2021, '腊月', '廿九', '辛丑', '牛', NULL, 1, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (763, '2022-02-01', '星期二', 2022, '正月', '初一', '壬寅', '虎', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (764, '2022-02-02', '星期三', 2022, '正月', '初二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (765, '2022-02-03', '星期四', 2022, '正月', '初三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (766, '2022-02-04', '星期五', 2022, '正月', '初四', '壬寅', '虎', NULL, 1, '', '', '立春', '', 0);
INSERT INTO `base_data_holiday` VALUES (767, '2022-02-05', '星期六', 2022, '正月', '初五', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (768, '2022-02-06', '星期日', 2022, '正月', '初六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (769, '2022-02-07', '星期一', 2022, '正月', '初七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (770, '2022-02-08', '星期二', 2022, '正月', '初八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (771, '2022-02-09', '星期三', 2022, '正月', '初九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (772, '2022-02-10', '星期四', 2022, '正月', '初十 ', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (773, '2022-02-11', '星期五', 2022, '正月', '十一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (774, '2022-02-12', '星期六', 2022, '正月', '十二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (775, '2022-02-13', '星期日', 2022, '正月', '十三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (776, '2022-02-14', '星期一', 2022, '正月', '十四', '壬寅', '虎', NULL, 0, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (777, '2022-02-15', '星期二', 2022, '正月', '十五', '壬寅', '虎', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (778, '2022-02-16', '星期三', 2022, '正月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (779, '2022-02-17', '星期四', 2022, '正月', '十七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (780, '2022-02-18', '星期五', 2022, '正月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (781, '2022-02-19', '星期六', 2022, '正月', '十九', '壬寅', '虎', NULL, 1, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (782, '2022-02-20', '星期日', 2022, '正月', '二十', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (783, '2022-02-21', '星期一', 2022, '正月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (784, '2022-02-22', '星期二', 2022, '正月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (785, '2022-02-23', '星期三', 2022, '正月', '廿三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (786, '2022-02-24', '星期四', 2022, '正月', '廿四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (787, '2022-02-25', '星期五', 2022, '正月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (788, '2022-02-26', '星期六', 2022, '正月', '廿六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (789, '2022-02-27', '星期日', 2022, '正月', '廿七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (790, '2022-02-28', '星期一', 2022, '正月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (791, '2022-03-01', '星期二', 2022, '正月', '廿九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (792, '2022-03-02', '星期三', 2022, '正月', '三十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (793, '2022-03-03', '星期四', 2022, '二月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (794, '2022-03-04', '星期五', 2022, '二月', '初二', '壬寅', '虎', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (795, '2022-03-05', '星期六', 2022, '二月', '初三', '壬寅', '虎', NULL, 1, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (796, '2022-03-06', '星期日', 2022, '二月', '初四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (797, '2022-03-07', '星期一', 2022, '二月', '初五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (798, '2022-03-08', '星期二', 2022, '二月', '初六', '壬寅', '虎', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (799, '2022-03-09', '星期三', 2022, '二月', '初七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (800, '2022-03-10', '星期四', 2022, '二月', '初八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (801, '2022-03-11', '星期五', 2022, '二月', '初九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (802, '2022-03-12', '星期六', 2022, '二月', '初十 ', '壬寅', '虎', NULL, 1, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (803, '2022-03-13', '星期日', 2022, '二月', '十一', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (804, '2022-03-14', '星期一', 2022, '二月', '十二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (805, '2022-03-15', '星期二', 2022, '二月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (806, '2022-03-16', '星期三', 2022, '二月', '十四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (807, '2022-03-17', '星期四', 2022, '二月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (808, '2022-03-18', '星期五', 2022, '二月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (809, '2022-03-19', '星期六', 2022, '二月', '十七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (810, '2022-03-20', '星期日', 2022, '二月', '十八', '壬寅', '虎', NULL, 1, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (811, '2022-03-21', '星期一', 2022, '二月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (812, '2022-03-22', '星期二', 2022, '二月', '二十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (813, '2022-03-23', '星期三', 2022, '二月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (814, '2022-03-24', '星期四', 2022, '二月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (815, '2022-03-25', '星期五', 2022, '二月', '廿三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (816, '2022-03-26', '星期六', 2022, '二月', '廿四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (817, '2022-03-27', '星期日', 2022, '二月', '廿五', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (818, '2022-03-28', '星期一', 2022, '二月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (819, '2022-03-29', '星期二', 2022, '二月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (820, '2022-03-30', '星期三', 2022, '二月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (821, '2022-03-31', '星期四', 2022, '二月', '廿九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (822, '2022-04-01', '星期五', 2022, '三月', '初一', '壬寅', '虎', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (823, '2022-04-02', '星期六', 2022, '三月', '初二', '壬寅', '虎', '清明节补班', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (824, '2022-04-03', '星期日', 2022, '三月', '初三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (825, '2022-04-04', '星期一', 2022, '三月', '初四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (826, '2022-04-05', '星期二', 2022, '三月', '初五', '壬寅', '虎', NULL, 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (827, '2022-04-06', '星期三', 2022, '三月', '初六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (828, '2022-04-07', '星期四', 2022, '三月', '初七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (829, '2022-04-08', '星期五', 2022, '三月', '初八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (830, '2022-04-09', '星期六', 2022, '三月', '初九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (831, '2022-04-10', '星期日', 2022, '三月', '初十 ', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (832, '2022-04-11', '星期一', 2022, '三月', '十一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (833, '2022-04-12', '星期二', 2022, '三月', '十二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (834, '2022-04-13', '星期三', 2022, '三月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (835, '2022-04-14', '星期四', 2022, '三月', '十四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (836, '2022-04-15', '星期五', 2022, '三月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (837, '2022-04-16', '星期六', 2022, '三月', '十六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (838, '2022-04-17', '星期日', 2022, '三月', '十七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (839, '2022-04-18', '星期一', 2022, '三月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (840, '2022-04-19', '星期二', 2022, '三月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (841, '2022-04-20', '星期三', 2022, '三月', '二十', '壬寅', '虎', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (842, '2022-04-21', '星期四', 2022, '三月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (843, '2022-04-22', '星期五', 2022, '三月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (844, '2022-04-23', '星期六', 2022, '三月', '廿三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (845, '2022-04-24', '星期日', 2022, '三月', '廿四', '壬寅', '虎', '劳动节补班', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (846, '2022-04-25', '星期一', 2022, '三月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (847, '2022-04-26', '星期二', 2022, '三月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (848, '2022-04-27', '星期三', 2022, '三月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (849, '2022-04-28', '星期四', 2022, '三月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (850, '2022-04-29', '星期五', 2022, '三月', '廿九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (851, '2022-04-30', '星期六', 2022, '三月', '三十', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (852, '2022-05-01', '星期日', 2022, '四月', '初一', '壬寅', '虎', NULL, 1, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (853, '2022-05-02', '星期一', 2022, '四月', '初二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (854, '2022-05-03', '星期二', 2022, '四月', '初三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (855, '2022-05-04', '星期三', 2022, '四月', '初四', '壬寅', '虎', NULL, 1, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (856, '2022-05-05', '星期四', 2022, '四月', '初五', '壬寅', '虎', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (857, '2022-05-06', '星期五', 2022, '四月', '初六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (858, '2022-05-07', '星期六', 2022, '四月', '初七', '壬寅', '虎', '劳动节补班', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (859, '2022-05-08', '星期日', 2022, '四月', '初八', '壬寅', '虎', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (860, '2022-05-09', '星期一', 2022, '四月', '初九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (861, '2022-05-10', '星期二', 2022, '四月', '初十 ', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (862, '2022-05-11', '星期三', 2022, '四月', '十一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (863, '2022-05-12', '星期四', 2022, '四月', '十二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (864, '2022-05-13', '星期五', 2022, '四月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (865, '2022-05-14', '星期六', 2022, '四月', '十四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (866, '2022-05-15', '星期日', 2022, '四月', '十五', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (867, '2022-05-16', '星期一', 2022, '四月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (868, '2022-05-17', '星期二', 2022, '四月', '十七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (869, '2022-05-18', '星期三', 2022, '四月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (870, '2022-05-19', '星期四', 2022, '四月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (871, '2022-05-20', '星期五', 2022, '四月', '二十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (872, '2022-05-21', '星期六', 2022, '四月', '廿一', '壬寅', '虎', NULL, 1, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (873, '2022-05-22', '星期日', 2022, '四月', '廿二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (874, '2022-05-23', '星期一', 2022, '四月', '廿三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (875, '2022-05-24', '星期二', 2022, '四月', '廿四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (876, '2022-05-25', '星期三', 2022, '四月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (877, '2022-05-26', '星期四', 2022, '四月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (878, '2022-05-27', '星期五', 2022, '四月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (879, '2022-05-28', '星期六', 2022, '四月', '廿八', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (880, '2022-05-29', '星期日', 2022, '四月', '廿九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (881, '2022-05-30', '星期一', 2022, '五月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (882, '2022-05-31', '星期二', 2022, '五月', '初二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (883, '2022-06-01', '星期三', 2022, '五月', '初三', '壬寅', '虎', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (884, '2022-06-02', '星期四', 2022, '五月', '初四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (885, '2022-06-03', '星期五', 2022, '五月', '初五', '壬寅', '虎', NULL, 1, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (886, '2022-06-04', '星期六', 2022, '五月', '初六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (887, '2022-06-05', '星期日', 2022, '五月', '初七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (888, '2022-06-06', '星期一', 2022, '五月', '初八', '壬寅', '虎', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (889, '2022-06-07', '星期二', 2022, '五月', '初九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (890, '2022-06-08', '星期三', 2022, '五月', '初十 ', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (891, '2022-06-09', '星期四', 2022, '五月', '十一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (892, '2022-06-10', '星期五', 2022, '五月', '十二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (893, '2022-06-11', '星期六', 2022, '五月', '十三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (894, '2022-06-12', '星期日', 2022, '五月', '十四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (895, '2022-06-13', '星期一', 2022, '五月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (896, '2022-06-14', '星期二', 2022, '五月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (897, '2022-06-15', '星期三', 2022, '五月', '十七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (898, '2022-06-16', '星期四', 2022, '五月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (899, '2022-06-17', '星期五', 2022, '五月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (900, '2022-06-18', '星期六', 2022, '五月', '二十', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (901, '2022-06-19', '星期日', 2022, '五月', '廿一', '壬寅', '虎', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (902, '2022-06-20', '星期一', 2022, '五月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (903, '2022-06-21', '星期二', 2022, '五月', '廿三', '壬寅', '虎', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (904, '2022-06-22', '星期三', 2022, '五月', '廿四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (905, '2022-06-23', '星期四', 2022, '五月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (906, '2022-06-24', '星期五', 2022, '五月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (907, '2022-06-25', '星期六', 2022, '五月', '廿七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (908, '2022-06-26', '星期日', 2022, '五月', '廿八', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (909, '2022-06-27', '星期一', 2022, '五月', '廿九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (910, '2022-06-28', '星期二', 2022, '五月', '三十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (911, '2022-06-29', '星期三', 2022, '六月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (912, '2022-06-30', '星期四', 2022, '六月', '初二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (913, '2022-07-01', '星期五', 2022, '六月', '初三', '壬寅', '虎', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (914, '2022-07-02', '星期六', 2022, '六月', '初四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (915, '2022-07-03', '星期日', 2022, '六月', '初五', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (916, '2022-07-04', '星期一', 2022, '六月', '初六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (917, '2022-07-05', '星期二', 2022, '六月', '初七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (918, '2022-07-06', '星期三', 2022, '六月', '初八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (919, '2022-07-07', '星期四', 2022, '六月', '初九', '壬寅', '虎', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (920, '2022-07-08', '星期五', 2022, '六月', '初十 ', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (921, '2022-07-09', '星期六', 2022, '六月', '十一', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (922, '2022-07-10', '星期日', 2022, '六月', '十二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (923, '2022-07-11', '星期一', 2022, '六月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (924, '2022-07-12', '星期二', 2022, '六月', '十四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (925, '2022-07-13', '星期三', 2022, '六月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (926, '2022-07-14', '星期四', 2022, '六月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (927, '2022-07-15', '星期五', 2022, '六月', '十七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (928, '2022-07-16', '星期六', 2022, '六月', '十八', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (929, '2022-07-17', '星期日', 2022, '六月', '十九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (930, '2022-07-18', '星期一', 2022, '六月', '二十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (931, '2022-07-19', '星期二', 2022, '六月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (932, '2022-07-20', '星期三', 2022, '六月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (933, '2022-07-21', '星期四', 2022, '六月', '廿三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (934, '2022-07-22', '星期五', 2022, '六月', '廿四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (935, '2022-07-23', '星期六', 2022, '六月', '廿五', '壬寅', '虎', NULL, 1, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (936, '2022-07-24', '星期日', 2022, '六月', '廿六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (937, '2022-07-25', '星期一', 2022, '六月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (938, '2022-07-26', '星期二', 2022, '六月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (939, '2022-07-27', '星期三', 2022, '六月', '廿九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (940, '2022-07-28', '星期四', 2022, '六月', '三十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (941, '2022-07-29', '星期五', 2022, '七月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (942, '2022-07-30', '星期六', 2022, '七月', '初二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (943, '2022-07-31', '星期日', 2022, '七月', '初三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (944, '2022-08-01', '星期一', 2022, '七月', '初四', '壬寅', '虎', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (945, '2022-08-02', '星期二', 2022, '七月', '初五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (946, '2022-08-03', '星期三', 2022, '七月', '初六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (947, '2022-08-04', '星期四', 2022, '七月', '初七', '壬寅', '虎', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (948, '2022-08-05', '星期五', 2022, '七月', '初八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (949, '2022-08-06', '星期六', 2022, '七月', '初九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (950, '2022-08-07', '星期日', 2022, '七月', '初十 ', '壬寅', '虎', NULL, 1, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (951, '2022-08-08', '星期一', 2022, '七月', '十一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (952, '2022-08-09', '星期二', 2022, '七月', '十二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (953, '2022-08-10', '星期三', 2022, '七月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (954, '2022-08-11', '星期四', 2022, '七月', '十四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (955, '2022-08-12', '星期五', 2022, '七月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (956, '2022-08-13', '星期六', 2022, '七月', '十六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (957, '2022-08-14', '星期日', 2022, '七月', '十七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (958, '2022-08-15', '星期一', 2022, '七月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (959, '2022-08-16', '星期二', 2022, '七月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (960, '2022-08-17', '星期三', 2022, '七月', '二十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (961, '2022-08-18', '星期四', 2022, '七月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (962, '2022-08-19', '星期五', 2022, '七月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (963, '2022-08-20', '星期六', 2022, '七月', '廿三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (964, '2022-08-21', '星期日', 2022, '七月', '廿四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (965, '2022-08-22', '星期一', 2022, '七月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (966, '2022-08-23', '星期二', 2022, '七月', '廿六', '壬寅', '虎', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (967, '2022-08-24', '星期三', 2022, '七月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (968, '2022-08-25', '星期四', 2022, '七月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (969, '2022-08-26', '星期五', 2022, '七月', '廿九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (970, '2022-08-27', '星期六', 2022, '八月', '初一', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (971, '2022-08-28', '星期日', 2022, '八月', '初二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (972, '2022-08-29', '星期一', 2022, '八月', '初三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (973, '2022-08-30', '星期二', 2022, '八月', '初四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (974, '2022-08-31', '星期三', 2022, '八月', '初五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (975, '2022-09-01', '星期四', 2022, '八月', '初六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (976, '2022-09-02', '星期五', 2022, '八月', '初七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (977, '2022-09-03', '星期六', 2022, '八月', '初八', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (978, '2022-09-04', '星期日', 2022, '八月', '初九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (979, '2022-09-05', '星期一', 2022, '八月', '初十 ', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (980, '2022-09-06', '星期二', 2022, '八月', '十一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (981, '2022-09-07', '星期三', 2022, '八月', '十二', '壬寅', '虎', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (982, '2022-09-08', '星期四', 2022, '八月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (983, '2022-09-09', '星期五', 2022, '八月', '十四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (984, '2022-09-10', '星期六', 2022, '八月', '十五', '壬寅', '虎', NULL, 1, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (985, '2022-09-11', '星期日', 2022, '八月', '十六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (986, '2022-09-12', '星期一', 2022, '八月', '十七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (987, '2022-09-13', '星期二', 2022, '八月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (988, '2022-09-14', '星期三', 2022, '八月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (989, '2022-09-15', '星期四', 2022, '八月', '二十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (990, '2022-09-16', '星期五', 2022, '八月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (991, '2022-09-17', '星期六', 2022, '八月', '廿二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (992, '2022-09-18', '星期日', 2022, '八月', '廿三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (993, '2022-09-19', '星期一', 2022, '八月', '廿四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (994, '2022-09-20', '星期二', 2022, '八月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (995, '2022-09-21', '星期三', 2022, '八月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (996, '2022-09-22', '星期四', 2022, '八月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (997, '2022-09-23', '星期五', 2022, '八月', '廿八', '壬寅', '虎', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (998, '2022-09-24', '星期六', 2022, '八月', '廿九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (999, '2022-09-25', '星期日', 2022, '八月', '三十', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1000, '2022-09-26', '星期一', 2022, '九月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1001, '2022-09-27', '星期二', 2022, '九月', '初二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1002, '2022-09-28', '星期三', 2022, '九月', '初三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1003, '2022-09-29', '星期四', 2022, '九月', '初四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1004, '2022-09-30', '星期五', 2022, '九月', '初五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1005, '2022-10-01', '星期六', 2022, '九月', '初六', '壬寅', '虎', NULL, 1, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1006, '2022-10-02', '星期日', 2022, '九月', '初七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1007, '2022-10-03', '星期一', 2022, '九月', '初八', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1008, '2022-10-04', '星期二', 2022, '九月', '初九', '壬寅', '虎', NULL, 1, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1009, '2022-10-05', '星期三', 2022, '九月', '初十 ', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1010, '2022-10-06', '星期四', 2022, '九月', '十一', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1011, '2022-10-07', '星期五', 2022, '九月', '十二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1012, '2022-10-08', '星期六', 2022, '九月', '十三', '壬寅', '虎', '国庆补班', 2, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (1013, '2022-10-09', '星期日', 2022, '九月', '十四', '壬寅', '虎', '国庆补班', 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1014, '2022-10-10', '星期一', 2022, '九月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1015, '2022-10-11', '星期二', 2022, '九月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1016, '2022-10-12', '星期三', 2022, '九月', '十七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1017, '2022-10-13', '星期四', 2022, '九月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1018, '2022-10-14', '星期五', 2022, '九月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1019, '2022-10-15', '星期六', 2022, '九月', '二十', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1020, '2022-10-16', '星期日', 2022, '九月', '廿一', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1021, '2022-10-17', '星期一', 2022, '九月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1022, '2022-10-18', '星期二', 2022, '九月', '廿三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1023, '2022-10-19', '星期三', 2022, '九月', '廿四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1024, '2022-10-20', '星期四', 2022, '九月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1025, '2022-10-21', '星期五', 2022, '九月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1026, '2022-10-22', '星期六', 2022, '九月', '廿七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1027, '2022-10-23', '星期日', 2022, '九月', '廿八', '壬寅', '虎', NULL, 1, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (1028, '2022-10-24', '星期一', 2022, '九月', '廿九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1029, '2022-10-25', '星期二', 2022, '十月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1030, '2022-10-26', '星期三', 2022, '十月', '初二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1031, '2022-10-27', '星期四', 2022, '十月', '初三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1032, '2022-10-28', '星期五', 2022, '十月', '初四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1033, '2022-10-29', '星期六', 2022, '十月', '初五', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1034, '2022-10-30', '星期日', 2022, '十月', '初六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1035, '2022-10-31', '星期一', 2022, '十月', '初七', '壬寅', '虎', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1036, '2022-11-01', '星期二', 2022, '十月', '初八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1037, '2022-11-02', '星期三', 2022, '十月', '初九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1038, '2022-11-03', '星期四', 2022, '十月', '初十 ', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1039, '2022-11-04', '星期五', 2022, '十月', '十一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1040, '2022-11-05', '星期六', 2022, '十月', '十二', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1041, '2022-11-06', '星期日', 2022, '十月', '十三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1042, '2022-11-07', '星期一', 2022, '十月', '十四', '壬寅', '虎', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (1043, '2022-11-08', '星期二', 2022, '十月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1044, '2022-11-09', '星期三', 2022, '十月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1045, '2022-11-10', '星期四', 2022, '十月', '十七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1046, '2022-11-11', '星期五', 2022, '十月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1047, '2022-11-12', '星期六', 2022, '十月', '十九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1048, '2022-11-13', '星期日', 2022, '十月', '二十', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1049, '2022-11-14', '星期一', 2022, '十月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1050, '2022-11-15', '星期二', 2022, '十月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1051, '2022-11-16', '星期三', 2022, '十月', '廿三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1052, '2022-11-17', '星期四', 2022, '十月', '廿四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1053, '2022-11-18', '星期五', 2022, '十月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1054, '2022-11-19', '星期六', 2022, '十月', '廿六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1055, '2022-11-20', '星期日', 2022, '十月', '廿七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1056, '2022-11-21', '星期一', 2022, '十月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1057, '2022-11-22', '星期二', 2022, '十月', '廿九', '壬寅', '虎', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (1058, '2022-11-23', '星期三', 2022, '十月', '三十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1059, '2022-11-24', '星期四', 2022, '冬月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1060, '2022-11-25', '星期五', 2022, '冬月', '初二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1061, '2022-11-26', '星期六', 2022, '冬月', '初三', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1062, '2022-11-27', '星期日', 2022, '冬月', '初四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1063, '2022-11-28', '星期一', 2022, '冬月', '初五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1064, '2022-11-29', '星期二', 2022, '冬月', '初六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1065, '2022-11-30', '星期三', 2022, '冬月', '初七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1066, '2022-12-01', '星期四', 2022, '冬月', '初八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1067, '2022-12-02', '星期五', 2022, '冬月', '初九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1068, '2022-12-03', '星期六', 2022, '冬月', '初十 ', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1069, '2022-12-04', '星期日', 2022, '冬月', '十一', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1070, '2022-12-05', '星期一', 2022, '冬月', '十二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1071, '2022-12-06', '星期二', 2022, '冬月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1072, '2022-12-07', '星期三', 2022, '冬月', '十四', '壬寅', '虎', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (1073, '2022-12-08', '星期四', 2022, '冬月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1074, '2022-12-09', '星期五', 2022, '冬月', '十六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1075, '2022-12-10', '星期六', 2022, '冬月', '十七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1076, '2022-12-11', '星期日', 2022, '冬月', '十八', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1077, '2022-12-12', '星期一', 2022, '冬月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1078, '2022-12-13', '星期二', 2022, '冬月', '二十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1079, '2022-12-14', '星期三', 2022, '冬月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1080, '2022-12-15', '星期四', 2022, '冬月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1081, '2022-12-16', '星期五', 2022, '冬月', '廿三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1082, '2022-12-17', '星期六', 2022, '冬月', '廿四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1083, '2022-12-18', '星期日', 2022, '冬月', '廿五', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1084, '2022-12-19', '星期一', 2022, '冬月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1085, '2022-12-20', '星期二', 2022, '冬月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1086, '2022-12-21', '星期三', 2022, '冬月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1087, '2022-12-22', '星期四', 2022, '冬月', '廿九', '壬寅', '虎', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (1088, '2022-12-23', '星期五', 2022, '腊月', '初一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1089, '2022-12-24', '星期六', 2022, '腊月', '初二', '壬寅', '虎', NULL, 1, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1090, '2022-12-25', '星期日', 2022, '腊月', '初三', '壬寅', '虎', NULL, 1, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1091, '2022-12-26', '星期一', 2022, '腊月', '初四', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1092, '2022-12-27', '星期二', 2022, '腊月', '初五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1093, '2022-12-28', '星期三', 2022, '腊月', '初六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1094, '2022-12-29', '星期四', 2022, '腊月', '初七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1095, '2022-12-30', '星期五', 2022, '腊月', '初八', '壬寅', '虎', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1096, '2022-12-31', '星期六', 2022, '腊月', '初九', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1097, '2023-01-01', '星期日', 2022, '腊月', '初十 ', '壬寅', '虎', NULL, 1, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1098, '2023-01-02', '星期一', 2022, '腊月', '十一', '壬寅', '虎', NULL, 1, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1099, '2023-01-03', '星期二', 2022, '腊月', '十二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1100, '2023-01-04', '星期三', 2022, '腊月', '十三', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1101, '2023-01-05', '星期四', 2022, '腊月', '十四', '壬寅', '虎', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (1102, '2023-01-06', '星期五', 2022, '腊月', '十五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1103, '2023-01-07', '星期六', 2022, '腊月', '十六', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1104, '2023-01-08', '星期日', 2022, '腊月', '十七', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1105, '2023-01-09', '星期一', 2022, '腊月', '十八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1106, '2023-01-10', '星期二', 2022, '腊月', '十九', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1107, '2023-01-11', '星期三', 2022, '腊月', '二十', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1108, '2023-01-12', '星期四', 2022, '腊月', '廿一', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1109, '2023-01-13', '星期五', 2022, '腊月', '廿二', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1110, '2023-01-14', '星期六', 2022, '腊月', '廿三', '壬寅', '虎', NULL, 1, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1111, '2023-01-15', '星期日', 2022, '腊月', '廿四', '壬寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1112, '2023-01-16', '星期一', 2022, '腊月', '廿五', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1113, '2023-01-17', '星期二', 2022, '腊月', '廿六', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1114, '2023-01-18', '星期三', 2022, '腊月', '廿七', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1115, '2023-01-19', '星期四', 2022, '腊月', '廿八', '壬寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1116, '2023-01-20', '星期五', 2022, '腊月', '廿九', '壬寅', '虎', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (1117, '2023-01-21', '星期六', 2022, '腊月', '三十', '壬寅', '虎', NULL, 1, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1118, '2023-01-22', '星期日', 2023, '正月', '初一', '癸卯', '兔', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1119, '2023-01-23', '星期一', 2023, '正月', '初二', '癸卯', '兔', NULL, 1, '', '春节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1120, '2023-01-24', '星期二', 2023, '正月', '初三', '癸卯', '兔', NULL, 1, '', '春节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1121, '2023-01-25', '星期三', 2023, '正月', '初四', '癸卯', '兔', NULL, 1, '', '春节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1122, '2023-01-26', '星期四', 2023, '正月', '初五', '癸卯', '兔', NULL, 1, '', '春节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1123, '2023-01-27', '星期五', 2023, '正月', '初六', '癸卯', '兔', NULL, 1, '', '春节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1124, '2023-01-28', '星期六', 2023, '正月', '初七', '癸卯', '兔', NULL, 2, '', '春节补班', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1125, '2023-01-29', '星期日', 2023, '正月', '初八', '癸卯', '兔', NULL, 2, '', '春节补班', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1126, '2023-01-30', '星期一', 2023, '正月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1127, '2023-01-31', '星期二', 2023, '正月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1128, '2023-02-01', '星期三', 2023, '正月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1129, '2023-02-02', '星期四', 2023, '正月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1130, '2023-02-03', '星期五', 2023, '正月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1131, '2023-02-04', '星期六', 2023, '正月', '十四', '癸卯', '兔', NULL, 1, '', '', '立春', '', 2);
INSERT INTO `base_data_holiday` VALUES (1132, '2023-02-05', '星期日', 2023, '正月', '十五', '癸卯', '兔', NULL, 1, '', '元宵节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1133, '2023-02-06', '星期一', 2023, '正月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1134, '2023-02-07', '星期二', 2023, '正月', '十七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1135, '2023-02-08', '星期三', 2023, '正月', '十八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1136, '2023-02-09', '星期四', 2023, '正月', '十九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1137, '2023-02-10', '星期五', 2023, '正月', '二十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1138, '2023-02-11', '星期六', 2023, '正月', '廿一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1139, '2023-02-12', '星期日', 2023, '正月', '廿二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1140, '2023-02-13', '星期一', 2023, '正月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1141, '2023-02-14', '星期二', 2023, '正月', '廿四', '癸卯', '兔', NULL, 0, '情人节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1142, '2023-02-15', '星期三', 2023, '正月', '廿五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1143, '2023-02-16', '星期四', 2023, '正月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1144, '2023-02-17', '星期五', 2023, '正月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1145, '2023-02-18', '星期六', 2023, '正月', '廿八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1146, '2023-02-19', '星期日', 2023, '正月', '廿九', '癸卯', '兔', NULL, 1, '', '', '雨水', '', 2);
INSERT INTO `base_data_holiday` VALUES (1147, '2023-02-20', '星期一', 2023, '二月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1148, '2023-02-21', '星期二', 2023, '二月', '初二', '癸卯', '兔', NULL, 0, '', '龙抬头', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1149, '2023-02-22', '星期三', 2023, '二月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1150, '2023-02-23', '星期四', 2023, '二月', '初四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1151, '2023-02-24', '星期五', 2023, '二月', '初五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1152, '2023-02-25', '星期六', 2023, '二月', '初六', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1153, '2023-02-26', '星期日', 2023, '二月', '初七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1154, '2023-02-27', '星期一', 2023, '二月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1155, '2023-02-28', '星期二', 2023, '二月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1156, '2023-03-01', '星期三', 2023, '二月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1157, '2023-03-02', '星期四', 2023, '二月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1158, '2023-03-03', '星期五', 2023, '二月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1159, '2023-03-04', '星期六', 2023, '二月', '十三', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1160, '2023-03-05', '星期日', 2023, '二月', '十四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1161, '2023-03-06', '星期一', 2023, '二月', '十五', '癸卯', '兔', NULL, 0, '', '', '惊蛰', '', 2);
INSERT INTO `base_data_holiday` VALUES (1162, '2023-03-07', '星期二', 2023, '二月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1163, '2023-03-08', '星期三', 2023, '二月', '十七', '癸卯', '兔', NULL, 0, '妇女节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1164, '2023-03-09', '星期四', 2023, '二月', '十八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1165, '2023-03-10', '星期五', 2023, '二月', '十九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1166, '2023-03-11', '星期六', 2023, '二月', '二十', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1167, '2023-03-12', '星期日', 2023, '二月', '廿一', '癸卯', '兔', NULL, 1, '植树节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1168, '2023-03-13', '星期一', 2023, '二月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1169, '2023-03-14', '星期二', 2023, '二月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1170, '2023-03-15', '星期三', 2023, '二月', '廿四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1171, '2023-03-16', '星期四', 2023, '二月', '廿五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1172, '2023-03-17', '星期五', 2023, '二月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1173, '2023-03-18', '星期六', 2023, '二月', '廿七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1174, '2023-03-19', '星期日', 2023, '二月', '廿八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1175, '2023-03-20', '星期一', 2023, '二月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1176, '2023-03-21', '星期二', 2023, '二月', '三十', '癸卯', '兔', NULL, 0, '', '', '春分', '', 2);
INSERT INTO `base_data_holiday` VALUES (1177, '2023-03-22', '星期三', 2023, '闰二月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1178, '2023-03-23', '星期四', 2023, '闰二月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1179, '2023-03-24', '星期五', 2023, '闰二月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1180, '2023-03-25', '星期六', 2023, '闰二月', '初四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1181, '2023-03-26', '星期日', 2023, '闰二月', '初五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1182, '2023-03-27', '星期一', 2023, '闰二月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1183, '2023-03-28', '星期二', 2023, '闰二月', '初七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1184, '2023-03-29', '星期三', 2023, '闰二月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1185, '2023-03-30', '星期四', 2023, '闰二月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1186, '2023-03-31', '星期五', 2023, '闰二月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1187, '2023-04-01', '星期六', 2023, '闰二月', '十一', '癸卯', '兔', NULL, 1, '愚人节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1188, '2023-04-02', '星期日', 2023, '闰二月', '十二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1189, '2023-04-03', '星期一', 2023, '闰二月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1190, '2023-04-04', '星期二', 2023, '闰二月', '十四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1191, '2023-04-05', '星期三', 2023, '闰二月', '十五', '癸卯', '兔', NULL, 1, '清明节', '', '清明', '', 2);
INSERT INTO `base_data_holiday` VALUES (1192, '2023-04-06', '星期四', 2023, '闰二月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1193, '2023-04-07', '星期五', 2023, '闰二月', '十七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1194, '2023-04-08', '星期六', 2023, '闰二月', '十八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1195, '2023-04-09', '星期日', 2023, '闰二月', '十九', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1196, '2023-04-10', '星期一', 2023, '闰二月', '二十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1197, '2023-04-11', '星期二', 2023, '闰二月', '廿一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1198, '2023-04-12', '星期三', 2023, '闰二月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1199, '2023-04-13', '星期四', 2023, '闰二月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1200, '2023-04-14', '星期五', 2023, '闰二月', '廿四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1201, '2023-04-15', '星期六', 2023, '闰二月', '廿五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1202, '2023-04-16', '星期日', 2023, '闰二月', '廿六', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1203, '2023-04-17', '星期一', 2023, '闰二月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1204, '2023-04-18', '星期二', 2023, '闰二月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1205, '2023-04-19', '星期三', 2023, '闰二月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1206, '2023-04-20', '星期四', 2023, '三月', '初一', '癸卯', '兔', NULL, 0, '', '', '谷雨', '', 2);
INSERT INTO `base_data_holiday` VALUES (1207, '2023-04-21', '星期五', 2023, '三月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1208, '2023-04-22', '星期六', 2023, '三月', '初三', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1209, '2023-04-23', '星期日', 2023, '三月', '初四', '癸卯', '兔', NULL, 2, '劳动节补班', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1210, '2023-04-24', '星期一', 2023, '三月', '初五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1211, '2023-04-25', '星期二', 2023, '三月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1212, '2023-04-26', '星期三', 2023, '三月', '初七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1213, '2023-04-27', '星期四', 2023, '三月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1214, '2023-04-28', '星期五', 2023, '三月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1215, '2023-04-29', '星期六', 2023, '三月', '初十 ', '癸卯', '兔', NULL, 1, '劳动节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1216, '2023-04-30', '星期日', 2023, '三月', '十一', '癸卯', '兔', NULL, 1, '劳动节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1217, '2023-05-01', '星期一', 2023, '三月', '十二', '癸卯', '兔', NULL, 1, '劳动节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1218, '2023-05-02', '星期二', 2023, '三月', '十三', '癸卯', '兔', NULL, 1, '劳动节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1219, '2023-05-03', '星期三', 2023, '三月', '十四', '癸卯', '兔', NULL, 1, '劳动节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1220, '2023-05-04', '星期四', 2023, '三月', '十五', '癸卯', '兔', NULL, 0, '青年节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1221, '2023-05-05', '星期五', 2023, '三月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1222, '2023-05-06', '星期六', 2023, '三月', '十七', '癸卯', '兔', NULL, 2, '劳动节补班', '', '立夏', '', 2);
INSERT INTO `base_data_holiday` VALUES (1223, '2023-05-07', '星期日', 2023, '三月', '十八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1224, '2023-05-08', '星期一', 2023, '三月', '十九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1225, '2023-05-09', '星期二', 2023, '三月', '二十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1226, '2023-05-10', '星期三', 2023, '三月', '廿一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1227, '2023-05-11', '星期四', 2023, '三月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1228, '2023-05-12', '星期五', 2023, '三月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1229, '2023-05-13', '星期六', 2023, '三月', '廿四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1230, '2023-05-14', '星期日', 2023, '三月', '廿五', '癸卯', '兔', NULL, 1, '', '', '', '母亲节', 2);
INSERT INTO `base_data_holiday` VALUES (1231, '2023-05-15', '星期一', 2023, '三月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1232, '2023-05-16', '星期二', 2023, '三月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1233, '2023-05-17', '星期三', 2023, '三月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1234, '2023-05-18', '星期四', 2023, '三月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1235, '2023-05-19', '星期五', 2023, '四月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1236, '2023-05-20', '星期六', 2023, '四月', '初二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1237, '2023-05-21', '星期日', 2023, '四月', '初三', '癸卯', '兔', NULL, 1, '', '', '小满', '', 2);
INSERT INTO `base_data_holiday` VALUES (1238, '2023-05-22', '星期一', 2023, '四月', '初四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1239, '2023-05-23', '星期二', 2023, '四月', '初五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1240, '2023-05-24', '星期三', 2023, '四月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1241, '2023-05-25', '星期四', 2023, '四月', '初七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1242, '2023-05-26', '星期五', 2023, '四月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1243, '2023-05-27', '星期六', 2023, '四月', '初九', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1244, '2023-05-28', '星期日', 2023, '四月', '初十 ', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1245, '2023-05-29', '星期一', 2023, '四月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1246, '2023-05-30', '星期二', 2023, '四月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1247, '2023-05-31', '星期三', 2023, '四月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1248, '2023-06-01', '星期四', 2023, '四月', '十四', '癸卯', '兔', NULL, 0, '儿童节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1249, '2023-06-02', '星期五', 2023, '四月', '十五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1250, '2023-06-03', '星期六', 2023, '四月', '十六', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1251, '2023-06-04', '星期日', 2023, '四月', '十七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1252, '2023-06-05', '星期一', 2023, '四月', '十八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1253, '2023-06-06', '星期二', 2023, '四月', '十九', '癸卯', '兔', NULL, 0, '', '', '芒种', '', 2);
INSERT INTO `base_data_holiday` VALUES (1254, '2023-06-07', '星期三', 2023, '四月', '二十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1255, '2023-06-08', '星期四', 2023, '四月', '廿一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1256, '2023-06-09', '星期五', 2023, '四月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1257, '2023-06-10', '星期六', 2023, '四月', '廿三', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1258, '2023-06-11', '星期日', 2023, '四月', '廿四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1259, '2023-06-12', '星期一', 2023, '四月', '廿五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1260, '2023-06-13', '星期二', 2023, '四月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1261, '2023-06-14', '星期三', 2023, '四月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1262, '2023-06-15', '星期四', 2023, '四月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1263, '2023-06-16', '星期五', 2023, '四月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1264, '2023-06-17', '星期六', 2023, '四月', '三十', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1265, '2023-06-18', '星期日', 2023, '五月', '初一', '癸卯', '兔', NULL, 1, '', '', '', '父亲节', 2);
INSERT INTO `base_data_holiday` VALUES (1266, '2023-06-19', '星期一', 2023, '五月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1267, '2023-06-20', '星期二', 2023, '五月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1268, '2023-06-21', '星期三', 2023, '五月', '初四', '癸卯', '兔', NULL, 0, '', '', '夏至', '', 2);
INSERT INTO `base_data_holiday` VALUES (1269, '2023-06-22', '星期四', 2023, '五月', '初五', '癸卯', '兔', NULL, 1, '端午节', '端午节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1270, '2023-06-23', '星期五', 2023, '五月', '初六', '癸卯', '兔', NULL, 1, '端午节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1271, '2023-06-24', '星期六', 2023, '五月', '初七', '癸卯', '兔', NULL, 1, '端午节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1272, '2023-06-25', '星期日', 2023, '五月', '初八', '癸卯', '兔', NULL, 2, '端午节补班', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1273, '2023-06-26', '星期一', 2023, '五月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1274, '2023-06-27', '星期二', 2023, '五月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1275, '2023-06-28', '星期三', 2023, '五月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1276, '2023-06-29', '星期四', 2023, '五月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1277, '2023-06-30', '星期五', 2023, '五月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1278, '2023-07-01', '星期六', 2023, '五月', '十四', '癸卯', '兔', NULL, 1, '建党节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1279, '2023-07-02', '星期日', 2023, '五月', '十五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1280, '2023-07-03', '星期一', 2023, '五月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1281, '2023-07-04', '星期二', 2023, '五月', '十七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1282, '2023-07-05', '星期三', 2023, '五月', '十八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1283, '2023-07-06', '星期四', 2023, '五月', '十九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1284, '2023-07-07', '星期五', 2023, '五月', '二十', '癸卯', '兔', NULL, 0, '', '', '小暑', '', 2);
INSERT INTO `base_data_holiday` VALUES (1285, '2023-07-08', '星期六', 2023, '五月', '廿一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1286, '2023-07-09', '星期日', 2023, '五月', '廿二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1287, '2023-07-10', '星期一', 2023, '五月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1288, '2023-07-11', '星期二', 2023, '五月', '廿四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1289, '2023-07-12', '星期三', 2023, '五月', '廿五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1290, '2023-07-13', '星期四', 2023, '五月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1291, '2023-07-14', '星期五', 2023, '五月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1292, '2023-07-15', '星期六', 2023, '五月', '廿八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1293, '2023-07-16', '星期日', 2023, '五月', '廿九', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1294, '2023-07-17', '星期一', 2023, '五月', '三十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1295, '2023-07-18', '星期二', 2023, '六月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1296, '2023-07-19', '星期三', 2023, '六月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1297, '2023-07-20', '星期四', 2023, '六月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1298, '2023-07-21', '星期五', 2023, '六月', '初四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1299, '2023-07-22', '星期六', 2023, '六月', '初五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1300, '2023-07-23', '星期日', 2023, '六月', '初六', '癸卯', '兔', NULL, 1, '', '', '大暑', '', 2);
INSERT INTO `base_data_holiday` VALUES (1301, '2023-07-24', '星期一', 2023, '六月', '初七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1302, '2023-07-25', '星期二', 2023, '六月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1303, '2023-07-26', '星期三', 2023, '六月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1304, '2023-07-27', '星期四', 2023, '六月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1305, '2023-07-28', '星期五', 2023, '六月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1306, '2023-07-29', '星期六', 2023, '六月', '十二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1307, '2023-07-30', '星期日', 2023, '六月', '十三', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1308, '2023-07-31', '星期一', 2023, '六月', '十四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1309, '2023-08-01', '星期二', 2023, '六月', '十五', '癸卯', '兔', NULL, 0, '建军节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1310, '2023-08-02', '星期三', 2023, '六月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1311, '2023-08-03', '星期四', 2023, '六月', '十七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1312, '2023-08-04', '星期五', 2023, '六月', '十八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1313, '2023-08-05', '星期六', 2023, '六月', '十九', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1314, '2023-08-06', '星期日', 2023, '六月', '二十', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1315, '2023-08-07', '星期一', 2023, '六月', '廿一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1316, '2023-08-08', '星期二', 2023, '六月', '廿二', '癸卯', '兔', NULL, 0, '', '', '立秋', '', 2);
INSERT INTO `base_data_holiday` VALUES (1317, '2023-08-09', '星期三', 2023, '六月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1318, '2023-08-10', '星期四', 2023, '六月', '廿四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1319, '2023-08-11', '星期五', 2023, '六月', '廿五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1320, '2023-08-12', '星期六', 2023, '六月', '廿六', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1321, '2023-08-13', '星期日', 2023, '六月', '廿七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1322, '2023-08-14', '星期一', 2023, '六月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1323, '2023-08-15', '星期二', 2023, '六月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1324, '2023-08-16', '星期三', 2023, '七月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1325, '2023-08-17', '星期四', 2023, '七月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1326, '2023-08-18', '星期五', 2023, '七月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1327, '2023-08-19', '星期六', 2023, '七月', '初四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1328, '2023-08-20', '星期日', 2023, '七月', '初五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1329, '2023-08-21', '星期一', 2023, '七月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1330, '2023-08-22', '星期二', 2023, '七月', '初七', '癸卯', '兔', NULL, 0, '', '七夕', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1331, '2023-08-23', '星期三', 2023, '七月', '初八', '癸卯', '兔', NULL, 0, '', '', '处暑', '', 2);
INSERT INTO `base_data_holiday` VALUES (1332, '2023-08-24', '星期四', 2023, '七月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1333, '2023-08-25', '星期五', 2023, '七月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1334, '2023-08-26', '星期六', 2023, '七月', '十一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1335, '2023-08-27', '星期日', 2023, '七月', '十二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1336, '2023-08-28', '星期一', 2023, '七月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1337, '2023-08-29', '星期二', 2023, '七月', '十四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1338, '2023-08-30', '星期三', 2023, '七月', '十五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1339, '2023-08-31', '星期四', 2023, '七月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1340, '2023-09-01', '星期五', 2023, '七月', '十七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1341, '2023-09-02', '星期六', 2023, '七月', '十八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1342, '2023-09-03', '星期日', 2023, '七月', '十九', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1343, '2023-09-04', '星期一', 2023, '七月', '二十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1344, '2023-09-05', '星期二', 2023, '七月', '廿一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1345, '2023-09-06', '星期三', 2023, '七月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1346, '2023-09-07', '星期四', 2023, '七月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1347, '2023-09-08', '星期五', 2023, '七月', '廿四', '癸卯', '兔', NULL, 0, '', '', '白露', '', 2);
INSERT INTO `base_data_holiday` VALUES (1348, '2023-09-09', '星期六', 2023, '七月', '廿五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1349, '2023-09-10', '星期日', 2023, '七月', '廿六', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1350, '2023-09-11', '星期一', 2023, '七月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1351, '2023-09-12', '星期二', 2023, '七月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1352, '2023-09-13', '星期三', 2023, '七月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1353, '2023-09-14', '星期四', 2023, '七月', '三十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1354, '2023-09-15', '星期五', 2023, '八月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1355, '2023-09-16', '星期六', 2023, '八月', '初二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1356, '2023-09-17', '星期日', 2023, '八月', '初三', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1357, '2023-09-18', '星期一', 2023, '八月', '初四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1358, '2023-09-19', '星期二', 2023, '八月', '初五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1359, '2023-09-20', '星期三', 2023, '八月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1360, '2023-09-21', '星期四', 2023, '八月', '初七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1361, '2023-09-22', '星期五', 2023, '八月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1362, '2023-09-23', '星期六', 2023, '八月', '初九', '癸卯', '兔', NULL, 1, '农民丰收节', '', '秋分', '', 2);
INSERT INTO `base_data_holiday` VALUES (1363, '2023-09-24', '星期日', 2023, '八月', '初十 ', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1364, '2023-09-25', '星期一', 2023, '八月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1365, '2023-09-26', '星期二', 2023, '八月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1366, '2023-09-27', '星期三', 2023, '八月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1367, '2023-09-28', '星期四', 2023, '八月', '十四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1368, '2023-09-29', '星期五', 2023, '八月', '十五', '癸卯', '兔', NULL, 1, '中秋节', '中秋节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1369, '2023-09-30', '星期六', 2023, '八月', '十六', '癸卯', '兔', NULL, 1, '中秋节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1370, '2023-10-01', '星期日', 2023, '八月', '十七', '癸卯', '兔', NULL, 1, '国庆节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1371, '2023-10-02', '星期一', 2023, '八月', '十八', '癸卯', '兔', NULL, 1, '国庆节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1372, '2023-10-03', '星期二', 2023, '八月', '十九', '癸卯', '兔', NULL, 1, '国庆节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1373, '2023-10-04', '星期三', 2023, '八月', '二十', '癸卯', '兔', NULL, 1, '国庆节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1374, '2023-10-05', '星期四', 2023, '八月', '廿一', '癸卯', '兔', NULL, 1, '国庆节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1375, '2023-10-06', '星期五', 2023, '八月', '廿二', '癸卯', '兔', NULL, 1, '国庆节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1376, '2023-10-07', '星期六', 2023, '八月', '廿三', '癸卯', '兔', NULL, 2, '国庆节补班', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1377, '2023-10-08', '星期日', 2023, '八月', '廿四', '癸卯', '兔', NULL, 2, '国庆节补班', '', '寒露', '', 2);
INSERT INTO `base_data_holiday` VALUES (1378, '2023-10-09', '星期一', 2023, '八月', '廿五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1379, '2023-10-10', '星期二', 2023, '八月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1380, '2023-10-11', '星期三', 2023, '八月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1381, '2023-10-12', '星期四', 2023, '八月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1382, '2023-10-13', '星期五', 2023, '八月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1383, '2023-10-14', '星期六', 2023, '八月', '三十', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1384, '2023-10-15', '星期日', 2023, '九月', '初一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1385, '2023-10-16', '星期一', 2023, '九月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1386, '2023-10-17', '星期二', 2023, '九月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1387, '2023-10-18', '星期三', 2023, '九月', '初四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1388, '2023-10-19', '星期四', 2023, '九月', '初五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1389, '2023-10-20', '星期五', 2023, '九月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1390, '2023-10-21', '星期六', 2023, '九月', '初七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1391, '2023-10-22', '星期日', 2023, '九月', '初八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1392, '2023-10-23', '星期一', 2023, '九月', '初九', '癸卯', '兔', NULL, 0, '', '重阳节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1393, '2023-10-24', '星期二', 2023, '九月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '霜降', '', 2);
INSERT INTO `base_data_holiday` VALUES (1394, '2023-10-25', '星期三', 2023, '九月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1395, '2023-10-26', '星期四', 2023, '九月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1396, '2023-10-27', '星期五', 2023, '九月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1397, '2023-10-28', '星期六', 2023, '九月', '十四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1398, '2023-10-29', '星期日', 2023, '九月', '十五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1399, '2023-10-30', '星期一', 2023, '九月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1400, '2023-10-31', '星期二', 2023, '九月', '十七', '癸卯', '兔', NULL, 0, '万圣节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1401, '2023-11-01', '星期三', 2023, '九月', '十八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1402, '2023-11-02', '星期四', 2023, '九月', '十九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1403, '2023-11-03', '星期五', 2023, '九月', '二十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1404, '2023-11-04', '星期六', 2023, '九月', '廿一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1405, '2023-11-05', '星期日', 2023, '九月', '廿二', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1406, '2023-11-06', '星期一', 2023, '九月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1407, '2023-11-07', '星期二', 2023, '九月', '廿四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1408, '2023-11-08', '星期三', 2023, '九月', '廿五', '癸卯', '兔', NULL, 0, '', '', '立冬', '', 2);
INSERT INTO `base_data_holiday` VALUES (1409, '2023-11-09', '星期四', 2023, '九月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1410, '2023-11-10', '星期五', 2023, '九月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1411, '2023-11-11', '星期六', 2023, '九月', '廿八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1412, '2023-11-12', '星期日', 2023, '九月', '廿九', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1413, '2023-11-13', '星期一', 2023, '十月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1414, '2023-11-14', '星期二', 2023, '十月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1415, '2023-11-15', '星期三', 2023, '十月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1416, '2023-11-16', '星期四', 2023, '十月', '初四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1417, '2023-11-17', '星期五', 2023, '十月', '初五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1418, '2023-11-18', '星期六', 2023, '十月', '初六', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1419, '2023-11-19', '星期日', 2023, '十月', '初七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1420, '2023-11-20', '星期一', 2023, '十月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1421, '2023-11-21', '星期二', 2023, '十月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1422, '2023-11-22', '星期三', 2023, '十月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '小雪', '', 2);
INSERT INTO `base_data_holiday` VALUES (1423, '2023-11-23', '星期四', 2023, '十月', '十一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1424, '2023-11-24', '星期五', 2023, '十月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1425, '2023-11-25', '星期六', 2023, '十月', '十三', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1426, '2023-11-26', '星期日', 2023, '十月', '十四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1427, '2023-11-27', '星期一', 2023, '十月', '十五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1428, '2023-11-28', '星期二', 2023, '十月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1429, '2023-11-29', '星期三', 2023, '十月', '十七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1430, '2023-11-30', '星期四', 2023, '十月', '十八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1431, '2023-12-01', '星期五', 2023, '十月', '十九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1432, '2023-12-02', '星期六', 2023, '十月', '二十', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1433, '2023-12-03', '星期日', 2023, '十月', '廿一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1434, '2023-12-04', '星期一', 2023, '十月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1435, '2023-12-05', '星期二', 2023, '十月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1436, '2023-12-06', '星期三', 2023, '十月', '廿四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1437, '2023-12-07', '星期四', 2023, '十月', '廿五', '癸卯', '兔', NULL, 0, '', '', '大雪', '', 2);
INSERT INTO `base_data_holiday` VALUES (1438, '2023-12-08', '星期五', 2023, '十月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1439, '2023-12-09', '星期六', 2023, '十月', '廿七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1440, '2023-12-10', '星期日', 2023, '十月', '廿八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1441, '2023-12-11', '星期一', 2023, '十月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1442, '2023-12-12', '星期二', 2023, '十月', '三十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1443, '2023-12-13', '星期三', 2023, '冬月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1444, '2023-12-14', '星期四', 2023, '冬月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1445, '2023-12-15', '星期五', 2023, '冬月', '初三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1446, '2023-12-16', '星期六', 2023, '冬月', '初四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1447, '2023-12-17', '星期日', 2023, '冬月', '初五', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1448, '2023-12-18', '星期一', 2023, '冬月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1449, '2023-12-19', '星期二', 2023, '冬月', '初七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1450, '2023-12-20', '星期三', 2023, '冬月', '初八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1451, '2023-12-21', '星期四', 2023, '冬月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1452, '2023-12-22', '星期五', 2023, '冬月', '初十 ', '癸卯', '兔', NULL, 0, '', '', '冬至', '', 2);
INSERT INTO `base_data_holiday` VALUES (1453, '2023-12-23', '星期六', 2023, '冬月', '十一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1454, '2023-12-24', '星期日', 2023, '冬月', '十二', '癸卯', '兔', NULL, 1, '平安夜', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1455, '2023-12-25', '星期一', 2023, '冬月', '十三', '癸卯', '兔', NULL, 0, '圣诞节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1456, '2023-12-26', '星期二', 2023, '冬月', '十四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1457, '2023-12-27', '星期三', 2023, '冬月', '十五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1458, '2023-12-28', '星期四', 2023, '冬月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1459, '2023-12-29', '星期五', 2023, '冬月', '十七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1460, '2023-12-30', '星期六', 2023, '冬月', '十八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1461, '2023-12-31', '星期日', 2023, '冬月', '十九', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1462, '2024-01-01', '星期一', 2023, '冬月', '二十', '癸卯', '兔', NULL, 1, '元旦', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1463, '2024-01-02', '星期二', 2023, '冬月', '廿一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1464, '2024-01-03', '星期三', 2023, '冬月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1465, '2024-01-04', '星期四', 2023, '冬月', '廿三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1466, '2024-01-05', '星期五', 2023, '冬月', '廿四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1467, '2024-01-06', '星期六', 2023, '冬月', '廿五', '癸卯', '兔', NULL, 1, '', '', '小寒', '', 2);
INSERT INTO `base_data_holiday` VALUES (1468, '2024-01-07', '星期日', 2023, '冬月', '廿六', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1469, '2024-01-08', '星期一', 2023, '冬月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1470, '2024-01-09', '星期二', 2023, '冬月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1471, '2024-01-10', '星期三', 2023, '冬月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1472, '2024-01-11', '星期四', 2023, '腊月', '初一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1473, '2024-01-12', '星期五', 2023, '腊月', '初二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1474, '2024-01-13', '星期六', 2023, '腊月', '初三', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1475, '2024-01-14', '星期日', 2023, '腊月', '初四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1476, '2024-01-15', '星期一', 2023, '腊月', '初五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1477, '2024-01-16', '星期二', 2023, '腊月', '初六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1478, '2024-01-17', '星期三', 2023, '腊月', '初七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1479, '2024-01-18', '星期四', 2023, '腊月', '初八', '癸卯', '兔', NULL, 0, '', '腊八节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1480, '2024-01-19', '星期五', 2023, '腊月', '初九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1481, '2024-01-20', '星期六', 2023, '腊月', '初十 ', '癸卯', '兔', NULL, 1, '', '', '大寒', '', 2);
INSERT INTO `base_data_holiday` VALUES (1482, '2024-01-21', '星期日', 2023, '腊月', '十一', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1483, '2024-01-22', '星期一', 2023, '腊月', '十二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1484, '2024-01-23', '星期二', 2023, '腊月', '十三', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1485, '2024-01-24', '星期三', 2023, '腊月', '十四', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1486, '2024-01-25', '星期四', 2023, '腊月', '十五', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1487, '2024-01-26', '星期五', 2023, '腊月', '十六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1488, '2024-01-27', '星期六', 2023, '腊月', '十七', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1489, '2024-01-28', '星期日', 2023, '腊月', '十八', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1490, '2024-01-29', '星期一', 2023, '腊月', '十九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1491, '2024-01-30', '星期二', 2023, '腊月', '二十', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1492, '2024-01-31', '星期三', 2023, '腊月', '廿一', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1493, '2024-02-01', '星期四', 2023, '腊月', '廿二', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1494, '2024-02-02', '星期五', 2023, '腊月', '廿三', '癸卯', '兔', NULL, 0, '', '小年', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1495, '2024-02-03', '星期六', 2023, '腊月', '廿四', '癸卯', '兔', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1496, '2024-02-04', '星期日', 2023, '腊月', '廿五', '癸卯', '兔', NULL, 2, '', '', '立春', '', 2);
INSERT INTO `base_data_holiday` VALUES (1497, '2024-02-05', '星期一', 2023, '腊月', '廿六', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1498, '2024-02-06', '星期二', 2023, '腊月', '廿七', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1499, '2024-02-07', '星期三', 2023, '腊月', '廿八', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1500, '2024-02-08', '星期四', 2023, '腊月', '廿九', '癸卯', '兔', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1501, '2024-02-09', '星期五', 2023, '腊月', '三十', '癸卯', '兔', NULL, 0, '', '除夕', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (1502, '2024-02-10', '星期六', 2024, '正月', '初一', '甲辰', '龙', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1503, '2024-02-11', '星期日', 2024, '正月', '初二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1504, '2024-02-12', '星期一', 2024, '正月', '初三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1505, '2024-02-13', '星期二', 2024, '正月', '初四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1506, '2024-02-14', '星期三', 2024, '正月', '初五', '甲辰', '龙', NULL, 1, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1507, '2024-02-15', '星期四', 2024, '正月', '初六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1508, '2024-02-16', '星期五', 2024, '正月', '初七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1509, '2024-02-17', '星期六', 2024, '正月', '初八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1510, '2024-02-18', '星期日', 2024, '正月', '初九', '甲辰', '龙', NULL, 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1511, '2024-02-19', '星期一', 2024, '正月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (1512, '2024-02-20', '星期二', 2024, '正月', '十一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1513, '2024-02-21', '星期三', 2024, '正月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1514, '2024-02-22', '星期四', 2024, '正月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1515, '2024-02-23', '星期五', 2024, '正月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1516, '2024-02-24', '星期六', 2024, '正月', '十五', '甲辰', '龙', NULL, 1, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1517, '2024-02-25', '星期日', 2024, '正月', '十六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1518, '2024-02-26', '星期一', 2024, '正月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1519, '2024-02-27', '星期二', 2024, '正月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1520, '2024-02-28', '星期三', 2024, '正月', '十九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1521, '2024-02-29', '星期四', 2024, '正月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1522, '2024-03-01', '星期五', 2024, '正月', '廿一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1523, '2024-03-02', '星期六', 2024, '正月', '廿二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1524, '2024-03-03', '星期日', 2024, '正月', '廿三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1525, '2024-03-04', '星期一', 2024, '正月', '廿四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1526, '2024-03-05', '星期二', 2024, '正月', '廿五', '甲辰', '龙', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (1527, '2024-03-06', '星期三', 2024, '正月', '廿六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1528, '2024-03-07', '星期四', 2024, '正月', '廿七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1529, '2024-03-08', '星期五', 2024, '正月', '廿八', '甲辰', '龙', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1530, '2024-03-09', '星期六', 2024, '正月', '廿九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1531, '2024-03-10', '星期日', 2024, '二月', '初一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1532, '2024-03-11', '星期一', 2024, '二月', '初二', '甲辰', '龙', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1533, '2024-03-12', '星期二', 2024, '二月', '初三', '甲辰', '龙', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1534, '2024-03-13', '星期三', 2024, '二月', '初四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1535, '2024-03-14', '星期四', 2024, '二月', '初五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1536, '2024-03-15', '星期五', 2024, '二月', '初六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1537, '2024-03-16', '星期六', 2024, '二月', '初七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1538, '2024-03-17', '星期日', 2024, '二月', '初八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1539, '2024-03-18', '星期一', 2024, '二月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1540, '2024-03-19', '星期二', 2024, '二月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1541, '2024-03-20', '星期三', 2024, '二月', '十一', '甲辰', '龙', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (1542, '2024-03-21', '星期四', 2024, '二月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1543, '2024-03-22', '星期五', 2024, '二月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1544, '2024-03-23', '星期六', 2024, '二月', '十四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1545, '2024-03-24', '星期日', 2024, '二月', '十五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1546, '2024-03-25', '星期一', 2024, '二月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1547, '2024-03-26', '星期二', 2024, '二月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1548, '2024-03-27', '星期三', 2024, '二月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1549, '2024-03-28', '星期四', 2024, '二月', '十九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1550, '2024-03-29', '星期五', 2024, '二月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1551, '2024-03-30', '星期六', 2024, '二月', '廿一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1552, '2024-03-31', '星期日', 2024, '二月', '廿二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1553, '2024-04-01', '星期一', 2024, '二月', '廿三', '甲辰', '龙', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1554, '2024-04-02', '星期二', 2024, '二月', '廿四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1555, '2024-04-03', '星期三', 2024, '二月', '廿五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1556, '2024-04-04', '星期四', 2024, '二月', '廿六', '甲辰', '龙', NULL, 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (1557, '2024-04-05', '星期五', 2024, '二月', '廿七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1558, '2024-04-06', '星期六', 2024, '二月', '廿八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1559, '2024-04-07', '星期日', 2024, '二月', '廿九', '甲辰', '龙', NULL, 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1560, '2024-04-08', '星期一', 2024, '二月', '三十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1561, '2024-04-09', '星期二', 2024, '三月', '初一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1562, '2024-04-10', '星期三', 2024, '三月', '初二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1563, '2024-04-11', '星期四', 2024, '三月', '初三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1564, '2024-04-12', '星期五', 2024, '三月', '初四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1565, '2024-04-13', '星期六', 2024, '三月', '初五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1566, '2024-04-14', '星期日', 2024, '三月', '初六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1567, '2024-04-15', '星期一', 2024, '三月', '初七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1568, '2024-04-16', '星期二', 2024, '三月', '初八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1569, '2024-04-17', '星期三', 2024, '三月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1570, '2024-04-18', '星期四', 2024, '三月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1571, '2024-04-19', '星期五', 2024, '三月', '十一', '甲辰', '龙', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (1572, '2024-04-20', '星期六', 2024, '三月', '十二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1573, '2024-04-21', '星期日', 2024, '三月', '十三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1574, '2024-04-22', '星期一', 2024, '三月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1575, '2024-04-23', '星期二', 2024, '三月', '十五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1576, '2024-04-24', '星期三', 2024, '三月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1577, '2024-04-25', '星期四', 2024, '三月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1578, '2024-04-26', '星期五', 2024, '三月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1579, '2024-04-27', '星期六', 2024, '三月', '十九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1580, '2024-04-28', '星期日', 2024, '三月', '二十', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1581, '2024-04-29', '星期一', 2024, '三月', '廿一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1582, '2024-04-30', '星期二', 2024, '三月', '廿二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1583, '2024-05-01', '星期三', 2024, '三月', '廿三', '甲辰', '龙', NULL, 1, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1584, '2024-05-02', '星期四', 2024, '三月', '廿四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1585, '2024-05-03', '星期五', 2024, '三月', '廿五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1586, '2024-05-04', '星期六', 2024, '三月', '廿六', '甲辰', '龙', NULL, 1, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1587, '2024-05-05', '星期日', 2024, '三月', '廿七', '甲辰', '龙', NULL, 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (1588, '2024-05-06', '星期一', 2024, '三月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1589, '2024-05-07', '星期二', 2024, '三月', '廿九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1590, '2024-05-08', '星期三', 2024, '四月', '初一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1591, '2024-05-09', '星期四', 2024, '四月', '初二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1592, '2024-05-10', '星期五', 2024, '四月', '初三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1593, '2024-05-11', '星期六', 2024, '四月', '初四', '甲辰', '龙', NULL, 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1594, '2024-05-12', '星期日', 2024, '四月', '初五', '甲辰', '龙', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (1595, '2024-05-13', '星期一', 2024, '四月', '初六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1596, '2024-05-14', '星期二', 2024, '四月', '初七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1597, '2024-05-15', '星期三', 2024, '四月', '初八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1598, '2024-05-16', '星期四', 2024, '四月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1599, '2024-05-17', '星期五', 2024, '四月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1600, '2024-05-18', '星期六', 2024, '四月', '十一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1601, '2024-05-19', '星期日', 2024, '四月', '十二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1602, '2024-05-20', '星期一', 2024, '四月', '十三', '甲辰', '龙', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (1603, '2024-05-21', '星期二', 2024, '四月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1604, '2024-05-22', '星期三', 2024, '四月', '十五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1605, '2024-05-23', '星期四', 2024, '四月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1606, '2024-05-24', '星期五', 2024, '四月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1607, '2024-05-25', '星期六', 2024, '四月', '十八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1608, '2024-05-26', '星期日', 2024, '四月', '十九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1609, '2024-05-27', '星期一', 2024, '四月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1610, '2024-05-28', '星期二', 2024, '四月', '廿一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1611, '2024-05-29', '星期三', 2024, '四月', '廿二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1612, '2024-05-30', '星期四', 2024, '四月', '廿三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1613, '2024-05-31', '星期五', 2024, '四月', '廿四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1614, '2024-06-01', '星期六', 2024, '四月', '廿五', '甲辰', '龙', NULL, 1, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1615, '2024-06-02', '星期日', 2024, '四月', '廿六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1616, '2024-06-03', '星期一', 2024, '四月', '廿七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1617, '2024-06-04', '星期二', 2024, '四月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1618, '2024-06-05', '星期三', 2024, '四月', '廿九', '甲辰', '龙', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (1619, '2024-06-06', '星期四', 2024, '五月', '初一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1620, '2024-06-07', '星期五', 2024, '五月', '初二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1621, '2024-06-08', '星期六', 2024, '五月', '初三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1622, '2024-06-09', '星期日', 2024, '五月', '初四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1623, '2024-06-10', '星期一', 2024, '五月', '初五', '甲辰', '龙', NULL, 1, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1624, '2024-06-11', '星期二', 2024, '五月', '初六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1625, '2024-06-12', '星期三', 2024, '五月', '初七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1626, '2024-06-13', '星期四', 2024, '五月', '初八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1627, '2024-06-14', '星期五', 2024, '五月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1628, '2024-06-15', '星期六', 2024, '五月', '初十 ', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1629, '2024-06-16', '星期日', 2024, '五月', '十一', '甲辰', '龙', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (1630, '2024-06-17', '星期一', 2024, '五月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1631, '2024-06-18', '星期二', 2024, '五月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1632, '2024-06-19', '星期三', 2024, '五月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1633, '2024-06-20', '星期四', 2024, '五月', '十五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1634, '2024-06-21', '星期五', 2024, '五月', '十六', '甲辰', '龙', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (1635, '2024-06-22', '星期六', 2024, '五月', '十七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1636, '2024-06-23', '星期日', 2024, '五月', '十八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1637, '2024-06-24', '星期一', 2024, '五月', '十九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1638, '2024-06-25', '星期二', 2024, '五月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1639, '2024-06-26', '星期三', 2024, '五月', '廿一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1640, '2024-06-27', '星期四', 2024, '五月', '廿二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1641, '2024-06-28', '星期五', 2024, '五月', '廿三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1642, '2024-06-29', '星期六', 2024, '五月', '廿四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1643, '2024-06-30', '星期日', 2024, '五月', '廿五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1644, '2024-07-01', '星期一', 2024, '五月', '廿六', '甲辰', '龙', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1645, '2024-07-02', '星期二', 2024, '五月', '廿七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1646, '2024-07-03', '星期三', 2024, '五月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1647, '2024-07-04', '星期四', 2024, '五月', '廿九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1648, '2024-07-05', '星期五', 2024, '五月', '三十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1649, '2024-07-06', '星期六', 2024, '六月', '初一', '甲辰', '龙', NULL, 1, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (1650, '2024-07-07', '星期日', 2024, '六月', '初二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1651, '2024-07-08', '星期一', 2024, '六月', '初三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1652, '2024-07-09', '星期二', 2024, '六月', '初四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1653, '2024-07-10', '星期三', 2024, '六月', '初五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1654, '2024-07-11', '星期四', 2024, '六月', '初六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1655, '2024-07-12', '星期五', 2024, '六月', '初七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1656, '2024-07-13', '星期六', 2024, '六月', '初八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1657, '2024-07-14', '星期日', 2024, '六月', '初九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1658, '2024-07-15', '星期一', 2024, '六月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1659, '2024-07-16', '星期二', 2024, '六月', '十一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1660, '2024-07-17', '星期三', 2024, '六月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1661, '2024-07-18', '星期四', 2024, '六月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1662, '2024-07-19', '星期五', 2024, '六月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1663, '2024-07-20', '星期六', 2024, '六月', '十五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1664, '2024-07-21', '星期日', 2024, '六月', '十六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1665, '2024-07-22', '星期一', 2024, '六月', '十七', '甲辰', '龙', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (1666, '2024-07-23', '星期二', 2024, '六月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1667, '2024-07-24', '星期三', 2024, '六月', '十九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1668, '2024-07-25', '星期四', 2024, '六月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1669, '2024-07-26', '星期五', 2024, '六月', '廿一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1670, '2024-07-27', '星期六', 2024, '六月', '廿二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1671, '2024-07-28', '星期日', 2024, '六月', '廿三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1672, '2024-07-29', '星期一', 2024, '六月', '廿四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1673, '2024-07-30', '星期二', 2024, '六月', '廿五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1674, '2024-07-31', '星期三', 2024, '六月', '廿六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1675, '2024-08-01', '星期四', 2024, '六月', '廿七', '甲辰', '龙', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1676, '2024-08-02', '星期五', 2024, '六月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1677, '2024-08-03', '星期六', 2024, '六月', '廿九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1678, '2024-08-04', '星期日', 2024, '七月', '初一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1679, '2024-08-05', '星期一', 2024, '七月', '初二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1680, '2024-08-06', '星期二', 2024, '七月', '初三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1681, '2024-08-07', '星期三', 2024, '七月', '初四', '甲辰', '龙', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (1682, '2024-08-08', '星期四', 2024, '七月', '初五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1683, '2024-08-09', '星期五', 2024, '七月', '初六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1684, '2024-08-10', '星期六', 2024, '七月', '初七', '甲辰', '龙', NULL, 1, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1685, '2024-08-11', '星期日', 2024, '七月', '初八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1686, '2024-08-12', '星期一', 2024, '七月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1687, '2024-08-13', '星期二', 2024, '七月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1688, '2024-08-14', '星期三', 2024, '七月', '十一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1689, '2024-08-15', '星期四', 2024, '七月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1690, '2024-08-16', '星期五', 2024, '七月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1691, '2024-08-17', '星期六', 2024, '七月', '十四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1692, '2024-08-18', '星期日', 2024, '七月', '十五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1693, '2024-08-19', '星期一', 2024, '七月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1694, '2024-08-20', '星期二', 2024, '七月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1695, '2024-08-21', '星期三', 2024, '七月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1696, '2024-08-22', '星期四', 2024, '七月', '十九', '甲辰', '龙', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (1697, '2024-08-23', '星期五', 2024, '七月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1698, '2024-08-24', '星期六', 2024, '七月', '廿一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1699, '2024-08-25', '星期日', 2024, '七月', '廿二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1700, '2024-08-26', '星期一', 2024, '七月', '廿三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1701, '2024-08-27', '星期二', 2024, '七月', '廿四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1702, '2024-08-28', '星期三', 2024, '七月', '廿五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1703, '2024-08-29', '星期四', 2024, '七月', '廿六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1704, '2024-08-30', '星期五', 2024, '七月', '廿七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1705, '2024-08-31', '星期六', 2024, '七月', '廿八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1706, '2024-09-01', '星期日', 2024, '七月', '廿九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1707, '2024-09-02', '星期一', 2024, '七月', '三十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1708, '2024-09-03', '星期二', 2024, '八月', '初一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1709, '2024-09-04', '星期三', 2024, '八月', '初二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1710, '2024-09-05', '星期四', 2024, '八月', '初三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1711, '2024-09-06', '星期五', 2024, '八月', '初四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1712, '2024-09-07', '星期六', 2024, '八月', '初五', '甲辰', '龙', NULL, 1, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (1713, '2024-09-08', '星期日', 2024, '八月', '初六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1714, '2024-09-09', '星期一', 2024, '八月', '初七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1715, '2024-09-10', '星期二', 2024, '八月', '初八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1716, '2024-09-11', '星期三', 2024, '八月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1717, '2024-09-12', '星期四', 2024, '八月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1718, '2024-09-13', '星期五', 2024, '八月', '十一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1719, '2024-09-14', '星期六', 2024, '八月', '十二', '甲辰', '龙', NULL, 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1720, '2024-09-15', '星期日', 2024, '八月', '十三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1721, '2024-09-16', '星期一', 2024, '八月', '十四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1722, '2024-09-17', '星期二', 2024, '八月', '十五', '甲辰', '龙', NULL, 1, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1723, '2024-09-18', '星期三', 2024, '八月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1724, '2024-09-19', '星期四', 2024, '八月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1725, '2024-09-20', '星期五', 2024, '八月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1726, '2024-09-21', '星期六', 2024, '八月', '十九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1727, '2024-09-22', '星期日', 2024, '八月', '二十', '甲辰', '龙', NULL, 1, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (1728, '2024-09-23', '星期一', 2024, '八月', '廿一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1729, '2024-09-24', '星期二', 2024, '八月', '廿二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1730, '2024-09-25', '星期三', 2024, '八月', '廿三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1731, '2024-09-26', '星期四', 2024, '八月', '廿四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1732, '2024-09-27', '星期五', 2024, '八月', '廿五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1733, '2024-09-28', '星期六', 2024, '八月', '廿六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1734, '2024-09-29', '星期日', 2024, '八月', '廿七', '甲辰', '龙', NULL, 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1735, '2024-09-30', '星期一', 2024, '八月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1736, '2024-10-01', '星期二', 2024, '八月', '廿九', '甲辰', '龙', NULL, 1, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1737, '2024-10-02', '星期三', 2024, '八月', '三十', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1738, '2024-10-03', '星期四', 2024, '九月', '初一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1739, '2024-10-04', '星期五', 2024, '九月', '初二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1740, '2024-10-05', '星期六', 2024, '九月', '初三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1741, '2024-10-06', '星期日', 2024, '九月', '初四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1742, '2024-10-07', '星期一', 2024, '九月', '初五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1743, '2024-10-08', '星期二', 2024, '九月', '初六', '甲辰', '龙', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (1744, '2024-10-09', '星期三', 2024, '九月', '初七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1745, '2024-10-10', '星期四', 2024, '九月', '初八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1746, '2024-10-11', '星期五', 2024, '九月', '初九', '甲辰', '龙', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1747, '2024-10-12', '星期六', 2024, '九月', '初十 ', '甲辰', '龙', NULL, 2, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1748, '2024-10-13', '星期日', 2024, '九月', '十一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1749, '2024-10-14', '星期一', 2024, '九月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1750, '2024-10-15', '星期二', 2024, '九月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1751, '2024-10-16', '星期三', 2024, '九月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1752, '2024-10-17', '星期四', 2024, '九月', '十五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1753, '2024-10-18', '星期五', 2024, '九月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1754, '2024-10-19', '星期六', 2024, '九月', '十七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1755, '2024-10-20', '星期日', 2024, '九月', '十八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1756, '2024-10-21', '星期一', 2024, '九月', '十九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1757, '2024-10-22', '星期二', 2024, '九月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1758, '2024-10-23', '星期三', 2024, '九月', '廿一', '甲辰', '龙', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (1759, '2024-10-24', '星期四', 2024, '九月', '廿二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1760, '2024-10-25', '星期五', 2024, '九月', '廿三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1761, '2024-10-26', '星期六', 2024, '九月', '廿四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1762, '2024-10-27', '星期日', 2024, '九月', '廿五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1763, '2024-10-28', '星期一', 2024, '九月', '廿六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1764, '2024-10-29', '星期二', 2024, '九月', '廿七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1765, '2024-10-30', '星期三', 2024, '九月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1766, '2024-10-31', '星期四', 2024, '九月', '廿九', '甲辰', '龙', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1767, '2024-11-01', '星期五', 2024, '十月', '初一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1768, '2024-11-02', '星期六', 2024, '十月', '初二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1769, '2024-11-03', '星期日', 2024, '十月', '初三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1770, '2024-11-04', '星期一', 2024, '十月', '初四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1771, '2024-11-05', '星期二', 2024, '十月', '初五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1772, '2024-11-06', '星期三', 2024, '十月', '初六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1773, '2024-11-07', '星期四', 2024, '十月', '初七', '甲辰', '龙', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (1774, '2024-11-08', '星期五', 2024, '十月', '初八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1775, '2024-11-09', '星期六', 2024, '十月', '初九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1776, '2024-11-10', '星期日', 2024, '十月', '初十 ', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1777, '2024-11-11', '星期一', 2024, '十月', '十一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1778, '2024-11-12', '星期二', 2024, '十月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1779, '2024-11-13', '星期三', 2024, '十月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1780, '2024-11-14', '星期四', 2024, '十月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1781, '2024-11-15', '星期五', 2024, '十月', '十五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1782, '2024-11-16', '星期六', 2024, '十月', '十六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1783, '2024-11-17', '星期日', 2024, '十月', '十七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1784, '2024-11-18', '星期一', 2024, '十月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1785, '2024-11-19', '星期二', 2024, '十月', '十九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1786, '2024-11-20', '星期三', 2024, '十月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1787, '2024-11-21', '星期四', 2024, '十月', '廿一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1788, '2024-11-22', '星期五', 2024, '十月', '廿二', '甲辰', '龙', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (1789, '2024-11-23', '星期六', 2024, '十月', '廿三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1790, '2024-11-24', '星期日', 2024, '十月', '廿四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1791, '2024-11-25', '星期一', 2024, '十月', '廿五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1792, '2024-11-26', '星期二', 2024, '十月', '廿六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1793, '2024-11-27', '星期三', 2024, '十月', '廿七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1794, '2024-11-28', '星期四', 2024, '十月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1795, '2024-11-29', '星期五', 2024, '十月', '廿九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1796, '2024-11-30', '星期六', 2024, '十月', '三十', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1797, '2024-12-01', '星期日', 2024, '冬月', '初一', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1798, '2024-12-02', '星期一', 2024, '冬月', '初二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1799, '2024-12-03', '星期二', 2024, '冬月', '初三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1800, '2024-12-04', '星期三', 2024, '冬月', '初四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1801, '2024-12-05', '星期四', 2024, '冬月', '初五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1802, '2024-12-06', '星期五', 2024, '冬月', '初六', '甲辰', '龙', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (1803, '2024-12-07', '星期六', 2024, '冬月', '初七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1804, '2024-12-08', '星期日', 2024, '冬月', '初八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1805, '2024-12-09', '星期一', 2024, '冬月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1806, '2024-12-10', '星期二', 2024, '冬月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1807, '2024-12-11', '星期三', 2024, '冬月', '十一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1808, '2024-12-12', '星期四', 2024, '冬月', '十二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1809, '2024-12-13', '星期五', 2024, '冬月', '十三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1810, '2024-12-14', '星期六', 2024, '冬月', '十四', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1811, '2024-12-15', '星期日', 2024, '冬月', '十五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1812, '2024-12-16', '星期一', 2024, '冬月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1813, '2024-12-17', '星期二', 2024, '冬月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1814, '2024-12-18', '星期三', 2024, '冬月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1815, '2024-12-19', '星期四', 2024, '冬月', '十九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1816, '2024-12-20', '星期五', 2024, '冬月', '二十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1817, '2024-12-21', '星期六', 2024, '冬月', '廿一', '甲辰', '龙', NULL, 1, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (1818, '2024-12-22', '星期日', 2024, '冬月', '廿二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1819, '2024-12-23', '星期一', 2024, '冬月', '廿三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1820, '2024-12-24', '星期二', 2024, '冬月', '廿四', '甲辰', '龙', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1821, '2024-12-25', '星期三', 2024, '冬月', '廿五', '甲辰', '龙', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1822, '2024-12-26', '星期四', 2024, '冬月', '廿六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1823, '2024-12-27', '星期五', 2024, '冬月', '廿七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1824, '2024-12-28', '星期六', 2024, '冬月', '廿八', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1825, '2024-12-29', '星期日', 2024, '冬月', '廿九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1826, '2024-12-30', '星期一', 2024, '冬月', '三十', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1827, '2024-12-31', '星期二', 2024, '腊月', '初一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1828, '2025-01-01', '星期三', 2024, '腊月', '初二', '甲辰', '龙', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1829, '2025-01-02', '星期四', 2024, '腊月', '初三', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1830, '2025-01-03', '星期五', 2024, '腊月', '初四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1831, '2025-01-04', '星期六', 2024, '腊月', '初五', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1832, '2025-01-05', '星期日', 2024, '腊月', '初六', '甲辰', '龙', NULL, 1, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (1833, '2025-01-06', '星期一', 2024, '腊月', '初七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1834, '2025-01-07', '星期二', 2024, '腊月', '初八', '甲辰', '龙', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1835, '2025-01-08', '星期三', 2024, '腊月', '初九', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1836, '2025-01-09', '星期四', 2024, '腊月', '初十 ', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1837, '2025-01-10', '星期五', 2024, '腊月', '十一', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1838, '2025-01-11', '星期六', 2024, '腊月', '十二', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1839, '2025-01-12', '星期日', 2024, '腊月', '十三', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1840, '2025-01-13', '星期一', 2024, '腊月', '十四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1841, '2025-01-14', '星期二', 2024, '腊月', '十五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1842, '2025-01-15', '星期三', 2024, '腊月', '十六', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1843, '2025-01-16', '星期四', 2024, '腊月', '十七', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1844, '2025-01-17', '星期五', 2024, '腊月', '十八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1845, '2025-01-18', '星期六', 2024, '腊月', '十九', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1846, '2025-01-19', '星期日', 2024, '腊月', '二十', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1847, '2025-01-20', '星期一', 2024, '腊月', '廿一', '甲辰', '龙', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (1848, '2025-01-21', '星期二', 2024, '腊月', '廿二', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1849, '2025-01-22', '星期三', 2024, '腊月', '廿三', '甲辰', '龙', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1850, '2025-01-23', '星期四', 2024, '腊月', '廿四', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1851, '2025-01-24', '星期五', 2024, '腊月', '廿五', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1852, '2025-01-25', '星期六', 2024, '腊月', '廿六', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1853, '2025-01-26', '星期日', 2024, '腊月', '廿七', '甲辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1854, '2025-01-27', '星期一', 2024, '腊月', '廿八', '甲辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1855, '2025-01-28', '星期二', 2024, '腊月', '廿九', '甲辰', '龙', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1856, '2025-01-29', '星期三', 2025, '正月', '初一', '乙巳', '蛇', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (1857, '2025-01-30', '星期四', 2025, '正月', '初二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1858, '2025-01-31', '星期五', 2025, '正月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1859, '2025-02-01', '星期六', 2025, '正月', '初四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1860, '2025-02-02', '星期日', 2025, '正月', '初五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1861, '2025-02-03', '星期一', 2025, '正月', '初六', '乙巳', '蛇', NULL, 0, '', '', '立春', '', 6);
INSERT INTO `base_data_holiday` VALUES (1862, '2025-02-04', '星期二', 2025, '正月', '初七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1863, '2025-02-05', '星期三', 2025, '正月', '初八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1864, '2025-02-06', '星期四', 2025, '正月', '初九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1865, '2025-02-07', '星期五', 2025, '正月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1866, '2025-02-08', '星期六', 2025, '正月', '十一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1867, '2025-02-09', '星期日', 2025, '正月', '十二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1868, '2025-02-10', '星期一', 2025, '正月', '十三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1869, '2025-02-11', '星期二', 2025, '正月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1870, '2025-02-12', '星期三', 2025, '正月', '十五', '乙巳', '蛇', NULL, 0, '', '元宵节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1871, '2025-02-13', '星期四', 2025, '正月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1872, '2025-02-14', '星期五', 2025, '正月', '十七', '乙巳', '蛇', NULL, 0, '情人节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1873, '2025-02-15', '星期六', 2025, '正月', '十八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1874, '2025-02-16', '星期日', 2025, '正月', '十九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1875, '2025-02-17', '星期一', 2025, '正月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1876, '2025-02-18', '星期二', 2025, '正月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '雨水', '', 6);
INSERT INTO `base_data_holiday` VALUES (1877, '2025-02-19', '星期三', 2025, '正月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1878, '2025-02-20', '星期四', 2025, '正月', '廿三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1879, '2025-02-21', '星期五', 2025, '正月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1880, '2025-02-22', '星期六', 2025, '正月', '廿五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1881, '2025-02-23', '星期日', 2025, '正月', '廿六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1882, '2025-02-24', '星期一', 2025, '正月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1883, '2025-02-25', '星期二', 2025, '正月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1884, '2025-02-26', '星期三', 2025, '正月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1885, '2025-02-27', '星期四', 2025, '正月', '三十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1886, '2025-02-28', '星期五', 2025, '二月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1887, '2025-03-01', '星期六', 2025, '二月', '初二', '乙巳', '蛇', NULL, 1, '', '龙抬头', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1888, '2025-03-02', '星期日', 2025, '二月', '初三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1889, '2025-03-03', '星期一', 2025, '二月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1890, '2025-03-04', '星期二', 2025, '二月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1891, '2025-03-05', '星期三', 2025, '二月', '初六', '乙巳', '蛇', NULL, 0, '', '', '惊蛰', '', 6);
INSERT INTO `base_data_holiday` VALUES (1892, '2025-03-06', '星期四', 2025, '二月', '初七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1893, '2025-03-07', '星期五', 2025, '二月', '初八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1894, '2025-03-08', '星期六', 2025, '二月', '初九', '乙巳', '蛇', NULL, 1, '妇女节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1895, '2025-03-09', '星期日', 2025, '二月', '初十 ', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1896, '2025-03-10', '星期一', 2025, '二月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1897, '2025-03-11', '星期二', 2025, '二月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1898, '2025-03-12', '星期三', 2025, '二月', '十三', '乙巳', '蛇', NULL, 0, '植树节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1899, '2025-03-13', '星期四', 2025, '二月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1900, '2025-03-14', '星期五', 2025, '二月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1901, '2025-03-15', '星期六', 2025, '二月', '十六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1902, '2025-03-16', '星期日', 2025, '二月', '十七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1903, '2025-03-17', '星期一', 2025, '二月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1904, '2025-03-18', '星期二', 2025, '二月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1905, '2025-03-19', '星期三', 2025, '二月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1906, '2025-03-20', '星期四', 2025, '二月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '春分', '', 6);
INSERT INTO `base_data_holiday` VALUES (1907, '2025-03-21', '星期五', 2025, '二月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1908, '2025-03-22', '星期六', 2025, '二月', '廿三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1909, '2025-03-23', '星期日', 2025, '二月', '廿四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1910, '2025-03-24', '星期一', 2025, '二月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1911, '2025-03-25', '星期二', 2025, '二月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1912, '2025-03-26', '星期三', 2025, '二月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1913, '2025-03-27', '星期四', 2025, '二月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1914, '2025-03-28', '星期五', 2025, '二月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1915, '2025-03-29', '星期六', 2025, '三月', '初一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1916, '2025-03-30', '星期日', 2025, '三月', '初二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1917, '2025-03-31', '星期一', 2025, '三月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1918, '2025-04-01', '星期二', 2025, '三月', '初四', '乙巳', '蛇', NULL, 0, '愚人节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1919, '2025-04-02', '星期三', 2025, '三月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1920, '2025-04-03', '星期四', 2025, '三月', '初六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1921, '2025-04-04', '星期五', 2025, '三月', '初七', '乙巳', '蛇', NULL, 0, '', '', '清明', '', 6);
INSERT INTO `base_data_holiday` VALUES (1922, '2025-04-05', '星期六', 2025, '三月', '初八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1923, '2025-04-06', '星期日', 2025, '三月', '初九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1924, '2025-04-07', '星期一', 2025, '三月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1925, '2025-04-08', '星期二', 2025, '三月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1926, '2025-04-09', '星期三', 2025, '三月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1927, '2025-04-10', '星期四', 2025, '三月', '十三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1928, '2025-04-11', '星期五', 2025, '三月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1929, '2025-04-12', '星期六', 2025, '三月', '十五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1930, '2025-04-13', '星期日', 2025, '三月', '十六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1931, '2025-04-14', '星期一', 2025, '三月', '十七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1932, '2025-04-15', '星期二', 2025, '三月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1933, '2025-04-16', '星期三', 2025, '三月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1934, '2025-04-17', '星期四', 2025, '三月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1935, '2025-04-18', '星期五', 2025, '三月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1936, '2025-04-19', '星期六', 2025, '三月', '廿二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1937, '2025-04-20', '星期日', 2025, '三月', '廿三', '乙巳', '蛇', NULL, 1, '', '', '谷雨', '', 6);
INSERT INTO `base_data_holiday` VALUES (1938, '2025-04-21', '星期一', 2025, '三月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1939, '2025-04-22', '星期二', 2025, '三月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1940, '2025-04-23', '星期三', 2025, '三月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1941, '2025-04-24', '星期四', 2025, '三月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1942, '2025-04-25', '星期五', 2025, '三月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1943, '2025-04-26', '星期六', 2025, '三月', '廿九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1944, '2025-04-27', '星期日', 2025, '三月', '三十', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1945, '2025-04-28', '星期一', 2025, '四月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1946, '2025-04-29', '星期二', 2025, '四月', '初二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1947, '2025-04-30', '星期三', 2025, '四月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1948, '2025-05-01', '星期四', 2025, '四月', '初四', '乙巳', '蛇', NULL, 0, '劳动节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1949, '2025-05-02', '星期五', 2025, '四月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1950, '2025-05-03', '星期六', 2025, '四月', '初六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1951, '2025-05-04', '星期日', 2025, '四月', '初七', '乙巳', '蛇', NULL, 1, '青年节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1952, '2025-05-05', '星期一', 2025, '四月', '初八', '乙巳', '蛇', NULL, 0, '', '', '立夏', '', 6);
INSERT INTO `base_data_holiday` VALUES (1953, '2025-05-06', '星期二', 2025, '四月', '初九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1954, '2025-05-07', '星期三', 2025, '四月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1955, '2025-05-08', '星期四', 2025, '四月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1956, '2025-05-09', '星期五', 2025, '四月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1957, '2025-05-10', '星期六', 2025, '四月', '十三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1958, '2025-05-11', '星期日', 2025, '四月', '十四', '乙巳', '蛇', NULL, 1, '', '', '', '母亲节', 6);
INSERT INTO `base_data_holiday` VALUES (1959, '2025-05-12', '星期一', 2025, '四月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1960, '2025-05-13', '星期二', 2025, '四月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1961, '2025-05-14', '星期三', 2025, '四月', '十七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1962, '2025-05-15', '星期四', 2025, '四月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1963, '2025-05-16', '星期五', 2025, '四月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1964, '2025-05-17', '星期六', 2025, '四月', '二十', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1965, '2025-05-18', '星期日', 2025, '四月', '廿一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1966, '2025-05-19', '星期一', 2025, '四月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1967, '2025-05-20', '星期二', 2025, '四月', '廿三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1968, '2025-05-21', '星期三', 2025, '四月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '小满', '', 6);
INSERT INTO `base_data_holiday` VALUES (1969, '2025-05-22', '星期四', 2025, '四月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1970, '2025-05-23', '星期五', 2025, '四月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1971, '2025-05-24', '星期六', 2025, '四月', '廿七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1972, '2025-05-25', '星期日', 2025, '四月', '廿八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1973, '2025-05-26', '星期一', 2025, '四月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1974, '2025-05-27', '星期二', 2025, '五月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1975, '2025-05-28', '星期三', 2025, '五月', '初二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1976, '2025-05-29', '星期四', 2025, '五月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1977, '2025-05-30', '星期五', 2025, '五月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1978, '2025-05-31', '星期六', 2025, '五月', '初五', '乙巳', '蛇', NULL, 1, '', '端午节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1979, '2025-06-01', '星期日', 2025, '五月', '初六', '乙巳', '蛇', NULL, 1, '儿童节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1980, '2025-06-02', '星期一', 2025, '五月', '初七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1981, '2025-06-03', '星期二', 2025, '五月', '初八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1982, '2025-06-04', '星期三', 2025, '五月', '初九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1983, '2025-06-05', '星期四', 2025, '五月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '芒种', '', 6);
INSERT INTO `base_data_holiday` VALUES (1984, '2025-06-06', '星期五', 2025, '五月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1985, '2025-06-07', '星期六', 2025, '五月', '十二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1986, '2025-06-08', '星期日', 2025, '五月', '十三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1987, '2025-06-09', '星期一', 2025, '五月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1988, '2025-06-10', '星期二', 2025, '五月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1989, '2025-06-11', '星期三', 2025, '五月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1990, '2025-06-12', '星期四', 2025, '五月', '十七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1991, '2025-06-13', '星期五', 2025, '五月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1992, '2025-06-14', '星期六', 2025, '五月', '十九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1993, '2025-06-15', '星期日', 2025, '五月', '二十', '乙巳', '蛇', NULL, 1, '', '', '', '父亲节', 6);
INSERT INTO `base_data_holiday` VALUES (1994, '2025-06-16', '星期一', 2025, '五月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1995, '2025-06-17', '星期二', 2025, '五月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1996, '2025-06-18', '星期三', 2025, '五月', '廿三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1997, '2025-06-19', '星期四', 2025, '五月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1998, '2025-06-20', '星期五', 2025, '五月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (1999, '2025-06-21', '星期六', 2025, '五月', '廿六', '乙巳', '蛇', NULL, 1, '', '', '夏至', '', 6);
INSERT INTO `base_data_holiday` VALUES (2000, '2025-06-22', '星期日', 2025, '五月', '廿七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2001, '2025-06-23', '星期一', 2025, '五月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2002, '2025-06-24', '星期二', 2025, '五月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2003, '2025-06-25', '星期三', 2025, '六月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2004, '2025-06-26', '星期四', 2025, '六月', '初二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2005, '2025-06-27', '星期五', 2025, '六月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2006, '2025-06-28', '星期六', 2025, '六月', '初四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2007, '2025-06-29', '星期日', 2025, '六月', '初五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2008, '2025-06-30', '星期一', 2025, '六月', '初六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2009, '2025-07-01', '星期二', 2025, '六月', '初七', '乙巳', '蛇', NULL, 0, '建党节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2010, '2025-07-02', '星期三', 2025, '六月', '初八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2011, '2025-07-03', '星期四', 2025, '六月', '初九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2012, '2025-07-04', '星期五', 2025, '六月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2013, '2025-07-05', '星期六', 2025, '六月', '十一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2014, '2025-07-06', '星期日', 2025, '六月', '十二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2015, '2025-07-07', '星期一', 2025, '六月', '十三', '乙巳', '蛇', NULL, 0, '', '', '小暑', '', 6);
INSERT INTO `base_data_holiday` VALUES (2016, '2025-07-08', '星期二', 2025, '六月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2017, '2025-07-09', '星期三', 2025, '六月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2018, '2025-07-10', '星期四', 2025, '六月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2019, '2025-07-11', '星期五', 2025, '六月', '十七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2020, '2025-07-12', '星期六', 2025, '六月', '十八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2021, '2025-07-13', '星期日', 2025, '六月', '十九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2022, '2025-07-14', '星期一', 2025, '六月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2023, '2025-07-15', '星期二', 2025, '六月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2024, '2025-07-16', '星期三', 2025, '六月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2025, '2025-07-17', '星期四', 2025, '六月', '廿三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2026, '2025-07-18', '星期五', 2025, '六月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2027, '2025-07-19', '星期六', 2025, '六月', '廿五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2028, '2025-07-20', '星期日', 2025, '六月', '廿六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2029, '2025-07-21', '星期一', 2025, '六月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2030, '2025-07-22', '星期二', 2025, '六月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '大暑', '', 6);
INSERT INTO `base_data_holiday` VALUES (2031, '2025-07-23', '星期三', 2025, '六月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2032, '2025-07-24', '星期四', 2025, '六月', '三十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2033, '2025-07-25', '星期五', 2025, '闰六月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2034, '2025-07-26', '星期六', 2025, '闰六月', '初二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2035, '2025-07-27', '星期日', 2025, '闰六月', '初三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2036, '2025-07-28', '星期一', 2025, '闰六月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2037, '2025-07-29', '星期二', 2025, '闰六月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2038, '2025-07-30', '星期三', 2025, '闰六月', '初六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2039, '2025-07-31', '星期四', 2025, '闰六月', '初七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2040, '2025-08-01', '星期五', 2025, '闰六月', '初八', '乙巳', '蛇', NULL, 0, '建军节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2041, '2025-08-02', '星期六', 2025, '闰六月', '初九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2042, '2025-08-03', '星期日', 2025, '闰六月', '初十 ', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2043, '2025-08-04', '星期一', 2025, '闰六月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2044, '2025-08-05', '星期二', 2025, '闰六月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2045, '2025-08-06', '星期三', 2025, '闰六月', '十三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2046, '2025-08-07', '星期四', 2025, '闰六月', '十四', '乙巳', '蛇', NULL, 0, '', '', '立秋', '', 6);
INSERT INTO `base_data_holiday` VALUES (2047, '2025-08-08', '星期五', 2025, '闰六月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2048, '2025-08-09', '星期六', 2025, '闰六月', '十六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2049, '2025-08-10', '星期日', 2025, '闰六月', '十七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2050, '2025-08-11', '星期一', 2025, '闰六月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2051, '2025-08-12', '星期二', 2025, '闰六月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2052, '2025-08-13', '星期三', 2025, '闰六月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2053, '2025-08-14', '星期四', 2025, '闰六月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2054, '2025-08-15', '星期五', 2025, '闰六月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2055, '2025-08-16', '星期六', 2025, '闰六月', '廿三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2056, '2025-08-17', '星期日', 2025, '闰六月', '廿四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2057, '2025-08-18', '星期一', 2025, '闰六月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2058, '2025-08-19', '星期二', 2025, '闰六月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2059, '2025-08-20', '星期三', 2025, '闰六月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2060, '2025-08-21', '星期四', 2025, '闰六月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2061, '2025-08-22', '星期五', 2025, '闰六月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2062, '2025-08-23', '星期六', 2025, '七月', '初一', '乙巳', '蛇', NULL, 1, '', '', '处暑', '', 6);
INSERT INTO `base_data_holiday` VALUES (2063, '2025-08-24', '星期日', 2025, '七月', '初二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2064, '2025-08-25', '星期一', 2025, '七月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2065, '2025-08-26', '星期二', 2025, '七月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2066, '2025-08-27', '星期三', 2025, '七月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2067, '2025-08-28', '星期四', 2025, '七月', '初六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2068, '2025-08-29', '星期五', 2025, '七月', '初七', '乙巳', '蛇', NULL, 0, '', '七夕', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2069, '2025-08-30', '星期六', 2025, '七月', '初八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2070, '2025-08-31', '星期日', 2025, '七月', '初九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2071, '2025-09-01', '星期一', 2025, '七月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2072, '2025-09-02', '星期二', 2025, '七月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2073, '2025-09-03', '星期三', 2025, '七月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2074, '2025-09-04', '星期四', 2025, '七月', '十三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2075, '2025-09-05', '星期五', 2025, '七月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2076, '2025-09-06', '星期六', 2025, '七月', '十五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2077, '2025-09-07', '星期日', 2025, '七月', '十六', '乙巳', '蛇', NULL, 1, '', '', '白露', '', 6);
INSERT INTO `base_data_holiday` VALUES (2078, '2025-09-08', '星期一', 2025, '七月', '十七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2079, '2025-09-09', '星期二', 2025, '七月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2080, '2025-09-10', '星期三', 2025, '七月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2081, '2025-09-11', '星期四', 2025, '七月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2082, '2025-09-12', '星期五', 2025, '七月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2083, '2025-09-13', '星期六', 2025, '七月', '廿二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2084, '2025-09-14', '星期日', 2025, '七月', '廿三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2085, '2025-09-15', '星期一', 2025, '七月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2086, '2025-09-16', '星期二', 2025, '七月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2087, '2025-09-17', '星期三', 2025, '七月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2088, '2025-09-18', '星期四', 2025, '七月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2089, '2025-09-19', '星期五', 2025, '七月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2090, '2025-09-20', '星期六', 2025, '七月', '廿九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2091, '2025-09-21', '星期日', 2025, '七月', '三十', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2092, '2025-09-22', '星期一', 2025, '八月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2093, '2025-09-23', '星期二', 2025, '八月', '初二', '乙巳', '蛇', NULL, 0, '农民丰收节', '', '秋分', '', 6);
INSERT INTO `base_data_holiday` VALUES (2094, '2025-09-24', '星期三', 2025, '八月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2095, '2025-09-25', '星期四', 2025, '八月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2096, '2025-09-26', '星期五', 2025, '八月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2097, '2025-09-27', '星期六', 2025, '八月', '初六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2098, '2025-09-28', '星期日', 2025, '八月', '初七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2099, '2025-09-29', '星期一', 2025, '八月', '初八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2100, '2025-09-30', '星期二', 2025, '八月', '初九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2101, '2025-10-01', '星期三', 2025, '八月', '初十 ', '乙巳', '蛇', NULL, 0, '国庆节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2102, '2025-10-02', '星期四', 2025, '八月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2103, '2025-10-03', '星期五', 2025, '八月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2104, '2025-10-04', '星期六', 2025, '八月', '十三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2105, '2025-10-05', '星期日', 2025, '八月', '十四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2106, '2025-10-06', '星期一', 2025, '八月', '十五', '乙巳', '蛇', NULL, 0, '', '中秋节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2107, '2025-10-07', '星期二', 2025, '八月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2108, '2025-10-08', '星期三', 2025, '八月', '十七', '乙巳', '蛇', NULL, 0, '', '', '寒露', '', 6);
INSERT INTO `base_data_holiday` VALUES (2109, '2025-10-09', '星期四', 2025, '八月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2110, '2025-10-10', '星期五', 2025, '八月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2111, '2025-10-11', '星期六', 2025, '八月', '二十', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2112, '2025-10-12', '星期日', 2025, '八月', '廿一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2113, '2025-10-13', '星期一', 2025, '八月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2114, '2025-10-14', '星期二', 2025, '八月', '廿三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2115, '2025-10-15', '星期三', 2025, '八月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2116, '2025-10-16', '星期四', 2025, '八月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2117, '2025-10-17', '星期五', 2025, '八月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2118, '2025-10-18', '星期六', 2025, '八月', '廿七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2119, '2025-10-19', '星期日', 2025, '八月', '廿八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2120, '2025-10-20', '星期一', 2025, '八月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2121, '2025-10-21', '星期二', 2025, '九月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2122, '2025-10-22', '星期三', 2025, '九月', '初二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2123, '2025-10-23', '星期四', 2025, '九月', '初三', '乙巳', '蛇', NULL, 0, '', '', '霜降', '', 6);
INSERT INTO `base_data_holiday` VALUES (2124, '2025-10-24', '星期五', 2025, '九月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2125, '2025-10-25', '星期六', 2025, '九月', '初五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2126, '2025-10-26', '星期日', 2025, '九月', '初六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2127, '2025-10-27', '星期一', 2025, '九月', '初七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2128, '2025-10-28', '星期二', 2025, '九月', '初八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2129, '2025-10-29', '星期三', 2025, '九月', '初九', '乙巳', '蛇', NULL, 0, '', '重阳节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2130, '2025-10-30', '星期四', 2025, '九月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2131, '2025-10-31', '星期五', 2025, '九月', '十一', '乙巳', '蛇', NULL, 0, '万圣节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2132, '2025-11-01', '星期六', 2025, '九月', '十二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2133, '2025-11-02', '星期日', 2025, '九月', '十三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2134, '2025-11-03', '星期一', 2025, '九月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2135, '2025-11-04', '星期二', 2025, '九月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2136, '2025-11-05', '星期三', 2025, '九月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2137, '2025-11-06', '星期四', 2025, '九月', '十七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2138, '2025-11-07', '星期五', 2025, '九月', '十八', '乙巳', '蛇', NULL, 0, '', '', '立冬', '', 6);
INSERT INTO `base_data_holiday` VALUES (2139, '2025-11-08', '星期六', 2025, '九月', '十九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2140, '2025-11-09', '星期日', 2025, '九月', '二十', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2141, '2025-11-10', '星期一', 2025, '九月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2142, '2025-11-11', '星期二', 2025, '九月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2143, '2025-11-12', '星期三', 2025, '九月', '廿三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2144, '2025-11-13', '星期四', 2025, '九月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2145, '2025-11-14', '星期五', 2025, '九月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2146, '2025-11-15', '星期六', 2025, '九月', '廿六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2147, '2025-11-16', '星期日', 2025, '九月', '廿七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2148, '2025-11-17', '星期一', 2025, '九月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2149, '2025-11-18', '星期二', 2025, '九月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2150, '2025-11-19', '星期三', 2025, '九月', '三十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2151, '2025-11-20', '星期四', 2025, '十月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2152, '2025-11-21', '星期五', 2025, '十月', '初二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2153, '2025-11-22', '星期六', 2025, '十月', '初三', '乙巳', '蛇', NULL, 1, '', '', '小雪', '', 6);
INSERT INTO `base_data_holiday` VALUES (2154, '2025-11-23', '星期日', 2025, '十月', '初四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2155, '2025-11-24', '星期一', 2025, '十月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2156, '2025-11-25', '星期二', 2025, '十月', '初六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2157, '2025-11-26', '星期三', 2025, '十月', '初七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2158, '2025-11-27', '星期四', 2025, '十月', '初八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2159, '2025-11-28', '星期五', 2025, '十月', '初九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2160, '2025-11-29', '星期六', 2025, '十月', '初十 ', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2161, '2025-11-30', '星期日', 2025, '十月', '十一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2162, '2025-12-01', '星期一', 2025, '十月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2163, '2025-12-02', '星期二', 2025, '十月', '十三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2164, '2025-12-03', '星期三', 2025, '十月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2165, '2025-12-04', '星期四', 2025, '十月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2166, '2025-12-05', '星期五', 2025, '十月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2167, '2025-12-06', '星期六', 2025, '十月', '十七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2168, '2025-12-07', '星期日', 2025, '十月', '十八', '乙巳', '蛇', NULL, 1, '', '', '大雪', '', 6);
INSERT INTO `base_data_holiday` VALUES (2169, '2025-12-08', '星期一', 2025, '十月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2170, '2025-12-09', '星期二', 2025, '十月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2171, '2025-12-10', '星期三', 2025, '十月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2172, '2025-12-11', '星期四', 2025, '十月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2173, '2025-12-12', '星期五', 2025, '十月', '廿三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2174, '2025-12-13', '星期六', 2025, '十月', '廿四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2175, '2025-12-14', '星期日', 2025, '十月', '廿五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2176, '2025-12-15', '星期一', 2025, '十月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2177, '2025-12-16', '星期二', 2025, '十月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2178, '2025-12-17', '星期三', 2025, '十月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2179, '2025-12-18', '星期四', 2025, '十月', '廿九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2180, '2025-12-19', '星期五', 2025, '十月', '三十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2181, '2025-12-20', '星期六', 2025, '冬月', '初一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2182, '2025-12-21', '星期日', 2025, '冬月', '初二', '乙巳', '蛇', NULL, 1, '', '', '冬至', '', 6);
INSERT INTO `base_data_holiday` VALUES (2183, '2025-12-22', '星期一', 2025, '冬月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2184, '2025-12-23', '星期二', 2025, '冬月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2185, '2025-12-24', '星期三', 2025, '冬月', '初五', '乙巳', '蛇', NULL, 0, '平安夜', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2186, '2025-12-25', '星期四', 2025, '冬月', '初六', '乙巳', '蛇', NULL, 0, '圣诞节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2187, '2025-12-26', '星期五', 2025, '冬月', '初七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2188, '2025-12-27', '星期六', 2025, '冬月', '初八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2189, '2025-12-28', '星期日', 2025, '冬月', '初九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2190, '2025-12-29', '星期一', 2025, '冬月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2191, '2025-12-30', '星期二', 2025, '冬月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2192, '2025-12-31', '星期三', 2025, '冬月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2193, '2026-01-01', '星期四', 2025, '冬月', '十三', '乙巳', '蛇', NULL, 0, '元旦', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2194, '2026-01-02', '星期五', 2025, '冬月', '十四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2195, '2026-01-03', '星期六', 2025, '冬月', '十五', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2196, '2026-01-04', '星期日', 2025, '冬月', '十六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2197, '2026-01-05', '星期一', 2025, '冬月', '十七', '乙巳', '蛇', NULL, 0, '', '', '小寒', '', 6);
INSERT INTO `base_data_holiday` VALUES (2198, '2026-01-06', '星期二', 2025, '冬月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2199, '2026-01-07', '星期三', 2025, '冬月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2200, '2026-01-08', '星期四', 2025, '冬月', '二十', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2201, '2026-01-09', '星期五', 2025, '冬月', '廿一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2202, '2026-01-10', '星期六', 2025, '冬月', '廿二', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2203, '2026-01-11', '星期日', 2025, '冬月', '廿三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2204, '2026-01-12', '星期一', 2025, '冬月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2205, '2026-01-13', '星期二', 2025, '冬月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2206, '2026-01-14', '星期三', 2025, '冬月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2207, '2026-01-15', '星期四', 2025, '冬月', '廿七', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2208, '2026-01-16', '星期五', 2025, '冬月', '廿八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2209, '2026-01-17', '星期六', 2025, '冬月', '廿九', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2210, '2026-01-18', '星期日', 2025, '冬月', '三十', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2211, '2026-01-19', '星期一', 2025, '腊月', '初一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2212, '2026-01-20', '星期二', 2025, '腊月', '初二', '乙巳', '蛇', NULL, 0, '', '', '大寒', '', 6);
INSERT INTO `base_data_holiday` VALUES (2213, '2026-01-21', '星期三', 2025, '腊月', '初三', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2214, '2026-01-22', '星期四', 2025, '腊月', '初四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2215, '2026-01-23', '星期五', 2025, '腊月', '初五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2216, '2026-01-24', '星期六', 2025, '腊月', '初六', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2217, '2026-01-25', '星期日', 2025, '腊月', '初七', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2218, '2026-01-26', '星期一', 2025, '腊月', '初八', '乙巳', '蛇', NULL, 0, '', '腊八节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2219, '2026-01-27', '星期二', 2025, '腊月', '初九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2220, '2026-01-28', '星期三', 2025, '腊月', '初十 ', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2221, '2026-01-29', '星期四', 2025, '腊月', '十一', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2222, '2026-01-30', '星期五', 2025, '腊月', '十二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2223, '2026-01-31', '星期六', 2025, '腊月', '十三', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2224, '2026-02-01', '星期日', 2025, '腊月', '十四', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2225, '2026-02-02', '星期一', 2025, '腊月', '十五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2226, '2026-02-03', '星期二', 2025, '腊月', '十六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2227, '2026-02-04', '星期三', 2025, '腊月', '十七', '乙巳', '蛇', NULL, 0, '', '', '立春', '', 6);
INSERT INTO `base_data_holiday` VALUES (2228, '2026-02-05', '星期四', 2025, '腊月', '十八', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2229, '2026-02-06', '星期五', 2025, '腊月', '十九', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2230, '2026-02-07', '星期六', 2025, '腊月', '二十', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2231, '2026-02-08', '星期日', 2025, '腊月', '廿一', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2232, '2026-02-09', '星期一', 2025, '腊月', '廿二', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2233, '2026-02-10', '星期二', 2025, '腊月', '廿三', '乙巳', '蛇', NULL, 0, '', '小年', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2234, '2026-02-11', '星期三', 2025, '腊月', '廿四', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2235, '2026-02-12', '星期四', 2025, '腊月', '廿五', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2236, '2026-02-13', '星期五', 2025, '腊月', '廿六', '乙巳', '蛇', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2237, '2026-02-14', '星期六', 2025, '腊月', '廿七', '乙巳', '蛇', NULL, 1, '情人节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2238, '2026-02-15', '星期日', 2025, '腊月', '廿八', '乙巳', '蛇', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2239, '2026-02-16', '星期一', 2025, '腊月', '廿九', '乙巳', '蛇', NULL, 0, '', '除夕', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (2240, '2026-02-17', '星期二', 2026, '正月', '初一', '丙午', '马', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2241, '2026-02-18', '星期三', 2026, '正月', '初二', '丙午', '马', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (2242, '2026-02-19', '星期四', 2026, '正月', '初三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2243, '2026-02-20', '星期五', 2026, '正月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2244, '2026-02-21', '星期六', 2026, '正月', '初五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2245, '2026-02-22', '星期日', 2026, '正月', '初六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2246, '2026-02-23', '星期一', 2026, '正月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2247, '2026-02-24', '星期二', 2026, '正月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2248, '2026-02-25', '星期三', 2026, '正月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2249, '2026-02-26', '星期四', 2026, '正月', '初十 ', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2250, '2026-02-27', '星期五', 2026, '正月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2251, '2026-02-28', '星期六', 2026, '正月', '十二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2252, '2026-03-01', '星期日', 2026, '正月', '十三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2253, '2026-03-02', '星期一', 2026, '正月', '十四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2254, '2026-03-03', '星期二', 2026, '正月', '十五', '丙午', '马', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2255, '2026-03-04', '星期三', 2026, '正月', '十六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2256, '2026-03-05', '星期四', 2026, '正月', '十七', '丙午', '马', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (2257, '2026-03-06', '星期五', 2026, '正月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2258, '2026-03-07', '星期六', 2026, '正月', '十九', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2259, '2026-03-08', '星期日', 2026, '正月', '二十', '丙午', '马', NULL, 1, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2260, '2026-03-09', '星期一', 2026, '正月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2261, '2026-03-10', '星期二', 2026, '正月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2262, '2026-03-11', '星期三', 2026, '正月', '廿三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2263, '2026-03-12', '星期四', 2026, '正月', '廿四', '丙午', '马', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2264, '2026-03-13', '星期五', 2026, '正月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2265, '2026-03-14', '星期六', 2026, '正月', '廿六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2266, '2026-03-15', '星期日', 2026, '正月', '廿七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2267, '2026-03-16', '星期一', 2026, '正月', '廿八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2268, '2026-03-17', '星期二', 2026, '正月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2269, '2026-03-18', '星期三', 2026, '正月', '三十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2270, '2026-03-19', '星期四', 2026, '二月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2271, '2026-03-20', '星期五', 2026, '二月', '初二', '丙午', '马', NULL, 0, '', '龙抬头', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (2272, '2026-03-21', '星期六', 2026, '二月', '初三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2273, '2026-03-22', '星期日', 2026, '二月', '初四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2274, '2026-03-23', '星期一', 2026, '二月', '初五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2275, '2026-03-24', '星期二', 2026, '二月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2276, '2026-03-25', '星期三', 2026, '二月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2277, '2026-03-26', '星期四', 2026, '二月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2278, '2026-03-27', '星期五', 2026, '二月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2279, '2026-03-28', '星期六', 2026, '二月', '初十 ', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2280, '2026-03-29', '星期日', 2026, '二月', '十一', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2281, '2026-03-30', '星期一', 2026, '二月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2282, '2026-03-31', '星期二', 2026, '二月', '十三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2283, '2026-04-01', '星期三', 2026, '二月', '十四', '丙午', '马', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2284, '2026-04-02', '星期四', 2026, '二月', '十五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2285, '2026-04-03', '星期五', 2026, '二月', '十六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2286, '2026-04-04', '星期六', 2026, '二月', '十七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2287, '2026-04-05', '星期日', 2026, '二月', '十八', '丙午', '马', NULL, 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (2288, '2026-04-06', '星期一', 2026, '二月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2289, '2026-04-07', '星期二', 2026, '二月', '二十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2290, '2026-04-08', '星期三', 2026, '二月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2291, '2026-04-09', '星期四', 2026, '二月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2292, '2026-04-10', '星期五', 2026, '二月', '廿三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2293, '2026-04-11', '星期六', 2026, '二月', '廿四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2294, '2026-04-12', '星期日', 2026, '二月', '廿五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2295, '2026-04-13', '星期一', 2026, '二月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2296, '2026-04-14', '星期二', 2026, '二月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2297, '2026-04-15', '星期三', 2026, '二月', '廿八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2298, '2026-04-16', '星期四', 2026, '二月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2299, '2026-04-17', '星期五', 2026, '三月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2300, '2026-04-18', '星期六', 2026, '三月', '初二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2301, '2026-04-19', '星期日', 2026, '三月', '初三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2302, '2026-04-20', '星期一', 2026, '三月', '初四', '丙午', '马', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (2303, '2026-04-21', '星期二', 2026, '三月', '初五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2304, '2026-04-22', '星期三', 2026, '三月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2305, '2026-04-23', '星期四', 2026, '三月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2306, '2026-04-24', '星期五', 2026, '三月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2307, '2026-04-25', '星期六', 2026, '三月', '初九', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2308, '2026-04-26', '星期日', 2026, '三月', '初十 ', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2309, '2026-04-27', '星期一', 2026, '三月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2310, '2026-04-28', '星期二', 2026, '三月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2311, '2026-04-29', '星期三', 2026, '三月', '十三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2312, '2026-04-30', '星期四', 2026, '三月', '十四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2313, '2026-05-01', '星期五', 2026, '三月', '十五', '丙午', '马', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2314, '2026-05-02', '星期六', 2026, '三月', '十六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2315, '2026-05-03', '星期日', 2026, '三月', '十七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2316, '2026-05-04', '星期一', 2026, '三月', '十八', '丙午', '马', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2317, '2026-05-05', '星期二', 2026, '三月', '十九', '丙午', '马', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (2318, '2026-05-06', '星期三', 2026, '三月', '二十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2319, '2026-05-07', '星期四', 2026, '三月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2320, '2026-05-08', '星期五', 2026, '三月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2321, '2026-05-09', '星期六', 2026, '三月', '廿三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2322, '2026-05-10', '星期日', 2026, '三月', '廿四', '丙午', '马', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (2323, '2026-05-11', '星期一', 2026, '三月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2324, '2026-05-12', '星期二', 2026, '三月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2325, '2026-05-13', '星期三', 2026, '三月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2326, '2026-05-14', '星期四', 2026, '三月', '廿八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2327, '2026-05-15', '星期五', 2026, '三月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2328, '2026-05-16', '星期六', 2026, '三月', '三十', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2329, '2026-05-17', '星期日', 2026, '四月', '初一', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2330, '2026-05-18', '星期一', 2026, '四月', '初二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2331, '2026-05-19', '星期二', 2026, '四月', '初三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2332, '2026-05-20', '星期三', 2026, '四月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2333, '2026-05-21', '星期四', 2026, '四月', '初五', '丙午', '马', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (2334, '2026-05-22', '星期五', 2026, '四月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2335, '2026-05-23', '星期六', 2026, '四月', '初七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2336, '2026-05-24', '星期日', 2026, '四月', '初八', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2337, '2026-05-25', '星期一', 2026, '四月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2338, '2026-05-26', '星期二', 2026, '四月', '初十 ', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2339, '2026-05-27', '星期三', 2026, '四月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2340, '2026-05-28', '星期四', 2026, '四月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2341, '2026-05-29', '星期五', 2026, '四月', '十三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2342, '2026-05-30', '星期六', 2026, '四月', '十四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2343, '2026-05-31', '星期日', 2026, '四月', '十五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2344, '2026-06-01', '星期一', 2026, '四月', '十六', '丙午', '马', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2345, '2026-06-02', '星期二', 2026, '四月', '十七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2346, '2026-06-03', '星期三', 2026, '四月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2347, '2026-06-04', '星期四', 2026, '四月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2348, '2026-06-05', '星期五', 2026, '四月', '二十', '丙午', '马', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (2349, '2026-06-06', '星期六', 2026, '四月', '廿一', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2350, '2026-06-07', '星期日', 2026, '四月', '廿二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2351, '2026-06-08', '星期一', 2026, '四月', '廿三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2352, '2026-06-09', '星期二', 2026, '四月', '廿四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2353, '2026-06-10', '星期三', 2026, '四月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2354, '2026-06-11', '星期四', 2026, '四月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2355, '2026-06-12', '星期五', 2026, '四月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2356, '2026-06-13', '星期六', 2026, '四月', '廿八', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2357, '2026-06-14', '星期日', 2026, '四月', '廿九', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2358, '2026-06-15', '星期一', 2026, '五月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2359, '2026-06-16', '星期二', 2026, '五月', '初二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2360, '2026-06-17', '星期三', 2026, '五月', '初三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2361, '2026-06-18', '星期四', 2026, '五月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2362, '2026-06-19', '星期五', 2026, '五月', '初五', '丙午', '马', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2363, '2026-06-20', '星期六', 2026, '五月', '初六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2364, '2026-06-21', '星期日', 2026, '五月', '初七', '丙午', '马', NULL, 1, '', '', '夏至', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (2365, '2026-06-22', '星期一', 2026, '五月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2366, '2026-06-23', '星期二', 2026, '五月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2367, '2026-06-24', '星期三', 2026, '五月', '初十 ', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2368, '2026-06-25', '星期四', 2026, '五月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2369, '2026-06-26', '星期五', 2026, '五月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2370, '2026-06-27', '星期六', 2026, '五月', '十三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2371, '2026-06-28', '星期日', 2026, '五月', '十四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2372, '2026-06-29', '星期一', 2026, '五月', '十五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2373, '2026-06-30', '星期二', 2026, '五月', '十六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2374, '2026-07-01', '星期三', 2026, '五月', '十七', '丙午', '马', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2375, '2026-07-02', '星期四', 2026, '五月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2376, '2026-07-03', '星期五', 2026, '五月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2377, '2026-07-04', '星期六', 2026, '五月', '二十', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2378, '2026-07-05', '星期日', 2026, '五月', '廿一', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2379, '2026-07-06', '星期一', 2026, '五月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2380, '2026-07-07', '星期二', 2026, '五月', '廿三', '丙午', '马', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (2381, '2026-07-08', '星期三', 2026, '五月', '廿四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2382, '2026-07-09', '星期四', 2026, '五月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2383, '2026-07-10', '星期五', 2026, '五月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2384, '2026-07-11', '星期六', 2026, '五月', '廿七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2385, '2026-07-12', '星期日', 2026, '五月', '廿八', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2386, '2026-07-13', '星期一', 2026, '五月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2387, '2026-07-14', '星期二', 2026, '六月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2388, '2026-07-15', '星期三', 2026, '六月', '初二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2389, '2026-07-16', '星期四', 2026, '六月', '初三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2390, '2026-07-17', '星期五', 2026, '六月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2391, '2026-07-18', '星期六', 2026, '六月', '初五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2392, '2026-07-19', '星期日', 2026, '六月', '初六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2393, '2026-07-20', '星期一', 2026, '六月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2394, '2026-07-21', '星期二', 2026, '六月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2395, '2026-07-22', '星期三', 2026, '六月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2396, '2026-07-23', '星期四', 2026, '六月', '初十 ', '丙午', '马', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (2397, '2026-07-24', '星期五', 2026, '六月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2398, '2026-07-25', '星期六', 2026, '六月', '十二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2399, '2026-07-26', '星期日', 2026, '六月', '十三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2400, '2026-07-27', '星期一', 2026, '六月', '十四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2401, '2026-07-28', '星期二', 2026, '六月', '十五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2402, '2026-07-29', '星期三', 2026, '六月', '十六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2403, '2026-07-30', '星期四', 2026, '六月', '十七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2404, '2026-07-31', '星期五', 2026, '六月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2405, '2026-08-01', '星期六', 2026, '六月', '十九', '丙午', '马', NULL, 1, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2406, '2026-08-02', '星期日', 2026, '六月', '二十', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2407, '2026-08-03', '星期一', 2026, '六月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2408, '2026-08-04', '星期二', 2026, '六月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2409, '2026-08-05', '星期三', 2026, '六月', '廿三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2410, '2026-08-06', '星期四', 2026, '六月', '廿四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2411, '2026-08-07', '星期五', 2026, '六月', '廿五', '丙午', '马', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (2412, '2026-08-08', '星期六', 2026, '六月', '廿六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2413, '2026-08-09', '星期日', 2026, '六月', '廿七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2414, '2026-08-10', '星期一', 2026, '六月', '廿八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2415, '2026-08-11', '星期二', 2026, '六月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2416, '2026-08-12', '星期三', 2026, '六月', '三十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2417, '2026-08-13', '星期四', 2026, '七月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2418, '2026-08-14', '星期五', 2026, '七月', '初二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2419, '2026-08-15', '星期六', 2026, '七月', '初三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2420, '2026-08-16', '星期日', 2026, '七月', '初四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2421, '2026-08-17', '星期一', 2026, '七月', '初五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2422, '2026-08-18', '星期二', 2026, '七月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2423, '2026-08-19', '星期三', 2026, '七月', '初七', '丙午', '马', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2424, '2026-08-20', '星期四', 2026, '七月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2425, '2026-08-21', '星期五', 2026, '七月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2426, '2026-08-22', '星期六', 2026, '七月', '初十 ', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2427, '2026-08-23', '星期日', 2026, '七月', '十一', '丙午', '马', NULL, 1, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (2428, '2026-08-24', '星期一', 2026, '七月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2429, '2026-08-25', '星期二', 2026, '七月', '十三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2430, '2026-08-26', '星期三', 2026, '七月', '十四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2431, '2026-08-27', '星期四', 2026, '七月', '十五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2432, '2026-08-28', '星期五', 2026, '七月', '十六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2433, '2026-08-29', '星期六', 2026, '七月', '十七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2434, '2026-08-30', '星期日', 2026, '七月', '十八', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2435, '2026-08-31', '星期一', 2026, '七月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2436, '2026-09-01', '星期二', 2026, '七月', '二十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2437, '2026-09-02', '星期三', 2026, '七月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2438, '2026-09-03', '星期四', 2026, '七月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2439, '2026-09-04', '星期五', 2026, '七月', '廿三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2440, '2026-09-05', '星期六', 2026, '七月', '廿四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2441, '2026-09-06', '星期日', 2026, '七月', '廿五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2442, '2026-09-07', '星期一', 2026, '七月', '廿六', '丙午', '马', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (2443, '2026-09-08', '星期二', 2026, '七月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2444, '2026-09-09', '星期三', 2026, '七月', '廿八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2445, '2026-09-10', '星期四', 2026, '七月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2446, '2026-09-11', '星期五', 2026, '八月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2447, '2026-09-12', '星期六', 2026, '八月', '初二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2448, '2026-09-13', '星期日', 2026, '八月', '初三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2449, '2026-09-14', '星期一', 2026, '八月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2450, '2026-09-15', '星期二', 2026, '八月', '初五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2451, '2026-09-16', '星期三', 2026, '八月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2452, '2026-09-17', '星期四', 2026, '八月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2453, '2026-09-18', '星期五', 2026, '八月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2454, '2026-09-19', '星期六', 2026, '八月', '初九', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2455, '2026-09-20', '星期日', 2026, '八月', '初十 ', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2456, '2026-09-21', '星期一', 2026, '八月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2457, '2026-09-22', '星期二', 2026, '八月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2458, '2026-09-23', '星期三', 2026, '八月', '十三', '丙午', '马', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (2459, '2026-09-24', '星期四', 2026, '八月', '十四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2460, '2026-09-25', '星期五', 2026, '八月', '十五', '丙午', '马', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2461, '2026-09-26', '星期六', 2026, '八月', '十六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2462, '2026-09-27', '星期日', 2026, '八月', '十七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2463, '2026-09-28', '星期一', 2026, '八月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2464, '2026-09-29', '星期二', 2026, '八月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2465, '2026-09-30', '星期三', 2026, '八月', '二十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2466, '2026-10-01', '星期四', 2026, '八月', '廿一', '丙午', '马', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2467, '2026-10-02', '星期五', 2026, '八月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2468, '2026-10-03', '星期六', 2026, '八月', '廿三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2469, '2026-10-04', '星期日', 2026, '八月', '廿四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2470, '2026-10-05', '星期一', 2026, '八月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2471, '2026-10-06', '星期二', 2026, '八月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2472, '2026-10-07', '星期三', 2026, '八月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2473, '2026-10-08', '星期四', 2026, '八月', '廿八', '丙午', '马', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (2474, '2026-10-09', '星期五', 2026, '八月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2475, '2026-10-10', '星期六', 2026, '九月', '初一', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2476, '2026-10-11', '星期日', 2026, '九月', '初二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2477, '2026-10-12', '星期一', 2026, '九月', '初三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2478, '2026-10-13', '星期二', 2026, '九月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2479, '2026-10-14', '星期三', 2026, '九月', '初五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2480, '2026-10-15', '星期四', 2026, '九月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2481, '2026-10-16', '星期五', 2026, '九月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2482, '2026-10-17', '星期六', 2026, '九月', '初八', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2483, '2026-10-18', '星期日', 2026, '九月', '初九', '丙午', '马', NULL, 1, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2484, '2026-10-19', '星期一', 2026, '九月', '初十 ', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2485, '2026-10-20', '星期二', 2026, '九月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2486, '2026-10-21', '星期三', 2026, '九月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2487, '2026-10-22', '星期四', 2026, '九月', '十三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2488, '2026-10-23', '星期五', 2026, '九月', '十四', '丙午', '马', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (2489, '2026-10-24', '星期六', 2026, '九月', '十五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2490, '2026-10-25', '星期日', 2026, '九月', '十六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2491, '2026-10-26', '星期一', 2026, '九月', '十七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2492, '2026-10-27', '星期二', 2026, '九月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2493, '2026-10-28', '星期三', 2026, '九月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2494, '2026-10-29', '星期四', 2026, '九月', '二十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2495, '2026-10-30', '星期五', 2026, '九月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2496, '2026-10-31', '星期六', 2026, '九月', '廿二', '丙午', '马', NULL, 1, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2497, '2026-11-01', '星期日', 2026, '九月', '廿三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2498, '2026-11-02', '星期一', 2026, '九月', '廿四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2499, '2026-11-03', '星期二', 2026, '九月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2500, '2026-11-04', '星期三', 2026, '九月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2501, '2026-11-05', '星期四', 2026, '九月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2502, '2026-11-06', '星期五', 2026, '九月', '廿八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2503, '2026-11-07', '星期六', 2026, '九月', '廿九', '丙午', '马', NULL, 1, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (2504, '2026-11-08', '星期日', 2026, '九月', '三十', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2505, '2026-11-09', '星期一', 2026, '十月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2506, '2026-11-10', '星期二', 2026, '十月', '初二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2507, '2026-11-11', '星期三', 2026, '十月', '初三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2508, '2026-11-12', '星期四', 2026, '十月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2509, '2026-11-13', '星期五', 2026, '十月', '初五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2510, '2026-11-14', '星期六', 2026, '十月', '初六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2511, '2026-11-15', '星期日', 2026, '十月', '初七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2512, '2026-11-16', '星期一', 2026, '十月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2513, '2026-11-17', '星期二', 2026, '十月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2514, '2026-11-18', '星期三', 2026, '十月', '初十 ', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2515, '2026-11-19', '星期四', 2026, '十月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2516, '2026-11-20', '星期五', 2026, '十月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2517, '2026-11-21', '星期六', 2026, '十月', '十三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2518, '2026-11-22', '星期日', 2026, '十月', '十四', '丙午', '马', NULL, 1, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (2519, '2026-11-23', '星期一', 2026, '十月', '十五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2520, '2026-11-24', '星期二', 2026, '十月', '十六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2521, '2026-11-25', '星期三', 2026, '十月', '十七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2522, '2026-11-26', '星期四', 2026, '十月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2523, '2026-11-27', '星期五', 2026, '十月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2524, '2026-11-28', '星期六', 2026, '十月', '二十', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2525, '2026-11-29', '星期日', 2026, '十月', '廿一', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2526, '2026-11-30', '星期一', 2026, '十月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2527, '2026-12-01', '星期二', 2026, '十月', '廿三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2528, '2026-12-02', '星期三', 2026, '十月', '廿四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2529, '2026-12-03', '星期四', 2026, '十月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2530, '2026-12-04', '星期五', 2026, '十月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2531, '2026-12-05', '星期六', 2026, '十月', '廿七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2532, '2026-12-06', '星期日', 2026, '十月', '廿八', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2533, '2026-12-07', '星期一', 2026, '十月', '廿九', '丙午', '马', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (2534, '2026-12-08', '星期二', 2026, '十月', '三十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2535, '2026-12-09', '星期三', 2026, '冬月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2536, '2026-12-10', '星期四', 2026, '冬月', '初二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2537, '2026-12-11', '星期五', 2026, '冬月', '初三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2538, '2026-12-12', '星期六', 2026, '冬月', '初四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2539, '2026-12-13', '星期日', 2026, '冬月', '初五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2540, '2026-12-14', '星期一', 2026, '冬月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2541, '2026-12-15', '星期二', 2026, '冬月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2542, '2026-12-16', '星期三', 2026, '冬月', '初八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2543, '2026-12-17', '星期四', 2026, '冬月', '初九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2544, '2026-12-18', '星期五', 2026, '冬月', '初十 ', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2545, '2026-12-19', '星期六', 2026, '冬月', '十一', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2546, '2026-12-20', '星期日', 2026, '冬月', '十二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2547, '2026-12-21', '星期一', 2026, '冬月', '十三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2548, '2026-12-22', '星期二', 2026, '冬月', '十四', '丙午', '马', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (2549, '2026-12-23', '星期三', 2026, '冬月', '十五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2550, '2026-12-24', '星期四', 2026, '冬月', '十六', '丙午', '马', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2551, '2026-12-25', '星期五', 2026, '冬月', '十七', '丙午', '马', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2552, '2026-12-26', '星期六', 2026, '冬月', '十八', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2553, '2026-12-27', '星期日', 2026, '冬月', '十九', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2554, '2026-12-28', '星期一', 2026, '冬月', '二十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2555, '2026-12-29', '星期二', 2026, '冬月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2556, '2026-12-30', '星期三', 2026, '冬月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2557, '2026-12-31', '星期四', 2026, '冬月', '廿三', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2558, '2027-01-01', '星期五', 2026, '冬月', '廿四', '丙午', '马', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2559, '2027-01-02', '星期六', 2026, '冬月', '廿五', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2560, '2027-01-03', '星期日', 2026, '冬月', '廿六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2561, '2027-01-04', '星期一', 2026, '冬月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2562, '2027-01-05', '星期二', 2026, '冬月', '廿八', '丙午', '马', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (2563, '2027-01-06', '星期三', 2026, '冬月', '廿九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2564, '2027-01-07', '星期四', 2026, '冬月', '三十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2565, '2027-01-08', '星期五', 2026, '腊月', '初一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2566, '2027-01-09', '星期六', 2026, '腊月', '初二', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2567, '2027-01-10', '星期日', 2026, '腊月', '初三', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2568, '2027-01-11', '星期一', 2026, '腊月', '初四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2569, '2027-01-12', '星期二', 2026, '腊月', '初五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2570, '2027-01-13', '星期三', 2026, '腊月', '初六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2571, '2027-01-14', '星期四', 2026, '腊月', '初七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2572, '2027-01-15', '星期五', 2026, '腊月', '初八', '丙午', '马', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2573, '2027-01-16', '星期六', 2026, '腊月', '初九', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2574, '2027-01-17', '星期日', 2026, '腊月', '初十 ', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2575, '2027-01-18', '星期一', 2026, '腊月', '十一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2576, '2027-01-19', '星期二', 2026, '腊月', '十二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2577, '2027-01-20', '星期三', 2026, '腊月', '十三', '丙午', '马', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (2578, '2027-01-21', '星期四', 2026, '腊月', '十四', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2579, '2027-01-22', '星期五', 2026, '腊月', '十五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2580, '2027-01-23', '星期六', 2026, '腊月', '十六', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2581, '2027-01-24', '星期日', 2026, '腊月', '十七', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2582, '2027-01-25', '星期一', 2026, '腊月', '十八', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2583, '2027-01-26', '星期二', 2026, '腊月', '十九', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2584, '2027-01-27', '星期三', 2026, '腊月', '二十', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2585, '2027-01-28', '星期四', 2026, '腊月', '廿一', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2586, '2027-01-29', '星期五', 2026, '腊月', '廿二', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2587, '2027-01-30', '星期六', 2026, '腊月', '廿三', '丙午', '马', NULL, 1, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2588, '2027-01-31', '星期日', 2026, '腊月', '廿四', '丙午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2589, '2027-02-01', '星期一', 2026, '腊月', '廿五', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2590, '2027-02-02', '星期二', 2026, '腊月', '廿六', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2591, '2027-02-03', '星期三', 2026, '腊月', '廿七', '丙午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2592, '2027-02-04', '星期四', 2026, '腊月', '廿八', '丙午', '马', NULL, 0, '', '', '立春', '', 0);
INSERT INTO `base_data_holiday` VALUES (2593, '2027-02-05', '星期五', 2026, '腊月', '廿九', '丙午', '马', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2594, '2027-02-06', '星期六', 2027, '正月', '初一', '丁未', '羊', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2595, '2027-02-07', '星期日', 2027, '正月', '初二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2596, '2027-02-08', '星期一', 2027, '正月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2597, '2027-02-09', '星期二', 2027, '正月', '初四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2598, '2027-02-10', '星期三', 2027, '正月', '初五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2599, '2027-02-11', '星期四', 2027, '正月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2600, '2027-02-12', '星期五', 2027, '正月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2601, '2027-02-13', '星期六', 2027, '正月', '初八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2602, '2027-02-14', '星期日', 2027, '正月', '初九', '丁未', '羊', NULL, 1, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2603, '2027-02-15', '星期一', 2027, '正月', '初十 ', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2604, '2027-02-16', '星期二', 2027, '正月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2605, '2027-02-17', '星期三', 2027, '正月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2606, '2027-02-18', '星期四', 2027, '正月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2607, '2027-02-19', '星期五', 2027, '正月', '十四', '丁未', '羊', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (2608, '2027-02-20', '星期六', 2027, '正月', '十五', '丁未', '羊', NULL, 1, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2609, '2027-02-21', '星期日', 2027, '正月', '十六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2610, '2027-02-22', '星期一', 2027, '正月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2611, '2027-02-23', '星期二', 2027, '正月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2612, '2027-02-24', '星期三', 2027, '正月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2613, '2027-02-25', '星期四', 2027, '正月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2614, '2027-02-26', '星期五', 2027, '正月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2615, '2027-02-27', '星期六', 2027, '正月', '廿二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2616, '2027-02-28', '星期日', 2027, '正月', '廿三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2617, '2027-03-01', '星期一', 2027, '正月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2618, '2027-03-02', '星期二', 2027, '正月', '廿五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2619, '2027-03-03', '星期三', 2027, '正月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2620, '2027-03-04', '星期四', 2027, '正月', '廿七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2621, '2027-03-05', '星期五', 2027, '正月', '廿八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2622, '2027-03-06', '星期六', 2027, '正月', '廿九', '丁未', '羊', NULL, 1, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (2623, '2027-03-07', '星期日', 2027, '正月', '三十', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2624, '2027-03-08', '星期一', 2027, '二月', '初一', '丁未', '羊', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2625, '2027-03-09', '星期二', 2027, '二月', '初二', '丁未', '羊', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2626, '2027-03-10', '星期三', 2027, '二月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2627, '2027-03-11', '星期四', 2027, '二月', '初四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2628, '2027-03-12', '星期五', 2027, '二月', '初五', '丁未', '羊', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2629, '2027-03-13', '星期六', 2027, '二月', '初六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2630, '2027-03-14', '星期日', 2027, '二月', '初七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2631, '2027-03-15', '星期一', 2027, '二月', '初八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2632, '2027-03-16', '星期二', 2027, '二月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2633, '2027-03-17', '星期三', 2027, '二月', '初十 ', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2634, '2027-03-18', '星期四', 2027, '二月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2635, '2027-03-19', '星期五', 2027, '二月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2636, '2027-03-20', '星期六', 2027, '二月', '十三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2637, '2027-03-21', '星期日', 2027, '二月', '十四', '丁未', '羊', NULL, 1, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (2638, '2027-03-22', '星期一', 2027, '二月', '十五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2639, '2027-03-23', '星期二', 2027, '二月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2640, '2027-03-24', '星期三', 2027, '二月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2641, '2027-03-25', '星期四', 2027, '二月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2642, '2027-03-26', '星期五', 2027, '二月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2643, '2027-03-27', '星期六', 2027, '二月', '二十', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2644, '2027-03-28', '星期日', 2027, '二月', '廿一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2645, '2027-03-29', '星期一', 2027, '二月', '廿二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2646, '2027-03-30', '星期二', 2027, '二月', '廿三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2647, '2027-03-31', '星期三', 2027, '二月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2648, '2027-04-01', '星期四', 2027, '二月', '廿五', '丁未', '羊', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2649, '2027-04-02', '星期五', 2027, '二月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2650, '2027-04-03', '星期六', 2027, '二月', '廿七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2651, '2027-04-04', '星期日', 2027, '二月', '廿八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2652, '2027-04-05', '星期一', 2027, '二月', '廿九', '丁未', '羊', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (2653, '2027-04-06', '星期二', 2027, '二月', '三十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2654, '2027-04-07', '星期三', 2027, '三月', '初一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2655, '2027-04-08', '星期四', 2027, '三月', '初二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2656, '2027-04-09', '星期五', 2027, '三月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2657, '2027-04-10', '星期六', 2027, '三月', '初四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2658, '2027-04-11', '星期日', 2027, '三月', '初五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2659, '2027-04-12', '星期一', 2027, '三月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2660, '2027-04-13', '星期二', 2027, '三月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2661, '2027-04-14', '星期三', 2027, '三月', '初八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2662, '2027-04-15', '星期四', 2027, '三月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2663, '2027-04-16', '星期五', 2027, '三月', '初十 ', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2664, '2027-04-17', '星期六', 2027, '三月', '十一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2665, '2027-04-18', '星期日', 2027, '三月', '十二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2666, '2027-04-19', '星期一', 2027, '三月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2667, '2027-04-20', '星期二', 2027, '三月', '十四', '丁未', '羊', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (2668, '2027-04-21', '星期三', 2027, '三月', '十五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2669, '2027-04-22', '星期四', 2027, '三月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2670, '2027-04-23', '星期五', 2027, '三月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2671, '2027-04-24', '星期六', 2027, '三月', '十八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2672, '2027-04-25', '星期日', 2027, '三月', '十九', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2673, '2027-04-26', '星期一', 2027, '三月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2674, '2027-04-27', '星期二', 2027, '三月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2675, '2027-04-28', '星期三', 2027, '三月', '廿二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2676, '2027-04-29', '星期四', 2027, '三月', '廿三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2677, '2027-04-30', '星期五', 2027, '三月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2678, '2027-05-01', '星期六', 2027, '三月', '廿五', '丁未', '羊', NULL, 1, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2679, '2027-05-02', '星期日', 2027, '三月', '廿六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2680, '2027-05-03', '星期一', 2027, '三月', '廿七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2681, '2027-05-04', '星期二', 2027, '三月', '廿八', '丁未', '羊', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2682, '2027-05-05', '星期三', 2027, '三月', '廿九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2683, '2027-05-06', '星期四', 2027, '四月', '初一', '丁未', '羊', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (2684, '2027-05-07', '星期五', 2027, '四月', '初二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2685, '2027-05-08', '星期六', 2027, '四月', '初三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2686, '2027-05-09', '星期日', 2027, '四月', '初四', '丁未', '羊', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (2687, '2027-05-10', '星期一', 2027, '四月', '初五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2688, '2027-05-11', '星期二', 2027, '四月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2689, '2027-05-12', '星期三', 2027, '四月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2690, '2027-05-13', '星期四', 2027, '四月', '初八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2691, '2027-05-14', '星期五', 2027, '四月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2692, '2027-05-15', '星期六', 2027, '四月', '初十 ', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2693, '2027-05-16', '星期日', 2027, '四月', '十一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2694, '2027-05-17', '星期一', 2027, '四月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2695, '2027-05-18', '星期二', 2027, '四月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2696, '2027-05-19', '星期三', 2027, '四月', '十四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2697, '2027-05-20', '星期四', 2027, '四月', '十五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2698, '2027-05-21', '星期五', 2027, '四月', '十六', '丁未', '羊', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (2699, '2027-05-22', '星期六', 2027, '四月', '十七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2700, '2027-05-23', '星期日', 2027, '四月', '十八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2701, '2027-05-24', '星期一', 2027, '四月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2702, '2027-05-25', '星期二', 2027, '四月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2703, '2027-05-26', '星期三', 2027, '四月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2704, '2027-05-27', '星期四', 2027, '四月', '廿二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2705, '2027-05-28', '星期五', 2027, '四月', '廿三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2706, '2027-05-29', '星期六', 2027, '四月', '廿四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2707, '2027-05-30', '星期日', 2027, '四月', '廿五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2708, '2027-05-31', '星期一', 2027, '四月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2709, '2027-06-01', '星期二', 2027, '四月', '廿七', '丁未', '羊', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2710, '2027-06-02', '星期三', 2027, '四月', '廿八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2711, '2027-06-03', '星期四', 2027, '四月', '廿九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2712, '2027-06-04', '星期五', 2027, '四月', '三十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2713, '2027-06-05', '星期六', 2027, '五月', '初一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2714, '2027-06-06', '星期日', 2027, '五月', '初二', '丁未', '羊', NULL, 1, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (2715, '2027-06-07', '星期一', 2027, '五月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2716, '2027-06-08', '星期二', 2027, '五月', '初四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2717, '2027-06-09', '星期三', 2027, '五月', '初五', '丁未', '羊', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2718, '2027-06-10', '星期四', 2027, '五月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2719, '2027-06-11', '星期五', 2027, '五月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2720, '2027-06-12', '星期六', 2027, '五月', '初八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2721, '2027-06-13', '星期日', 2027, '五月', '初九', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2722, '2027-06-14', '星期一', 2027, '五月', '初十 ', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2723, '2027-06-15', '星期二', 2027, '五月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2724, '2027-06-16', '星期三', 2027, '五月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2725, '2027-06-17', '星期四', 2027, '五月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2726, '2027-06-18', '星期五', 2027, '五月', '十四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2727, '2027-06-19', '星期六', 2027, '五月', '十五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2728, '2027-06-20', '星期日', 2027, '五月', '十六', '丁未', '羊', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (2729, '2027-06-21', '星期一', 2027, '五月', '十七', '丁未', '羊', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (2730, '2027-06-22', '星期二', 2027, '五月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2731, '2027-06-23', '星期三', 2027, '五月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2732, '2027-06-24', '星期四', 2027, '五月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2733, '2027-06-25', '星期五', 2027, '五月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2734, '2027-06-26', '星期六', 2027, '五月', '廿二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2735, '2027-06-27', '星期日', 2027, '五月', '廿三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2736, '2027-06-28', '星期一', 2027, '五月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2737, '2027-06-29', '星期二', 2027, '五月', '廿五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2738, '2027-06-30', '星期三', 2027, '五月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2739, '2027-07-01', '星期四', 2027, '五月', '廿七', '丁未', '羊', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2740, '2027-07-02', '星期五', 2027, '五月', '廿八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2741, '2027-07-03', '星期六', 2027, '五月', '廿九', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2742, '2027-07-04', '星期日', 2027, '六月', '初一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2743, '2027-07-05', '星期一', 2027, '六月', '初二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2744, '2027-07-06', '星期二', 2027, '六月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2745, '2027-07-07', '星期三', 2027, '六月', '初四', '丁未', '羊', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (2746, '2027-07-08', '星期四', 2027, '六月', '初五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2747, '2027-07-09', '星期五', 2027, '六月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2748, '2027-07-10', '星期六', 2027, '六月', '初七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2749, '2027-07-11', '星期日', 2027, '六月', '初八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2750, '2027-07-12', '星期一', 2027, '六月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2751, '2027-07-13', '星期二', 2027, '六月', '初十 ', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2752, '2027-07-14', '星期三', 2027, '六月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2753, '2027-07-15', '星期四', 2027, '六月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2754, '2027-07-16', '星期五', 2027, '六月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2755, '2027-07-17', '星期六', 2027, '六月', '十四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2756, '2027-07-18', '星期日', 2027, '六月', '十五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2757, '2027-07-19', '星期一', 2027, '六月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2758, '2027-07-20', '星期二', 2027, '六月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2759, '2027-07-21', '星期三', 2027, '六月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2760, '2027-07-22', '星期四', 2027, '六月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2761, '2027-07-23', '星期五', 2027, '六月', '二十', '丁未', '羊', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (2762, '2027-07-24', '星期六', 2027, '六月', '廿一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2763, '2027-07-25', '星期日', 2027, '六月', '廿二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2764, '2027-07-26', '星期一', 2027, '六月', '廿三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2765, '2027-07-27', '星期二', 2027, '六月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2766, '2027-07-28', '星期三', 2027, '六月', '廿五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2767, '2027-07-29', '星期四', 2027, '六月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2768, '2027-07-30', '星期五', 2027, '六月', '廿七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2769, '2027-07-31', '星期六', 2027, '六月', '廿八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2770, '2027-08-01', '星期日', 2027, '六月', '廿九', '丁未', '羊', NULL, 1, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2771, '2027-08-02', '星期一', 2027, '七月', '初一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2772, '2027-08-03', '星期二', 2027, '七月', '初二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2773, '2027-08-04', '星期三', 2027, '七月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2774, '2027-08-05', '星期四', 2027, '七月', '初四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2775, '2027-08-06', '星期五', 2027, '七月', '初五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2776, '2027-08-07', '星期六', 2027, '七月', '初六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2777, '2027-08-08', '星期日', 2027, '七月', '初七', '丁未', '羊', NULL, 1, '', '七夕', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (2778, '2027-08-09', '星期一', 2027, '七月', '初八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2779, '2027-08-10', '星期二', 2027, '七月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2780, '2027-08-11', '星期三', 2027, '七月', '初十 ', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2781, '2027-08-12', '星期四', 2027, '七月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2782, '2027-08-13', '星期五', 2027, '七月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2783, '2027-08-14', '星期六', 2027, '七月', '十三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2784, '2027-08-15', '星期日', 2027, '七月', '十四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2785, '2027-08-16', '星期一', 2027, '七月', '十五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2786, '2027-08-17', '星期二', 2027, '七月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2787, '2027-08-18', '星期三', 2027, '七月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2788, '2027-08-19', '星期四', 2027, '七月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2789, '2027-08-20', '星期五', 2027, '七月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2790, '2027-08-21', '星期六', 2027, '七月', '二十', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2791, '2027-08-22', '星期日', 2027, '七月', '廿一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2792, '2027-08-23', '星期一', 2027, '七月', '廿二', '丁未', '羊', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (2793, '2027-08-24', '星期二', 2027, '七月', '廿三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2794, '2027-08-25', '星期三', 2027, '七月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2795, '2027-08-26', '星期四', 2027, '七月', '廿五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2796, '2027-08-27', '星期五', 2027, '七月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2797, '2027-08-28', '星期六', 2027, '七月', '廿七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2798, '2027-08-29', '星期日', 2027, '七月', '廿八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2799, '2027-08-30', '星期一', 2027, '七月', '廿九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2800, '2027-08-31', '星期二', 2027, '七月', '三十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2801, '2027-09-01', '星期三', 2027, '八月', '初一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2802, '2027-09-02', '星期四', 2027, '八月', '初二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2803, '2027-09-03', '星期五', 2027, '八月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2804, '2027-09-04', '星期六', 2027, '八月', '初四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2805, '2027-09-05', '星期日', 2027, '八月', '初五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2806, '2027-09-06', '星期一', 2027, '八月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2807, '2027-09-07', '星期二', 2027, '八月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2808, '2027-09-08', '星期三', 2027, '八月', '初八', '丁未', '羊', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (2809, '2027-09-09', '星期四', 2027, '八月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2810, '2027-09-10', '星期五', 2027, '八月', '初十 ', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2811, '2027-09-11', '星期六', 2027, '八月', '十一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2812, '2027-09-12', '星期日', 2027, '八月', '十二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2813, '2027-09-13', '星期一', 2027, '八月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2814, '2027-09-14', '星期二', 2027, '八月', '十四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2815, '2027-09-15', '星期三', 2027, '八月', '十五', '丁未', '羊', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2816, '2027-09-16', '星期四', 2027, '八月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2817, '2027-09-17', '星期五', 2027, '八月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2818, '2027-09-18', '星期六', 2027, '八月', '十八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2819, '2027-09-19', '星期日', 2027, '八月', '十九', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2820, '2027-09-20', '星期一', 2027, '八月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2821, '2027-09-21', '星期二', 2027, '八月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2822, '2027-09-22', '星期三', 2027, '八月', '廿二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2823, '2027-09-23', '星期四', 2027, '八月', '廿三', '丁未', '羊', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (2824, '2027-09-24', '星期五', 2027, '八月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2825, '2027-09-25', '星期六', 2027, '八月', '廿五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2826, '2027-09-26', '星期日', 2027, '八月', '廿六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2827, '2027-09-27', '星期一', 2027, '八月', '廿七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2828, '2027-09-28', '星期二', 2027, '八月', '廿八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2829, '2027-09-29', '星期三', 2027, '八月', '廿九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2830, '2027-09-30', '星期四', 2027, '九月', '初一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2831, '2027-10-01', '星期五', 2027, '九月', '初二', '丁未', '羊', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2832, '2027-10-02', '星期六', 2027, '九月', '初三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2833, '2027-10-03', '星期日', 2027, '九月', '初四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2834, '2027-10-04', '星期一', 2027, '九月', '初五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2835, '2027-10-05', '星期二', 2027, '九月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2836, '2027-10-06', '星期三', 2027, '九月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2837, '2027-10-07', '星期四', 2027, '九月', '初八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2838, '2027-10-08', '星期五', 2027, '九月', '初九', '丁未', '羊', NULL, 0, '', '重阳节', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (2839, '2027-10-09', '星期六', 2027, '九月', '初十 ', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2840, '2027-10-10', '星期日', 2027, '九月', '十一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2841, '2027-10-11', '星期一', 2027, '九月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2842, '2027-10-12', '星期二', 2027, '九月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2843, '2027-10-13', '星期三', 2027, '九月', '十四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2844, '2027-10-14', '星期四', 2027, '九月', '十五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2845, '2027-10-15', '星期五', 2027, '九月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2846, '2027-10-16', '星期六', 2027, '九月', '十七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2847, '2027-10-17', '星期日', 2027, '九月', '十八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2848, '2027-10-18', '星期一', 2027, '九月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2849, '2027-10-19', '星期二', 2027, '九月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2850, '2027-10-20', '星期三', 2027, '九月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2851, '2027-10-21', '星期四', 2027, '九月', '廿二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2852, '2027-10-22', '星期五', 2027, '九月', '廿三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2853, '2027-10-23', '星期六', 2027, '九月', '廿四', '丁未', '羊', NULL, 1, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (2854, '2027-10-24', '星期日', 2027, '九月', '廿五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2855, '2027-10-25', '星期一', 2027, '九月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2856, '2027-10-26', '星期二', 2027, '九月', '廿七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2857, '2027-10-27', '星期三', 2027, '九月', '廿八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2858, '2027-10-28', '星期四', 2027, '九月', '廿九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2859, '2027-10-29', '星期五', 2027, '十月', '初一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2860, '2027-10-30', '星期六', 2027, '十月', '初二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2861, '2027-10-31', '星期日', 2027, '十月', '初三', '丁未', '羊', NULL, 1, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2862, '2027-11-01', '星期一', 2027, '十月', '初四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2863, '2027-11-02', '星期二', 2027, '十月', '初五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2864, '2027-11-03', '星期三', 2027, '十月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2865, '2027-11-04', '星期四', 2027, '十月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2866, '2027-11-05', '星期五', 2027, '十月', '初八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2867, '2027-11-06', '星期六', 2027, '十月', '初九', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2868, '2027-11-07', '星期日', 2027, '十月', '初十 ', '丁未', '羊', NULL, 1, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (2869, '2027-11-08', '星期一', 2027, '十月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2870, '2027-11-09', '星期二', 2027, '十月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2871, '2027-11-10', '星期三', 2027, '十月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2872, '2027-11-11', '星期四', 2027, '十月', '十四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2873, '2027-11-12', '星期五', 2027, '十月', '十五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2874, '2027-11-13', '星期六', 2027, '十月', '十六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2875, '2027-11-14', '星期日', 2027, '十月', '十七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2876, '2027-11-15', '星期一', 2027, '十月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2877, '2027-11-16', '星期二', 2027, '十月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2878, '2027-11-17', '星期三', 2027, '十月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2879, '2027-11-18', '星期四', 2027, '十月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2880, '2027-11-19', '星期五', 2027, '十月', '廿二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2881, '2027-11-20', '星期六', 2027, '十月', '廿三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2882, '2027-11-21', '星期日', 2027, '十月', '廿四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2883, '2027-11-22', '星期一', 2027, '十月', '廿五', '丁未', '羊', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (2884, '2027-11-23', '星期二', 2027, '十月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2885, '2027-11-24', '星期三', 2027, '十月', '廿七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2886, '2027-11-25', '星期四', 2027, '十月', '廿八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2887, '2027-11-26', '星期五', 2027, '十月', '廿九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2888, '2027-11-27', '星期六', 2027, '十月', '三十', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2889, '2027-11-28', '星期日', 2027, '冬月', '初一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2890, '2027-11-29', '星期一', 2027, '冬月', '初二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2891, '2027-11-30', '星期二', 2027, '冬月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2892, '2027-12-01', '星期三', 2027, '冬月', '初四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2893, '2027-12-02', '星期四', 2027, '冬月', '初五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2894, '2027-12-03', '星期五', 2027, '冬月', '初六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2895, '2027-12-04', '星期六', 2027, '冬月', '初七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2896, '2027-12-05', '星期日', 2027, '冬月', '初八', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2897, '2027-12-06', '星期一', 2027, '冬月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2898, '2027-12-07', '星期二', 2027, '冬月', '初十 ', '丁未', '羊', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (2899, '2027-12-08', '星期三', 2027, '冬月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2900, '2027-12-09', '星期四', 2027, '冬月', '十二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2901, '2027-12-10', '星期五', 2027, '冬月', '十三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2902, '2027-12-11', '星期六', 2027, '冬月', '十四', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2903, '2027-12-12', '星期日', 2027, '冬月', '十五', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2904, '2027-12-13', '星期一', 2027, '冬月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2905, '2027-12-14', '星期二', 2027, '冬月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2906, '2027-12-15', '星期三', 2027, '冬月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2907, '2027-12-16', '星期四', 2027, '冬月', '十九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2908, '2027-12-17', '星期五', 2027, '冬月', '二十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2909, '2027-12-18', '星期六', 2027, '冬月', '廿一', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2910, '2027-12-19', '星期日', 2027, '冬月', '廿二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2911, '2027-12-20', '星期一', 2027, '冬月', '廿三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2912, '2027-12-21', '星期二', 2027, '冬月', '廿四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2913, '2027-12-22', '星期三', 2027, '冬月', '廿五', '丁未', '羊', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (2914, '2027-12-23', '星期四', 2027, '冬月', '廿六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2915, '2027-12-24', '星期五', 2027, '冬月', '廿七', '丁未', '羊', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2916, '2027-12-25', '星期六', 2027, '冬月', '廿八', '丁未', '羊', NULL, 1, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2917, '2027-12-26', '星期日', 2027, '冬月', '廿九', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2918, '2027-12-27', '星期一', 2027, '冬月', '三十', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2919, '2027-12-28', '星期二', 2027, '腊月', '初一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2920, '2027-12-29', '星期三', 2027, '腊月', '初二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2921, '2027-12-30', '星期四', 2027, '腊月', '初三', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2922, '2027-12-31', '星期五', 2027, '腊月', '初四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2923, '2028-01-01', '星期六', 2027, '腊月', '初五', '丁未', '羊', NULL, 1, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2924, '2028-01-02', '星期日', 2027, '腊月', '初六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2925, '2028-01-03', '星期一', 2027, '腊月', '初七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2926, '2028-01-04', '星期二', 2027, '腊月', '初八', '丁未', '羊', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2927, '2028-01-05', '星期三', 2027, '腊月', '初九', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2928, '2028-01-06', '星期四', 2027, '腊月', '初十 ', '丁未', '羊', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (2929, '2028-01-07', '星期五', 2027, '腊月', '十一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2930, '2028-01-08', '星期六', 2027, '腊月', '十二', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2931, '2028-01-09', '星期日', 2027, '腊月', '十三', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2932, '2028-01-10', '星期一', 2027, '腊月', '十四', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2933, '2028-01-11', '星期二', 2027, '腊月', '十五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2934, '2028-01-12', '星期三', 2027, '腊月', '十六', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2935, '2028-01-13', '星期四', 2027, '腊月', '十七', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2936, '2028-01-14', '星期五', 2027, '腊月', '十八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2937, '2028-01-15', '星期六', 2027, '腊月', '十九', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2938, '2028-01-16', '星期日', 2027, '腊月', '二十', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2939, '2028-01-17', '星期一', 2027, '腊月', '廿一', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2940, '2028-01-18', '星期二', 2027, '腊月', '廿二', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2941, '2028-01-19', '星期三', 2027, '腊月', '廿三', '丁未', '羊', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2942, '2028-01-20', '星期四', 2027, '腊月', '廿四', '丁未', '羊', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (2943, '2028-01-21', '星期五', 2027, '腊月', '廿五', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2944, '2028-01-22', '星期六', 2027, '腊月', '廿六', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2945, '2028-01-23', '星期日', 2027, '腊月', '廿七', '丁未', '羊', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2946, '2028-01-24', '星期一', 2027, '腊月', '廿八', '丁未', '羊', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2947, '2028-01-25', '星期二', 2027, '腊月', '廿九', '丁未', '羊', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2948, '2028-01-26', '星期三', 2028, '正月', '初一', '戊申', '猴', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (2949, '2028-01-27', '星期四', 2028, '正月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2950, '2028-01-28', '星期五', 2028, '正月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2951, '2028-01-29', '星期六', 2028, '正月', '初四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2952, '2028-01-30', '星期日', 2028, '正月', '初五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2953, '2028-01-31', '星期一', 2028, '正月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2954, '2028-02-01', '星期二', 2028, '正月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2955, '2028-02-02', '星期三', 2028, '正月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2956, '2028-02-03', '星期四', 2028, '正月', '初九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2957, '2028-02-04', '星期五', 2028, '正月', '初十 ', '戊申', '猴', NULL, 0, '', '', '立春', '', 5);
INSERT INTO `base_data_holiday` VALUES (2958, '2028-02-05', '星期六', 2028, '正月', '十一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2959, '2028-02-06', '星期日', 2028, '正月', '十二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2960, '2028-02-07', '星期一', 2028, '正月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2961, '2028-02-08', '星期二', 2028, '正月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2962, '2028-02-09', '星期三', 2028, '正月', '十五', '戊申', '猴', NULL, 0, '', '元宵节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2963, '2028-02-10', '星期四', 2028, '正月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2964, '2028-02-11', '星期五', 2028, '正月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2965, '2028-02-12', '星期六', 2028, '正月', '十八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2966, '2028-02-13', '星期日', 2028, '正月', '十九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2967, '2028-02-14', '星期一', 2028, '正月', '二十', '戊申', '猴', NULL, 0, '情人节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2968, '2028-02-15', '星期二', 2028, '正月', '廿一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2969, '2028-02-16', '星期三', 2028, '正月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2970, '2028-02-17', '星期四', 2028, '正月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2971, '2028-02-18', '星期五', 2028, '正月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2972, '2028-02-19', '星期六', 2028, '正月', '廿五', '戊申', '猴', NULL, 1, '', '', '雨水', '', 5);
INSERT INTO `base_data_holiday` VALUES (2973, '2028-02-20', '星期日', 2028, '正月', '廿六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2974, '2028-02-21', '星期一', 2028, '正月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2975, '2028-02-22', '星期二', 2028, '正月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2976, '2028-02-23', '星期三', 2028, '正月', '廿九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2977, '2028-02-24', '星期四', 2028, '正月', '三十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2978, '2028-02-25', '星期五', 2028, '二月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2979, '2028-02-26', '星期六', 2028, '二月', '初二', '戊申', '猴', NULL, 1, '', '龙抬头', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2980, '2028-02-27', '星期日', 2028, '二月', '初三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2981, '2028-02-28', '星期一', 2028, '二月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2982, '2028-02-29', '星期二', 2028, '二月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2983, '2028-03-01', '星期三', 2028, '二月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2984, '2028-03-02', '星期四', 2028, '二月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2985, '2028-03-03', '星期五', 2028, '二月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2986, '2028-03-04', '星期六', 2028, '二月', '初九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2987, '2028-03-05', '星期日', 2028, '二月', '初十 ', '戊申', '猴', NULL, 1, '', '', '惊蛰', '', 5);
INSERT INTO `base_data_holiday` VALUES (2988, '2028-03-06', '星期一', 2028, '二月', '十一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2989, '2028-03-07', '星期二', 2028, '二月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2990, '2028-03-08', '星期三', 2028, '二月', '十三', '戊申', '猴', NULL, 0, '妇女节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2991, '2028-03-09', '星期四', 2028, '二月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2992, '2028-03-10', '星期五', 2028, '二月', '十五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2993, '2028-03-11', '星期六', 2028, '二月', '十六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2994, '2028-03-12', '星期日', 2028, '二月', '十七', '戊申', '猴', NULL, 1, '植树节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2995, '2028-03-13', '星期一', 2028, '二月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2996, '2028-03-14', '星期二', 2028, '二月', '十九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2997, '2028-03-15', '星期三', 2028, '二月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2998, '2028-03-16', '星期四', 2028, '二月', '廿一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (2999, '2028-03-17', '星期五', 2028, '二月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3000, '2028-03-18', '星期六', 2028, '二月', '廿三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3001, '2028-03-19', '星期日', 2028, '二月', '廿四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3002, '2028-03-20', '星期一', 2028, '二月', '廿五', '戊申', '猴', NULL, 0, '', '', '春分', '', 5);
INSERT INTO `base_data_holiday` VALUES (3003, '2028-03-21', '星期二', 2028, '二月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3004, '2028-03-22', '星期三', 2028, '二月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3005, '2028-03-23', '星期四', 2028, '二月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3006, '2028-03-24', '星期五', 2028, '二月', '廿九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3007, '2028-03-25', '星期六', 2028, '二月', '三十', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3008, '2028-03-26', '星期日', 2028, '三月', '初一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3009, '2028-03-27', '星期一', 2028, '三月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3010, '2028-03-28', '星期二', 2028, '三月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3011, '2028-03-29', '星期三', 2028, '三月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3012, '2028-03-30', '星期四', 2028, '三月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3013, '2028-03-31', '星期五', 2028, '三月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3014, '2028-04-01', '星期六', 2028, '三月', '初七', '戊申', '猴', NULL, 1, '愚人节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3015, '2028-04-02', '星期日', 2028, '三月', '初八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3016, '2028-04-03', '星期一', 2028, '三月', '初九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3017, '2028-04-04', '星期二', 2028, '三月', '初十 ', '戊申', '猴', NULL, 0, '', '', '清明', '', 5);
INSERT INTO `base_data_holiday` VALUES (3018, '2028-04-05', '星期三', 2028, '三月', '十一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3019, '2028-04-06', '星期四', 2028, '三月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3020, '2028-04-07', '星期五', 2028, '三月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3021, '2028-04-08', '星期六', 2028, '三月', '十四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3022, '2028-04-09', '星期日', 2028, '三月', '十五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3023, '2028-04-10', '星期一', 2028, '三月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3024, '2028-04-11', '星期二', 2028, '三月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3025, '2028-04-12', '星期三', 2028, '三月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3026, '2028-04-13', '星期四', 2028, '三月', '十九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3027, '2028-04-14', '星期五', 2028, '三月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3028, '2028-04-15', '星期六', 2028, '三月', '廿一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3029, '2028-04-16', '星期日', 2028, '三月', '廿二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3030, '2028-04-17', '星期一', 2028, '三月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3031, '2028-04-18', '星期二', 2028, '三月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3032, '2028-04-19', '星期三', 2028, '三月', '廿五', '戊申', '猴', NULL, 0, '', '', '谷雨', '', 5);
INSERT INTO `base_data_holiday` VALUES (3033, '2028-04-20', '星期四', 2028, '三月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3034, '2028-04-21', '星期五', 2028, '三月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3035, '2028-04-22', '星期六', 2028, '三月', '廿八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3036, '2028-04-23', '星期日', 2028, '三月', '廿九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3037, '2028-04-24', '星期一', 2028, '三月', '三十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3038, '2028-04-25', '星期二', 2028, '四月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3039, '2028-04-26', '星期三', 2028, '四月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3040, '2028-04-27', '星期四', 2028, '四月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3041, '2028-04-28', '星期五', 2028, '四月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3042, '2028-04-29', '星期六', 2028, '四月', '初五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3043, '2028-04-30', '星期日', 2028, '四月', '初六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3044, '2028-05-01', '星期一', 2028, '四月', '初七', '戊申', '猴', NULL, 0, '劳动节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3045, '2028-05-02', '星期二', 2028, '四月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3046, '2028-05-03', '星期三', 2028, '四月', '初九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3047, '2028-05-04', '星期四', 2028, '四月', '初十 ', '戊申', '猴', NULL, 0, '青年节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3048, '2028-05-05', '星期五', 2028, '四月', '十一', '戊申', '猴', NULL, 0, '', '', '立夏', '', 5);
INSERT INTO `base_data_holiday` VALUES (3049, '2028-05-06', '星期六', 2028, '四月', '十二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3050, '2028-05-07', '星期日', 2028, '四月', '十三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3051, '2028-05-08', '星期一', 2028, '四月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3052, '2028-05-09', '星期二', 2028, '四月', '十五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3053, '2028-05-10', '星期三', 2028, '四月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3054, '2028-05-11', '星期四', 2028, '四月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3055, '2028-05-12', '星期五', 2028, '四月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3056, '2028-05-13', '星期六', 2028, '四月', '十九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3057, '2028-05-14', '星期日', 2028, '四月', '二十', '戊申', '猴', NULL, 1, '', '', '', '母亲节', 5);
INSERT INTO `base_data_holiday` VALUES (3058, '2028-05-15', '星期一', 2028, '四月', '廿一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3059, '2028-05-16', '星期二', 2028, '四月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3060, '2028-05-17', '星期三', 2028, '四月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3061, '2028-05-18', '星期四', 2028, '四月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3062, '2028-05-19', '星期五', 2028, '四月', '廿五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3063, '2028-05-20', '星期六', 2028, '四月', '廿六', '戊申', '猴', NULL, 1, '', '', '小满', '', 5);
INSERT INTO `base_data_holiday` VALUES (3064, '2028-05-21', '星期日', 2028, '四月', '廿七', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3065, '2028-05-22', '星期一', 2028, '四月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3066, '2028-05-23', '星期二', 2028, '四月', '廿九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3067, '2028-05-24', '星期三', 2028, '五月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3068, '2028-05-25', '星期四', 2028, '五月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3069, '2028-05-26', '星期五', 2028, '五月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3070, '2028-05-27', '星期六', 2028, '五月', '初四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3071, '2028-05-28', '星期日', 2028, '五月', '初五', '戊申', '猴', NULL, 1, '', '端午节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3072, '2028-05-29', '星期一', 2028, '五月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3073, '2028-05-30', '星期二', 2028, '五月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3074, '2028-05-31', '星期三', 2028, '五月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3075, '2028-06-01', '星期四', 2028, '五月', '初九', '戊申', '猴', NULL, 0, '儿童节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3076, '2028-06-02', '星期五', 2028, '五月', '初十 ', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3077, '2028-06-03', '星期六', 2028, '五月', '十一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3078, '2028-06-04', '星期日', 2028, '五月', '十二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3079, '2028-06-05', '星期一', 2028, '五月', '十三', '戊申', '猴', NULL, 0, '', '', '芒种', '', 5);
INSERT INTO `base_data_holiday` VALUES (3080, '2028-06-06', '星期二', 2028, '五月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3081, '2028-06-07', '星期三', 2028, '五月', '十五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3082, '2028-06-08', '星期四', 2028, '五月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3083, '2028-06-09', '星期五', 2028, '五月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3084, '2028-06-10', '星期六', 2028, '五月', '十八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3085, '2028-06-11', '星期日', 2028, '五月', '十九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3086, '2028-06-12', '星期一', 2028, '五月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3087, '2028-06-13', '星期二', 2028, '五月', '廿一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3088, '2028-06-14', '星期三', 2028, '五月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3089, '2028-06-15', '星期四', 2028, '五月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3090, '2028-06-16', '星期五', 2028, '五月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3091, '2028-06-17', '星期六', 2028, '五月', '廿五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3092, '2028-06-18', '星期日', 2028, '五月', '廿六', '戊申', '猴', NULL, 1, '', '', '', '父亲节', 5);
INSERT INTO `base_data_holiday` VALUES (3093, '2028-06-19', '星期一', 2028, '五月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3094, '2028-06-20', '星期二', 2028, '五月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3095, '2028-06-21', '星期三', 2028, '五月', '廿九', '戊申', '猴', NULL, 0, '', '', '夏至', '', 5);
INSERT INTO `base_data_holiday` VALUES (3096, '2028-06-22', '星期四', 2028, '五月', '三十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3097, '2028-06-23', '星期五', 2028, '闰五月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3098, '2028-06-24', '星期六', 2028, '闰五月', '初二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3099, '2028-06-25', '星期日', 2028, '闰五月', '初三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3100, '2028-06-26', '星期一', 2028, '闰五月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3101, '2028-06-27', '星期二', 2028, '闰五月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3102, '2028-06-28', '星期三', 2028, '闰五月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3103, '2028-06-29', '星期四', 2028, '闰五月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3104, '2028-06-30', '星期五', 2028, '闰五月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3105, '2028-07-01', '星期六', 2028, '闰五月', '初九', '戊申', '猴', NULL, 1, '建党节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3106, '2028-07-02', '星期日', 2028, '闰五月', '初十 ', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3107, '2028-07-03', '星期一', 2028, '闰五月', '十一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3108, '2028-07-04', '星期二', 2028, '闰五月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3109, '2028-07-05', '星期三', 2028, '闰五月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3110, '2028-07-06', '星期四', 2028, '闰五月', '十四', '戊申', '猴', NULL, 0, '', '', '小暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (3111, '2028-07-07', '星期五', 2028, '闰五月', '十五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3112, '2028-07-08', '星期六', 2028, '闰五月', '十六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3113, '2028-07-09', '星期日', 2028, '闰五月', '十七', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3114, '2028-07-10', '星期一', 2028, '闰五月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3115, '2028-07-11', '星期二', 2028, '闰五月', '十九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3116, '2028-07-12', '星期三', 2028, '闰五月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3117, '2028-07-13', '星期四', 2028, '闰五月', '廿一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3118, '2028-07-14', '星期五', 2028, '闰五月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3119, '2028-07-15', '星期六', 2028, '闰五月', '廿三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3120, '2028-07-16', '星期日', 2028, '闰五月', '廿四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3121, '2028-07-17', '星期一', 2028, '闰五月', '廿五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3122, '2028-07-18', '星期二', 2028, '闰五月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3123, '2028-07-19', '星期三', 2028, '闰五月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3124, '2028-07-20', '星期四', 2028, '闰五月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3125, '2028-07-21', '星期五', 2028, '闰五月', '廿九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3126, '2028-07-22', '星期六', 2028, '六月', '初一', '戊申', '猴', NULL, 1, '', '', '大暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (3127, '2028-07-23', '星期日', 2028, '六月', '初二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3128, '2028-07-24', '星期一', 2028, '六月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3129, '2028-07-25', '星期二', 2028, '六月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3130, '2028-07-26', '星期三', 2028, '六月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3131, '2028-07-27', '星期四', 2028, '六月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3132, '2028-07-28', '星期五', 2028, '六月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3133, '2028-07-29', '星期六', 2028, '六月', '初八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3134, '2028-07-30', '星期日', 2028, '六月', '初九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3135, '2028-07-31', '星期一', 2028, '六月', '初十 ', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3136, '2028-08-01', '星期二', 2028, '六月', '十一', '戊申', '猴', NULL, 0, '建军节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3137, '2028-08-02', '星期三', 2028, '六月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3138, '2028-08-03', '星期四', 2028, '六月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3139, '2028-08-04', '星期五', 2028, '六月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3140, '2028-08-05', '星期六', 2028, '六月', '十五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3141, '2028-08-06', '星期日', 2028, '六月', '十六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3142, '2028-08-07', '星期一', 2028, '六月', '十七', '戊申', '猴', NULL, 0, '', '', '立秋', '', 5);
INSERT INTO `base_data_holiday` VALUES (3143, '2028-08-08', '星期二', 2028, '六月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3144, '2028-08-09', '星期三', 2028, '六月', '十九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3145, '2028-08-10', '星期四', 2028, '六月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3146, '2028-08-11', '星期五', 2028, '六月', '廿一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3147, '2028-08-12', '星期六', 2028, '六月', '廿二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3148, '2028-08-13', '星期日', 2028, '六月', '廿三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3149, '2028-08-14', '星期一', 2028, '六月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3150, '2028-08-15', '星期二', 2028, '六月', '廿五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3151, '2028-08-16', '星期三', 2028, '六月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3152, '2028-08-17', '星期四', 2028, '六月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3153, '2028-08-18', '星期五', 2028, '六月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3154, '2028-08-19', '星期六', 2028, '六月', '廿九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3155, '2028-08-20', '星期日', 2028, '七月', '初一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3156, '2028-08-21', '星期一', 2028, '七月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3157, '2028-08-22', '星期二', 2028, '七月', '初三', '戊申', '猴', NULL, 0, '', '', '处暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (3158, '2028-08-23', '星期三', 2028, '七月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3159, '2028-08-24', '星期四', 2028, '七月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3160, '2028-08-25', '星期五', 2028, '七月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3161, '2028-08-26', '星期六', 2028, '七月', '初七', '戊申', '猴', NULL, 1, '', '七夕', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3162, '2028-08-27', '星期日', 2028, '七月', '初八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3163, '2028-08-28', '星期一', 2028, '七月', '初九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3164, '2028-08-29', '星期二', 2028, '七月', '初十 ', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3165, '2028-08-30', '星期三', 2028, '七月', '十一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3166, '2028-08-31', '星期四', 2028, '七月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3167, '2028-09-01', '星期五', 2028, '七月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3168, '2028-09-02', '星期六', 2028, '七月', '十四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3169, '2028-09-03', '星期日', 2028, '七月', '十五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3170, '2028-09-04', '星期一', 2028, '七月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3171, '2028-09-05', '星期二', 2028, '七月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3172, '2028-09-06', '星期三', 2028, '七月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3173, '2028-09-07', '星期四', 2028, '七月', '十九', '戊申', '猴', NULL, 0, '', '', '白露', '', 5);
INSERT INTO `base_data_holiday` VALUES (3174, '2028-09-08', '星期五', 2028, '七月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3175, '2028-09-09', '星期六', 2028, '七月', '廿一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3176, '2028-09-10', '星期日', 2028, '七月', '廿二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3177, '2028-09-11', '星期一', 2028, '七月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3178, '2028-09-12', '星期二', 2028, '七月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3179, '2028-09-13', '星期三', 2028, '七月', '廿五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3180, '2028-09-14', '星期四', 2028, '七月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3181, '2028-09-15', '星期五', 2028, '七月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3182, '2028-09-16', '星期六', 2028, '七月', '廿八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3183, '2028-09-17', '星期日', 2028, '七月', '廿九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3184, '2028-09-18', '星期一', 2028, '七月', '三十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3185, '2028-09-19', '星期二', 2028, '八月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3186, '2028-09-20', '星期三', 2028, '八月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3187, '2028-09-21', '星期四', 2028, '八月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3188, '2028-09-22', '星期五', 2028, '八月', '初四', '戊申', '猴', NULL, 0, '农民丰收节', '', '秋分', '', 5);
INSERT INTO `base_data_holiday` VALUES (3189, '2028-09-23', '星期六', 2028, '八月', '初五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3190, '2028-09-24', '星期日', 2028, '八月', '初六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3191, '2028-09-25', '星期一', 2028, '八月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3192, '2028-09-26', '星期二', 2028, '八月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3193, '2028-09-27', '星期三', 2028, '八月', '初九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3194, '2028-09-28', '星期四', 2028, '八月', '初十 ', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3195, '2028-09-29', '星期五', 2028, '八月', '十一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3196, '2028-09-30', '星期六', 2028, '八月', '十二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3197, '2028-10-01', '星期日', 2028, '八月', '十三', '戊申', '猴', NULL, 1, '国庆节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3198, '2028-10-02', '星期一', 2028, '八月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3199, '2028-10-03', '星期二', 2028, '八月', '十五', '戊申', '猴', NULL, 0, '', '中秋节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3200, '2028-10-04', '星期三', 2028, '八月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3201, '2028-10-05', '星期四', 2028, '八月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3202, '2028-10-06', '星期五', 2028, '八月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3203, '2028-10-07', '星期六', 2028, '八月', '十九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3204, '2028-10-08', '星期日', 2028, '八月', '二十', '戊申', '猴', NULL, 1, '', '', '寒露', '', 5);
INSERT INTO `base_data_holiday` VALUES (3205, '2028-10-09', '星期一', 2028, '八月', '廿一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3206, '2028-10-10', '星期二', 2028, '八月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3207, '2028-10-11', '星期三', 2028, '八月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3208, '2028-10-12', '星期四', 2028, '八月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3209, '2028-10-13', '星期五', 2028, '八月', '廿五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3210, '2028-10-14', '星期六', 2028, '八月', '廿六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3211, '2028-10-15', '星期日', 2028, '八月', '廿七', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3212, '2028-10-16', '星期一', 2028, '八月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3213, '2028-10-17', '星期二', 2028, '八月', '廿九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3214, '2028-10-18', '星期三', 2028, '九月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3215, '2028-10-19', '星期四', 2028, '九月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3216, '2028-10-20', '星期五', 2028, '九月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3217, '2028-10-21', '星期六', 2028, '九月', '初四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3218, '2028-10-22', '星期日', 2028, '九月', '初五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3219, '2028-10-23', '星期一', 2028, '九月', '初六', '戊申', '猴', NULL, 0, '', '', '霜降', '', 5);
INSERT INTO `base_data_holiday` VALUES (3220, '2028-10-24', '星期二', 2028, '九月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3221, '2028-10-25', '星期三', 2028, '九月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3222, '2028-10-26', '星期四', 2028, '九月', '初九', '戊申', '猴', NULL, 0, '', '重阳节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3223, '2028-10-27', '星期五', 2028, '九月', '初十 ', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3224, '2028-10-28', '星期六', 2028, '九月', '十一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3225, '2028-10-29', '星期日', 2028, '九月', '十二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3226, '2028-10-30', '星期一', 2028, '九月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3227, '2028-10-31', '星期二', 2028, '九月', '十四', '戊申', '猴', NULL, 0, '万圣节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3228, '2028-11-01', '星期三', 2028, '九月', '十五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3229, '2028-11-02', '星期四', 2028, '九月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3230, '2028-11-03', '星期五', 2028, '九月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3231, '2028-11-04', '星期六', 2028, '九月', '十八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3232, '2028-11-05', '星期日', 2028, '九月', '十九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3233, '2028-11-06', '星期一', 2028, '九月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3234, '2028-11-07', '星期二', 2028, '九月', '廿一', '戊申', '猴', NULL, 0, '', '', '立冬', '', 5);
INSERT INTO `base_data_holiday` VALUES (3235, '2028-11-08', '星期三', 2028, '九月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3236, '2028-11-09', '星期四', 2028, '九月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3237, '2028-11-10', '星期五', 2028, '九月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3238, '2028-11-11', '星期六', 2028, '九月', '廿五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3239, '2028-11-12', '星期日', 2028, '九月', '廿六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3240, '2028-11-13', '星期一', 2028, '九月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3241, '2028-11-14', '星期二', 2028, '九月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3242, '2028-11-15', '星期三', 2028, '九月', '廿九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3243, '2028-11-16', '星期四', 2028, '十月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3244, '2028-11-17', '星期五', 2028, '十月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3245, '2028-11-18', '星期六', 2028, '十月', '初三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3246, '2028-11-19', '星期日', 2028, '十月', '初四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3247, '2028-11-20', '星期一', 2028, '十月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3248, '2028-11-21', '星期二', 2028, '十月', '初六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3249, '2028-11-22', '星期三', 2028, '十月', '初七', '戊申', '猴', NULL, 0, '', '', '小雪', '', 5);
INSERT INTO `base_data_holiday` VALUES (3250, '2028-11-23', '星期四', 2028, '十月', '初八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3251, '2028-11-24', '星期五', 2028, '十月', '初九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3252, '2028-11-25', '星期六', 2028, '十月', '初十 ', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3253, '2028-11-26', '星期日', 2028, '十月', '十一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3254, '2028-11-27', '星期一', 2028, '十月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3255, '2028-11-28', '星期二', 2028, '十月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3256, '2028-11-29', '星期三', 2028, '十月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3257, '2028-11-30', '星期四', 2028, '十月', '十五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3258, '2028-12-01', '星期五', 2028, '十月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3259, '2028-12-02', '星期六', 2028, '十月', '十七', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3260, '2028-12-03', '星期日', 2028, '十月', '十八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3261, '2028-12-04', '星期一', 2028, '十月', '十九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3262, '2028-12-05', '星期二', 2028, '十月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3263, '2028-12-06', '星期三', 2028, '十月', '廿一', '戊申', '猴', NULL, 0, '', '', '大雪', '', 5);
INSERT INTO `base_data_holiday` VALUES (3264, '2028-12-07', '星期四', 2028, '十月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3265, '2028-12-08', '星期五', 2028, '十月', '廿三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3266, '2028-12-09', '星期六', 2028, '十月', '廿四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3267, '2028-12-10', '星期日', 2028, '十月', '廿五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3268, '2028-12-11', '星期一', 2028, '十月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3269, '2028-12-12', '星期二', 2028, '十月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3270, '2028-12-13', '星期三', 2028, '十月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3271, '2028-12-14', '星期四', 2028, '十月', '廿九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3272, '2028-12-15', '星期五', 2028, '十月', '三十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3273, '2028-12-16', '星期六', 2028, '冬月', '初一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3274, '2028-12-17', '星期日', 2028, '冬月', '初二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3275, '2028-12-18', '星期一', 2028, '冬月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3276, '2028-12-19', '星期二', 2028, '冬月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3277, '2028-12-20', '星期三', 2028, '冬月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3278, '2028-12-21', '星期四', 2028, '冬月', '初六', '戊申', '猴', NULL, 0, '', '', '冬至', '', 5);
INSERT INTO `base_data_holiday` VALUES (3279, '2028-12-22', '星期五', 2028, '冬月', '初七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3280, '2028-12-23', '星期六', 2028, '冬月', '初八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3281, '2028-12-24', '星期日', 2028, '冬月', '初九', '戊申', '猴', NULL, 1, '平安夜', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3282, '2028-12-25', '星期一', 2028, '冬月', '初十 ', '戊申', '猴', NULL, 0, '圣诞节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3283, '2028-12-26', '星期二', 2028, '冬月', '十一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3284, '2028-12-27', '星期三', 2028, '冬月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3285, '2028-12-28', '星期四', 2028, '冬月', '十三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3286, '2028-12-29', '星期五', 2028, '冬月', '十四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3287, '2028-12-30', '星期六', 2028, '冬月', '十五', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3288, '2028-12-31', '星期日', 2028, '冬月', '十六', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3289, '2029-01-01', '星期一', 2028, '冬月', '十七', '戊申', '猴', NULL, 0, '元旦', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3290, '2029-01-02', '星期二', 2028, '冬月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3291, '2029-01-03', '星期三', 2028, '冬月', '十九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3292, '2029-01-04', '星期四', 2028, '冬月', '二十', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3293, '2029-01-05', '星期五', 2028, '冬月', '廿一', '戊申', '猴', NULL, 0, '', '', '小寒', '', 5);
INSERT INTO `base_data_holiday` VALUES (3294, '2029-01-06', '星期六', 2028, '冬月', '廿二', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3295, '2029-01-07', '星期日', 2028, '冬月', '廿三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3296, '2029-01-08', '星期一', 2028, '冬月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3297, '2029-01-09', '星期二', 2028, '冬月', '廿五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3298, '2029-01-10', '星期三', 2028, '冬月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3299, '2029-01-11', '星期四', 2028, '冬月', '廿七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3300, '2029-01-12', '星期五', 2028, '冬月', '廿八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3301, '2029-01-13', '星期六', 2028, '冬月', '廿九', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3302, '2029-01-14', '星期日', 2028, '冬月', '三十', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3303, '2029-01-15', '星期一', 2028, '腊月', '初一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3304, '2029-01-16', '星期二', 2028, '腊月', '初二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3305, '2029-01-17', '星期三', 2028, '腊月', '初三', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3306, '2029-01-18', '星期四', 2028, '腊月', '初四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3307, '2029-01-19', '星期五', 2028, '腊月', '初五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3308, '2029-01-20', '星期六', 2028, '腊月', '初六', '戊申', '猴', NULL, 1, '', '', '大寒', '', 5);
INSERT INTO `base_data_holiday` VALUES (3309, '2029-01-21', '星期日', 2028, '腊月', '初七', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3310, '2029-01-22', '星期一', 2028, '腊月', '初八', '戊申', '猴', NULL, 0, '', '腊八节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3311, '2029-01-23', '星期二', 2028, '腊月', '初九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3312, '2029-01-24', '星期三', 2028, '腊月', '初十 ', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3313, '2029-01-25', '星期四', 2028, '腊月', '十一', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3314, '2029-01-26', '星期五', 2028, '腊月', '十二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3315, '2029-01-27', '星期六', 2028, '腊月', '十三', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3316, '2029-01-28', '星期日', 2028, '腊月', '十四', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3317, '2029-01-29', '星期一', 2028, '腊月', '十五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3318, '2029-01-30', '星期二', 2028, '腊月', '十六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3319, '2029-01-31', '星期三', 2028, '腊月', '十七', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3320, '2029-02-01', '星期四', 2028, '腊月', '十八', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3321, '2029-02-02', '星期五', 2028, '腊月', '十九', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3322, '2029-02-03', '星期六', 2028, '腊月', '二十', '戊申', '猴', NULL, 1, '', '', '立春', '', 5);
INSERT INTO `base_data_holiday` VALUES (3323, '2029-02-04', '星期日', 2028, '腊月', '廿一', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3324, '2029-02-05', '星期一', 2028, '腊月', '廿二', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3325, '2029-02-06', '星期二', 2028, '腊月', '廿三', '戊申', '猴', NULL, 0, '', '小年', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3326, '2029-02-07', '星期三', 2028, '腊月', '廿四', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3327, '2029-02-08', '星期四', 2028, '腊月', '廿五', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3328, '2029-02-09', '星期五', 2028, '腊月', '廿六', '戊申', '猴', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3329, '2029-02-10', '星期六', 2028, '腊月', '廿七', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3330, '2029-02-11', '星期日', 2028, '腊月', '廿八', '戊申', '猴', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3331, '2029-02-12', '星期一', 2028, '腊月', '廿九', '戊申', '猴', NULL, 0, '', '除夕', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (3332, '2029-02-13', '星期二', 2029, '正月', '初一', '己酉', '鸡', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3333, '2029-02-14', '星期三', 2029, '正月', '初二', '己酉', '鸡', NULL, 0, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3334, '2029-02-15', '星期四', 2029, '正月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3335, '2029-02-16', '星期五', 2029, '正月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3336, '2029-02-17', '星期六', 2029, '正月', '初五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3337, '2029-02-18', '星期日', 2029, '正月', '初六', '己酉', '鸡', NULL, 1, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (3338, '2029-02-19', '星期一', 2029, '正月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3339, '2029-02-20', '星期二', 2029, '正月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3340, '2029-02-21', '星期三', 2029, '正月', '初九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3341, '2029-02-22', '星期四', 2029, '正月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3342, '2029-02-23', '星期五', 2029, '正月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3343, '2029-02-24', '星期六', 2029, '正月', '十二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3344, '2029-02-25', '星期日', 2029, '正月', '十三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3345, '2029-02-26', '星期一', 2029, '正月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3346, '2029-02-27', '星期二', 2029, '正月', '十五', '己酉', '鸡', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3347, '2029-02-28', '星期三', 2029, '正月', '十六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3348, '2029-03-01', '星期四', 2029, '正月', '十七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3349, '2029-03-02', '星期五', 2029, '正月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3350, '2029-03-03', '星期六', 2029, '正月', '十九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3351, '2029-03-04', '星期日', 2029, '正月', '二十', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3352, '2029-03-05', '星期一', 2029, '正月', '廿一', '己酉', '鸡', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (3353, '2029-03-06', '星期二', 2029, '正月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3354, '2029-03-07', '星期三', 2029, '正月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3355, '2029-03-08', '星期四', 2029, '正月', '廿四', '己酉', '鸡', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3356, '2029-03-09', '星期五', 2029, '正月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3357, '2029-03-10', '星期六', 2029, '正月', '廿六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3358, '2029-03-11', '星期日', 2029, '正月', '廿七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3359, '2029-03-12', '星期一', 2029, '正月', '廿八', '己酉', '鸡', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3360, '2029-03-13', '星期二', 2029, '正月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3361, '2029-03-14', '星期三', 2029, '正月', '三十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3362, '2029-03-15', '星期四', 2029, '二月', '初一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3363, '2029-03-16', '星期五', 2029, '二月', '初二', '己酉', '鸡', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3364, '2029-03-17', '星期六', 2029, '二月', '初三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3365, '2029-03-18', '星期日', 2029, '二月', '初四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3366, '2029-03-19', '星期一', 2029, '二月', '初五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3367, '2029-03-20', '星期二', 2029, '二月', '初六', '己酉', '鸡', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (3368, '2029-03-21', '星期三', 2029, '二月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3369, '2029-03-22', '星期四', 2029, '二月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3370, '2029-03-23', '星期五', 2029, '二月', '初九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3371, '2029-03-24', '星期六', 2029, '二月', '初十 ', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3372, '2029-03-25', '星期日', 2029, '二月', '十一', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3373, '2029-03-26', '星期一', 2029, '二月', '十二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3374, '2029-03-27', '星期二', 2029, '二月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3375, '2029-03-28', '星期三', 2029, '二月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3376, '2029-03-29', '星期四', 2029, '二月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3377, '2029-03-30', '星期五', 2029, '二月', '十六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3378, '2029-03-31', '星期六', 2029, '二月', '十七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3379, '2029-04-01', '星期日', 2029, '二月', '十八', '己酉', '鸡', NULL, 1, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3380, '2029-04-02', '星期一', 2029, '二月', '十九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3381, '2029-04-03', '星期二', 2029, '二月', '二十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3382, '2029-04-04', '星期三', 2029, '二月', '廿一', '己酉', '鸡', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (3383, '2029-04-05', '星期四', 2029, '二月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3384, '2029-04-06', '星期五', 2029, '二月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3385, '2029-04-07', '星期六', 2029, '二月', '廿四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3386, '2029-04-08', '星期日', 2029, '二月', '廿五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3387, '2029-04-09', '星期一', 2029, '二月', '廿六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3388, '2029-04-10', '星期二', 2029, '二月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3389, '2029-04-11', '星期三', 2029, '二月', '廿八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3390, '2029-04-12', '星期四', 2029, '二月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3391, '2029-04-13', '星期五', 2029, '二月', '三十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3392, '2029-04-14', '星期六', 2029, '三月', '初一', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3393, '2029-04-15', '星期日', 2029, '三月', '初二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3394, '2029-04-16', '星期一', 2029, '三月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3395, '2029-04-17', '星期二', 2029, '三月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3396, '2029-04-18', '星期三', 2029, '三月', '初五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3397, '2029-04-19', '星期四', 2029, '三月', '初六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3398, '2029-04-20', '星期五', 2029, '三月', '初七', '己酉', '鸡', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (3399, '2029-04-21', '星期六', 2029, '三月', '初八', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3400, '2029-04-22', '星期日', 2029, '三月', '初九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3401, '2029-04-23', '星期一', 2029, '三月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3402, '2029-04-24', '星期二', 2029, '三月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3403, '2029-04-25', '星期三', 2029, '三月', '十二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3404, '2029-04-26', '星期四', 2029, '三月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3405, '2029-04-27', '星期五', 2029, '三月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3406, '2029-04-28', '星期六', 2029, '三月', '十五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3407, '2029-04-29', '星期日', 2029, '三月', '十六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3408, '2029-04-30', '星期一', 2029, '三月', '十七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3409, '2029-05-01', '星期二', 2029, '三月', '十八', '己酉', '鸡', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3410, '2029-05-02', '星期三', 2029, '三月', '十九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3411, '2029-05-03', '星期四', 2029, '三月', '二十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3412, '2029-05-04', '星期五', 2029, '三月', '廿一', '己酉', '鸡', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3413, '2029-05-05', '星期六', 2029, '三月', '廿二', '己酉', '鸡', NULL, 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (3414, '2029-05-06', '星期日', 2029, '三月', '廿三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3415, '2029-05-07', '星期一', 2029, '三月', '廿四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3416, '2029-05-08', '星期二', 2029, '三月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3417, '2029-05-09', '星期三', 2029, '三月', '廿六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3418, '2029-05-10', '星期四', 2029, '三月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3419, '2029-05-11', '星期五', 2029, '三月', '廿八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3420, '2029-05-12', '星期六', 2029, '三月', '廿九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3421, '2029-05-13', '星期日', 2029, '四月', '初一', '己酉', '鸡', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (3422, '2029-05-14', '星期一', 2029, '四月', '初二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3423, '2029-05-15', '星期二', 2029, '四月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3424, '2029-05-16', '星期三', 2029, '四月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3425, '2029-05-17', '星期四', 2029, '四月', '初五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3426, '2029-05-18', '星期五', 2029, '四月', '初六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3427, '2029-05-19', '星期六', 2029, '四月', '初七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3428, '2029-05-20', '星期日', 2029, '四月', '初八', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3429, '2029-05-21', '星期一', 2029, '四月', '初九', '己酉', '鸡', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (3430, '2029-05-22', '星期二', 2029, '四月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3431, '2029-05-23', '星期三', 2029, '四月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3432, '2029-05-24', '星期四', 2029, '四月', '十二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3433, '2029-05-25', '星期五', 2029, '四月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3434, '2029-05-26', '星期六', 2029, '四月', '十四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3435, '2029-05-27', '星期日', 2029, '四月', '十五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3436, '2029-05-28', '星期一', 2029, '四月', '十六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3437, '2029-05-29', '星期二', 2029, '四月', '十七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3438, '2029-05-30', '星期三', 2029, '四月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3439, '2029-05-31', '星期四', 2029, '四月', '十九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3440, '2029-06-01', '星期五', 2029, '四月', '二十', '己酉', '鸡', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3441, '2029-06-02', '星期六', 2029, '四月', '廿一', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3442, '2029-06-03', '星期日', 2029, '四月', '廿二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3443, '2029-06-04', '星期一', 2029, '四月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3444, '2029-06-05', '星期二', 2029, '四月', '廿四', '己酉', '鸡', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (3445, '2029-06-06', '星期三', 2029, '四月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3446, '2029-06-07', '星期四', 2029, '四月', '廿六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3447, '2029-06-08', '星期五', 2029, '四月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3448, '2029-06-09', '星期六', 2029, '四月', '廿八', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3449, '2029-06-10', '星期日', 2029, '四月', '廿九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3450, '2029-06-11', '星期一', 2029, '四月', '三十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3451, '2029-06-12', '星期二', 2029, '五月', '初一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3452, '2029-06-13', '星期三', 2029, '五月', '初二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3453, '2029-06-14', '星期四', 2029, '五月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3454, '2029-06-15', '星期五', 2029, '五月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3455, '2029-06-16', '星期六', 2029, '五月', '初五', '己酉', '鸡', NULL, 1, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3456, '2029-06-17', '星期日', 2029, '五月', '初六', '己酉', '鸡', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (3457, '2029-06-18', '星期一', 2029, '五月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3458, '2029-06-19', '星期二', 2029, '五月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3459, '2029-06-20', '星期三', 2029, '五月', '初九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3460, '2029-06-21', '星期四', 2029, '五月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (3461, '2029-06-22', '星期五', 2029, '五月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3462, '2029-06-23', '星期六', 2029, '五月', '十二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3463, '2029-06-24', '星期日', 2029, '五月', '十三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3464, '2029-06-25', '星期一', 2029, '五月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3465, '2029-06-26', '星期二', 2029, '五月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3466, '2029-06-27', '星期三', 2029, '五月', '十六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3467, '2029-06-28', '星期四', 2029, '五月', '十七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3468, '2029-06-29', '星期五', 2029, '五月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3469, '2029-06-30', '星期六', 2029, '五月', '十九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3470, '2029-07-01', '星期日', 2029, '五月', '二十', '己酉', '鸡', NULL, 1, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3471, '2029-07-02', '星期一', 2029, '五月', '廿一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3472, '2029-07-03', '星期二', 2029, '五月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3473, '2029-07-04', '星期三', 2029, '五月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3474, '2029-07-05', '星期四', 2029, '五月', '廿四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3475, '2029-07-06', '星期五', 2029, '五月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3476, '2029-07-07', '星期六', 2029, '五月', '廿六', '己酉', '鸡', NULL, 1, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (3477, '2029-07-08', '星期日', 2029, '五月', '廿七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3478, '2029-07-09', '星期一', 2029, '五月', '廿八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3479, '2029-07-10', '星期二', 2029, '五月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3480, '2029-07-11', '星期三', 2029, '六月', '初一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3481, '2029-07-12', '星期四', 2029, '六月', '初二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3482, '2029-07-13', '星期五', 2029, '六月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3483, '2029-07-14', '星期六', 2029, '六月', '初四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3484, '2029-07-15', '星期日', 2029, '六月', '初五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3485, '2029-07-16', '星期一', 2029, '六月', '初六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3486, '2029-07-17', '星期二', 2029, '六月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3487, '2029-07-18', '星期三', 2029, '六月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3488, '2029-07-19', '星期四', 2029, '六月', '初九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3489, '2029-07-20', '星期五', 2029, '六月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3490, '2029-07-21', '星期六', 2029, '六月', '十一', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3491, '2029-07-22', '星期日', 2029, '六月', '十二', '己酉', '鸡', NULL, 1, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (3492, '2029-07-23', '星期一', 2029, '六月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3493, '2029-07-24', '星期二', 2029, '六月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3494, '2029-07-25', '星期三', 2029, '六月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3495, '2029-07-26', '星期四', 2029, '六月', '十六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3496, '2029-07-27', '星期五', 2029, '六月', '十七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3497, '2029-07-28', '星期六', 2029, '六月', '十八', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3498, '2029-07-29', '星期日', 2029, '六月', '十九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3499, '2029-07-30', '星期一', 2029, '六月', '二十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3500, '2029-07-31', '星期二', 2029, '六月', '廿一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3501, '2029-08-01', '星期三', 2029, '六月', '廿二', '己酉', '鸡', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3502, '2029-08-02', '星期四', 2029, '六月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3503, '2029-08-03', '星期五', 2029, '六月', '廿四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3504, '2029-08-04', '星期六', 2029, '六月', '廿五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3505, '2029-08-05', '星期日', 2029, '六月', '廿六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3506, '2029-08-06', '星期一', 2029, '六月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3507, '2029-08-07', '星期二', 2029, '六月', '廿八', '己酉', '鸡', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (3508, '2029-08-08', '星期三', 2029, '六月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3509, '2029-08-09', '星期四', 2029, '六月', '三十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3510, '2029-08-10', '星期五', 2029, '七月', '初一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3511, '2029-08-11', '星期六', 2029, '七月', '初二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3512, '2029-08-12', '星期日', 2029, '七月', '初三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3513, '2029-08-13', '星期一', 2029, '七月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3514, '2029-08-14', '星期二', 2029, '七月', '初五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3515, '2029-08-15', '星期三', 2029, '七月', '初六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3516, '2029-08-16', '星期四', 2029, '七月', '初七', '己酉', '鸡', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3517, '2029-08-17', '星期五', 2029, '七月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3518, '2029-08-18', '星期六', 2029, '七月', '初九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3519, '2029-08-19', '星期日', 2029, '七月', '初十 ', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3520, '2029-08-20', '星期一', 2029, '七月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3521, '2029-08-21', '星期二', 2029, '七月', '十二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3522, '2029-08-22', '星期三', 2029, '七月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3523, '2029-08-23', '星期四', 2029, '七月', '十四', '己酉', '鸡', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (3524, '2029-08-24', '星期五', 2029, '七月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3525, '2029-08-25', '星期六', 2029, '七月', '十六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3526, '2029-08-26', '星期日', 2029, '七月', '十七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3527, '2029-08-27', '星期一', 2029, '七月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3528, '2029-08-28', '星期二', 2029, '七月', '十九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3529, '2029-08-29', '星期三', 2029, '七月', '二十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3530, '2029-08-30', '星期四', 2029, '七月', '廿一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3531, '2029-08-31', '星期五', 2029, '七月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3532, '2029-09-01', '星期六', 2029, '七月', '廿三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3533, '2029-09-02', '星期日', 2029, '七月', '廿四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3534, '2029-09-03', '星期一', 2029, '七月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3535, '2029-09-04', '星期二', 2029, '七月', '廿六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3536, '2029-09-05', '星期三', 2029, '七月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3537, '2029-09-06', '星期四', 2029, '七月', '廿八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3538, '2029-09-07', '星期五', 2029, '七月', '廿九', '己酉', '鸡', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (3539, '2029-09-08', '星期六', 2029, '八月', '初一', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3540, '2029-09-09', '星期日', 2029, '八月', '初二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3541, '2029-09-10', '星期一', 2029, '八月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3542, '2029-09-11', '星期二', 2029, '八月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3543, '2029-09-12', '星期三', 2029, '八月', '初五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3544, '2029-09-13', '星期四', 2029, '八月', '初六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3545, '2029-09-14', '星期五', 2029, '八月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3546, '2029-09-15', '星期六', 2029, '八月', '初八', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3547, '2029-09-16', '星期日', 2029, '八月', '初九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3548, '2029-09-17', '星期一', 2029, '八月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3549, '2029-09-18', '星期二', 2029, '八月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3550, '2029-09-19', '星期三', 2029, '八月', '十二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3551, '2029-09-20', '星期四', 2029, '八月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3552, '2029-09-21', '星期五', 2029, '八月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3553, '2029-09-22', '星期六', 2029, '八月', '十五', '己酉', '鸡', NULL, 1, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3554, '2029-09-23', '星期日', 2029, '八月', '十六', '己酉', '鸡', NULL, 1, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (3555, '2029-09-24', '星期一', 2029, '八月', '十七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3556, '2029-09-25', '星期二', 2029, '八月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3557, '2029-09-26', '星期三', 2029, '八月', '十九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3558, '2029-09-27', '星期四', 2029, '八月', '二十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3559, '2029-09-28', '星期五', 2029, '八月', '廿一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3560, '2029-09-29', '星期六', 2029, '八月', '廿二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3561, '2029-09-30', '星期日', 2029, '八月', '廿三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3562, '2029-10-01', '星期一', 2029, '八月', '廿四', '己酉', '鸡', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3563, '2029-10-02', '星期二', 2029, '八月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3564, '2029-10-03', '星期三', 2029, '八月', '廿六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3565, '2029-10-04', '星期四', 2029, '八月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3566, '2029-10-05', '星期五', 2029, '八月', '廿八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3567, '2029-10-06', '星期六', 2029, '八月', '廿九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3568, '2029-10-07', '星期日', 2029, '八月', '三十', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3569, '2029-10-08', '星期一', 2029, '九月', '初一', '己酉', '鸡', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (3570, '2029-10-09', '星期二', 2029, '九月', '初二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3571, '2029-10-10', '星期三', 2029, '九月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3572, '2029-10-11', '星期四', 2029, '九月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3573, '2029-10-12', '星期五', 2029, '九月', '初五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3574, '2029-10-13', '星期六', 2029, '九月', '初六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3575, '2029-10-14', '星期日', 2029, '九月', '初七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3576, '2029-10-15', '星期一', 2029, '九月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3577, '2029-10-16', '星期二', 2029, '九月', '初九', '己酉', '鸡', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3578, '2029-10-17', '星期三', 2029, '九月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3579, '2029-10-18', '星期四', 2029, '九月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3580, '2029-10-19', '星期五', 2029, '九月', '十二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3581, '2029-10-20', '星期六', 2029, '九月', '十三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3582, '2029-10-21', '星期日', 2029, '九月', '十四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3583, '2029-10-22', '星期一', 2029, '九月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3584, '2029-10-23', '星期二', 2029, '九月', '十六', '己酉', '鸡', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (3585, '2029-10-24', '星期三', 2029, '九月', '十七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3586, '2029-10-25', '星期四', 2029, '九月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3587, '2029-10-26', '星期五', 2029, '九月', '十九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3588, '2029-10-27', '星期六', 2029, '九月', '二十', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3589, '2029-10-28', '星期日', 2029, '九月', '廿一', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3590, '2029-10-29', '星期一', 2029, '九月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3591, '2029-10-30', '星期二', 2029, '九月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3592, '2029-10-31', '星期三', 2029, '九月', '廿四', '己酉', '鸡', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3593, '2029-11-01', '星期四', 2029, '九月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3594, '2029-11-02', '星期五', 2029, '九月', '廿六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3595, '2029-11-03', '星期六', 2029, '九月', '廿七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3596, '2029-11-04', '星期日', 2029, '九月', '廿八', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3597, '2029-11-05', '星期一', 2029, '九月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3598, '2029-11-06', '星期二', 2029, '十月', '初一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3599, '2029-11-07', '星期三', 2029, '十月', '初二', '己酉', '鸡', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (3600, '2029-11-08', '星期四', 2029, '十月', '初三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3601, '2029-11-09', '星期五', 2029, '十月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3602, '2029-11-10', '星期六', 2029, '十月', '初五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3603, '2029-11-11', '星期日', 2029, '十月', '初六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3604, '2029-11-12', '星期一', 2029, '十月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3605, '2029-11-13', '星期二', 2029, '十月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3606, '2029-11-14', '星期三', 2029, '十月', '初九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3607, '2029-11-15', '星期四', 2029, '十月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3608, '2029-11-16', '星期五', 2029, '十月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3609, '2029-11-17', '星期六', 2029, '十月', '十二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3610, '2029-11-18', '星期日', 2029, '十月', '十三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3611, '2029-11-19', '星期一', 2029, '十月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3612, '2029-11-20', '星期二', 2029, '十月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3613, '2029-11-21', '星期三', 2029, '十月', '十六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3614, '2029-11-22', '星期四', 2029, '十月', '十七', '己酉', '鸡', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (3615, '2029-11-23', '星期五', 2029, '十月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3616, '2029-11-24', '星期六', 2029, '十月', '十九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3617, '2029-11-25', '星期日', 2029, '十月', '二十', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3618, '2029-11-26', '星期一', 2029, '十月', '廿一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3619, '2029-11-27', '星期二', 2029, '十月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3620, '2029-11-28', '星期三', 2029, '十月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3621, '2029-11-29', '星期四', 2029, '十月', '廿四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3622, '2029-11-30', '星期五', 2029, '十月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3623, '2029-12-01', '星期六', 2029, '十月', '廿六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3624, '2029-12-02', '星期日', 2029, '十月', '廿七', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3625, '2029-12-03', '星期一', 2029, '十月', '廿八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3626, '2029-12-04', '星期二', 2029, '十月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3627, '2029-12-05', '星期三', 2029, '冬月', '初一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3628, '2029-12-06', '星期四', 2029, '冬月', '初二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3629, '2029-12-07', '星期五', 2029, '冬月', '初三', '己酉', '鸡', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (3630, '2029-12-08', '星期六', 2029, '冬月', '初四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3631, '2029-12-09', '星期日', 2029, '冬月', '初五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3632, '2029-12-10', '星期一', 2029, '冬月', '初六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3633, '2029-12-11', '星期二', 2029, '冬月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3634, '2029-12-12', '星期三', 2029, '冬月', '初八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3635, '2029-12-13', '星期四', 2029, '冬月', '初九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3636, '2029-12-14', '星期五', 2029, '冬月', '初十 ', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3637, '2029-12-15', '星期六', 2029, '冬月', '十一', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3638, '2029-12-16', '星期日', 2029, '冬月', '十二', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3639, '2029-12-17', '星期一', 2029, '冬月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3640, '2029-12-18', '星期二', 2029, '冬月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3641, '2029-12-19', '星期三', 2029, '冬月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3642, '2029-12-20', '星期四', 2029, '冬月', '十六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3643, '2029-12-21', '星期五', 2029, '冬月', '十七', '己酉', '鸡', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (3644, '2029-12-22', '星期六', 2029, '冬月', '十八', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3645, '2029-12-23', '星期日', 2029, '冬月', '十九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3646, '2029-12-24', '星期一', 2029, '冬月', '二十', '己酉', '鸡', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3647, '2029-12-25', '星期二', 2029, '冬月', '廿一', '己酉', '鸡', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3648, '2029-12-26', '星期三', 2029, '冬月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3649, '2029-12-27', '星期四', 2029, '冬月', '廿三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3650, '2029-12-28', '星期五', 2029, '冬月', '廿四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3651, '2029-12-29', '星期六', 2029, '冬月', '廿五', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3652, '2029-12-30', '星期日', 2029, '冬月', '廿六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3653, '2029-12-31', '星期一', 2029, '冬月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3654, '2030-01-01', '星期二', 2029, '冬月', '廿八', '己酉', '鸡', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3655, '2030-01-02', '星期三', 2029, '冬月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3656, '2030-01-03', '星期四', 2029, '冬月', '三十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3657, '2030-01-04', '星期五', 2029, '腊月', '初一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3658, '2030-01-05', '星期六', 2029, '腊月', '初二', '己酉', '鸡', NULL, 1, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (3659, '2030-01-06', '星期日', 2029, '腊月', '初三', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3660, '2030-01-07', '星期一', 2029, '腊月', '初四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3661, '2030-01-08', '星期二', 2029, '腊月', '初五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3662, '2030-01-09', '星期三', 2029, '腊月', '初六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3663, '2030-01-10', '星期四', 2029, '腊月', '初七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3664, '2030-01-11', '星期五', 2029, '腊月', '初八', '己酉', '鸡', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3665, '2030-01-12', '星期六', 2029, '腊月', '初九', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3666, '2030-01-13', '星期日', 2029, '腊月', '初十 ', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3667, '2030-01-14', '星期一', 2029, '腊月', '十一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3668, '2030-01-15', '星期二', 2029, '腊月', '十二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3669, '2030-01-16', '星期三', 2029, '腊月', '十三', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3670, '2030-01-17', '星期四', 2029, '腊月', '十四', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3671, '2030-01-18', '星期五', 2029, '腊月', '十五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3672, '2030-01-19', '星期六', 2029, '腊月', '十六', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3673, '2030-01-20', '星期日', 2029, '腊月', '十七', '己酉', '鸡', NULL, 1, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (3674, '2030-01-21', '星期一', 2029, '腊月', '十八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3675, '2030-01-22', '星期二', 2029, '腊月', '十九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3676, '2030-01-23', '星期三', 2029, '腊月', '二十', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3677, '2030-01-24', '星期四', 2029, '腊月', '廿一', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3678, '2030-01-25', '星期五', 2029, '腊月', '廿二', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3679, '2030-01-26', '星期六', 2029, '腊月', '廿三', '己酉', '鸡', NULL, 1, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3680, '2030-01-27', '星期日', 2029, '腊月', '廿四', '己酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3681, '2030-01-28', '星期一', 2029, '腊月', '廿五', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3682, '2030-01-29', '星期二', 2029, '腊月', '廿六', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3683, '2030-01-30', '星期三', 2029, '腊月', '廿七', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3684, '2030-01-31', '星期四', 2029, '腊月', '廿八', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3685, '2030-02-01', '星期五', 2029, '腊月', '廿九', '己酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3686, '2030-02-02', '星期六', 2029, '腊月', '三十', '己酉', '鸡', NULL, 1, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3687, '2030-02-03', '星期日', 2030, '正月', '初一', '庚戌', '狗', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3688, '2030-02-04', '星期一', 2030, '正月', '初二', '庚戌', '狗', NULL, 0, '', '', '立春', '', 0);
INSERT INTO `base_data_holiday` VALUES (3689, '2030-02-05', '星期二', 2030, '正月', '初三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3690, '2030-02-06', '星期三', 2030, '正月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3691, '2030-02-07', '星期四', 2030, '正月', '初五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3692, '2030-02-08', '星期五', 2030, '正月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3693, '2030-02-09', '星期六', 2030, '正月', '初七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3694, '2030-02-10', '星期日', 2030, '正月', '初八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3695, '2030-02-11', '星期一', 2030, '正月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3696, '2030-02-12', '星期二', 2030, '正月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3697, '2030-02-13', '星期三', 2030, '正月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3698, '2030-02-14', '星期四', 2030, '正月', '十二', '庚戌', '狗', NULL, 0, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3699, '2030-02-15', '星期五', 2030, '正月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3700, '2030-02-16', '星期六', 2030, '正月', '十四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3701, '2030-02-17', '星期日', 2030, '正月', '十五', '庚戌', '狗', NULL, 1, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3702, '2030-02-18', '星期一', 2030, '正月', '十六', '庚戌', '狗', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (3703, '2030-02-19', '星期二', 2030, '正月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3704, '2030-02-20', '星期三', 2030, '正月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3705, '2030-02-21', '星期四', 2030, '正月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3706, '2030-02-22', '星期五', 2030, '正月', '二十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3707, '2030-02-23', '星期六', 2030, '正月', '廿一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3708, '2030-02-24', '星期日', 2030, '正月', '廿二', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3709, '2030-02-25', '星期一', 2030, '正月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3710, '2030-02-26', '星期二', 2030, '正月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3711, '2030-02-27', '星期三', 2030, '正月', '廿五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3712, '2030-02-28', '星期四', 2030, '正月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3713, '2030-03-01', '星期五', 2030, '正月', '廿七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3714, '2030-03-02', '星期六', 2030, '正月', '廿八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3715, '2030-03-03', '星期日', 2030, '正月', '廿九', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3716, '2030-03-04', '星期一', 2030, '二月', '初一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3717, '2030-03-05', '星期二', 2030, '二月', '初二', '庚戌', '狗', NULL, 0, '', '龙抬头', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (3718, '2030-03-06', '星期三', 2030, '二月', '初三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3719, '2030-03-07', '星期四', 2030, '二月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3720, '2030-03-08', '星期五', 2030, '二月', '初五', '庚戌', '狗', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3721, '2030-03-09', '星期六', 2030, '二月', '初六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3722, '2030-03-10', '星期日', 2030, '二月', '初七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3723, '2030-03-11', '星期一', 2030, '二月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3724, '2030-03-12', '星期二', 2030, '二月', '初九', '庚戌', '狗', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3725, '2030-03-13', '星期三', 2030, '二月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3726, '2030-03-14', '星期四', 2030, '二月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3727, '2030-03-15', '星期五', 2030, '二月', '十二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3728, '2030-03-16', '星期六', 2030, '二月', '十三', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3729, '2030-03-17', '星期日', 2030, '二月', '十四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3730, '2030-03-18', '星期一', 2030, '二月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3731, '2030-03-19', '星期二', 2030, '二月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3732, '2030-03-20', '星期三', 2030, '二月', '十七', '庚戌', '狗', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (3733, '2030-03-21', '星期四', 2030, '二月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3734, '2030-03-22', '星期五', 2030, '二月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3735, '2030-03-23', '星期六', 2030, '二月', '二十', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3736, '2030-03-24', '星期日', 2030, '二月', '廿一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3737, '2030-03-25', '星期一', 2030, '二月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3738, '2030-03-26', '星期二', 2030, '二月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3739, '2030-03-27', '星期三', 2030, '二月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3740, '2030-03-28', '星期四', 2030, '二月', '廿五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3741, '2030-03-29', '星期五', 2030, '二月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3742, '2030-03-30', '星期六', 2030, '二月', '廿七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3743, '2030-03-31', '星期日', 2030, '二月', '廿八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3744, '2030-04-01', '星期一', 2030, '二月', '廿九', '庚戌', '狗', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3745, '2030-04-02', '星期二', 2030, '二月', '三十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3746, '2030-04-03', '星期三', 2030, '三月', '初一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3747, '2030-04-04', '星期四', 2030, '三月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3748, '2030-04-05', '星期五', 2030, '三月', '初三', '庚戌', '狗', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (3749, '2030-04-06', '星期六', 2030, '三月', '初四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3750, '2030-04-07', '星期日', 2030, '三月', '初五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3751, '2030-04-08', '星期一', 2030, '三月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3752, '2030-04-09', '星期二', 2030, '三月', '初七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3753, '2030-04-10', '星期三', 2030, '三月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3754, '2030-04-11', '星期四', 2030, '三月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3755, '2030-04-12', '星期五', 2030, '三月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3756, '2030-04-13', '星期六', 2030, '三月', '十一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3757, '2030-04-14', '星期日', 2030, '三月', '十二', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3758, '2030-04-15', '星期一', 2030, '三月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3759, '2030-04-16', '星期二', 2030, '三月', '十四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3760, '2030-04-17', '星期三', 2030, '三月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3761, '2030-04-18', '星期四', 2030, '三月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3762, '2030-04-19', '星期五', 2030, '三月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3763, '2030-04-20', '星期六', 2030, '三月', '十八', '庚戌', '狗', NULL, 1, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (3764, '2030-04-21', '星期日', 2030, '三月', '十九', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3765, '2030-04-22', '星期一', 2030, '三月', '二十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3766, '2030-04-23', '星期二', 2030, '三月', '廿一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3767, '2030-04-24', '星期三', 2030, '三月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3768, '2030-04-25', '星期四', 2030, '三月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3769, '2030-04-26', '星期五', 2030, '三月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3770, '2030-04-27', '星期六', 2030, '三月', '廿五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3771, '2030-04-28', '星期日', 2030, '三月', '廿六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3772, '2030-04-29', '星期一', 2030, '三月', '廿七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3773, '2030-04-30', '星期二', 2030, '三月', '廿八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3774, '2030-05-01', '星期三', 2030, '三月', '廿九', '庚戌', '狗', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3775, '2030-05-02', '星期四', 2030, '四月', '初一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3776, '2030-05-03', '星期五', 2030, '四月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3777, '2030-05-04', '星期六', 2030, '四月', '初三', '庚戌', '狗', NULL, 1, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3778, '2030-05-05', '星期日', 2030, '四月', '初四', '庚戌', '狗', NULL, 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (3779, '2030-05-06', '星期一', 2030, '四月', '初五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3780, '2030-05-07', '星期二', 2030, '四月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3781, '2030-05-08', '星期三', 2030, '四月', '初七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3782, '2030-05-09', '星期四', 2030, '四月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3783, '2030-05-10', '星期五', 2030, '四月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3784, '2030-05-11', '星期六', 2030, '四月', '初十 ', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3785, '2030-05-12', '星期日', 2030, '四月', '十一', '庚戌', '狗', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (3786, '2030-05-13', '星期一', 2030, '四月', '十二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3787, '2030-05-14', '星期二', 2030, '四月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3788, '2030-05-15', '星期三', 2030, '四月', '十四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3789, '2030-05-16', '星期四', 2030, '四月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3790, '2030-05-17', '星期五', 2030, '四月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3791, '2030-05-18', '星期六', 2030, '四月', '十七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3792, '2030-05-19', '星期日', 2030, '四月', '十八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3793, '2030-05-20', '星期一', 2030, '四月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3794, '2030-05-21', '星期二', 2030, '四月', '二十', '庚戌', '狗', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (3795, '2030-05-22', '星期三', 2030, '四月', '廿一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3796, '2030-05-23', '星期四', 2030, '四月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3797, '2030-05-24', '星期五', 2030, '四月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3798, '2030-05-25', '星期六', 2030, '四月', '廿四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3799, '2030-05-26', '星期日', 2030, '四月', '廿五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3800, '2030-05-27', '星期一', 2030, '四月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3801, '2030-05-28', '星期二', 2030, '四月', '廿七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3802, '2030-05-29', '星期三', 2030, '四月', '廿八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3803, '2030-05-30', '星期四', 2030, '四月', '廿九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3804, '2030-05-31', '星期五', 2030, '四月', '三十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3805, '2030-06-01', '星期六', 2030, '五月', '初一', '庚戌', '狗', NULL, 1, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3806, '2030-06-02', '星期日', 2030, '五月', '初二', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3807, '2030-06-03', '星期一', 2030, '五月', '初三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3808, '2030-06-04', '星期二', 2030, '五月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3809, '2030-06-05', '星期三', 2030, '五月', '初五', '庚戌', '狗', NULL, 0, '', '端午节', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (3810, '2030-06-06', '星期四', 2030, '五月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3811, '2030-06-07', '星期五', 2030, '五月', '初七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3812, '2030-06-08', '星期六', 2030, '五月', '初八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3813, '2030-06-09', '星期日', 2030, '五月', '初九', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3814, '2030-06-10', '星期一', 2030, '五月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3815, '2030-06-11', '星期二', 2030, '五月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3816, '2030-06-12', '星期三', 2030, '五月', '十二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3817, '2030-06-13', '星期四', 2030, '五月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3818, '2030-06-14', '星期五', 2030, '五月', '十四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3819, '2030-06-15', '星期六', 2030, '五月', '十五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3820, '2030-06-16', '星期日', 2030, '五月', '十六', '庚戌', '狗', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (3821, '2030-06-17', '星期一', 2030, '五月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3822, '2030-06-18', '星期二', 2030, '五月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3823, '2030-06-19', '星期三', 2030, '五月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3824, '2030-06-20', '星期四', 2030, '五月', '二十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3825, '2030-06-21', '星期五', 2030, '五月', '廿一', '庚戌', '狗', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (3826, '2030-06-22', '星期六', 2030, '五月', '廿二', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3827, '2030-06-23', '星期日', 2030, '五月', '廿三', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3828, '2030-06-24', '星期一', 2030, '五月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3829, '2030-06-25', '星期二', 2030, '五月', '廿五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3830, '2030-06-26', '星期三', 2030, '五月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3831, '2030-06-27', '星期四', 2030, '五月', '廿七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3832, '2030-06-28', '星期五', 2030, '五月', '廿八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3833, '2030-06-29', '星期六', 2030, '五月', '廿九', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3834, '2030-06-30', '星期日', 2030, '五月', '三十', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3835, '2030-07-01', '星期一', 2030, '六月', '初一', '庚戌', '狗', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3836, '2030-07-02', '星期二', 2030, '六月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3837, '2030-07-03', '星期三', 2030, '六月', '初三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3838, '2030-07-04', '星期四', 2030, '六月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3839, '2030-07-05', '星期五', 2030, '六月', '初五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3840, '2030-07-06', '星期六', 2030, '六月', '初六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3841, '2030-07-07', '星期日', 2030, '六月', '初七', '庚戌', '狗', NULL, 1, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (3842, '2030-07-08', '星期一', 2030, '六月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3843, '2030-07-09', '星期二', 2030, '六月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3844, '2030-07-10', '星期三', 2030, '六月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3845, '2030-07-11', '星期四', 2030, '六月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3846, '2030-07-12', '星期五', 2030, '六月', '十二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3847, '2030-07-13', '星期六', 2030, '六月', '十三', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3848, '2030-07-14', '星期日', 2030, '六月', '十四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3849, '2030-07-15', '星期一', 2030, '六月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3850, '2030-07-16', '星期二', 2030, '六月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3851, '2030-07-17', '星期三', 2030, '六月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3852, '2030-07-18', '星期四', 2030, '六月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3853, '2030-07-19', '星期五', 2030, '六月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3854, '2030-07-20', '星期六', 2030, '六月', '二十', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3855, '2030-07-21', '星期日', 2030, '六月', '廿一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3856, '2030-07-22', '星期一', 2030, '六月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3857, '2030-07-23', '星期二', 2030, '六月', '廿三', '庚戌', '狗', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (3858, '2030-07-24', '星期三', 2030, '六月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3859, '2030-07-25', '星期四', 2030, '六月', '廿五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3860, '2030-07-26', '星期五', 2030, '六月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3861, '2030-07-27', '星期六', 2030, '六月', '廿七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3862, '2030-07-28', '星期日', 2030, '六月', '廿八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3863, '2030-07-29', '星期一', 2030, '六月', '廿九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3864, '2030-07-30', '星期二', 2030, '七月', '初一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3865, '2030-07-31', '星期三', 2030, '七月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3866, '2030-08-01', '星期四', 2030, '七月', '初三', '庚戌', '狗', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3867, '2030-08-02', '星期五', 2030, '七月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3868, '2030-08-03', '星期六', 2030, '七月', '初五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3869, '2030-08-04', '星期日', 2030, '七月', '初六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3870, '2030-08-05', '星期一', 2030, '七月', '初七', '庚戌', '狗', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3871, '2030-08-06', '星期二', 2030, '七月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3872, '2030-08-07', '星期三', 2030, '七月', '初九', '庚戌', '狗', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (3873, '2030-08-08', '星期四', 2030, '七月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3874, '2030-08-09', '星期五', 2030, '七月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3875, '2030-08-10', '星期六', 2030, '七月', '十二', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3876, '2030-08-11', '星期日', 2030, '七月', '十三', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3877, '2030-08-12', '星期一', 2030, '七月', '十四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3878, '2030-08-13', '星期二', 2030, '七月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3879, '2030-08-14', '星期三', 2030, '七月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3880, '2030-08-15', '星期四', 2030, '七月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3881, '2030-08-16', '星期五', 2030, '七月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3882, '2030-08-17', '星期六', 2030, '七月', '十九', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3883, '2030-08-18', '星期日', 2030, '七月', '二十', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3884, '2030-08-19', '星期一', 2030, '七月', '廿一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3885, '2030-08-20', '星期二', 2030, '七月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3886, '2030-08-21', '星期三', 2030, '七月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3887, '2030-08-22', '星期四', 2030, '七月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3888, '2030-08-23', '星期五', 2030, '七月', '廿五', '庚戌', '狗', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (3889, '2030-08-24', '星期六', 2030, '七月', '廿六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3890, '2030-08-25', '星期日', 2030, '七月', '廿七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3891, '2030-08-26', '星期一', 2030, '七月', '廿八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3892, '2030-08-27', '星期二', 2030, '七月', '廿九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3893, '2030-08-28', '星期三', 2030, '七月', '三十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3894, '2030-08-29', '星期四', 2030, '八月', '初一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3895, '2030-08-30', '星期五', 2030, '八月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3896, '2030-08-31', '星期六', 2030, '八月', '初三', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3897, '2030-09-01', '星期日', 2030, '八月', '初四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3898, '2030-09-02', '星期一', 2030, '八月', '初五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3899, '2030-09-03', '星期二', 2030, '八月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3900, '2030-09-04', '星期三', 2030, '八月', '初七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3901, '2030-09-05', '星期四', 2030, '八月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3902, '2030-09-06', '星期五', 2030, '八月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3903, '2030-09-07', '星期六', 2030, '八月', '初十 ', '庚戌', '狗', NULL, 1, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (3904, '2030-09-08', '星期日', 2030, '八月', '十一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3905, '2030-09-09', '星期一', 2030, '八月', '十二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3906, '2030-09-10', '星期二', 2030, '八月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3907, '2030-09-11', '星期三', 2030, '八月', '十四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3908, '2030-09-12', '星期四', 2030, '八月', '十五', '庚戌', '狗', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3909, '2030-09-13', '星期五', 2030, '八月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3910, '2030-09-14', '星期六', 2030, '八月', '十七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3911, '2030-09-15', '星期日', 2030, '八月', '十八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3912, '2030-09-16', '星期一', 2030, '八月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3913, '2030-09-17', '星期二', 2030, '八月', '二十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3914, '2030-09-18', '星期三', 2030, '八月', '廿一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3915, '2030-09-19', '星期四', 2030, '八月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3916, '2030-09-20', '星期五', 2030, '八月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3917, '2030-09-21', '星期六', 2030, '八月', '廿四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3918, '2030-09-22', '星期日', 2030, '八月', '廿五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3919, '2030-09-23', '星期一', 2030, '八月', '廿六', '庚戌', '狗', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (3920, '2030-09-24', '星期二', 2030, '八月', '廿七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3921, '2030-09-25', '星期三', 2030, '八月', '廿八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3922, '2030-09-26', '星期四', 2030, '八月', '廿九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3923, '2030-09-27', '星期五', 2030, '九月', '初一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3924, '2030-09-28', '星期六', 2030, '九月', '初二', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3925, '2030-09-29', '星期日', 2030, '九月', '初三', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3926, '2030-09-30', '星期一', 2030, '九月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3927, '2030-10-01', '星期二', 2030, '九月', '初五', '庚戌', '狗', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3928, '2030-10-02', '星期三', 2030, '九月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3929, '2030-10-03', '星期四', 2030, '九月', '初七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3930, '2030-10-04', '星期五', 2030, '九月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3931, '2030-10-05', '星期六', 2030, '九月', '初九', '庚戌', '狗', NULL, 1, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3932, '2030-10-06', '星期日', 2030, '九月', '初十 ', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3933, '2030-10-07', '星期一', 2030, '九月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3934, '2030-10-08', '星期二', 2030, '九月', '十二', '庚戌', '狗', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (3935, '2030-10-09', '星期三', 2030, '九月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3936, '2030-10-10', '星期四', 2030, '九月', '十四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3937, '2030-10-11', '星期五', 2030, '九月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3938, '2030-10-12', '星期六', 2030, '九月', '十六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3939, '2030-10-13', '星期日', 2030, '九月', '十七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3940, '2030-10-14', '星期一', 2030, '九月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3941, '2030-10-15', '星期二', 2030, '九月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3942, '2030-10-16', '星期三', 2030, '九月', '二十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3943, '2030-10-17', '星期四', 2030, '九月', '廿一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3944, '2030-10-18', '星期五', 2030, '九月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3945, '2030-10-19', '星期六', 2030, '九月', '廿三', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3946, '2030-10-20', '星期日', 2030, '九月', '廿四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3947, '2030-10-21', '星期一', 2030, '九月', '廿五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3948, '2030-10-22', '星期二', 2030, '九月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3949, '2030-10-23', '星期三', 2030, '九月', '廿七', '庚戌', '狗', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (3950, '2030-10-24', '星期四', 2030, '九月', '廿八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3951, '2030-10-25', '星期五', 2030, '九月', '廿九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3952, '2030-10-26', '星期六', 2030, '九月', '三十', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3953, '2030-10-27', '星期日', 2030, '十月', '初一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3954, '2030-10-28', '星期一', 2030, '十月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3955, '2030-10-29', '星期二', 2030, '十月', '初三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3956, '2030-10-30', '星期三', 2030, '十月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3957, '2030-10-31', '星期四', 2030, '十月', '初五', '庚戌', '狗', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3958, '2030-11-01', '星期五', 2030, '十月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3959, '2030-11-02', '星期六', 2030, '十月', '初七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3960, '2030-11-03', '星期日', 2030, '十月', '初八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3961, '2030-11-04', '星期一', 2030, '十月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3962, '2030-11-05', '星期二', 2030, '十月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3963, '2030-11-06', '星期三', 2030, '十月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3964, '2030-11-07', '星期四', 2030, '十月', '十二', '庚戌', '狗', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (3965, '2030-11-08', '星期五', 2030, '十月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3966, '2030-11-09', '星期六', 2030, '十月', '十四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3967, '2030-11-10', '星期日', 2030, '十月', '十五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3968, '2030-11-11', '星期一', 2030, '十月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3969, '2030-11-12', '星期二', 2030, '十月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3970, '2030-11-13', '星期三', 2030, '十月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3971, '2030-11-14', '星期四', 2030, '十月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3972, '2030-11-15', '星期五', 2030, '十月', '二十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3973, '2030-11-16', '星期六', 2030, '十月', '廿一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3974, '2030-11-17', '星期日', 2030, '十月', '廿二', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3975, '2030-11-18', '星期一', 2030, '十月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3976, '2030-11-19', '星期二', 2030, '十月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3977, '2030-11-20', '星期三', 2030, '十月', '廿五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3978, '2030-11-21', '星期四', 2030, '十月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3979, '2030-11-22', '星期五', 2030, '十月', '廿七', '庚戌', '狗', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (3980, '2030-11-23', '星期六', 2030, '十月', '廿八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3981, '2030-11-24', '星期日', 2030, '十月', '廿九', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3982, '2030-11-25', '星期一', 2030, '冬月', '初一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3983, '2030-11-26', '星期二', 2030, '冬月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3984, '2030-11-27', '星期三', 2030, '冬月', '初三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3985, '2030-11-28', '星期四', 2030, '冬月', '初四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3986, '2030-11-29', '星期五', 2030, '冬月', '初五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3987, '2030-11-30', '星期六', 2030, '冬月', '初六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3988, '2030-12-01', '星期日', 2030, '冬月', '初七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3989, '2030-12-02', '星期一', 2030, '冬月', '初八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3990, '2030-12-03', '星期二', 2030, '冬月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3991, '2030-12-04', '星期三', 2030, '冬月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3992, '2030-12-05', '星期四', 2030, '冬月', '十一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3993, '2030-12-06', '星期五', 2030, '冬月', '十二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3994, '2030-12-07', '星期六', 2030, '冬月', '十三', '庚戌', '狗', NULL, 1, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (3995, '2030-12-08', '星期日', 2030, '冬月', '十四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3996, '2030-12-09', '星期一', 2030, '冬月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3997, '2030-12-10', '星期二', 2030, '冬月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3998, '2030-12-11', '星期三', 2030, '冬月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (3999, '2030-12-12', '星期四', 2030, '冬月', '十八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4000, '2030-12-13', '星期五', 2030, '冬月', '十九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4001, '2030-12-14', '星期六', 2030, '冬月', '二十', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4002, '2030-12-15', '星期日', 2030, '冬月', '廿一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4003, '2030-12-16', '星期一', 2030, '冬月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4004, '2030-12-17', '星期二', 2030, '冬月', '廿三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4005, '2030-12-18', '星期三', 2030, '冬月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4006, '2030-12-19', '星期四', 2030, '冬月', '廿五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4007, '2030-12-20', '星期五', 2030, '冬月', '廿六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4008, '2030-12-21', '星期六', 2030, '冬月', '廿七', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4009, '2030-12-22', '星期日', 2030, '冬月', '廿八', '庚戌', '狗', NULL, 1, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (4010, '2030-12-23', '星期一', 2030, '冬月', '廿九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4011, '2030-12-24', '星期二', 2030, '冬月', '三十', '庚戌', '狗', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4012, '2030-12-25', '星期三', 2030, '腊月', '初一', '庚戌', '狗', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4013, '2030-12-26', '星期四', 2030, '腊月', '初二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4014, '2030-12-27', '星期五', 2030, '腊月', '初三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4015, '2030-12-28', '星期六', 2030, '腊月', '初四', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4016, '2030-12-29', '星期日', 2030, '腊月', '初五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4017, '2030-12-30', '星期一', 2030, '腊月', '初六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4018, '2030-12-31', '星期二', 2030, '腊月', '初七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4019, '2031-01-01', '星期三', 2030, '腊月', '初八', '庚戌', '狗', NULL, 0, '元旦', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4020, '2031-01-02', '星期四', 2030, '腊月', '初九', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4021, '2031-01-03', '星期五', 2030, '腊月', '初十 ', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4022, '2031-01-04', '星期六', 2030, '腊月', '十一', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4023, '2031-01-05', '星期日', 2030, '腊月', '十二', '庚戌', '狗', NULL, 1, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (4024, '2031-01-06', '星期一', 2030, '腊月', '十三', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4025, '2031-01-07', '星期二', 2030, '腊月', '十四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4026, '2031-01-08', '星期三', 2030, '腊月', '十五', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4027, '2031-01-09', '星期四', 2030, '腊月', '十六', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4028, '2031-01-10', '星期五', 2030, '腊月', '十七', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4029, '2031-01-11', '星期六', 2030, '腊月', '十八', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4030, '2031-01-12', '星期日', 2030, '腊月', '十九', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4031, '2031-01-13', '星期一', 2030, '腊月', '二十', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4032, '2031-01-14', '星期二', 2030, '腊月', '廿一', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4033, '2031-01-15', '星期三', 2030, '腊月', '廿二', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4034, '2031-01-16', '星期四', 2030, '腊月', '廿三', '庚戌', '狗', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4035, '2031-01-17', '星期五', 2030, '腊月', '廿四', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4036, '2031-01-18', '星期六', 2030, '腊月', '廿五', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4037, '2031-01-19', '星期日', 2030, '腊月', '廿六', '庚戌', '狗', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4038, '2031-01-20', '星期一', 2030, '腊月', '廿七', '庚戌', '狗', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (4039, '2031-01-21', '星期二', 2030, '腊月', '廿八', '庚戌', '狗', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4040, '2031-01-22', '星期三', 2030, '腊月', '廿九', '庚戌', '狗', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4041, '2031-01-23', '星期四', 2031, '正月', '初一', '辛亥', '猪', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4042, '2031-01-24', '星期五', 2031, '正月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4043, '2031-01-25', '星期六', 2031, '正月', '初三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4044, '2031-01-26', '星期日', 2031, '正月', '初四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4045, '2031-01-27', '星期一', 2031, '正月', '初五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4046, '2031-01-28', '星期二', 2031, '正月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4047, '2031-01-29', '星期三', 2031, '正月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4048, '2031-01-30', '星期四', 2031, '正月', '初八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4049, '2031-01-31', '星期五', 2031, '正月', '初九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4050, '2031-02-01', '星期六', 2031, '正月', '初十 ', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4051, '2031-02-02', '星期日', 2031, '正月', '十一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4052, '2031-02-03', '星期一', 2031, '正月', '十二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4053, '2031-02-04', '星期二', 2031, '正月', '十三', '辛亥', '猪', NULL, 0, '', '', '立春', '', 3);
INSERT INTO `base_data_holiday` VALUES (4054, '2031-02-05', '星期三', 2031, '正月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4055, '2031-02-06', '星期四', 2031, '正月', '十五', '辛亥', '猪', NULL, 0, '', '元宵节', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4056, '2031-02-07', '星期五', 2031, '正月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4057, '2031-02-08', '星期六', 2031, '正月', '十七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4058, '2031-02-09', '星期日', 2031, '正月', '十八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4059, '2031-02-10', '星期一', 2031, '正月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4060, '2031-02-11', '星期二', 2031, '正月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4061, '2031-02-12', '星期三', 2031, '正月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4062, '2031-02-13', '星期四', 2031, '正月', '廿二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4063, '2031-02-14', '星期五', 2031, '正月', '廿三', '辛亥', '猪', NULL, 0, '情人节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4064, '2031-02-15', '星期六', 2031, '正月', '廿四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4065, '2031-02-16', '星期日', 2031, '正月', '廿五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4066, '2031-02-17', '星期一', 2031, '正月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4067, '2031-02-18', '星期二', 2031, '正月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4068, '2031-02-19', '星期三', 2031, '正月', '廿八', '辛亥', '猪', NULL, 0, '', '', '雨水', '', 3);
INSERT INTO `base_data_holiday` VALUES (4069, '2031-02-20', '星期四', 2031, '正月', '廿九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4070, '2031-02-21', '星期五', 2031, '二月', '初一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4071, '2031-02-22', '星期六', 2031, '二月', '初二', '辛亥', '猪', NULL, 1, '', '龙抬头', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4072, '2031-02-23', '星期日', 2031, '二月', '初三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4073, '2031-02-24', '星期一', 2031, '二月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4074, '2031-02-25', '星期二', 2031, '二月', '初五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4075, '2031-02-26', '星期三', 2031, '二月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4076, '2031-02-27', '星期四', 2031, '二月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4077, '2031-02-28', '星期五', 2031, '二月', '初八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4078, '2031-03-01', '星期六', 2031, '二月', '初九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4079, '2031-03-02', '星期日', 2031, '二月', '初十 ', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4080, '2031-03-03', '星期一', 2031, '二月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4081, '2031-03-04', '星期二', 2031, '二月', '十二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4082, '2031-03-05', '星期三', 2031, '二月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4083, '2031-03-06', '星期四', 2031, '二月', '十四', '辛亥', '猪', NULL, 0, '', '', '惊蛰', '', 3);
INSERT INTO `base_data_holiday` VALUES (4084, '2031-03-07', '星期五', 2031, '二月', '十五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4085, '2031-03-08', '星期六', 2031, '二月', '十六', '辛亥', '猪', NULL, 1, '妇女节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4086, '2031-03-09', '星期日', 2031, '二月', '十七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4087, '2031-03-10', '星期一', 2031, '二月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4088, '2031-03-11', '星期二', 2031, '二月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4089, '2031-03-12', '星期三', 2031, '二月', '二十', '辛亥', '猪', NULL, 0, '植树节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4090, '2031-03-13', '星期四', 2031, '二月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4091, '2031-03-14', '星期五', 2031, '二月', '廿二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4092, '2031-03-15', '星期六', 2031, '二月', '廿三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4093, '2031-03-16', '星期日', 2031, '二月', '廿四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4094, '2031-03-17', '星期一', 2031, '二月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4095, '2031-03-18', '星期二', 2031, '二月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4096, '2031-03-19', '星期三', 2031, '二月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4097, '2031-03-20', '星期四', 2031, '二月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4098, '2031-03-21', '星期五', 2031, '二月', '廿九', '辛亥', '猪', NULL, 0, '', '', '春分', '', 3);
INSERT INTO `base_data_holiday` VALUES (4099, '2031-03-22', '星期六', 2031, '二月', '三十', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4100, '2031-03-23', '星期日', 2031, '三月', '初一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4101, '2031-03-24', '星期一', 2031, '三月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4102, '2031-03-25', '星期二', 2031, '三月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4103, '2031-03-26', '星期三', 2031, '三月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4104, '2031-03-27', '星期四', 2031, '三月', '初五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4105, '2031-03-28', '星期五', 2031, '三月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4106, '2031-03-29', '星期六', 2031, '三月', '初七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4107, '2031-03-30', '星期日', 2031, '三月', '初八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4108, '2031-03-31', '星期一', 2031, '三月', '初九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4109, '2031-04-01', '星期二', 2031, '三月', '初十 ', '辛亥', '猪', NULL, 0, '愚人节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4110, '2031-04-02', '星期三', 2031, '三月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4111, '2031-04-03', '星期四', 2031, '三月', '十二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4112, '2031-04-04', '星期五', 2031, '三月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4113, '2031-04-05', '星期六', 2031, '三月', '十四', '辛亥', '猪', NULL, 1, '', '', '清明', '', 3);
INSERT INTO `base_data_holiday` VALUES (4114, '2031-04-06', '星期日', 2031, '三月', '十五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4115, '2031-04-07', '星期一', 2031, '三月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4116, '2031-04-08', '星期二', 2031, '三月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4117, '2031-04-09', '星期三', 2031, '三月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4118, '2031-04-10', '星期四', 2031, '三月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4119, '2031-04-11', '星期五', 2031, '三月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4120, '2031-04-12', '星期六', 2031, '三月', '廿一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4121, '2031-04-13', '星期日', 2031, '三月', '廿二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4122, '2031-04-14', '星期一', 2031, '三月', '廿三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4123, '2031-04-15', '星期二', 2031, '三月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4124, '2031-04-16', '星期三', 2031, '三月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4125, '2031-04-17', '星期四', 2031, '三月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4126, '2031-04-18', '星期五', 2031, '三月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4127, '2031-04-19', '星期六', 2031, '三月', '廿八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4128, '2031-04-20', '星期日', 2031, '三月', '廿九', '辛亥', '猪', NULL, 1, '', '', '谷雨', '', 3);
INSERT INTO `base_data_holiday` VALUES (4129, '2031-04-21', '星期一', 2031, '三月', '三十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4130, '2031-04-22', '星期二', 2031, '闰三月', '初一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4131, '2031-04-23', '星期三', 2031, '闰三月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4132, '2031-04-24', '星期四', 2031, '闰三月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4133, '2031-04-25', '星期五', 2031, '闰三月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4134, '2031-04-26', '星期六', 2031, '闰三月', '初五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4135, '2031-04-27', '星期日', 2031, '闰三月', '初六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4136, '2031-04-28', '星期一', 2031, '闰三月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4137, '2031-04-29', '星期二', 2031, '闰三月', '初八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4138, '2031-04-30', '星期三', 2031, '闰三月', '初九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4139, '2031-05-01', '星期四', 2031, '闰三月', '初十 ', '辛亥', '猪', NULL, 0, '劳动节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4140, '2031-05-02', '星期五', 2031, '闰三月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4141, '2031-05-03', '星期六', 2031, '闰三月', '十二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4142, '2031-05-04', '星期日', 2031, '闰三月', '十三', '辛亥', '猪', NULL, 1, '青年节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4143, '2031-05-05', '星期一', 2031, '闰三月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4144, '2031-05-06', '星期二', 2031, '闰三月', '十五', '辛亥', '猪', NULL, 0, '', '', '立夏', '', 3);
INSERT INTO `base_data_holiday` VALUES (4145, '2031-05-07', '星期三', 2031, '闰三月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4146, '2031-05-08', '星期四', 2031, '闰三月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4147, '2031-05-09', '星期五', 2031, '闰三月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4148, '2031-05-10', '星期六', 2031, '闰三月', '十九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4149, '2031-05-11', '星期日', 2031, '闰三月', '二十', '辛亥', '猪', NULL, 1, '', '', '', '母亲节', 3);
INSERT INTO `base_data_holiday` VALUES (4150, '2031-05-12', '星期一', 2031, '闰三月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4151, '2031-05-13', '星期二', 2031, '闰三月', '廿二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4152, '2031-05-14', '星期三', 2031, '闰三月', '廿三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4153, '2031-05-15', '星期四', 2031, '闰三月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4154, '2031-05-16', '星期五', 2031, '闰三月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4155, '2031-05-17', '星期六', 2031, '闰三月', '廿六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4156, '2031-05-18', '星期日', 2031, '闰三月', '廿七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4157, '2031-05-19', '星期一', 2031, '闰三月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4158, '2031-05-20', '星期二', 2031, '闰三月', '廿九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4159, '2031-05-21', '星期三', 2031, '四月', '初一', '辛亥', '猪', NULL, 0, '', '', '小满', '', 3);
INSERT INTO `base_data_holiday` VALUES (4160, '2031-05-22', '星期四', 2031, '四月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4161, '2031-05-23', '星期五', 2031, '四月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4162, '2031-05-24', '星期六', 2031, '四月', '初四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4163, '2031-05-25', '星期日', 2031, '四月', '初五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4164, '2031-05-26', '星期一', 2031, '四月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4165, '2031-05-27', '星期二', 2031, '四月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4166, '2031-05-28', '星期三', 2031, '四月', '初八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4167, '2031-05-29', '星期四', 2031, '四月', '初九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4168, '2031-05-30', '星期五', 2031, '四月', '初十 ', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4169, '2031-05-31', '星期六', 2031, '四月', '十一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4170, '2031-06-01', '星期日', 2031, '四月', '十二', '辛亥', '猪', NULL, 1, '儿童节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4171, '2031-06-02', '星期一', 2031, '四月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4172, '2031-06-03', '星期二', 2031, '四月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4173, '2031-06-04', '星期三', 2031, '四月', '十五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4174, '2031-06-05', '星期四', 2031, '四月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4175, '2031-06-06', '星期五', 2031, '四月', '十七', '辛亥', '猪', NULL, 0, '', '', '芒种', '', 3);
INSERT INTO `base_data_holiday` VALUES (4176, '2031-06-07', '星期六', 2031, '四月', '十八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4177, '2031-06-08', '星期日', 2031, '四月', '十九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4178, '2031-06-09', '星期一', 2031, '四月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4179, '2031-06-10', '星期二', 2031, '四月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4180, '2031-06-11', '星期三', 2031, '四月', '廿二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4181, '2031-06-12', '星期四', 2031, '四月', '廿三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4182, '2031-06-13', '星期五', 2031, '四月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4183, '2031-06-14', '星期六', 2031, '四月', '廿五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4184, '2031-06-15', '星期日', 2031, '四月', '廿六', '辛亥', '猪', NULL, 1, '', '', '', '父亲节', 3);
INSERT INTO `base_data_holiday` VALUES (4185, '2031-06-16', '星期一', 2031, '四月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4186, '2031-06-17', '星期二', 2031, '四月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4187, '2031-06-18', '星期三', 2031, '四月', '廿九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4188, '2031-06-19', '星期四', 2031, '四月', '三十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4189, '2031-06-20', '星期五', 2031, '五月', '初一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4190, '2031-06-21', '星期六', 2031, '五月', '初二', '辛亥', '猪', NULL, 1, '', '', '夏至', '', 3);
INSERT INTO `base_data_holiday` VALUES (4191, '2031-06-22', '星期日', 2031, '五月', '初三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4192, '2031-06-23', '星期一', 2031, '五月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4193, '2031-06-24', '星期二', 2031, '五月', '初五', '辛亥', '猪', NULL, 0, '', '端午节', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4194, '2031-06-25', '星期三', 2031, '五月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4195, '2031-06-26', '星期四', 2031, '五月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4196, '2031-06-27', '星期五', 2031, '五月', '初八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4197, '2031-06-28', '星期六', 2031, '五月', '初九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4198, '2031-06-29', '星期日', 2031, '五月', '初十 ', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4199, '2031-06-30', '星期一', 2031, '五月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4200, '2031-07-01', '星期二', 2031, '五月', '十二', '辛亥', '猪', NULL, 0, '建党节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4201, '2031-07-02', '星期三', 2031, '五月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4202, '2031-07-03', '星期四', 2031, '五月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4203, '2031-07-04', '星期五', 2031, '五月', '十五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4204, '2031-07-05', '星期六', 2031, '五月', '十六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4205, '2031-07-06', '星期日', 2031, '五月', '十七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4206, '2031-07-07', '星期一', 2031, '五月', '十八', '辛亥', '猪', NULL, 0, '', '', '小暑', '', 3);
INSERT INTO `base_data_holiday` VALUES (4207, '2031-07-08', '星期二', 2031, '五月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4208, '2031-07-09', '星期三', 2031, '五月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4209, '2031-07-10', '星期四', 2031, '五月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4210, '2031-07-11', '星期五', 2031, '五月', '廿二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4211, '2031-07-12', '星期六', 2031, '五月', '廿三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4212, '2031-07-13', '星期日', 2031, '五月', '廿四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4213, '2031-07-14', '星期一', 2031, '五月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4214, '2031-07-15', '星期二', 2031, '五月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4215, '2031-07-16', '星期三', 2031, '五月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4216, '2031-07-17', '星期四', 2031, '五月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4217, '2031-07-18', '星期五', 2031, '五月', '廿九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4218, '2031-07-19', '星期六', 2031, '六月', '初一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4219, '2031-07-20', '星期日', 2031, '六月', '初二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4220, '2031-07-21', '星期一', 2031, '六月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4221, '2031-07-22', '星期二', 2031, '六月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4222, '2031-07-23', '星期三', 2031, '六月', '初五', '辛亥', '猪', NULL, 0, '', '', '大暑', '', 3);
INSERT INTO `base_data_holiday` VALUES (4223, '2031-07-24', '星期四', 2031, '六月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4224, '2031-07-25', '星期五', 2031, '六月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4225, '2031-07-26', '星期六', 2031, '六月', '初八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4226, '2031-07-27', '星期日', 2031, '六月', '初九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4227, '2031-07-28', '星期一', 2031, '六月', '初十 ', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4228, '2031-07-29', '星期二', 2031, '六月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4229, '2031-07-30', '星期三', 2031, '六月', '十二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4230, '2031-07-31', '星期四', 2031, '六月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4231, '2031-08-01', '星期五', 2031, '六月', '十四', '辛亥', '猪', NULL, 0, '建军节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4232, '2031-08-02', '星期六', 2031, '六月', '十五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4233, '2031-08-03', '星期日', 2031, '六月', '十六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4234, '2031-08-04', '星期一', 2031, '六月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4235, '2031-08-05', '星期二', 2031, '六月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4236, '2031-08-06', '星期三', 2031, '六月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4237, '2031-08-07', '星期四', 2031, '六月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4238, '2031-08-08', '星期五', 2031, '六月', '廿一', '辛亥', '猪', NULL, 0, '', '', '立秋', '', 3);
INSERT INTO `base_data_holiday` VALUES (4239, '2031-08-09', '星期六', 2031, '六月', '廿二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4240, '2031-08-10', '星期日', 2031, '六月', '廿三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4241, '2031-08-11', '星期一', 2031, '六月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4242, '2031-08-12', '星期二', 2031, '六月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4243, '2031-08-13', '星期三', 2031, '六月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4244, '2031-08-14', '星期四', 2031, '六月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4245, '2031-08-15', '星期五', 2031, '六月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4246, '2031-08-16', '星期六', 2031, '六月', '廿九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4247, '2031-08-17', '星期日', 2031, '六月', '三十', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4248, '2031-08-18', '星期一', 2031, '七月', '初一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4249, '2031-08-19', '星期二', 2031, '七月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4250, '2031-08-20', '星期三', 2031, '七月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4251, '2031-08-21', '星期四', 2031, '七月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4252, '2031-08-22', '星期五', 2031, '七月', '初五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4253, '2031-08-23', '星期六', 2031, '七月', '初六', '辛亥', '猪', NULL, 1, '', '', '处暑', '', 3);
INSERT INTO `base_data_holiday` VALUES (4254, '2031-08-24', '星期日', 2031, '七月', '初七', '辛亥', '猪', NULL, 1, '', '七夕', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4255, '2031-08-25', '星期一', 2031, '七月', '初八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4256, '2031-08-26', '星期二', 2031, '七月', '初九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4257, '2031-08-27', '星期三', 2031, '七月', '初十 ', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4258, '2031-08-28', '星期四', 2031, '七月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4259, '2031-08-29', '星期五', 2031, '七月', '十二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4260, '2031-08-30', '星期六', 2031, '七月', '十三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4261, '2031-08-31', '星期日', 2031, '七月', '十四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4262, '2031-09-01', '星期一', 2031, '七月', '十五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4263, '2031-09-02', '星期二', 2031, '七月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4264, '2031-09-03', '星期三', 2031, '七月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4265, '2031-09-04', '星期四', 2031, '七月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4266, '2031-09-05', '星期五', 2031, '七月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4267, '2031-09-06', '星期六', 2031, '七月', '二十', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4268, '2031-09-07', '星期日', 2031, '七月', '廿一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4269, '2031-09-08', '星期一', 2031, '七月', '廿二', '辛亥', '猪', NULL, 0, '', '', '白露', '', 3);
INSERT INTO `base_data_holiday` VALUES (4270, '2031-09-09', '星期二', 2031, '七月', '廿三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4271, '2031-09-10', '星期三', 2031, '七月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4272, '2031-09-11', '星期四', 2031, '七月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4273, '2031-09-12', '星期五', 2031, '七月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4274, '2031-09-13', '星期六', 2031, '七月', '廿七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4275, '2031-09-14', '星期日', 2031, '七月', '廿八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4276, '2031-09-15', '星期一', 2031, '七月', '廿九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4277, '2031-09-16', '星期二', 2031, '七月', '三十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4278, '2031-09-17', '星期三', 2031, '八月', '初一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4279, '2031-09-18', '星期四', 2031, '八月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4280, '2031-09-19', '星期五', 2031, '八月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4281, '2031-09-20', '星期六', 2031, '八月', '初四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4282, '2031-09-21', '星期日', 2031, '八月', '初五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4283, '2031-09-22', '星期一', 2031, '八月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4284, '2031-09-23', '星期二', 2031, '八月', '初七', '辛亥', '猪', NULL, 0, '农民丰收节', '', '秋分', '', 3);
INSERT INTO `base_data_holiday` VALUES (4285, '2031-09-24', '星期三', 2031, '八月', '初八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4286, '2031-09-25', '星期四', 2031, '八月', '初九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4287, '2031-09-26', '星期五', 2031, '八月', '初十 ', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4288, '2031-09-27', '星期六', 2031, '八月', '十一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4289, '2031-09-28', '星期日', 2031, '八月', '十二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4290, '2031-09-29', '星期一', 2031, '八月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4291, '2031-09-30', '星期二', 2031, '八月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4292, '2031-10-01', '星期三', 2031, '八月', '十五', '辛亥', '猪', NULL, 0, '国庆节', '中秋节', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4293, '2031-10-02', '星期四', 2031, '八月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4294, '2031-10-03', '星期五', 2031, '八月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4295, '2031-10-04', '星期六', 2031, '八月', '十八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4296, '2031-10-05', '星期日', 2031, '八月', '十九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4297, '2031-10-06', '星期一', 2031, '八月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4298, '2031-10-07', '星期二', 2031, '八月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4299, '2031-10-08', '星期三', 2031, '八月', '廿二', '辛亥', '猪', NULL, 0, '', '', '寒露', '', 3);
INSERT INTO `base_data_holiday` VALUES (4300, '2031-10-09', '星期四', 2031, '八月', '廿三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4301, '2031-10-10', '星期五', 2031, '八月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4302, '2031-10-11', '星期六', 2031, '八月', '廿五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4303, '2031-10-12', '星期日', 2031, '八月', '廿六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4304, '2031-10-13', '星期一', 2031, '八月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4305, '2031-10-14', '星期二', 2031, '八月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4306, '2031-10-15', '星期三', 2031, '八月', '廿九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4307, '2031-10-16', '星期四', 2031, '九月', '初一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4308, '2031-10-17', '星期五', 2031, '九月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4309, '2031-10-18', '星期六', 2031, '九月', '初三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4310, '2031-10-19', '星期日', 2031, '九月', '初四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4311, '2031-10-20', '星期一', 2031, '九月', '初五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4312, '2031-10-21', '星期二', 2031, '九月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4313, '2031-10-22', '星期三', 2031, '九月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4314, '2031-10-23', '星期四', 2031, '九月', '初八', '辛亥', '猪', NULL, 0, '', '', '霜降', '', 3);
INSERT INTO `base_data_holiday` VALUES (4315, '2031-10-24', '星期五', 2031, '九月', '初九', '辛亥', '猪', NULL, 0, '', '重阳节', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4316, '2031-10-25', '星期六', 2031, '九月', '初十 ', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4317, '2031-10-26', '星期日', 2031, '九月', '十一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4318, '2031-10-27', '星期一', 2031, '九月', '十二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4319, '2031-10-28', '星期二', 2031, '九月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4320, '2031-10-29', '星期三', 2031, '九月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4321, '2031-10-30', '星期四', 2031, '九月', '十五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4322, '2031-10-31', '星期五', 2031, '九月', '十六', '辛亥', '猪', NULL, 0, '万圣节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4323, '2031-11-01', '星期六', 2031, '九月', '十七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4324, '2031-11-02', '星期日', 2031, '九月', '十八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4325, '2031-11-03', '星期一', 2031, '九月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4326, '2031-11-04', '星期二', 2031, '九月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4327, '2031-11-05', '星期三', 2031, '九月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4328, '2031-11-06', '星期四', 2031, '九月', '廿二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4329, '2031-11-07', '星期五', 2031, '九月', '廿三', '辛亥', '猪', NULL, 0, '', '', '立冬', '', 3);
INSERT INTO `base_data_holiday` VALUES (4330, '2031-11-08', '星期六', 2031, '九月', '廿四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4331, '2031-11-09', '星期日', 2031, '九月', '廿五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4332, '2031-11-10', '星期一', 2031, '九月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4333, '2031-11-11', '星期二', 2031, '九月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4334, '2031-11-12', '星期三', 2031, '九月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4335, '2031-11-13', '星期四', 2031, '九月', '廿九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4336, '2031-11-14', '星期五', 2031, '九月', '三十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4337, '2031-11-15', '星期六', 2031, '十月', '初一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4338, '2031-11-16', '星期日', 2031, '十月', '初二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4339, '2031-11-17', '星期一', 2031, '十月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4340, '2031-11-18', '星期二', 2031, '十月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4341, '2031-11-19', '星期三', 2031, '十月', '初五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4342, '2031-11-20', '星期四', 2031, '十月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4343, '2031-11-21', '星期五', 2031, '十月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4344, '2031-11-22', '星期六', 2031, '十月', '初八', '辛亥', '猪', NULL, 1, '', '', '小雪', '', 3);
INSERT INTO `base_data_holiday` VALUES (4345, '2031-11-23', '星期日', 2031, '十月', '初九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4346, '2031-11-24', '星期一', 2031, '十月', '初十 ', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4347, '2031-11-25', '星期二', 2031, '十月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4348, '2031-11-26', '星期三', 2031, '十月', '十二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4349, '2031-11-27', '星期四', 2031, '十月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4350, '2031-11-28', '星期五', 2031, '十月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4351, '2031-11-29', '星期六', 2031, '十月', '十五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4352, '2031-11-30', '星期日', 2031, '十月', '十六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4353, '2031-12-01', '星期一', 2031, '十月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4354, '2031-12-02', '星期二', 2031, '十月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4355, '2031-12-03', '星期三', 2031, '十月', '十九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4356, '2031-12-04', '星期四', 2031, '十月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4357, '2031-12-05', '星期五', 2031, '十月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4358, '2031-12-06', '星期六', 2031, '十月', '廿二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4359, '2031-12-07', '星期日', 2031, '十月', '廿三', '辛亥', '猪', NULL, 1, '', '', '大雪', '', 3);
INSERT INTO `base_data_holiday` VALUES (4360, '2031-12-08', '星期一', 2031, '十月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4361, '2031-12-09', '星期二', 2031, '十月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4362, '2031-12-10', '星期三', 2031, '十月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4363, '2031-12-11', '星期四', 2031, '十月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4364, '2031-12-12', '星期五', 2031, '十月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4365, '2031-12-13', '星期六', 2031, '十月', '廿九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4366, '2031-12-14', '星期日', 2031, '冬月', '初一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4367, '2031-12-15', '星期一', 2031, '冬月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4368, '2031-12-16', '星期二', 2031, '冬月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4369, '2031-12-17', '星期三', 2031, '冬月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4370, '2031-12-18', '星期四', 2031, '冬月', '初五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4371, '2031-12-19', '星期五', 2031, '冬月', '初六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4372, '2031-12-20', '星期六', 2031, '冬月', '初七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4373, '2031-12-21', '星期日', 2031, '冬月', '初八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4374, '2031-12-22', '星期一', 2031, '冬月', '初九', '辛亥', '猪', NULL, 0, '', '', '冬至', '', 3);
INSERT INTO `base_data_holiday` VALUES (4375, '2031-12-23', '星期二', 2031, '冬月', '初十 ', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4376, '2031-12-24', '星期三', 2031, '冬月', '十一', '辛亥', '猪', NULL, 0, '平安夜', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4377, '2031-12-25', '星期四', 2031, '冬月', '十二', '辛亥', '猪', NULL, 0, '圣诞节', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4378, '2031-12-26', '星期五', 2031, '冬月', '十三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4379, '2031-12-27', '星期六', 2031, '冬月', '十四', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4380, '2031-12-28', '星期日', 2031, '冬月', '十五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4381, '2031-12-29', '星期一', 2031, '冬月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4382, '2031-12-30', '星期二', 2031, '冬月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4383, '2031-12-31', '星期三', 2031, '冬月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4384, '2032-01-01', '星期四', 2031, '冬月', '十九', '辛亥', '猪', NULL, 0, '元旦', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4385, '2032-01-02', '星期五', 2031, '冬月', '二十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4386, '2032-01-03', '星期六', 2031, '冬月', '廿一', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4387, '2032-01-04', '星期日', 2031, '冬月', '廿二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4388, '2032-01-05', '星期一', 2031, '冬月', '廿三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4389, '2032-01-06', '星期二', 2031, '冬月', '廿四', '辛亥', '猪', NULL, 0, '', '', '小寒', '', 3);
INSERT INTO `base_data_holiday` VALUES (4390, '2032-01-07', '星期三', 2031, '冬月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4391, '2032-01-08', '星期四', 2031, '冬月', '廿六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4392, '2032-01-09', '星期五', 2031, '冬月', '廿七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4393, '2032-01-10', '星期六', 2031, '冬月', '廿八', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4394, '2032-01-11', '星期日', 2031, '冬月', '廿九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4395, '2032-01-12', '星期一', 2031, '冬月', '三十', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4396, '2032-01-13', '星期二', 2031, '腊月', '初一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4397, '2032-01-14', '星期三', 2031, '腊月', '初二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4398, '2032-01-15', '星期四', 2031, '腊月', '初三', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4399, '2032-01-16', '星期五', 2031, '腊月', '初四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4400, '2032-01-17', '星期六', 2031, '腊月', '初五', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4401, '2032-01-18', '星期日', 2031, '腊月', '初六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4402, '2032-01-19', '星期一', 2031, '腊月', '初七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4403, '2032-01-20', '星期二', 2031, '腊月', '初八', '辛亥', '猪', NULL, 0, '', '腊八节', '大寒', '', 3);
INSERT INTO `base_data_holiday` VALUES (4404, '2032-01-21', '星期三', 2031, '腊月', '初九', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4405, '2032-01-22', '星期四', 2031, '腊月', '初十 ', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4406, '2032-01-23', '星期五', 2031, '腊月', '十一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4407, '2032-01-24', '星期六', 2031, '腊月', '十二', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4408, '2032-01-25', '星期日', 2031, '腊月', '十三', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4409, '2032-01-26', '星期一', 2031, '腊月', '十四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4410, '2032-01-27', '星期二', 2031, '腊月', '十五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4411, '2032-01-28', '星期三', 2031, '腊月', '十六', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4412, '2032-01-29', '星期四', 2031, '腊月', '十七', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4413, '2032-01-30', '星期五', 2031, '腊月', '十八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4414, '2032-01-31', '星期六', 2031, '腊月', '十九', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4415, '2032-02-01', '星期日', 2031, '腊月', '二十', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4416, '2032-02-02', '星期一', 2031, '腊月', '廿一', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4417, '2032-02-03', '星期二', 2031, '腊月', '廿二', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4418, '2032-02-04', '星期三', 2031, '腊月', '廿三', '辛亥', '猪', NULL, 0, '', '小年', '立春', '', 3);
INSERT INTO `base_data_holiday` VALUES (4419, '2032-02-05', '星期四', 2031, '腊月', '廿四', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4420, '2032-02-06', '星期五', 2031, '腊月', '廿五', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4421, '2032-02-07', '星期六', 2031, '腊月', '廿六', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4422, '2032-02-08', '星期日', 2031, '腊月', '廿七', '辛亥', '猪', NULL, 1, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4423, '2032-02-09', '星期一', 2031, '腊月', '廿八', '辛亥', '猪', NULL, 0, '', '', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4424, '2032-02-10', '星期二', 2031, '腊月', '廿九', '辛亥', '猪', NULL, 0, '', '除夕', '', '', 3);
INSERT INTO `base_data_holiday` VALUES (4425, '2032-02-11', '星期三', 2032, '正月', '初一', '壬子', '鼠', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4426, '2032-02-12', '星期四', 2032, '正月', '初二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4427, '2032-02-13', '星期五', 2032, '正月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4428, '2032-02-14', '星期六', 2032, '正月', '初四', '壬子', '鼠', NULL, 1, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4429, '2032-02-15', '星期日', 2032, '正月', '初五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4430, '2032-02-16', '星期一', 2032, '正月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4431, '2032-02-17', '星期二', 2032, '正月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4432, '2032-02-18', '星期三', 2032, '正月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4433, '2032-02-19', '星期四', 2032, '正月', '初九', '壬子', '鼠', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (4434, '2032-02-20', '星期五', 2032, '正月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4435, '2032-02-21', '星期六', 2032, '正月', '十一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4436, '2032-02-22', '星期日', 2032, '正月', '十二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4437, '2032-02-23', '星期一', 2032, '正月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4438, '2032-02-24', '星期二', 2032, '正月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4439, '2032-02-25', '星期三', 2032, '正月', '十五', '壬子', '鼠', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4440, '2032-02-26', '星期四', 2032, '正月', '十六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4441, '2032-02-27', '星期五', 2032, '正月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4442, '2032-02-28', '星期六', 2032, '正月', '十八', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4443, '2032-02-29', '星期日', 2032, '正月', '十九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4444, '2032-03-01', '星期一', 2032, '正月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4445, '2032-03-02', '星期二', 2032, '正月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4446, '2032-03-03', '星期三', 2032, '正月', '廿二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4447, '2032-03-04', '星期四', 2032, '正月', '廿三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4448, '2032-03-05', '星期五', 2032, '正月', '廿四', '壬子', '鼠', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (4449, '2032-03-06', '星期六', 2032, '正月', '廿五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4450, '2032-03-07', '星期日', 2032, '正月', '廿六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4451, '2032-03-08', '星期一', 2032, '正月', '廿七', '壬子', '鼠', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4452, '2032-03-09', '星期二', 2032, '正月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4453, '2032-03-10', '星期三', 2032, '正月', '廿九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4454, '2032-03-11', '星期四', 2032, '正月', '三十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4455, '2032-03-12', '星期五', 2032, '二月', '初一', '壬子', '鼠', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4456, '2032-03-13', '星期六', 2032, '二月', '初二', '壬子', '鼠', NULL, 1, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4457, '2032-03-14', '星期日', 2032, '二月', '初三', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4458, '2032-03-15', '星期一', 2032, '二月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4459, '2032-03-16', '星期二', 2032, '二月', '初五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4460, '2032-03-17', '星期三', 2032, '二月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4461, '2032-03-18', '星期四', 2032, '二月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4462, '2032-03-19', '星期五', 2032, '二月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4463, '2032-03-20', '星期六', 2032, '二月', '初九', '壬子', '鼠', NULL, 1, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (4464, '2032-03-21', '星期日', 2032, '二月', '初十 ', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4465, '2032-03-22', '星期一', 2032, '二月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4466, '2032-03-23', '星期二', 2032, '二月', '十二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4467, '2032-03-24', '星期三', 2032, '二月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4468, '2032-03-25', '星期四', 2032, '二月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4469, '2032-03-26', '星期五', 2032, '二月', '十五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4470, '2032-03-27', '星期六', 2032, '二月', '十六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4471, '2032-03-28', '星期日', 2032, '二月', '十七', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4472, '2032-03-29', '星期一', 2032, '二月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4473, '2032-03-30', '星期二', 2032, '二月', '十九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4474, '2032-03-31', '星期三', 2032, '二月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4475, '2032-04-01', '星期四', 2032, '二月', '廿一', '壬子', '鼠', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4476, '2032-04-02', '星期五', 2032, '二月', '廿二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4477, '2032-04-03', '星期六', 2032, '二月', '廿三', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4478, '2032-04-04', '星期日', 2032, '二月', '廿四', '壬子', '鼠', NULL, 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (4479, '2032-04-05', '星期一', 2032, '二月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4480, '2032-04-06', '星期二', 2032, '二月', '廿六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4481, '2032-04-07', '星期三', 2032, '二月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4482, '2032-04-08', '星期四', 2032, '二月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4483, '2032-04-09', '星期五', 2032, '二月', '廿九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4484, '2032-04-10', '星期六', 2032, '三月', '初一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4485, '2032-04-11', '星期日', 2032, '三月', '初二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4486, '2032-04-12', '星期一', 2032, '三月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4487, '2032-04-13', '星期二', 2032, '三月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4488, '2032-04-14', '星期三', 2032, '三月', '初五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4489, '2032-04-15', '星期四', 2032, '三月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4490, '2032-04-16', '星期五', 2032, '三月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4491, '2032-04-17', '星期六', 2032, '三月', '初八', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4492, '2032-04-18', '星期日', 2032, '三月', '初九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4493, '2032-04-19', '星期一', 2032, '三月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (4494, '2032-04-20', '星期二', 2032, '三月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4495, '2032-04-21', '星期三', 2032, '三月', '十二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4496, '2032-04-22', '星期四', 2032, '三月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4497, '2032-04-23', '星期五', 2032, '三月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4498, '2032-04-24', '星期六', 2032, '三月', '十五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4499, '2032-04-25', '星期日', 2032, '三月', '十六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4500, '2032-04-26', '星期一', 2032, '三月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4501, '2032-04-27', '星期二', 2032, '三月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4502, '2032-04-28', '星期三', 2032, '三月', '十九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4503, '2032-04-29', '星期四', 2032, '三月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4504, '2032-04-30', '星期五', 2032, '三月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4505, '2032-05-01', '星期六', 2032, '三月', '廿二', '壬子', '鼠', NULL, 1, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4506, '2032-05-02', '星期日', 2032, '三月', '廿三', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4507, '2032-05-03', '星期一', 2032, '三月', '廿四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4508, '2032-05-04', '星期二', 2032, '三月', '廿五', '壬子', '鼠', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4509, '2032-05-05', '星期三', 2032, '三月', '廿六', '壬子', '鼠', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (4510, '2032-05-06', '星期四', 2032, '三月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4511, '2032-05-07', '星期五', 2032, '三月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4512, '2032-05-08', '星期六', 2032, '三月', '廿九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4513, '2032-05-09', '星期日', 2032, '四月', '初一', '壬子', '鼠', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (4514, '2032-05-10', '星期一', 2032, '四月', '初二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4515, '2032-05-11', '星期二', 2032, '四月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4516, '2032-05-12', '星期三', 2032, '四月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4517, '2032-05-13', '星期四', 2032, '四月', '初五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4518, '2032-05-14', '星期五', 2032, '四月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4519, '2032-05-15', '星期六', 2032, '四月', '初七', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4520, '2032-05-16', '星期日', 2032, '四月', '初八', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4521, '2032-05-17', '星期一', 2032, '四月', '初九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4522, '2032-05-18', '星期二', 2032, '四月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4523, '2032-05-19', '星期三', 2032, '四月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4524, '2032-05-20', '星期四', 2032, '四月', '十二', '壬子', '鼠', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (4525, '2032-05-21', '星期五', 2032, '四月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4526, '2032-05-22', '星期六', 2032, '四月', '十四', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4527, '2032-05-23', '星期日', 2032, '四月', '十五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4528, '2032-05-24', '星期一', 2032, '四月', '十六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4529, '2032-05-25', '星期二', 2032, '四月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4530, '2032-05-26', '星期三', 2032, '四月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4531, '2032-05-27', '星期四', 2032, '四月', '十九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4532, '2032-05-28', '星期五', 2032, '四月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4533, '2032-05-29', '星期六', 2032, '四月', '廿一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4534, '2032-05-30', '星期日', 2032, '四月', '廿二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4535, '2032-05-31', '星期一', 2032, '四月', '廿三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4536, '2032-06-01', '星期二', 2032, '四月', '廿四', '壬子', '鼠', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4537, '2032-06-02', '星期三', 2032, '四月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4538, '2032-06-03', '星期四', 2032, '四月', '廿六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4539, '2032-06-04', '星期五', 2032, '四月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4540, '2032-06-05', '星期六', 2032, '四月', '廿八', '壬子', '鼠', NULL, 1, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (4541, '2032-06-06', '星期日', 2032, '四月', '廿九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4542, '2032-06-07', '星期一', 2032, '四月', '三十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4543, '2032-06-08', '星期二', 2032, '五月', '初一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4544, '2032-06-09', '星期三', 2032, '五月', '初二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4545, '2032-06-10', '星期四', 2032, '五月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4546, '2032-06-11', '星期五', 2032, '五月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4547, '2032-06-12', '星期六', 2032, '五月', '初五', '壬子', '鼠', NULL, 1, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4548, '2032-06-13', '星期日', 2032, '五月', '初六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4549, '2032-06-14', '星期一', 2032, '五月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4550, '2032-06-15', '星期二', 2032, '五月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4551, '2032-06-16', '星期三', 2032, '五月', '初九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4552, '2032-06-17', '星期四', 2032, '五月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4553, '2032-06-18', '星期五', 2032, '五月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4554, '2032-06-19', '星期六', 2032, '五月', '十二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4555, '2032-06-20', '星期日', 2032, '五月', '十三', '壬子', '鼠', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (4556, '2032-06-21', '星期一', 2032, '五月', '十四', '壬子', '鼠', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (4557, '2032-06-22', '星期二', 2032, '五月', '十五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4558, '2032-06-23', '星期三', 2032, '五月', '十六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4559, '2032-06-24', '星期四', 2032, '五月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4560, '2032-06-25', '星期五', 2032, '五月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4561, '2032-06-26', '星期六', 2032, '五月', '十九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4562, '2032-06-27', '星期日', 2032, '五月', '二十', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4563, '2032-06-28', '星期一', 2032, '五月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4564, '2032-06-29', '星期二', 2032, '五月', '廿二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4565, '2032-06-30', '星期三', 2032, '五月', '廿三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4566, '2032-07-01', '星期四', 2032, '五月', '廿四', '壬子', '鼠', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4567, '2032-07-02', '星期五', 2032, '五月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4568, '2032-07-03', '星期六', 2032, '五月', '廿六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4569, '2032-07-04', '星期日', 2032, '五月', '廿七', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4570, '2032-07-05', '星期一', 2032, '五月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4571, '2032-07-06', '星期二', 2032, '五月', '廿九', '壬子', '鼠', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (4572, '2032-07-07', '星期三', 2032, '六月', '初一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4573, '2032-07-08', '星期四', 2032, '六月', '初二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4574, '2032-07-09', '星期五', 2032, '六月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4575, '2032-07-10', '星期六', 2032, '六月', '初四', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4576, '2032-07-11', '星期日', 2032, '六月', '初五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4577, '2032-07-12', '星期一', 2032, '六月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4578, '2032-07-13', '星期二', 2032, '六月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4579, '2032-07-14', '星期三', 2032, '六月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4580, '2032-07-15', '星期四', 2032, '六月', '初九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4581, '2032-07-16', '星期五', 2032, '六月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4582, '2032-07-17', '星期六', 2032, '六月', '十一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4583, '2032-07-18', '星期日', 2032, '六月', '十二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4584, '2032-07-19', '星期一', 2032, '六月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4585, '2032-07-20', '星期二', 2032, '六月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4586, '2032-07-21', '星期三', 2032, '六月', '十五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4587, '2032-07-22', '星期四', 2032, '六月', '十六', '壬子', '鼠', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (4588, '2032-07-23', '星期五', 2032, '六月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4589, '2032-07-24', '星期六', 2032, '六月', '十八', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4590, '2032-07-25', '星期日', 2032, '六月', '十九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4591, '2032-07-26', '星期一', 2032, '六月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4592, '2032-07-27', '星期二', 2032, '六月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4593, '2032-07-28', '星期三', 2032, '六月', '廿二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4594, '2032-07-29', '星期四', 2032, '六月', '廿三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4595, '2032-07-30', '星期五', 2032, '六月', '廿四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4596, '2032-07-31', '星期六', 2032, '六月', '廿五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4597, '2032-08-01', '星期日', 2032, '六月', '廿六', '壬子', '鼠', NULL, 1, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4598, '2032-08-02', '星期一', 2032, '六月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4599, '2032-08-03', '星期二', 2032, '六月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4600, '2032-08-04', '星期三', 2032, '六月', '廿九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4601, '2032-08-05', '星期四', 2032, '六月', '三十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4602, '2032-08-06', '星期五', 2032, '七月', '初一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4603, '2032-08-07', '星期六', 2032, '七月', '初二', '壬子', '鼠', NULL, 1, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (4604, '2032-08-08', '星期日', 2032, '七月', '初三', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4605, '2032-08-09', '星期一', 2032, '七月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4606, '2032-08-10', '星期二', 2032, '七月', '初五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4607, '2032-08-11', '星期三', 2032, '七月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4608, '2032-08-12', '星期四', 2032, '七月', '初七', '壬子', '鼠', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4609, '2032-08-13', '星期五', 2032, '七月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4610, '2032-08-14', '星期六', 2032, '七月', '初九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4611, '2032-08-15', '星期日', 2032, '七月', '初十 ', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4612, '2032-08-16', '星期一', 2032, '七月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4613, '2032-08-17', '星期二', 2032, '七月', '十二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4614, '2032-08-18', '星期三', 2032, '七月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4615, '2032-08-19', '星期四', 2032, '七月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4616, '2032-08-20', '星期五', 2032, '七月', '十五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4617, '2032-08-21', '星期六', 2032, '七月', '十六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4618, '2032-08-22', '星期日', 2032, '七月', '十七', '壬子', '鼠', NULL, 1, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (4619, '2032-08-23', '星期一', 2032, '七月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4620, '2032-08-24', '星期二', 2032, '七月', '十九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4621, '2032-08-25', '星期三', 2032, '七月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4622, '2032-08-26', '星期四', 2032, '七月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4623, '2032-08-27', '星期五', 2032, '七月', '廿二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4624, '2032-08-28', '星期六', 2032, '七月', '廿三', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4625, '2032-08-29', '星期日', 2032, '七月', '廿四', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4626, '2032-08-30', '星期一', 2032, '七月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4627, '2032-08-31', '星期二', 2032, '七月', '廿六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4628, '2032-09-01', '星期三', 2032, '七月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4629, '2032-09-02', '星期四', 2032, '七月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4630, '2032-09-03', '星期五', 2032, '七月', '廿九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4631, '2032-09-04', '星期六', 2032, '七月', '三十', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4632, '2032-09-05', '星期日', 2032, '八月', '初一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4633, '2032-09-06', '星期一', 2032, '八月', '初二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4634, '2032-09-07', '星期二', 2032, '八月', '初三', '壬子', '鼠', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (4635, '2032-09-08', '星期三', 2032, '八月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4636, '2032-09-09', '星期四', 2032, '八月', '初五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4637, '2032-09-10', '星期五', 2032, '八月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4638, '2032-09-11', '星期六', 2032, '八月', '初七', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4639, '2032-09-12', '星期日', 2032, '八月', '初八', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4640, '2032-09-13', '星期一', 2032, '八月', '初九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4641, '2032-09-14', '星期二', 2032, '八月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4642, '2032-09-15', '星期三', 2032, '八月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4643, '2032-09-16', '星期四', 2032, '八月', '十二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4644, '2032-09-17', '星期五', 2032, '八月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4645, '2032-09-18', '星期六', 2032, '八月', '十四', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4646, '2032-09-19', '星期日', 2032, '八月', '十五', '壬子', '鼠', NULL, 1, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4647, '2032-09-20', '星期一', 2032, '八月', '十六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4648, '2032-09-21', '星期二', 2032, '八月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4649, '2032-09-22', '星期三', 2032, '八月', '十八', '壬子', '鼠', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (4650, '2032-09-23', '星期四', 2032, '八月', '十九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4651, '2032-09-24', '星期五', 2032, '八月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4652, '2032-09-25', '星期六', 2032, '八月', '廿一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4653, '2032-09-26', '星期日', 2032, '八月', '廿二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4654, '2032-09-27', '星期一', 2032, '八月', '廿三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4655, '2032-09-28', '星期二', 2032, '八月', '廿四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4656, '2032-09-29', '星期三', 2032, '八月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4657, '2032-09-30', '星期四', 2032, '八月', '廿六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4658, '2032-10-01', '星期五', 2032, '八月', '廿七', '壬子', '鼠', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4659, '2032-10-02', '星期六', 2032, '八月', '廿八', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4660, '2032-10-03', '星期日', 2032, '八月', '廿九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4661, '2032-10-04', '星期一', 2032, '九月', '初一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4662, '2032-10-05', '星期二', 2032, '九月', '初二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4663, '2032-10-06', '星期三', 2032, '九月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4664, '2032-10-07', '星期四', 2032, '九月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4665, '2032-10-08', '星期五', 2032, '九月', '初五', '壬子', '鼠', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (4666, '2032-10-09', '星期六', 2032, '九月', '初六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4667, '2032-10-10', '星期日', 2032, '九月', '初七', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4668, '2032-10-11', '星期一', 2032, '九月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4669, '2032-10-12', '星期二', 2032, '九月', '初九', '壬子', '鼠', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4670, '2032-10-13', '星期三', 2032, '九月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4671, '2032-10-14', '星期四', 2032, '九月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4672, '2032-10-15', '星期五', 2032, '九月', '十二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4673, '2032-10-16', '星期六', 2032, '九月', '十三', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4674, '2032-10-17', '星期日', 2032, '九月', '十四', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4675, '2032-10-18', '星期一', 2032, '九月', '十五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4676, '2032-10-19', '星期二', 2032, '九月', '十六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4677, '2032-10-20', '星期三', 2032, '九月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4678, '2032-10-21', '星期四', 2032, '九月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4679, '2032-10-22', '星期五', 2032, '九月', '十九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4680, '2032-10-23', '星期六', 2032, '九月', '二十', '壬子', '鼠', NULL, 1, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (4681, '2032-10-24', '星期日', 2032, '九月', '廿一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4682, '2032-10-25', '星期一', 2032, '九月', '廿二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4683, '2032-10-26', '星期二', 2032, '九月', '廿三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4684, '2032-10-27', '星期三', 2032, '九月', '廿四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4685, '2032-10-28', '星期四', 2032, '九月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4686, '2032-10-29', '星期五', 2032, '九月', '廿六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4687, '2032-10-30', '星期六', 2032, '九月', '廿七', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4688, '2032-10-31', '星期日', 2032, '九月', '廿八', '壬子', '鼠', NULL, 1, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4689, '2032-11-01', '星期一', 2032, '九月', '廿九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4690, '2032-11-02', '星期二', 2032, '九月', '三十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4691, '2032-11-03', '星期三', 2032, '十月', '初一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4692, '2032-11-04', '星期四', 2032, '十月', '初二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4693, '2032-11-05', '星期五', 2032, '十月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4694, '2032-11-06', '星期六', 2032, '十月', '初四', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4695, '2032-11-07', '星期日', 2032, '十月', '初五', '壬子', '鼠', NULL, 1, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (4696, '2032-11-08', '星期一', 2032, '十月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4697, '2032-11-09', '星期二', 2032, '十月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4698, '2032-11-10', '星期三', 2032, '十月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4699, '2032-11-11', '星期四', 2032, '十月', '初九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4700, '2032-11-12', '星期五', 2032, '十月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4701, '2032-11-13', '星期六', 2032, '十月', '十一', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4702, '2032-11-14', '星期日', 2032, '十月', '十二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4703, '2032-11-15', '星期一', 2032, '十月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4704, '2032-11-16', '星期二', 2032, '十月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4705, '2032-11-17', '星期三', 2032, '十月', '十五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4706, '2032-11-18', '星期四', 2032, '十月', '十六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4707, '2032-11-19', '星期五', 2032, '十月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4708, '2032-11-20', '星期六', 2032, '十月', '十八', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4709, '2032-11-21', '星期日', 2032, '十月', '十九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4710, '2032-11-22', '星期一', 2032, '十月', '二十', '壬子', '鼠', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (4711, '2032-11-23', '星期二', 2032, '十月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4712, '2032-11-24', '星期三', 2032, '十月', '廿二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4713, '2032-11-25', '星期四', 2032, '十月', '廿三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4714, '2032-11-26', '星期五', 2032, '十月', '廿四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4715, '2032-11-27', '星期六', 2032, '十月', '廿五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4716, '2032-11-28', '星期日', 2032, '十月', '廿六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4717, '2032-11-29', '星期一', 2032, '十月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4718, '2032-11-30', '星期二', 2032, '十月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4719, '2032-12-01', '星期三', 2032, '十月', '廿九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4720, '2032-12-02', '星期四', 2032, '十月', '三十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4721, '2032-12-03', '星期五', 2032, '冬月', '初一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4722, '2032-12-04', '星期六', 2032, '冬月', '初二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4723, '2032-12-05', '星期日', 2032, '冬月', '初三', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4724, '2032-12-06', '星期一', 2032, '冬月', '初四', '壬子', '鼠', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (4725, '2032-12-07', '星期二', 2032, '冬月', '初五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4726, '2032-12-08', '星期三', 2032, '冬月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4727, '2032-12-09', '星期四', 2032, '冬月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4728, '2032-12-10', '星期五', 2032, '冬月', '初八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4729, '2032-12-11', '星期六', 2032, '冬月', '初九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4730, '2032-12-12', '星期日', 2032, '冬月', '初十 ', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4731, '2032-12-13', '星期一', 2032, '冬月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4732, '2032-12-14', '星期二', 2032, '冬月', '十二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4733, '2032-12-15', '星期三', 2032, '冬月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4734, '2032-12-16', '星期四', 2032, '冬月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4735, '2032-12-17', '星期五', 2032, '冬月', '十五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4736, '2032-12-18', '星期六', 2032, '冬月', '十六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4737, '2032-12-19', '星期日', 2032, '冬月', '十七', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4738, '2032-12-20', '星期一', 2032, '冬月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4739, '2032-12-21', '星期二', 2032, '冬月', '十九', '壬子', '鼠', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (4740, '2032-12-22', '星期三', 2032, '冬月', '二十', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4741, '2032-12-23', '星期四', 2032, '冬月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4742, '2032-12-24', '星期五', 2032, '冬月', '廿二', '壬子', '鼠', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4743, '2032-12-25', '星期六', 2032, '冬月', '廿三', '壬子', '鼠', NULL, 1, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4744, '2032-12-26', '星期日', 2032, '冬月', '廿四', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4745, '2032-12-27', '星期一', 2032, '冬月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4746, '2032-12-28', '星期二', 2032, '冬月', '廿六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4747, '2032-12-29', '星期三', 2032, '冬月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4748, '2032-12-30', '星期四', 2032, '冬月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4749, '2032-12-31', '星期五', 2032, '冬月', '廿九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4750, '2033-01-01', '星期六', 2032, '腊月', '初一', '壬子', '鼠', NULL, 1, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4751, '2033-01-02', '星期日', 2032, '腊月', '初二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4752, '2033-01-03', '星期一', 2032, '腊月', '初三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4753, '2033-01-04', '星期二', 2032, '腊月', '初四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4754, '2033-01-05', '星期三', 2032, '腊月', '初五', '壬子', '鼠', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (4755, '2033-01-06', '星期四', 2032, '腊月', '初六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4756, '2033-01-07', '星期五', 2032, '腊月', '初七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4757, '2033-01-08', '星期六', 2032, '腊月', '初八', '壬子', '鼠', NULL, 1, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4758, '2033-01-09', '星期日', 2032, '腊月', '初九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4759, '2033-01-10', '星期一', 2032, '腊月', '初十 ', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4760, '2033-01-11', '星期二', 2032, '腊月', '十一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4761, '2033-01-12', '星期三', 2032, '腊月', '十二', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4762, '2033-01-13', '星期四', 2032, '腊月', '十三', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4763, '2033-01-14', '星期五', 2032, '腊月', '十四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4764, '2033-01-15', '星期六', 2032, '腊月', '十五', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4765, '2033-01-16', '星期日', 2032, '腊月', '十六', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4766, '2033-01-17', '星期一', 2032, '腊月', '十七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4767, '2033-01-18', '星期二', 2032, '腊月', '十八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4768, '2033-01-19', '星期三', 2032, '腊月', '十九', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4769, '2033-01-20', '星期四', 2032, '腊月', '二十', '壬子', '鼠', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (4770, '2033-01-21', '星期五', 2032, '腊月', '廿一', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4771, '2033-01-22', '星期六', 2032, '腊月', '廿二', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4772, '2033-01-23', '星期日', 2032, '腊月', '廿三', '壬子', '鼠', NULL, 1, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4773, '2033-01-24', '星期一', 2032, '腊月', '廿四', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4774, '2033-01-25', '星期二', 2032, '腊月', '廿五', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4775, '2033-01-26', '星期三', 2032, '腊月', '廿六', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4776, '2033-01-27', '星期四', 2032, '腊月', '廿七', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4777, '2033-01-28', '星期五', 2032, '腊月', '廿八', '壬子', '鼠', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4778, '2033-01-29', '星期六', 2032, '腊月', '廿九', '壬子', '鼠', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4779, '2033-01-30', '星期日', 2032, '腊月', '三十', '壬子', '鼠', NULL, 1, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4780, '2033-01-31', '星期一', 2033, '正月', '初一', '癸丑', '牛', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (4781, '2033-02-01', '星期二', 2033, '正月', '初二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4782, '2033-02-02', '星期三', 2033, '正月', '初三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4783, '2033-02-03', '星期四', 2033, '正月', '初四', '癸丑', '牛', NULL, 0, '', '', '立春', '', 11);
INSERT INTO `base_data_holiday` VALUES (4784, '2033-02-04', '星期五', 2033, '正月', '初五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4785, '2033-02-05', '星期六', 2033, '正月', '初六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4786, '2033-02-06', '星期日', 2033, '正月', '初七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4787, '2033-02-07', '星期一', 2033, '正月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4788, '2033-02-08', '星期二', 2033, '正月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4789, '2033-02-09', '星期三', 2033, '正月', '初十 ', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4790, '2033-02-10', '星期四', 2033, '正月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4791, '2033-02-11', '星期五', 2033, '正月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4792, '2033-02-12', '星期六', 2033, '正月', '十三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4793, '2033-02-13', '星期日', 2033, '正月', '十四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4794, '2033-02-14', '星期一', 2033, '正月', '十五', '癸丑', '牛', NULL, 0, '情人节', '元宵节', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4795, '2033-02-15', '星期二', 2033, '正月', '十六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4796, '2033-02-16', '星期三', 2033, '正月', '十七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4797, '2033-02-17', '星期四', 2033, '正月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4798, '2033-02-18', '星期五', 2033, '正月', '十九', '癸丑', '牛', NULL, 0, '', '', '雨水', '', 11);
INSERT INTO `base_data_holiday` VALUES (4799, '2033-02-19', '星期六', 2033, '正月', '二十', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4800, '2033-02-20', '星期日', 2033, '正月', '廿一', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4801, '2033-02-21', '星期一', 2033, '正月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4802, '2033-02-22', '星期二', 2033, '正月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4803, '2033-02-23', '星期三', 2033, '正月', '廿四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4804, '2033-02-24', '星期四', 2033, '正月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4805, '2033-02-25', '星期五', 2033, '正月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4806, '2033-02-26', '星期六', 2033, '正月', '廿七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4807, '2033-02-27', '星期日', 2033, '正月', '廿八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4808, '2033-02-28', '星期一', 2033, '正月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4809, '2033-03-01', '星期二', 2033, '二月', '初一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4810, '2033-03-02', '星期三', 2033, '二月', '初二', '癸丑', '牛', NULL, 0, '', '龙抬头', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4811, '2033-03-03', '星期四', 2033, '二月', '初三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4812, '2033-03-04', '星期五', 2033, '二月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4813, '2033-03-05', '星期六', 2033, '二月', '初五', '癸丑', '牛', NULL, 1, '', '', '惊蛰', '', 11);
INSERT INTO `base_data_holiday` VALUES (4814, '2033-03-06', '星期日', 2033, '二月', '初六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4815, '2033-03-07', '星期一', 2033, '二月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4816, '2033-03-08', '星期二', 2033, '二月', '初八', '癸丑', '牛', NULL, 0, '妇女节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4817, '2033-03-09', '星期三', 2033, '二月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4818, '2033-03-10', '星期四', 2033, '二月', '初十 ', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4819, '2033-03-11', '星期五', 2033, '二月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4820, '2033-03-12', '星期六', 2033, '二月', '十二', '癸丑', '牛', NULL, 1, '植树节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4821, '2033-03-13', '星期日', 2033, '二月', '十三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4822, '2033-03-14', '星期一', 2033, '二月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4823, '2033-03-15', '星期二', 2033, '二月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4824, '2033-03-16', '星期三', 2033, '二月', '十六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4825, '2033-03-17', '星期四', 2033, '二月', '十七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4826, '2033-03-18', '星期五', 2033, '二月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4827, '2033-03-19', '星期六', 2033, '二月', '十九', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4828, '2033-03-20', '星期日', 2033, '二月', '二十', '癸丑', '牛', NULL, 1, '', '', '春分', '', 11);
INSERT INTO `base_data_holiday` VALUES (4829, '2033-03-21', '星期一', 2033, '二月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4830, '2033-03-22', '星期二', 2033, '二月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4831, '2033-03-23', '星期三', 2033, '二月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4832, '2033-03-24', '星期四', 2033, '二月', '廿四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4833, '2033-03-25', '星期五', 2033, '二月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4834, '2033-03-26', '星期六', 2033, '二月', '廿六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4835, '2033-03-27', '星期日', 2033, '二月', '廿七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4836, '2033-03-28', '星期一', 2033, '二月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4837, '2033-03-29', '星期二', 2033, '二月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4838, '2033-03-30', '星期三', 2033, '二月', '三十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4839, '2033-03-31', '星期四', 2033, '三月', '初一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4840, '2033-04-01', '星期五', 2033, '三月', '初二', '癸丑', '牛', NULL, 0, '愚人节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4841, '2033-04-02', '星期六', 2033, '三月', '初三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4842, '2033-04-03', '星期日', 2033, '三月', '初四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4843, '2033-04-04', '星期一', 2033, '三月', '初五', '癸丑', '牛', NULL, 0, '', '', '清明', '', 11);
INSERT INTO `base_data_holiday` VALUES (4844, '2033-04-05', '星期二', 2033, '三月', '初六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4845, '2033-04-06', '星期三', 2033, '三月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4846, '2033-04-07', '星期四', 2033, '三月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4847, '2033-04-08', '星期五', 2033, '三月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4848, '2033-04-09', '星期六', 2033, '三月', '初十 ', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4849, '2033-04-10', '星期日', 2033, '三月', '十一', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4850, '2033-04-11', '星期一', 2033, '三月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4851, '2033-04-12', '星期二', 2033, '三月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4852, '2033-04-13', '星期三', 2033, '三月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4853, '2033-04-14', '星期四', 2033, '三月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4854, '2033-04-15', '星期五', 2033, '三月', '十六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4855, '2033-04-16', '星期六', 2033, '三月', '十七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4856, '2033-04-17', '星期日', 2033, '三月', '十八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4857, '2033-04-18', '星期一', 2033, '三月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4858, '2033-04-19', '星期二', 2033, '三月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4859, '2033-04-20', '星期三', 2033, '三月', '廿一', '癸丑', '牛', NULL, 0, '', '', '谷雨', '', 11);
INSERT INTO `base_data_holiday` VALUES (4860, '2033-04-21', '星期四', 2033, '三月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4861, '2033-04-22', '星期五', 2033, '三月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4862, '2033-04-23', '星期六', 2033, '三月', '廿四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4863, '2033-04-24', '星期日', 2033, '三月', '廿五', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4864, '2033-04-25', '星期一', 2033, '三月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4865, '2033-04-26', '星期二', 2033, '三月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4866, '2033-04-27', '星期三', 2033, '三月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4867, '2033-04-28', '星期四', 2033, '三月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4868, '2033-04-29', '星期五', 2033, '四月', '初一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4869, '2033-04-30', '星期六', 2033, '四月', '初二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4870, '2033-05-01', '星期日', 2033, '四月', '初三', '癸丑', '牛', NULL, 1, '劳动节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4871, '2033-05-02', '星期一', 2033, '四月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4872, '2033-05-03', '星期二', 2033, '四月', '初五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4873, '2033-05-04', '星期三', 2033, '四月', '初六', '癸丑', '牛', NULL, 0, '青年节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4874, '2033-05-05', '星期四', 2033, '四月', '初七', '癸丑', '牛', NULL, 0, '', '', '立夏', '', 11);
INSERT INTO `base_data_holiday` VALUES (4875, '2033-05-06', '星期五', 2033, '四月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4876, '2033-05-07', '星期六', 2033, '四月', '初九', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4877, '2033-05-08', '星期日', 2033, '四月', '初十 ', '癸丑', '牛', NULL, 1, '', '', '', '母亲节', 11);
INSERT INTO `base_data_holiday` VALUES (4878, '2033-05-09', '星期一', 2033, '四月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4879, '2033-05-10', '星期二', 2033, '四月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4880, '2033-05-11', '星期三', 2033, '四月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4881, '2033-05-12', '星期四', 2033, '四月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4882, '2033-05-13', '星期五', 2033, '四月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4883, '2033-05-14', '星期六', 2033, '四月', '十六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4884, '2033-05-15', '星期日', 2033, '四月', '十七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4885, '2033-05-16', '星期一', 2033, '四月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4886, '2033-05-17', '星期二', 2033, '四月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4887, '2033-05-18', '星期三', 2033, '四月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4888, '2033-05-19', '星期四', 2033, '四月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4889, '2033-05-20', '星期五', 2033, '四月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4890, '2033-05-21', '星期六', 2033, '四月', '廿三', '癸丑', '牛', NULL, 1, '', '', '小满', '', 11);
INSERT INTO `base_data_holiday` VALUES (4891, '2033-05-22', '星期日', 2033, '四月', '廿四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4892, '2033-05-23', '星期一', 2033, '四月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4893, '2033-05-24', '星期二', 2033, '四月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4894, '2033-05-25', '星期三', 2033, '四月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4895, '2033-05-26', '星期四', 2033, '四月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4896, '2033-05-27', '星期五', 2033, '四月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4897, '2033-05-28', '星期六', 2033, '五月', '初一', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4898, '2033-05-29', '星期日', 2033, '五月', '初二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4899, '2033-05-30', '星期一', 2033, '五月', '初三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4900, '2033-05-31', '星期二', 2033, '五月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4901, '2033-06-01', '星期三', 2033, '五月', '初五', '癸丑', '牛', NULL, 0, '儿童节', '端午节', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4902, '2033-06-02', '星期四', 2033, '五月', '初六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4903, '2033-06-03', '星期五', 2033, '五月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4904, '2033-06-04', '星期六', 2033, '五月', '初八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4905, '2033-06-05', '星期日', 2033, '五月', '初九', '癸丑', '牛', NULL, 1, '', '', '芒种', '', 11);
INSERT INTO `base_data_holiday` VALUES (4906, '2033-06-06', '星期一', 2033, '五月', '初十 ', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4907, '2033-06-07', '星期二', 2033, '五月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4908, '2033-06-08', '星期三', 2033, '五月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4909, '2033-06-09', '星期四', 2033, '五月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4910, '2033-06-10', '星期五', 2033, '五月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4911, '2033-06-11', '星期六', 2033, '五月', '十五', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4912, '2033-06-12', '星期日', 2033, '五月', '十六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4913, '2033-06-13', '星期一', 2033, '五月', '十七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4914, '2033-06-14', '星期二', 2033, '五月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4915, '2033-06-15', '星期三', 2033, '五月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4916, '2033-06-16', '星期四', 2033, '五月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4917, '2033-06-17', '星期五', 2033, '五月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4918, '2033-06-18', '星期六', 2033, '五月', '廿二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4919, '2033-06-19', '星期日', 2033, '五月', '廿三', '癸丑', '牛', NULL, 1, '', '', '', '父亲节', 11);
INSERT INTO `base_data_holiday` VALUES (4920, '2033-06-20', '星期一', 2033, '五月', '廿四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4921, '2033-06-21', '星期二', 2033, '五月', '廿五', '癸丑', '牛', NULL, 0, '', '', '夏至', '', 11);
INSERT INTO `base_data_holiday` VALUES (4922, '2033-06-22', '星期三', 2033, '五月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4923, '2033-06-23', '星期四', 2033, '五月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4924, '2033-06-24', '星期五', 2033, '五月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4925, '2033-06-25', '星期六', 2033, '五月', '廿九', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4926, '2033-06-26', '星期日', 2033, '五月', '三十', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4927, '2033-06-27', '星期一', 2033, '六月', '初一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4928, '2033-06-28', '星期二', 2033, '六月', '初二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4929, '2033-06-29', '星期三', 2033, '六月', '初三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4930, '2033-06-30', '星期四', 2033, '六月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4931, '2033-07-01', '星期五', 2033, '六月', '初五', '癸丑', '牛', NULL, 0, '建党节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4932, '2033-07-02', '星期六', 2033, '六月', '初六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4933, '2033-07-03', '星期日', 2033, '六月', '初七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4934, '2033-07-04', '星期一', 2033, '六月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4935, '2033-07-05', '星期二', 2033, '六月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4936, '2033-07-06', '星期三', 2033, '六月', '初十 ', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4937, '2033-07-07', '星期四', 2033, '六月', '十一', '癸丑', '牛', NULL, 0, '', '', '小暑', '', 11);
INSERT INTO `base_data_holiday` VALUES (4938, '2033-07-08', '星期五', 2033, '六月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4939, '2033-07-09', '星期六', 2033, '六月', '十三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4940, '2033-07-10', '星期日', 2033, '六月', '十四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4941, '2033-07-11', '星期一', 2033, '六月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4942, '2033-07-12', '星期二', 2033, '六月', '十六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4943, '2033-07-13', '星期三', 2033, '六月', '十七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4944, '2033-07-14', '星期四', 2033, '六月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4945, '2033-07-15', '星期五', 2033, '六月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4946, '2033-07-16', '星期六', 2033, '六月', '二十', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4947, '2033-07-17', '星期日', 2033, '六月', '廿一', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4948, '2033-07-18', '星期一', 2033, '六月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4949, '2033-07-19', '星期二', 2033, '六月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4950, '2033-07-20', '星期三', 2033, '六月', '廿四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4951, '2033-07-21', '星期四', 2033, '六月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4952, '2033-07-22', '星期五', 2033, '六月', '廿六', '癸丑', '牛', NULL, 0, '', '', '大暑', '', 11);
INSERT INTO `base_data_holiday` VALUES (4953, '2033-07-23', '星期六', 2033, '六月', '廿七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4954, '2033-07-24', '星期日', 2033, '六月', '廿八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4955, '2033-07-25', '星期一', 2033, '六月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4956, '2033-07-26', '星期二', 2033, '七月', '初一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4957, '2033-07-27', '星期三', 2033, '七月', '初二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4958, '2033-07-28', '星期四', 2033, '七月', '初三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4959, '2033-07-29', '星期五', 2033, '七月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4960, '2033-07-30', '星期六', 2033, '七月', '初五', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4961, '2033-07-31', '星期日', 2033, '七月', '初六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4962, '2033-08-01', '星期一', 2033, '七月', '初七', '癸丑', '牛', NULL, 0, '建军节', '七夕', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4963, '2033-08-02', '星期二', 2033, '七月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4964, '2033-08-03', '星期三', 2033, '七月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4965, '2033-08-04', '星期四', 2033, '七月', '初十 ', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4966, '2033-08-05', '星期五', 2033, '七月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4967, '2033-08-06', '星期六', 2033, '七月', '十二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4968, '2033-08-07', '星期日', 2033, '七月', '十三', '癸丑', '牛', NULL, 1, '', '', '立秋', '', 11);
INSERT INTO `base_data_holiday` VALUES (4969, '2033-08-08', '星期一', 2033, '七月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4970, '2033-08-09', '星期二', 2033, '七月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4971, '2033-08-10', '星期三', 2033, '七月', '十六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4972, '2033-08-11', '星期四', 2033, '七月', '十七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4973, '2033-08-12', '星期五', 2033, '七月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4974, '2033-08-13', '星期六', 2033, '七月', '十九', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4975, '2033-08-14', '星期日', 2033, '七月', '二十', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4976, '2033-08-15', '星期一', 2033, '七月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4977, '2033-08-16', '星期二', 2033, '七月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4978, '2033-08-17', '星期三', 2033, '七月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4979, '2033-08-18', '星期四', 2033, '七月', '廿四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4980, '2033-08-19', '星期五', 2033, '七月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4981, '2033-08-20', '星期六', 2033, '七月', '廿六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4982, '2033-08-21', '星期日', 2033, '七月', '廿七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4983, '2033-08-22', '星期一', 2033, '七月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4984, '2033-08-23', '星期二', 2033, '七月', '廿九', '癸丑', '牛', NULL, 0, '', '', '处暑', '', 11);
INSERT INTO `base_data_holiday` VALUES (4985, '2033-08-24', '星期三', 2033, '七月', '三十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4986, '2033-08-25', '星期四', 2033, '八月', '初一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4987, '2033-08-26', '星期五', 2033, '八月', '初二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4988, '2033-08-27', '星期六', 2033, '八月', '初三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4989, '2033-08-28', '星期日', 2033, '八月', '初四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4990, '2033-08-29', '星期一', 2033, '八月', '初五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4991, '2033-08-30', '星期二', 2033, '八月', '初六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4992, '2033-08-31', '星期三', 2033, '八月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4993, '2033-09-01', '星期四', 2033, '八月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4994, '2033-09-02', '星期五', 2033, '八月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4995, '2033-09-03', '星期六', 2033, '八月', '初十 ', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4996, '2033-09-04', '星期日', 2033, '八月', '十一', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4997, '2033-09-05', '星期一', 2033, '八月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4998, '2033-09-06', '星期二', 2033, '八月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (4999, '2033-09-07', '星期三', 2033, '八月', '十四', '癸丑', '牛', NULL, 0, '', '', '白露', '', 11);
INSERT INTO `base_data_holiday` VALUES (5000, '2033-09-08', '星期四', 2033, '八月', '十五', '癸丑', '牛', NULL, 0, '', '中秋节', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5001, '2033-09-09', '星期五', 2033, '八月', '十六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5002, '2033-09-10', '星期六', 2033, '八月', '十七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5003, '2033-09-11', '星期日', 2033, '八月', '十八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5004, '2033-09-12', '星期一', 2033, '八月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5005, '2033-09-13', '星期二', 2033, '八月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5006, '2033-09-14', '星期三', 2033, '八月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5007, '2033-09-15', '星期四', 2033, '八月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5008, '2033-09-16', '星期五', 2033, '八月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5009, '2033-09-17', '星期六', 2033, '八月', '廿四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5010, '2033-09-18', '星期日', 2033, '八月', '廿五', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5011, '2033-09-19', '星期一', 2033, '八月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5012, '2033-09-20', '星期二', 2033, '八月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5013, '2033-09-21', '星期三', 2033, '八月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5014, '2033-09-22', '星期四', 2033, '八月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5015, '2033-09-23', '星期五', 2033, '九月', '初一', '癸丑', '牛', NULL, 0, '农民丰收节', '', '秋分', '', 11);
INSERT INTO `base_data_holiday` VALUES (5016, '2033-09-24', '星期六', 2033, '九月', '初二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5017, '2033-09-25', '星期日', 2033, '九月', '初三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5018, '2033-09-26', '星期一', 2033, '九月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5019, '2033-09-27', '星期二', 2033, '九月', '初五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5020, '2033-09-28', '星期三', 2033, '九月', '初六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5021, '2033-09-29', '星期四', 2033, '九月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5022, '2033-09-30', '星期五', 2033, '九月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5023, '2033-10-01', '星期六', 2033, '九月', '初九', '癸丑', '牛', NULL, 1, '国庆节', '重阳节', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5024, '2033-10-02', '星期日', 2033, '九月', '初十 ', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5025, '2033-10-03', '星期一', 2033, '九月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5026, '2033-10-04', '星期二', 2033, '九月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5027, '2033-10-05', '星期三', 2033, '九月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5028, '2033-10-06', '星期四', 2033, '九月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5029, '2033-10-07', '星期五', 2033, '九月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5030, '2033-10-08', '星期六', 2033, '九月', '十六', '癸丑', '牛', NULL, 1, '', '', '寒露', '', 11);
INSERT INTO `base_data_holiday` VALUES (5031, '2033-10-09', '星期日', 2033, '九月', '十七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5032, '2033-10-10', '星期一', 2033, '九月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5033, '2033-10-11', '星期二', 2033, '九月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5034, '2033-10-12', '星期三', 2033, '九月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5035, '2033-10-13', '星期四', 2033, '九月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5036, '2033-10-14', '星期五', 2033, '九月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5037, '2033-10-15', '星期六', 2033, '九月', '廿三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5038, '2033-10-16', '星期日', 2033, '九月', '廿四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5039, '2033-10-17', '星期一', 2033, '九月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5040, '2033-10-18', '星期二', 2033, '九月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5041, '2033-10-19', '星期三', 2033, '九月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5042, '2033-10-20', '星期四', 2033, '九月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5043, '2033-10-21', '星期五', 2033, '九月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5044, '2033-10-22', '星期六', 2033, '九月', '三十', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5045, '2033-10-23', '星期日', 2033, '十月', '初一', '癸丑', '牛', NULL, 1, '', '', '霜降', '', 11);
INSERT INTO `base_data_holiday` VALUES (5046, '2033-10-24', '星期一', 2033, '十月', '初二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5047, '2033-10-25', '星期二', 2033, '十月', '初三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5048, '2033-10-26', '星期三', 2033, '十月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5049, '2033-10-27', '星期四', 2033, '十月', '初五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5050, '2033-10-28', '星期五', 2033, '十月', '初六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5051, '2033-10-29', '星期六', 2033, '十月', '初七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5052, '2033-10-30', '星期日', 2033, '十月', '初八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5053, '2033-10-31', '星期一', 2033, '十月', '初九', '癸丑', '牛', NULL, 0, '万圣节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5054, '2033-11-01', '星期二', 2033, '十月', '初十 ', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5055, '2033-11-02', '星期三', 2033, '十月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5056, '2033-11-03', '星期四', 2033, '十月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5057, '2033-11-04', '星期五', 2033, '十月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5058, '2033-11-05', '星期六', 2033, '十月', '十四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5059, '2033-11-06', '星期日', 2033, '十月', '十五', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5060, '2033-11-07', '星期一', 2033, '十月', '十六', '癸丑', '牛', NULL, 0, '', '', '立冬', '', 11);
INSERT INTO `base_data_holiday` VALUES (5061, '2033-11-08', '星期二', 2033, '十月', '十七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5062, '2033-11-09', '星期三', 2033, '十月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5063, '2033-11-10', '星期四', 2033, '十月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5064, '2033-11-11', '星期五', 2033, '十月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5065, '2033-11-12', '星期六', 2033, '十月', '廿一', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5066, '2033-11-13', '星期日', 2033, '十月', '廿二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5067, '2033-11-14', '星期一', 2033, '十月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5068, '2033-11-15', '星期二', 2033, '十月', '廿四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5069, '2033-11-16', '星期三', 2033, '十月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5070, '2033-11-17', '星期四', 2033, '十月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5071, '2033-11-18', '星期五', 2033, '十月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5072, '2033-11-19', '星期六', 2033, '十月', '廿八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5073, '2033-11-20', '星期日', 2033, '十月', '廿九', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5074, '2033-11-21', '星期一', 2033, '十月', '三十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5075, '2033-11-22', '星期二', 2033, '冬月', '初一', '癸丑', '牛', NULL, 0, '', '', '小雪', '', 11);
INSERT INTO `base_data_holiday` VALUES (5076, '2033-11-23', '星期三', 2033, '冬月', '初二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5077, '2033-11-24', '星期四', 2033, '冬月', '初三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5078, '2033-11-25', '星期五', 2033, '冬月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5079, '2033-11-26', '星期六', 2033, '冬月', '初五', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5080, '2033-11-27', '星期日', 2033, '冬月', '初六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5081, '2033-11-28', '星期一', 2033, '冬月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5082, '2033-11-29', '星期二', 2033, '冬月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5083, '2033-11-30', '星期三', 2033, '冬月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5084, '2033-12-01', '星期四', 2033, '冬月', '初十 ', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5085, '2033-12-02', '星期五', 2033, '冬月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5086, '2033-12-03', '星期六', 2033, '冬月', '十二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5087, '2033-12-04', '星期日', 2033, '冬月', '十三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5088, '2033-12-05', '星期一', 2033, '冬月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5089, '2033-12-06', '星期二', 2033, '冬月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5090, '2033-12-07', '星期三', 2033, '冬月', '十六', '癸丑', '牛', NULL, 0, '', '', '大雪', '', 11);
INSERT INTO `base_data_holiday` VALUES (5091, '2033-12-08', '星期四', 2033, '冬月', '十七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5092, '2033-12-09', '星期五', 2033, '冬月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5093, '2033-12-10', '星期六', 2033, '冬月', '十九', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5094, '2033-12-11', '星期日', 2033, '冬月', '二十', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5095, '2033-12-12', '星期一', 2033, '冬月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5096, '2033-12-13', '星期二', 2033, '冬月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5097, '2033-12-14', '星期三', 2033, '冬月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5098, '2033-12-15', '星期四', 2033, '冬月', '廿四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5099, '2033-12-16', '星期五', 2033, '冬月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5100, '2033-12-17', '星期六', 2033, '冬月', '廿六', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5101, '2033-12-18', '星期日', 2033, '冬月', '廿七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5102, '2033-12-19', '星期一', 2033, '冬月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5103, '2033-12-20', '星期二', 2033, '冬月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5104, '2033-12-21', '星期三', 2033, '冬月', '三十', '癸丑', '牛', NULL, 0, '', '', '冬至', '', 11);
INSERT INTO `base_data_holiday` VALUES (5105, '2033-12-22', '星期四', 2033, '闰冬月', '初一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5106, '2033-12-23', '星期五', 2033, '闰冬月', '初二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5107, '2033-12-24', '星期六', 2033, '闰冬月', '初三', '癸丑', '牛', NULL, 1, '平安夜', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5108, '2033-12-25', '星期日', 2033, '闰冬月', '初四', '癸丑', '牛', NULL, 1, '圣诞节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5109, '2033-12-26', '星期一', 2033, '闰冬月', '初五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5110, '2033-12-27', '星期二', 2033, '闰冬月', '初六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5111, '2033-12-28', '星期三', 2033, '闰冬月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5112, '2033-12-29', '星期四', 2033, '闰冬月', '初八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5113, '2033-12-30', '星期五', 2033, '闰冬月', '初九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5114, '2033-12-31', '星期六', 2033, '闰冬月', '初十 ', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5115, '2034-01-01', '星期日', 2033, '闰冬月', '十一', '癸丑', '牛', NULL, 1, '元旦', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5116, '2034-01-02', '星期一', 2033, '闰冬月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5117, '2034-01-03', '星期二', 2033, '闰冬月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5118, '2034-01-04', '星期三', 2033, '闰冬月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5119, '2034-01-05', '星期四', 2033, '闰冬月', '十五', '癸丑', '牛', NULL, 0, '', '', '小寒', '', 11);
INSERT INTO `base_data_holiday` VALUES (5120, '2034-01-06', '星期五', 2033, '闰冬月', '十六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5121, '2034-01-07', '星期六', 2033, '闰冬月', '十七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5122, '2034-01-08', '星期日', 2033, '闰冬月', '十八', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5123, '2034-01-09', '星期一', 2033, '闰冬月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5124, '2034-01-10', '星期二', 2033, '闰冬月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5125, '2034-01-11', '星期三', 2033, '闰冬月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5126, '2034-01-12', '星期四', 2033, '闰冬月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5127, '2034-01-13', '星期五', 2033, '闰冬月', '廿三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5128, '2034-01-14', '星期六', 2033, '闰冬月', '廿四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5129, '2034-01-15', '星期日', 2033, '闰冬月', '廿五', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5130, '2034-01-16', '星期一', 2033, '闰冬月', '廿六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5131, '2034-01-17', '星期二', 2033, '闰冬月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5132, '2034-01-18', '星期三', 2033, '闰冬月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5133, '2034-01-19', '星期四', 2033, '闰冬月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5134, '2034-01-20', '星期五', 2033, '腊月', '初一', '癸丑', '牛', NULL, 0, '', '', '大寒', '', 11);
INSERT INTO `base_data_holiday` VALUES (5135, '2034-01-21', '星期六', 2033, '腊月', '初二', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5136, '2034-01-22', '星期日', 2033, '腊月', '初三', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5137, '2034-01-23', '星期一', 2033, '腊月', '初四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5138, '2034-01-24', '星期二', 2033, '腊月', '初五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5139, '2034-01-25', '星期三', 2033, '腊月', '初六', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5140, '2034-01-26', '星期四', 2033, '腊月', '初七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5141, '2034-01-27', '星期五', 2033, '腊月', '初八', '癸丑', '牛', NULL, 0, '', '腊八节', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5142, '2034-01-28', '星期六', 2033, '腊月', '初九', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5143, '2034-01-29', '星期日', 2033, '腊月', '初十 ', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5144, '2034-01-30', '星期一', 2033, '腊月', '十一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5145, '2034-01-31', '星期二', 2033, '腊月', '十二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5146, '2034-02-01', '星期三', 2033, '腊月', '十三', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5147, '2034-02-02', '星期四', 2033, '腊月', '十四', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5148, '2034-02-03', '星期五', 2033, '腊月', '十五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5149, '2034-02-04', '星期六', 2033, '腊月', '十六', '癸丑', '牛', NULL, 1, '', '', '立春', '', 11);
INSERT INTO `base_data_holiday` VALUES (5150, '2034-02-05', '星期日', 2033, '腊月', '十七', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5151, '2034-02-06', '星期一', 2033, '腊月', '十八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5152, '2034-02-07', '星期二', 2033, '腊月', '十九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5153, '2034-02-08', '星期三', 2033, '腊月', '二十', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5154, '2034-02-09', '星期四', 2033, '腊月', '廿一', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5155, '2034-02-10', '星期五', 2033, '腊月', '廿二', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5156, '2034-02-11', '星期六', 2033, '腊月', '廿三', '癸丑', '牛', NULL, 1, '', '小年', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5157, '2034-02-12', '星期日', 2033, '腊月', '廿四', '癸丑', '牛', NULL, 1, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5158, '2034-02-13', '星期一', 2033, '腊月', '廿五', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5159, '2034-02-14', '星期二', 2033, '腊月', '廿六', '癸丑', '牛', NULL, 0, '情人节', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5160, '2034-02-15', '星期三', 2033, '腊月', '廿七', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5161, '2034-02-16', '星期四', 2033, '腊月', '廿八', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5162, '2034-02-17', '星期五', 2033, '腊月', '廿九', '癸丑', '牛', NULL, 0, '', '', '', '', 11);
INSERT INTO `base_data_holiday` VALUES (5163, '2034-02-18', '星期六', 2033, '腊月', '三十', '癸丑', '牛', NULL, 1, '', '除夕', '雨水', '', 11);
INSERT INTO `base_data_holiday` VALUES (5164, '2034-02-19', '星期日', 2034, '正月', '初一', '甲寅', '虎', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5165, '2034-02-20', '星期一', 2034, '正月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5166, '2034-02-21', '星期二', 2034, '正月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5167, '2034-02-22', '星期三', 2034, '正月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5168, '2034-02-23', '星期四', 2034, '正月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5169, '2034-02-24', '星期五', 2034, '正月', '初六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5170, '2034-02-25', '星期六', 2034, '正月', '初七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5171, '2034-02-26', '星期日', 2034, '正月', '初八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5172, '2034-02-27', '星期一', 2034, '正月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5173, '2034-02-28', '星期二', 2034, '正月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5174, '2034-03-01', '星期三', 2034, '正月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5175, '2034-03-02', '星期四', 2034, '正月', '十二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5176, '2034-03-03', '星期五', 2034, '正月', '十三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5177, '2034-03-04', '星期六', 2034, '正月', '十四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5178, '2034-03-05', '星期日', 2034, '正月', '十五', '甲寅', '虎', NULL, 1, '', '元宵节', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (5179, '2034-03-06', '星期一', 2034, '正月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5180, '2034-03-07', '星期二', 2034, '正月', '十七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5181, '2034-03-08', '星期三', 2034, '正月', '十八', '甲寅', '虎', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5182, '2034-03-09', '星期四', 2034, '正月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5183, '2034-03-10', '星期五', 2034, '正月', '二十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5184, '2034-03-11', '星期六', 2034, '正月', '廿一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5185, '2034-03-12', '星期日', 2034, '正月', '廿二', '甲寅', '虎', NULL, 1, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5186, '2034-03-13', '星期一', 2034, '正月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5187, '2034-03-14', '星期二', 2034, '正月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5188, '2034-03-15', '星期三', 2034, '正月', '廿五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5189, '2034-03-16', '星期四', 2034, '正月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5190, '2034-03-17', '星期五', 2034, '正月', '廿七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5191, '2034-03-18', '星期六', 2034, '正月', '廿八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5192, '2034-03-19', '星期日', 2034, '正月', '廿九', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5193, '2034-03-20', '星期一', 2034, '二月', '初一', '甲寅', '虎', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (5194, '2034-03-21', '星期二', 2034, '二月', '初二', '甲寅', '虎', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5195, '2034-03-22', '星期三', 2034, '二月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5196, '2034-03-23', '星期四', 2034, '二月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5197, '2034-03-24', '星期五', 2034, '二月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5198, '2034-03-25', '星期六', 2034, '二月', '初六', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5199, '2034-03-26', '星期日', 2034, '二月', '初七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5200, '2034-03-27', '星期一', 2034, '二月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5201, '2034-03-28', '星期二', 2034, '二月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5202, '2034-03-29', '星期三', 2034, '二月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5203, '2034-03-30', '星期四', 2034, '二月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5204, '2034-03-31', '星期五', 2034, '二月', '十二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5205, '2034-04-01', '星期六', 2034, '二月', '十三', '甲寅', '虎', NULL, 1, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5206, '2034-04-02', '星期日', 2034, '二月', '十四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5207, '2034-04-03', '星期一', 2034, '二月', '十五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5208, '2034-04-04', '星期二', 2034, '二月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5209, '2034-04-05', '星期三', 2034, '二月', '十七', '甲寅', '虎', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (5210, '2034-04-06', '星期四', 2034, '二月', '十八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5211, '2034-04-07', '星期五', 2034, '二月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5212, '2034-04-08', '星期六', 2034, '二月', '二十', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5213, '2034-04-09', '星期日', 2034, '二月', '廿一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5214, '2034-04-10', '星期一', 2034, '二月', '廿二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5215, '2034-04-11', '星期二', 2034, '二月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5216, '2034-04-12', '星期三', 2034, '二月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5217, '2034-04-13', '星期四', 2034, '二月', '廿五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5218, '2034-04-14', '星期五', 2034, '二月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5219, '2034-04-15', '星期六', 2034, '二月', '廿七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5220, '2034-04-16', '星期日', 2034, '二月', '廿八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5221, '2034-04-17', '星期一', 2034, '二月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5222, '2034-04-18', '星期二', 2034, '二月', '三十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5223, '2034-04-19', '星期三', 2034, '三月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5224, '2034-04-20', '星期四', 2034, '三月', '初二', '甲寅', '虎', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (5225, '2034-04-21', '星期五', 2034, '三月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5226, '2034-04-22', '星期六', 2034, '三月', '初四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5227, '2034-04-23', '星期日', 2034, '三月', '初五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5228, '2034-04-24', '星期一', 2034, '三月', '初六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5229, '2034-04-25', '星期二', 2034, '三月', '初七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5230, '2034-04-26', '星期三', 2034, '三月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5231, '2034-04-27', '星期四', 2034, '三月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5232, '2034-04-28', '星期五', 2034, '三月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5233, '2034-04-29', '星期六', 2034, '三月', '十一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5234, '2034-04-30', '星期日', 2034, '三月', '十二', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5235, '2034-05-01', '星期一', 2034, '三月', '十三', '甲寅', '虎', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5236, '2034-05-02', '星期二', 2034, '三月', '十四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5237, '2034-05-03', '星期三', 2034, '三月', '十五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5238, '2034-05-04', '星期四', 2034, '三月', '十六', '甲寅', '虎', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5239, '2034-05-05', '星期五', 2034, '三月', '十七', '甲寅', '虎', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (5240, '2034-05-06', '星期六', 2034, '三月', '十八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5241, '2034-05-07', '星期日', 2034, '三月', '十九', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5242, '2034-05-08', '星期一', 2034, '三月', '二十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5243, '2034-05-09', '星期二', 2034, '三月', '廿一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5244, '2034-05-10', '星期三', 2034, '三月', '廿二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5245, '2034-05-11', '星期四', 2034, '三月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5246, '2034-05-12', '星期五', 2034, '三月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5247, '2034-05-13', '星期六', 2034, '三月', '廿五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5248, '2034-05-14', '星期日', 2034, '三月', '廿六', '甲寅', '虎', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (5249, '2034-05-15', '星期一', 2034, '三月', '廿七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5250, '2034-05-16', '星期二', 2034, '三月', '廿八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5251, '2034-05-17', '星期三', 2034, '三月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5252, '2034-05-18', '星期四', 2034, '四月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5253, '2034-05-19', '星期五', 2034, '四月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5254, '2034-05-20', '星期六', 2034, '四月', '初三', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5255, '2034-05-21', '星期日', 2034, '四月', '初四', '甲寅', '虎', NULL, 1, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (5256, '2034-05-22', '星期一', 2034, '四月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5257, '2034-05-23', '星期二', 2034, '四月', '初六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5258, '2034-05-24', '星期三', 2034, '四月', '初七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5259, '2034-05-25', '星期四', 2034, '四月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5260, '2034-05-26', '星期五', 2034, '四月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5261, '2034-05-27', '星期六', 2034, '四月', '初十 ', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5262, '2034-05-28', '星期日', 2034, '四月', '十一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5263, '2034-05-29', '星期一', 2034, '四月', '十二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5264, '2034-05-30', '星期二', 2034, '四月', '十三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5265, '2034-05-31', '星期三', 2034, '四月', '十四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5266, '2034-06-01', '星期四', 2034, '四月', '十五', '甲寅', '虎', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5267, '2034-06-02', '星期五', 2034, '四月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5268, '2034-06-03', '星期六', 2034, '四月', '十七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5269, '2034-06-04', '星期日', 2034, '四月', '十八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5270, '2034-06-05', '星期一', 2034, '四月', '十九', '甲寅', '虎', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (5271, '2034-06-06', '星期二', 2034, '四月', '二十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5272, '2034-06-07', '星期三', 2034, '四月', '廿一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5273, '2034-06-08', '星期四', 2034, '四月', '廿二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5274, '2034-06-09', '星期五', 2034, '四月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5275, '2034-06-10', '星期六', 2034, '四月', '廿四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5276, '2034-06-11', '星期日', 2034, '四月', '廿五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5277, '2034-06-12', '星期一', 2034, '四月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5278, '2034-06-13', '星期二', 2034, '四月', '廿七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5279, '2034-06-14', '星期三', 2034, '四月', '廿八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5280, '2034-06-15', '星期四', 2034, '四月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5281, '2034-06-16', '星期五', 2034, '五月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5282, '2034-06-17', '星期六', 2034, '五月', '初二', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5283, '2034-06-18', '星期日', 2034, '五月', '初三', '甲寅', '虎', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (5284, '2034-06-19', '星期一', 2034, '五月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5285, '2034-06-20', '星期二', 2034, '五月', '初五', '甲寅', '虎', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5286, '2034-06-21', '星期三', 2034, '五月', '初六', '甲寅', '虎', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (5287, '2034-06-22', '星期四', 2034, '五月', '初七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5288, '2034-06-23', '星期五', 2034, '五月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5289, '2034-06-24', '星期六', 2034, '五月', '初九', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5290, '2034-06-25', '星期日', 2034, '五月', '初十 ', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5291, '2034-06-26', '星期一', 2034, '五月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5292, '2034-06-27', '星期二', 2034, '五月', '十二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5293, '2034-06-28', '星期三', 2034, '五月', '十三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5294, '2034-06-29', '星期四', 2034, '五月', '十四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5295, '2034-06-30', '星期五', 2034, '五月', '十五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5296, '2034-07-01', '星期六', 2034, '五月', '十六', '甲寅', '虎', NULL, 1, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5297, '2034-07-02', '星期日', 2034, '五月', '十七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5298, '2034-07-03', '星期一', 2034, '五月', '十八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5299, '2034-07-04', '星期二', 2034, '五月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5300, '2034-07-05', '星期三', 2034, '五月', '二十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5301, '2034-07-06', '星期四', 2034, '五月', '廿一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5302, '2034-07-07', '星期五', 2034, '五月', '廿二', '甲寅', '虎', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (5303, '2034-07-08', '星期六', 2034, '五月', '廿三', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5304, '2034-07-09', '星期日', 2034, '五月', '廿四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5305, '2034-07-10', '星期一', 2034, '五月', '廿五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5306, '2034-07-11', '星期二', 2034, '五月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5307, '2034-07-12', '星期三', 2034, '五月', '廿七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5308, '2034-07-13', '星期四', 2034, '五月', '廿八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5309, '2034-07-14', '星期五', 2034, '五月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5310, '2034-07-15', '星期六', 2034, '五月', '三十', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5311, '2034-07-16', '星期日', 2034, '六月', '初一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5312, '2034-07-17', '星期一', 2034, '六月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5313, '2034-07-18', '星期二', 2034, '六月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5314, '2034-07-19', '星期三', 2034, '六月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5315, '2034-07-20', '星期四', 2034, '六月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5316, '2034-07-21', '星期五', 2034, '六月', '初六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5317, '2034-07-22', '星期六', 2034, '六月', '初七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5318, '2034-07-23', '星期日', 2034, '六月', '初八', '甲寅', '虎', NULL, 1, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (5319, '2034-07-24', '星期一', 2034, '六月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5320, '2034-07-25', '星期二', 2034, '六月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5321, '2034-07-26', '星期三', 2034, '六月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5322, '2034-07-27', '星期四', 2034, '六月', '十二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5323, '2034-07-28', '星期五', 2034, '六月', '十三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5324, '2034-07-29', '星期六', 2034, '六月', '十四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5325, '2034-07-30', '星期日', 2034, '六月', '十五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5326, '2034-07-31', '星期一', 2034, '六月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5327, '2034-08-01', '星期二', 2034, '六月', '十七', '甲寅', '虎', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5328, '2034-08-02', '星期三', 2034, '六月', '十八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5329, '2034-08-03', '星期四', 2034, '六月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5330, '2034-08-04', '星期五', 2034, '六月', '二十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5331, '2034-08-05', '星期六', 2034, '六月', '廿一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5332, '2034-08-06', '星期日', 2034, '六月', '廿二', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5333, '2034-08-07', '星期一', 2034, '六月', '廿三', '甲寅', '虎', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (5334, '2034-08-08', '星期二', 2034, '六月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5335, '2034-08-09', '星期三', 2034, '六月', '廿五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5336, '2034-08-10', '星期四', 2034, '六月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5337, '2034-08-11', '星期五', 2034, '六月', '廿七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5338, '2034-08-12', '星期六', 2034, '六月', '廿八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5339, '2034-08-13', '星期日', 2034, '六月', '廿九', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5340, '2034-08-14', '星期一', 2034, '七月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5341, '2034-08-15', '星期二', 2034, '七月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5342, '2034-08-16', '星期三', 2034, '七月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5343, '2034-08-17', '星期四', 2034, '七月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5344, '2034-08-18', '星期五', 2034, '七月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5345, '2034-08-19', '星期六', 2034, '七月', '初六', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5346, '2034-08-20', '星期日', 2034, '七月', '初七', '甲寅', '虎', NULL, 1, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5347, '2034-08-21', '星期一', 2034, '七月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5348, '2034-08-22', '星期二', 2034, '七月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5349, '2034-08-23', '星期三', 2034, '七月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (5350, '2034-08-24', '星期四', 2034, '七月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5351, '2034-08-25', '星期五', 2034, '七月', '十二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5352, '2034-08-26', '星期六', 2034, '七月', '十三', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5353, '2034-08-27', '星期日', 2034, '七月', '十四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5354, '2034-08-28', '星期一', 2034, '七月', '十五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5355, '2034-08-29', '星期二', 2034, '七月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5356, '2034-08-30', '星期三', 2034, '七月', '十七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5357, '2034-08-31', '星期四', 2034, '七月', '十八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5358, '2034-09-01', '星期五', 2034, '七月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5359, '2034-09-02', '星期六', 2034, '七月', '二十', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5360, '2034-09-03', '星期日', 2034, '七月', '廿一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5361, '2034-09-04', '星期一', 2034, '七月', '廿二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5362, '2034-09-05', '星期二', 2034, '七月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5363, '2034-09-06', '星期三', 2034, '七月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5364, '2034-09-07', '星期四', 2034, '七月', '廿五', '甲寅', '虎', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (5365, '2034-09-08', '星期五', 2034, '七月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5366, '2034-09-09', '星期六', 2034, '七月', '廿七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5367, '2034-09-10', '星期日', 2034, '七月', '廿八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5368, '2034-09-11', '星期一', 2034, '七月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5369, '2034-09-12', '星期二', 2034, '七月', '三十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5370, '2034-09-13', '星期三', 2034, '八月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5371, '2034-09-14', '星期四', 2034, '八月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5372, '2034-09-15', '星期五', 2034, '八月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5373, '2034-09-16', '星期六', 2034, '八月', '初四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5374, '2034-09-17', '星期日', 2034, '八月', '初五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5375, '2034-09-18', '星期一', 2034, '八月', '初六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5376, '2034-09-19', '星期二', 2034, '八月', '初七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5377, '2034-09-20', '星期三', 2034, '八月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5378, '2034-09-21', '星期四', 2034, '八月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5379, '2034-09-22', '星期五', 2034, '八月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5380, '2034-09-23', '星期六', 2034, '八月', '十一', '甲寅', '虎', NULL, 1, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (5381, '2034-09-24', '星期日', 2034, '八月', '十二', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5382, '2034-09-25', '星期一', 2034, '八月', '十三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5383, '2034-09-26', '星期二', 2034, '八月', '十四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5384, '2034-09-27', '星期三', 2034, '八月', '十五', '甲寅', '虎', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5385, '2034-09-28', '星期四', 2034, '八月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5386, '2034-09-29', '星期五', 2034, '八月', '十七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5387, '2034-09-30', '星期六', 2034, '八月', '十八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5388, '2034-10-01', '星期日', 2034, '八月', '十九', '甲寅', '虎', NULL, 1, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5389, '2034-10-02', '星期一', 2034, '八月', '二十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5390, '2034-10-03', '星期二', 2034, '八月', '廿一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5391, '2034-10-04', '星期三', 2034, '八月', '廿二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5392, '2034-10-05', '星期四', 2034, '八月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5393, '2034-10-06', '星期五', 2034, '八月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5394, '2034-10-07', '星期六', 2034, '八月', '廿五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5395, '2034-10-08', '星期日', 2034, '八月', '廿六', '甲寅', '虎', NULL, 1, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (5396, '2034-10-09', '星期一', 2034, '八月', '廿七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5397, '2034-10-10', '星期二', 2034, '八月', '廿八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5398, '2034-10-11', '星期三', 2034, '八月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5399, '2034-10-12', '星期四', 2034, '九月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5400, '2034-10-13', '星期五', 2034, '九月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5401, '2034-10-14', '星期六', 2034, '九月', '初三', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5402, '2034-10-15', '星期日', 2034, '九月', '初四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5403, '2034-10-16', '星期一', 2034, '九月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5404, '2034-10-17', '星期二', 2034, '九月', '初六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5405, '2034-10-18', '星期三', 2034, '九月', '初七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5406, '2034-10-19', '星期四', 2034, '九月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5407, '2034-10-20', '星期五', 2034, '九月', '初九', '甲寅', '虎', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5408, '2034-10-21', '星期六', 2034, '九月', '初十 ', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5409, '2034-10-22', '星期日', 2034, '九月', '十一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5410, '2034-10-23', '星期一', 2034, '九月', '十二', '甲寅', '虎', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (5411, '2034-10-24', '星期二', 2034, '九月', '十三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5412, '2034-10-25', '星期三', 2034, '九月', '十四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5413, '2034-10-26', '星期四', 2034, '九月', '十五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5414, '2034-10-27', '星期五', 2034, '九月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5415, '2034-10-28', '星期六', 2034, '九月', '十七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5416, '2034-10-29', '星期日', 2034, '九月', '十八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5417, '2034-10-30', '星期一', 2034, '九月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5418, '2034-10-31', '星期二', 2034, '九月', '二十', '甲寅', '虎', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5419, '2034-11-01', '星期三', 2034, '九月', '廿一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5420, '2034-11-02', '星期四', 2034, '九月', '廿二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5421, '2034-11-03', '星期五', 2034, '九月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5422, '2034-11-04', '星期六', 2034, '九月', '廿四', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5423, '2034-11-05', '星期日', 2034, '九月', '廿五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5424, '2034-11-06', '星期一', 2034, '九月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5425, '2034-11-07', '星期二', 2034, '九月', '廿七', '甲寅', '虎', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (5426, '2034-11-08', '星期三', 2034, '九月', '廿八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5427, '2034-11-09', '星期四', 2034, '九月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5428, '2034-11-10', '星期五', 2034, '九月', '三十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5429, '2034-11-11', '星期六', 2034, '十月', '初一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5430, '2034-11-12', '星期日', 2034, '十月', '初二', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5431, '2034-11-13', '星期一', 2034, '十月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5432, '2034-11-14', '星期二', 2034, '十月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5433, '2034-11-15', '星期三', 2034, '十月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5434, '2034-11-16', '星期四', 2034, '十月', '初六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5435, '2034-11-17', '星期五', 2034, '十月', '初七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5436, '2034-11-18', '星期六', 2034, '十月', '初八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5437, '2034-11-19', '星期日', 2034, '十月', '初九', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5438, '2034-11-20', '星期一', 2034, '十月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5439, '2034-11-21', '星期二', 2034, '十月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5440, '2034-11-22', '星期三', 2034, '十月', '十二', '甲寅', '虎', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (5441, '2034-11-23', '星期四', 2034, '十月', '十三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5442, '2034-11-24', '星期五', 2034, '十月', '十四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5443, '2034-11-25', '星期六', 2034, '十月', '十五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5444, '2034-11-26', '星期日', 2034, '十月', '十六', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5445, '2034-11-27', '星期一', 2034, '十月', '十七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5446, '2034-11-28', '星期二', 2034, '十月', '十八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5447, '2034-11-29', '星期三', 2034, '十月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5448, '2034-11-30', '星期四', 2034, '十月', '二十', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5449, '2034-12-01', '星期五', 2034, '十月', '廿一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5450, '2034-12-02', '星期六', 2034, '十月', '廿二', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5451, '2034-12-03', '星期日', 2034, '十月', '廿三', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5452, '2034-12-04', '星期一', 2034, '十月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5453, '2034-12-05', '星期二', 2034, '十月', '廿五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5454, '2034-12-06', '星期三', 2034, '十月', '廿六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5455, '2034-12-07', '星期四', 2034, '十月', '廿七', '甲寅', '虎', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (5456, '2034-12-08', '星期五', 2034, '十月', '廿八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5457, '2034-12-09', '星期六', 2034, '十月', '廿九', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5458, '2034-12-10', '星期日', 2034, '十月', '三十', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5459, '2034-12-11', '星期一', 2034, '冬月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5460, '2034-12-12', '星期二', 2034, '冬月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5461, '2034-12-13', '星期三', 2034, '冬月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5462, '2034-12-14', '星期四', 2034, '冬月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5463, '2034-12-15', '星期五', 2034, '冬月', '初五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5464, '2034-12-16', '星期六', 2034, '冬月', '初六', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5465, '2034-12-17', '星期日', 2034, '冬月', '初七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5466, '2034-12-18', '星期一', 2034, '冬月', '初八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5467, '2034-12-19', '星期二', 2034, '冬月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5468, '2034-12-20', '星期三', 2034, '冬月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5469, '2034-12-21', '星期四', 2034, '冬月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5470, '2034-12-22', '星期五', 2034, '冬月', '十二', '甲寅', '虎', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (5471, '2034-12-23', '星期六', 2034, '冬月', '十三', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5472, '2034-12-24', '星期日', 2034, '冬月', '十四', '甲寅', '虎', NULL, 1, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5473, '2034-12-25', '星期一', 2034, '冬月', '十五', '甲寅', '虎', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5474, '2034-12-26', '星期二', 2034, '冬月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5475, '2034-12-27', '星期三', 2034, '冬月', '十七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5476, '2034-12-28', '星期四', 2034, '冬月', '十八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5477, '2034-12-29', '星期五', 2034, '冬月', '十九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5478, '2034-12-30', '星期六', 2034, '冬月', '二十', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5479, '2034-12-31', '星期日', 2034, '冬月', '廿一', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5480, '2035-01-01', '星期一', 2034, '冬月', '廿二', '甲寅', '虎', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5481, '2035-01-02', '星期二', 2034, '冬月', '廿三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5482, '2035-01-03', '星期三', 2034, '冬月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5483, '2035-01-04', '星期四', 2034, '冬月', '廿五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5484, '2035-01-05', '星期五', 2034, '冬月', '廿六', '甲寅', '虎', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (5485, '2035-01-06', '星期六', 2034, '冬月', '廿七', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5486, '2035-01-07', '星期日', 2034, '冬月', '廿八', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5487, '2035-01-08', '星期一', 2034, '冬月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5488, '2035-01-09', '星期二', 2034, '腊月', '初一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5489, '2035-01-10', '星期三', 2034, '腊月', '初二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5490, '2035-01-11', '星期四', 2034, '腊月', '初三', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5491, '2035-01-12', '星期五', 2034, '腊月', '初四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5492, '2035-01-13', '星期六', 2034, '腊月', '初五', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5493, '2035-01-14', '星期日', 2034, '腊月', '初六', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5494, '2035-01-15', '星期一', 2034, '腊月', '初七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5495, '2035-01-16', '星期二', 2034, '腊月', '初八', '甲寅', '虎', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5496, '2035-01-17', '星期三', 2034, '腊月', '初九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5497, '2035-01-18', '星期四', 2034, '腊月', '初十 ', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5498, '2035-01-19', '星期五', 2034, '腊月', '十一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5499, '2035-01-20', '星期六', 2034, '腊月', '十二', '甲寅', '虎', NULL, 1, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (5500, '2035-01-21', '星期日', 2034, '腊月', '十三', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5501, '2035-01-22', '星期一', 2034, '腊月', '十四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5502, '2035-01-23', '星期二', 2034, '腊月', '十五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5503, '2035-01-24', '星期三', 2034, '腊月', '十六', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5504, '2035-01-25', '星期四', 2034, '腊月', '十七', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5505, '2035-01-26', '星期五', 2034, '腊月', '十八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5506, '2035-01-27', '星期六', 2034, '腊月', '十九', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5507, '2035-01-28', '星期日', 2034, '腊月', '二十', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5508, '2035-01-29', '星期一', 2034, '腊月', '廿一', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5509, '2035-01-30', '星期二', 2034, '腊月', '廿二', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5510, '2035-01-31', '星期三', 2034, '腊月', '廿三', '甲寅', '虎', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5511, '2035-02-01', '星期四', 2034, '腊月', '廿四', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5512, '2035-02-02', '星期五', 2034, '腊月', '廿五', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5513, '2035-02-03', '星期六', 2034, '腊月', '廿六', '甲寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5514, '2035-02-04', '星期日', 2034, '腊月', '廿七', '甲寅', '虎', NULL, 1, '', '', '立春', '', 0);
INSERT INTO `base_data_holiday` VALUES (5515, '2035-02-05', '星期一', 2034, '腊月', '廿八', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5516, '2035-02-06', '星期二', 2034, '腊月', '廿九', '甲寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5517, '2035-02-07', '星期三', 2034, '腊月', '三十', '甲寅', '虎', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5518, '2035-02-08', '星期四', 2035, '正月', '初一', '乙卯', '兔', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5519, '2035-02-09', '星期五', 2035, '正月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5520, '2035-02-10', '星期六', 2035, '正月', '初三', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5521, '2035-02-11', '星期日', 2035, '正月', '初四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5522, '2035-02-12', '星期一', 2035, '正月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5523, '2035-02-13', '星期二', 2035, '正月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5524, '2035-02-14', '星期三', 2035, '正月', '初七', '乙卯', '兔', NULL, 0, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5525, '2035-02-15', '星期四', 2035, '正月', '初八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5526, '2035-02-16', '星期五', 2035, '正月', '初九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5527, '2035-02-17', '星期六', 2035, '正月', '初十 ', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5528, '2035-02-18', '星期日', 2035, '正月', '十一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5529, '2035-02-19', '星期一', 2035, '正月', '十二', '乙卯', '兔', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (5530, '2035-02-20', '星期二', 2035, '正月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5531, '2035-02-21', '星期三', 2035, '正月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5532, '2035-02-22', '星期四', 2035, '正月', '十五', '乙卯', '兔', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5533, '2035-02-23', '星期五', 2035, '正月', '十六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5534, '2035-02-24', '星期六', 2035, '正月', '十七', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5535, '2035-02-25', '星期日', 2035, '正月', '十八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5536, '2035-02-26', '星期一', 2035, '正月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5537, '2035-02-27', '星期二', 2035, '正月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5538, '2035-02-28', '星期三', 2035, '正月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5539, '2035-03-01', '星期四', 2035, '正月', '廿二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5540, '2035-03-02', '星期五', 2035, '正月', '廿三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5541, '2035-03-03', '星期六', 2035, '正月', '廿四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5542, '2035-03-04', '星期日', 2035, '正月', '廿五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5543, '2035-03-05', '星期一', 2035, '正月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5544, '2035-03-06', '星期二', 2035, '正月', '廿七', '乙卯', '兔', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (5545, '2035-03-07', '星期三', 2035, '正月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5546, '2035-03-08', '星期四', 2035, '正月', '廿九', '乙卯', '兔', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5547, '2035-03-09', '星期五', 2035, '正月', '三十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5548, '2035-03-10', '星期六', 2035, '二月', '初一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5549, '2035-03-11', '星期日', 2035, '二月', '初二', '乙卯', '兔', NULL, 1, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5550, '2035-03-12', '星期一', 2035, '二月', '初三', '乙卯', '兔', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5551, '2035-03-13', '星期二', 2035, '二月', '初四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5552, '2035-03-14', '星期三', 2035, '二月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5553, '2035-03-15', '星期四', 2035, '二月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5554, '2035-03-16', '星期五', 2035, '二月', '初七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5555, '2035-03-17', '星期六', 2035, '二月', '初八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5556, '2035-03-18', '星期日', 2035, '二月', '初九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5557, '2035-03-19', '星期一', 2035, '二月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5558, '2035-03-20', '星期二', 2035, '二月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5559, '2035-03-21', '星期三', 2035, '二月', '十二', '乙卯', '兔', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (5560, '2035-03-22', '星期四', 2035, '二月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5561, '2035-03-23', '星期五', 2035, '二月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5562, '2035-03-24', '星期六', 2035, '二月', '十五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5563, '2035-03-25', '星期日', 2035, '二月', '十六', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5564, '2035-03-26', '星期一', 2035, '二月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5565, '2035-03-27', '星期二', 2035, '二月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5566, '2035-03-28', '星期三', 2035, '二月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5567, '2035-03-29', '星期四', 2035, '二月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5568, '2035-03-30', '星期五', 2035, '二月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5569, '2035-03-31', '星期六', 2035, '二月', '廿二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5570, '2035-04-01', '星期日', 2035, '二月', '廿三', '乙卯', '兔', NULL, 1, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5571, '2035-04-02', '星期一', 2035, '二月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5572, '2035-04-03', '星期二', 2035, '二月', '廿五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5573, '2035-04-04', '星期三', 2035, '二月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5574, '2035-04-05', '星期四', 2035, '二月', '廿七', '乙卯', '兔', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (5575, '2035-04-06', '星期五', 2035, '二月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5576, '2035-04-07', '星期六', 2035, '二月', '廿九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5577, '2035-04-08', '星期日', 2035, '三月', '初一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5578, '2035-04-09', '星期一', 2035, '三月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5579, '2035-04-10', '星期二', 2035, '三月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5580, '2035-04-11', '星期三', 2035, '三月', '初四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5581, '2035-04-12', '星期四', 2035, '三月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5582, '2035-04-13', '星期五', 2035, '三月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5583, '2035-04-14', '星期六', 2035, '三月', '初七', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5584, '2035-04-15', '星期日', 2035, '三月', '初八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5585, '2035-04-16', '星期一', 2035, '三月', '初九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5586, '2035-04-17', '星期二', 2035, '三月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5587, '2035-04-18', '星期三', 2035, '三月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5588, '2035-04-19', '星期四', 2035, '三月', '十二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5589, '2035-04-20', '星期五', 2035, '三月', '十三', '乙卯', '兔', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (5590, '2035-04-21', '星期六', 2035, '三月', '十四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5591, '2035-04-22', '星期日', 2035, '三月', '十五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5592, '2035-04-23', '星期一', 2035, '三月', '十六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5593, '2035-04-24', '星期二', 2035, '三月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5594, '2035-04-25', '星期三', 2035, '三月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5595, '2035-04-26', '星期四', 2035, '三月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5596, '2035-04-27', '星期五', 2035, '三月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5597, '2035-04-28', '星期六', 2035, '三月', '廿一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5598, '2035-04-29', '星期日', 2035, '三月', '廿二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5599, '2035-04-30', '星期一', 2035, '三月', '廿三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5600, '2035-05-01', '星期二', 2035, '三月', '廿四', '乙卯', '兔', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5601, '2035-05-02', '星期三', 2035, '三月', '廿五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5602, '2035-05-03', '星期四', 2035, '三月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5603, '2035-05-04', '星期五', 2035, '三月', '廿七', '乙卯', '兔', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5604, '2035-05-05', '星期六', 2035, '三月', '廿八', '乙卯', '兔', NULL, 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (5605, '2035-05-06', '星期日', 2035, '三月', '廿九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5606, '2035-05-07', '星期一', 2035, '三月', '三十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5607, '2035-05-08', '星期二', 2035, '四月', '初一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5608, '2035-05-09', '星期三', 2035, '四月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5609, '2035-05-10', '星期四', 2035, '四月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5610, '2035-05-11', '星期五', 2035, '四月', '初四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5611, '2035-05-12', '星期六', 2035, '四月', '初五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5612, '2035-05-13', '星期日', 2035, '四月', '初六', '乙卯', '兔', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (5613, '2035-05-14', '星期一', 2035, '四月', '初七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5614, '2035-05-15', '星期二', 2035, '四月', '初八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5615, '2035-05-16', '星期三', 2035, '四月', '初九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5616, '2035-05-17', '星期四', 2035, '四月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5617, '2035-05-18', '星期五', 2035, '四月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5618, '2035-05-19', '星期六', 2035, '四月', '十二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5619, '2035-05-20', '星期日', 2035, '四月', '十三', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5620, '2035-05-21', '星期一', 2035, '四月', '十四', '乙卯', '兔', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (5621, '2035-05-22', '星期二', 2035, '四月', '十五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5622, '2035-05-23', '星期三', 2035, '四月', '十六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5623, '2035-05-24', '星期四', 2035, '四月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5624, '2035-05-25', '星期五', 2035, '四月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5625, '2035-05-26', '星期六', 2035, '四月', '十九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5626, '2035-05-27', '星期日', 2035, '四月', '二十', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5627, '2035-05-28', '星期一', 2035, '四月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5628, '2035-05-29', '星期二', 2035, '四月', '廿二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5629, '2035-05-30', '星期三', 2035, '四月', '廿三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5630, '2035-05-31', '星期四', 2035, '四月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5631, '2035-06-01', '星期五', 2035, '四月', '廿五', '乙卯', '兔', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5632, '2035-06-02', '星期六', 2035, '四月', '廿六', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5633, '2035-06-03', '星期日', 2035, '四月', '廿七', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5634, '2035-06-04', '星期一', 2035, '四月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5635, '2035-06-05', '星期二', 2035, '四月', '廿九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5636, '2035-06-06', '星期三', 2035, '五月', '初一', '乙卯', '兔', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (5637, '2035-06-07', '星期四', 2035, '五月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5638, '2035-06-08', '星期五', 2035, '五月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5639, '2035-06-09', '星期六', 2035, '五月', '初四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5640, '2035-06-10', '星期日', 2035, '五月', '初五', '乙卯', '兔', NULL, 1, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5641, '2035-06-11', '星期一', 2035, '五月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5642, '2035-06-12', '星期二', 2035, '五月', '初七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5643, '2035-06-13', '星期三', 2035, '五月', '初八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5644, '2035-06-14', '星期四', 2035, '五月', '初九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5645, '2035-06-15', '星期五', 2035, '五月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5646, '2035-06-16', '星期六', 2035, '五月', '十一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5647, '2035-06-17', '星期日', 2035, '五月', '十二', '乙卯', '兔', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (5648, '2035-06-18', '星期一', 2035, '五月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5649, '2035-06-19', '星期二', 2035, '五月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5650, '2035-06-20', '星期三', 2035, '五月', '十五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5651, '2035-06-21', '星期四', 2035, '五月', '十六', '乙卯', '兔', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (5652, '2035-06-22', '星期五', 2035, '五月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5653, '2035-06-23', '星期六', 2035, '五月', '十八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5654, '2035-06-24', '星期日', 2035, '五月', '十九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5655, '2035-06-25', '星期一', 2035, '五月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5656, '2035-06-26', '星期二', 2035, '五月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5657, '2035-06-27', '星期三', 2035, '五月', '廿二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5658, '2035-06-28', '星期四', 2035, '五月', '廿三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5659, '2035-06-29', '星期五', 2035, '五月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5660, '2035-06-30', '星期六', 2035, '五月', '廿五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5661, '2035-07-01', '星期日', 2035, '五月', '廿六', '乙卯', '兔', NULL, 1, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5662, '2035-07-02', '星期一', 2035, '五月', '廿七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5663, '2035-07-03', '星期二', 2035, '五月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5664, '2035-07-04', '星期三', 2035, '五月', '廿九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5665, '2035-07-05', '星期四', 2035, '六月', '初一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5666, '2035-07-06', '星期五', 2035, '六月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5667, '2035-07-07', '星期六', 2035, '六月', '初三', '乙卯', '兔', NULL, 1, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (5668, '2035-07-08', '星期日', 2035, '六月', '初四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5669, '2035-07-09', '星期一', 2035, '六月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5670, '2035-07-10', '星期二', 2035, '六月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5671, '2035-07-11', '星期三', 2035, '六月', '初七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5672, '2035-07-12', '星期四', 2035, '六月', '初八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5673, '2035-07-13', '星期五', 2035, '六月', '初九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5674, '2035-07-14', '星期六', 2035, '六月', '初十 ', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5675, '2035-07-15', '星期日', 2035, '六月', '十一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5676, '2035-07-16', '星期一', 2035, '六月', '十二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5677, '2035-07-17', '星期二', 2035, '六月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5678, '2035-07-18', '星期三', 2035, '六月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5679, '2035-07-19', '星期四', 2035, '六月', '十五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5680, '2035-07-20', '星期五', 2035, '六月', '十六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5681, '2035-07-21', '星期六', 2035, '六月', '十七', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5682, '2035-07-22', '星期日', 2035, '六月', '十八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5683, '2035-07-23', '星期一', 2035, '六月', '十九', '乙卯', '兔', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (5684, '2035-07-24', '星期二', 2035, '六月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5685, '2035-07-25', '星期三', 2035, '六月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5686, '2035-07-26', '星期四', 2035, '六月', '廿二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5687, '2035-07-27', '星期五', 2035, '六月', '廿三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5688, '2035-07-28', '星期六', 2035, '六月', '廿四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5689, '2035-07-29', '星期日', 2035, '六月', '廿五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5690, '2035-07-30', '星期一', 2035, '六月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5691, '2035-07-31', '星期二', 2035, '六月', '廿七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5692, '2035-08-01', '星期三', 2035, '六月', '廿八', '乙卯', '兔', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5693, '2035-08-02', '星期四', 2035, '六月', '廿九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5694, '2035-08-03', '星期五', 2035, '六月', '三十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5695, '2035-08-04', '星期六', 2035, '七月', '初一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5696, '2035-08-05', '星期日', 2035, '七月', '初二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5697, '2035-08-06', '星期一', 2035, '七月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5698, '2035-08-07', '星期二', 2035, '七月', '初四', '乙卯', '兔', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (5699, '2035-08-08', '星期三', 2035, '七月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5700, '2035-08-09', '星期四', 2035, '七月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5701, '2035-08-10', '星期五', 2035, '七月', '初七', '乙卯', '兔', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5702, '2035-08-11', '星期六', 2035, '七月', '初八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5703, '2035-08-12', '星期日', 2035, '七月', '初九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5704, '2035-08-13', '星期一', 2035, '七月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5705, '2035-08-14', '星期二', 2035, '七月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5706, '2035-08-15', '星期三', 2035, '七月', '十二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5707, '2035-08-16', '星期四', 2035, '七月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5708, '2035-08-17', '星期五', 2035, '七月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5709, '2035-08-18', '星期六', 2035, '七月', '十五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5710, '2035-08-19', '星期日', 2035, '七月', '十六', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5711, '2035-08-20', '星期一', 2035, '七月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5712, '2035-08-21', '星期二', 2035, '七月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5713, '2035-08-22', '星期三', 2035, '七月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5714, '2035-08-23', '星期四', 2035, '七月', '二十', '乙卯', '兔', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (5715, '2035-08-24', '星期五', 2035, '七月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5716, '2035-08-25', '星期六', 2035, '七月', '廿二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5717, '2035-08-26', '星期日', 2035, '七月', '廿三', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5718, '2035-08-27', '星期一', 2035, '七月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5719, '2035-08-28', '星期二', 2035, '七月', '廿五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5720, '2035-08-29', '星期三', 2035, '七月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5721, '2035-08-30', '星期四', 2035, '七月', '廿七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5722, '2035-08-31', '星期五', 2035, '七月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5723, '2035-09-01', '星期六', 2035, '七月', '廿九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5724, '2035-09-02', '星期日', 2035, '八月', '初一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5725, '2035-09-03', '星期一', 2035, '八月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5726, '2035-09-04', '星期二', 2035, '八月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5727, '2035-09-05', '星期三', 2035, '八月', '初四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5728, '2035-09-06', '星期四', 2035, '八月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5729, '2035-09-07', '星期五', 2035, '八月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5730, '2035-09-08', '星期六', 2035, '八月', '初七', '乙卯', '兔', NULL, 1, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (5731, '2035-09-09', '星期日', 2035, '八月', '初八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5732, '2035-09-10', '星期一', 2035, '八月', '初九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5733, '2035-09-11', '星期二', 2035, '八月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5734, '2035-09-12', '星期三', 2035, '八月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5735, '2035-09-13', '星期四', 2035, '八月', '十二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5736, '2035-09-14', '星期五', 2035, '八月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5737, '2035-09-15', '星期六', 2035, '八月', '十四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5738, '2035-09-16', '星期日', 2035, '八月', '十五', '乙卯', '兔', NULL, 1, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5739, '2035-09-17', '星期一', 2035, '八月', '十六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5740, '2035-09-18', '星期二', 2035, '八月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5741, '2035-09-19', '星期三', 2035, '八月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5742, '2035-09-20', '星期四', 2035, '八月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5743, '2035-09-21', '星期五', 2035, '八月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5744, '2035-09-22', '星期六', 2035, '八月', '廿一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5745, '2035-09-23', '星期日', 2035, '八月', '廿二', '乙卯', '兔', NULL, 1, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (5746, '2035-09-24', '星期一', 2035, '八月', '廿三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5747, '2035-09-25', '星期二', 2035, '八月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5748, '2035-09-26', '星期三', 2035, '八月', '廿五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5749, '2035-09-27', '星期四', 2035, '八月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5750, '2035-09-28', '星期五', 2035, '八月', '廿七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5751, '2035-09-29', '星期六', 2035, '八月', '廿八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5752, '2035-09-30', '星期日', 2035, '八月', '廿九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5753, '2035-10-01', '星期一', 2035, '九月', '初一', '乙卯', '兔', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5754, '2035-10-02', '星期二', 2035, '九月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5755, '2035-10-03', '星期三', 2035, '九月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5756, '2035-10-04', '星期四', 2035, '九月', '初四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5757, '2035-10-05', '星期五', 2035, '九月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5758, '2035-10-06', '星期六', 2035, '九月', '初六', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5759, '2035-10-07', '星期日', 2035, '九月', '初七', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5760, '2035-10-08', '星期一', 2035, '九月', '初八', '乙卯', '兔', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (5761, '2035-10-09', '星期二', 2035, '九月', '初九', '乙卯', '兔', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5762, '2035-10-10', '星期三', 2035, '九月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5763, '2035-10-11', '星期四', 2035, '九月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5764, '2035-10-12', '星期五', 2035, '九月', '十二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5765, '2035-10-13', '星期六', 2035, '九月', '十三', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5766, '2035-10-14', '星期日', 2035, '九月', '十四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5767, '2035-10-15', '星期一', 2035, '九月', '十五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5768, '2035-10-16', '星期二', 2035, '九月', '十六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5769, '2035-10-17', '星期三', 2035, '九月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5770, '2035-10-18', '星期四', 2035, '九月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5771, '2035-10-19', '星期五', 2035, '九月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5772, '2035-10-20', '星期六', 2035, '九月', '二十', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5773, '2035-10-21', '星期日', 2035, '九月', '廿一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5774, '2035-10-22', '星期一', 2035, '九月', '廿二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5775, '2035-10-23', '星期二', 2035, '九月', '廿三', '乙卯', '兔', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (5776, '2035-10-24', '星期三', 2035, '九月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5777, '2035-10-25', '星期四', 2035, '九月', '廿五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5778, '2035-10-26', '星期五', 2035, '九月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5779, '2035-10-27', '星期六', 2035, '九月', '廿七', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5780, '2035-10-28', '星期日', 2035, '九月', '廿八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5781, '2035-10-29', '星期一', 2035, '九月', '廿九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5782, '2035-10-30', '星期二', 2035, '九月', '三十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5783, '2035-10-31', '星期三', 2035, '十月', '初一', '乙卯', '兔', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5784, '2035-11-01', '星期四', 2035, '十月', '初二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5785, '2035-11-02', '星期五', 2035, '十月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5786, '2035-11-03', '星期六', 2035, '十月', '初四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5787, '2035-11-04', '星期日', 2035, '十月', '初五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5788, '2035-11-05', '星期一', 2035, '十月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5789, '2035-11-06', '星期二', 2035, '十月', '初七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5790, '2035-11-07', '星期三', 2035, '十月', '初八', '乙卯', '兔', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (5791, '2035-11-08', '星期四', 2035, '十月', '初九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5792, '2035-11-09', '星期五', 2035, '十月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5793, '2035-11-10', '星期六', 2035, '十月', '十一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5794, '2035-11-11', '星期日', 2035, '十月', '十二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5795, '2035-11-12', '星期一', 2035, '十月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5796, '2035-11-13', '星期二', 2035, '十月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5797, '2035-11-14', '星期三', 2035, '十月', '十五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5798, '2035-11-15', '星期四', 2035, '十月', '十六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5799, '2035-11-16', '星期五', 2035, '十月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5800, '2035-11-17', '星期六', 2035, '十月', '十八', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5801, '2035-11-18', '星期日', 2035, '十月', '十九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5802, '2035-11-19', '星期一', 2035, '十月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5803, '2035-11-20', '星期二', 2035, '十月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5804, '2035-11-21', '星期三', 2035, '十月', '廿二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5805, '2035-11-22', '星期四', 2035, '十月', '廿三', '乙卯', '兔', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (5806, '2035-11-23', '星期五', 2035, '十月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5807, '2035-11-24', '星期六', 2035, '十月', '廿五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5808, '2035-11-25', '星期日', 2035, '十月', '廿六', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5809, '2035-11-26', '星期一', 2035, '十月', '廿七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5810, '2035-11-27', '星期二', 2035, '十月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5811, '2035-11-28', '星期三', 2035, '十月', '廿九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5812, '2035-11-29', '星期四', 2035, '十月', '三十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5813, '2035-11-30', '星期五', 2035, '冬月', '初一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5814, '2035-12-01', '星期六', 2035, '冬月', '初二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5815, '2035-12-02', '星期日', 2035, '冬月', '初三', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5816, '2035-12-03', '星期一', 2035, '冬月', '初四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5817, '2035-12-04', '星期二', 2035, '冬月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5818, '2035-12-05', '星期三', 2035, '冬月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5819, '2035-12-06', '星期四', 2035, '冬月', '初七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5820, '2035-12-07', '星期五', 2035, '冬月', '初八', '乙卯', '兔', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (5821, '2035-12-08', '星期六', 2035, '冬月', '初九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5822, '2035-12-09', '星期日', 2035, '冬月', '初十 ', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5823, '2035-12-10', '星期一', 2035, '冬月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5824, '2035-12-11', '星期二', 2035, '冬月', '十二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5825, '2035-12-12', '星期三', 2035, '冬月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5826, '2035-12-13', '星期四', 2035, '冬月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5827, '2035-12-14', '星期五', 2035, '冬月', '十五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5828, '2035-12-15', '星期六', 2035, '冬月', '十六', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5829, '2035-12-16', '星期日', 2035, '冬月', '十七', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5830, '2035-12-17', '星期一', 2035, '冬月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5831, '2035-12-18', '星期二', 2035, '冬月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5832, '2035-12-19', '星期三', 2035, '冬月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5833, '2035-12-20', '星期四', 2035, '冬月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5834, '2035-12-21', '星期五', 2035, '冬月', '廿二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5835, '2035-12-22', '星期六', 2035, '冬月', '廿三', '乙卯', '兔', NULL, 1, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (5836, '2035-12-23', '星期日', 2035, '冬月', '廿四', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5837, '2035-12-24', '星期一', 2035, '冬月', '廿五', '乙卯', '兔', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5838, '2035-12-25', '星期二', 2035, '冬月', '廿六', '乙卯', '兔', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5839, '2035-12-26', '星期三', 2035, '冬月', '廿七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5840, '2035-12-27', '星期四', 2035, '冬月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5841, '2035-12-28', '星期五', 2035, '冬月', '廿九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5842, '2035-12-29', '星期六', 2035, '腊月', '初一', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5843, '2035-12-30', '星期日', 2035, '腊月', '初二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5844, '2035-12-31', '星期一', 2035, '腊月', '初三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5845, '2036-01-01', '星期二', 2035, '腊月', '初四', '乙卯', '兔', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5846, '2036-01-02', '星期三', 2035, '腊月', '初五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5847, '2036-01-03', '星期四', 2035, '腊月', '初六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5848, '2036-01-04', '星期五', 2035, '腊月', '初七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5849, '2036-01-05', '星期六', 2035, '腊月', '初八', '乙卯', '兔', NULL, 1, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5850, '2036-01-06', '星期日', 2035, '腊月', '初九', '乙卯', '兔', NULL, 1, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (5851, '2036-01-07', '星期一', 2035, '腊月', '初十 ', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5852, '2036-01-08', '星期二', 2035, '腊月', '十一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5853, '2036-01-09', '星期三', 2035, '腊月', '十二', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5854, '2036-01-10', '星期四', 2035, '腊月', '十三', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5855, '2036-01-11', '星期五', 2035, '腊月', '十四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5856, '2036-01-12', '星期六', 2035, '腊月', '十五', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5857, '2036-01-13', '星期日', 2035, '腊月', '十六', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5858, '2036-01-14', '星期一', 2035, '腊月', '十七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5859, '2036-01-15', '星期二', 2035, '腊月', '十八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5860, '2036-01-16', '星期三', 2035, '腊月', '十九', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5861, '2036-01-17', '星期四', 2035, '腊月', '二十', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5862, '2036-01-18', '星期五', 2035, '腊月', '廿一', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5863, '2036-01-19', '星期六', 2035, '腊月', '廿二', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5864, '2036-01-20', '星期日', 2035, '腊月', '廿三', '乙卯', '兔', NULL, 1, '', '小年', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (5865, '2036-01-21', '星期一', 2035, '腊月', '廿四', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5866, '2036-01-22', '星期二', 2035, '腊月', '廿五', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5867, '2036-01-23', '星期三', 2035, '腊月', '廿六', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5868, '2036-01-24', '星期四', 2035, '腊月', '廿七', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5869, '2036-01-25', '星期五', 2035, '腊月', '廿八', '乙卯', '兔', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5870, '2036-01-26', '星期六', 2035, '腊月', '廿九', '乙卯', '兔', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5871, '2036-01-27', '星期日', 2035, '腊月', '三十', '乙卯', '兔', NULL, 1, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5872, '2036-01-28', '星期一', 2036, '正月', '初一', '丙辰', '龙', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (5873, '2036-01-29', '星期二', 2036, '正月', '初二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5874, '2036-01-30', '星期三', 2036, '正月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5875, '2036-01-31', '星期四', 2036, '正月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5876, '2036-02-01', '星期五', 2036, '正月', '初五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5877, '2036-02-02', '星期六', 2036, '正月', '初六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5878, '2036-02-03', '星期日', 2036, '正月', '初七', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5879, '2036-02-04', '星期一', 2036, '正月', '初八', '丙辰', '龙', NULL, 0, '', '', '立春', '', 6);
INSERT INTO `base_data_holiday` VALUES (5880, '2036-02-05', '星期二', 2036, '正月', '初九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5881, '2036-02-06', '星期三', 2036, '正月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5882, '2036-02-07', '星期四', 2036, '正月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5883, '2036-02-08', '星期五', 2036, '正月', '十二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5884, '2036-02-09', '星期六', 2036, '正月', '十三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5885, '2036-02-10', '星期日', 2036, '正月', '十四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5886, '2036-02-11', '星期一', 2036, '正月', '十五', '丙辰', '龙', NULL, 0, '', '元宵节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5887, '2036-02-12', '星期二', 2036, '正月', '十六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5888, '2036-02-13', '星期三', 2036, '正月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5889, '2036-02-14', '星期四', 2036, '正月', '十八', '丙辰', '龙', NULL, 0, '情人节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5890, '2036-02-15', '星期五', 2036, '正月', '十九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5891, '2036-02-16', '星期六', 2036, '正月', '二十', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5892, '2036-02-17', '星期日', 2036, '正月', '廿一', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5893, '2036-02-18', '星期一', 2036, '正月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5894, '2036-02-19', '星期二', 2036, '正月', '廿三', '丙辰', '龙', NULL, 0, '', '', '雨水', '', 6);
INSERT INTO `base_data_holiday` VALUES (5895, '2036-02-20', '星期三', 2036, '正月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5896, '2036-02-21', '星期四', 2036, '正月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5897, '2036-02-22', '星期五', 2036, '正月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5898, '2036-02-23', '星期六', 2036, '正月', '廿七', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5899, '2036-02-24', '星期日', 2036, '正月', '廿八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5900, '2036-02-25', '星期一', 2036, '正月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5901, '2036-02-26', '星期二', 2036, '正月', '三十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5902, '2036-02-27', '星期三', 2036, '二月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5903, '2036-02-28', '星期四', 2036, '二月', '初二', '丙辰', '龙', NULL, 0, '', '龙抬头', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5904, '2036-02-29', '星期五', 2036, '二月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5905, '2036-03-01', '星期六', 2036, '二月', '初四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5906, '2036-03-02', '星期日', 2036, '二月', '初五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5907, '2036-03-03', '星期一', 2036, '二月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5908, '2036-03-04', '星期二', 2036, '二月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5909, '2036-03-05', '星期三', 2036, '二月', '初八', '丙辰', '龙', NULL, 0, '', '', '惊蛰', '', 6);
INSERT INTO `base_data_holiday` VALUES (5910, '2036-03-06', '星期四', 2036, '二月', '初九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5911, '2036-03-07', '星期五', 2036, '二月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5912, '2036-03-08', '星期六', 2036, '二月', '十一', '丙辰', '龙', NULL, 1, '妇女节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5913, '2036-03-09', '星期日', 2036, '二月', '十二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5914, '2036-03-10', '星期一', 2036, '二月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5915, '2036-03-11', '星期二', 2036, '二月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5916, '2036-03-12', '星期三', 2036, '二月', '十五', '丙辰', '龙', NULL, 0, '植树节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5917, '2036-03-13', '星期四', 2036, '二月', '十六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5918, '2036-03-14', '星期五', 2036, '二月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5919, '2036-03-15', '星期六', 2036, '二月', '十八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5920, '2036-03-16', '星期日', 2036, '二月', '十九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5921, '2036-03-17', '星期一', 2036, '二月', '二十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5922, '2036-03-18', '星期二', 2036, '二月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5923, '2036-03-19', '星期三', 2036, '二月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5924, '2036-03-20', '星期四', 2036, '二月', '廿三', '丙辰', '龙', NULL, 0, '', '', '春分', '', 6);
INSERT INTO `base_data_holiday` VALUES (5925, '2036-03-21', '星期五', 2036, '二月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5926, '2036-03-22', '星期六', 2036, '二月', '廿五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5927, '2036-03-23', '星期日', 2036, '二月', '廿六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5928, '2036-03-24', '星期一', 2036, '二月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5929, '2036-03-25', '星期二', 2036, '二月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5930, '2036-03-26', '星期三', 2036, '二月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5931, '2036-03-27', '星期四', 2036, '二月', '三十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5932, '2036-03-28', '星期五', 2036, '三月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5933, '2036-03-29', '星期六', 2036, '三月', '初二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5934, '2036-03-30', '星期日', 2036, '三月', '初三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5935, '2036-03-31', '星期一', 2036, '三月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5936, '2036-04-01', '星期二', 2036, '三月', '初五', '丙辰', '龙', NULL, 0, '愚人节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5937, '2036-04-02', '星期三', 2036, '三月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5938, '2036-04-03', '星期四', 2036, '三月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5939, '2036-04-04', '星期五', 2036, '三月', '初八', '丙辰', '龙', NULL, 0, '', '', '清明', '', 6);
INSERT INTO `base_data_holiday` VALUES (5940, '2036-04-05', '星期六', 2036, '三月', '初九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5941, '2036-04-06', '星期日', 2036, '三月', '初十 ', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5942, '2036-04-07', '星期一', 2036, '三月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5943, '2036-04-08', '星期二', 2036, '三月', '十二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5944, '2036-04-09', '星期三', 2036, '三月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5945, '2036-04-10', '星期四', 2036, '三月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5946, '2036-04-11', '星期五', 2036, '三月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5947, '2036-04-12', '星期六', 2036, '三月', '十六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5948, '2036-04-13', '星期日', 2036, '三月', '十七', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5949, '2036-04-14', '星期一', 2036, '三月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5950, '2036-04-15', '星期二', 2036, '三月', '十九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5951, '2036-04-16', '星期三', 2036, '三月', '二十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5952, '2036-04-17', '星期四', 2036, '三月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5953, '2036-04-18', '星期五', 2036, '三月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5954, '2036-04-19', '星期六', 2036, '三月', '廿三', '丙辰', '龙', NULL, 1, '', '', '谷雨', '', 6);
INSERT INTO `base_data_holiday` VALUES (5955, '2036-04-20', '星期日', 2036, '三月', '廿四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5956, '2036-04-21', '星期一', 2036, '三月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5957, '2036-04-22', '星期二', 2036, '三月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5958, '2036-04-23', '星期三', 2036, '三月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5959, '2036-04-24', '星期四', 2036, '三月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5960, '2036-04-25', '星期五', 2036, '三月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5961, '2036-04-26', '星期六', 2036, '四月', '初一', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5962, '2036-04-27', '星期日', 2036, '四月', '初二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5963, '2036-04-28', '星期一', 2036, '四月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5964, '2036-04-29', '星期二', 2036, '四月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5965, '2036-04-30', '星期三', 2036, '四月', '初五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5966, '2036-05-01', '星期四', 2036, '四月', '初六', '丙辰', '龙', NULL, 0, '劳动节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5967, '2036-05-02', '星期五', 2036, '四月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5968, '2036-05-03', '星期六', 2036, '四月', '初八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5969, '2036-05-04', '星期日', 2036, '四月', '初九', '丙辰', '龙', NULL, 1, '青年节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5970, '2036-05-05', '星期一', 2036, '四月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '立夏', '', 6);
INSERT INTO `base_data_holiday` VALUES (5971, '2036-05-06', '星期二', 2036, '四月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5972, '2036-05-07', '星期三', 2036, '四月', '十二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5973, '2036-05-08', '星期四', 2036, '四月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5974, '2036-05-09', '星期五', 2036, '四月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5975, '2036-05-10', '星期六', 2036, '四月', '十五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5976, '2036-05-11', '星期日', 2036, '四月', '十六', '丙辰', '龙', NULL, 1, '', '', '', '母亲节', 6);
INSERT INTO `base_data_holiday` VALUES (5977, '2036-05-12', '星期一', 2036, '四月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5978, '2036-05-13', '星期二', 2036, '四月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5979, '2036-05-14', '星期三', 2036, '四月', '十九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5980, '2036-05-15', '星期四', 2036, '四月', '二十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5981, '2036-05-16', '星期五', 2036, '四月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5982, '2036-05-17', '星期六', 2036, '四月', '廿二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5983, '2036-05-18', '星期日', 2036, '四月', '廿三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5984, '2036-05-19', '星期一', 2036, '四月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5985, '2036-05-20', '星期二', 2036, '四月', '廿五', '丙辰', '龙', NULL, 0, '', '', '小满', '', 6);
INSERT INTO `base_data_holiday` VALUES (5986, '2036-05-21', '星期三', 2036, '四月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5987, '2036-05-22', '星期四', 2036, '四月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5988, '2036-05-23', '星期五', 2036, '四月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5989, '2036-05-24', '星期六', 2036, '四月', '廿九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5990, '2036-05-25', '星期日', 2036, '四月', '三十', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5991, '2036-05-26', '星期一', 2036, '五月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5992, '2036-05-27', '星期二', 2036, '五月', '初二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5993, '2036-05-28', '星期三', 2036, '五月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5994, '2036-05-29', '星期四', 2036, '五月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5995, '2036-05-30', '星期五', 2036, '五月', '初五', '丙辰', '龙', NULL, 0, '', '端午节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5996, '2036-05-31', '星期六', 2036, '五月', '初六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5997, '2036-06-01', '星期日', 2036, '五月', '初七', '丙辰', '龙', NULL, 1, '儿童节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5998, '2036-06-02', '星期一', 2036, '五月', '初八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (5999, '2036-06-03', '星期二', 2036, '五月', '初九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6000, '2036-06-04', '星期三', 2036, '五月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6001, '2036-06-05', '星期四', 2036, '五月', '十一', '丙辰', '龙', NULL, 0, '', '', '芒种', '', 6);
INSERT INTO `base_data_holiday` VALUES (6002, '2036-06-06', '星期五', 2036, '五月', '十二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6003, '2036-06-07', '星期六', 2036, '五月', '十三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6004, '2036-06-08', '星期日', 2036, '五月', '十四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6005, '2036-06-09', '星期一', 2036, '五月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6006, '2036-06-10', '星期二', 2036, '五月', '十六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6007, '2036-06-11', '星期三', 2036, '五月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6008, '2036-06-12', '星期四', 2036, '五月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6009, '2036-06-13', '星期五', 2036, '五月', '十九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6010, '2036-06-14', '星期六', 2036, '五月', '二十', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6011, '2036-06-15', '星期日', 2036, '五月', '廿一', '丙辰', '龙', NULL, 1, '', '', '', '父亲节', 6);
INSERT INTO `base_data_holiday` VALUES (6012, '2036-06-16', '星期一', 2036, '五月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6013, '2036-06-17', '星期二', 2036, '五月', '廿三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6014, '2036-06-18', '星期三', 2036, '五月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6015, '2036-06-19', '星期四', 2036, '五月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6016, '2036-06-20', '星期五', 2036, '五月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6017, '2036-06-21', '星期六', 2036, '五月', '廿七', '丙辰', '龙', NULL, 1, '', '', '夏至', '', 6);
INSERT INTO `base_data_holiday` VALUES (6018, '2036-06-22', '星期日', 2036, '五月', '廿八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6019, '2036-06-23', '星期一', 2036, '五月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6020, '2036-06-24', '星期二', 2036, '六月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6021, '2036-06-25', '星期三', 2036, '六月', '初二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6022, '2036-06-26', '星期四', 2036, '六月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6023, '2036-06-27', '星期五', 2036, '六月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6024, '2036-06-28', '星期六', 2036, '六月', '初五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6025, '2036-06-29', '星期日', 2036, '六月', '初六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6026, '2036-06-30', '星期一', 2036, '六月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6027, '2036-07-01', '星期二', 2036, '六月', '初八', '丙辰', '龙', NULL, 0, '建党节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6028, '2036-07-02', '星期三', 2036, '六月', '初九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6029, '2036-07-03', '星期四', 2036, '六月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6030, '2036-07-04', '星期五', 2036, '六月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6031, '2036-07-05', '星期六', 2036, '六月', '十二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6032, '2036-07-06', '星期日', 2036, '六月', '十三', '丙辰', '龙', NULL, 1, '', '', '小暑', '', 6);
INSERT INTO `base_data_holiday` VALUES (6033, '2036-07-07', '星期一', 2036, '六月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6034, '2036-07-08', '星期二', 2036, '六月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6035, '2036-07-09', '星期三', 2036, '六月', '十六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6036, '2036-07-10', '星期四', 2036, '六月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6037, '2036-07-11', '星期五', 2036, '六月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6038, '2036-07-12', '星期六', 2036, '六月', '十九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6039, '2036-07-13', '星期日', 2036, '六月', '二十', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6040, '2036-07-14', '星期一', 2036, '六月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6041, '2036-07-15', '星期二', 2036, '六月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6042, '2036-07-16', '星期三', 2036, '六月', '廿三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6043, '2036-07-17', '星期四', 2036, '六月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6044, '2036-07-18', '星期五', 2036, '六月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6045, '2036-07-19', '星期六', 2036, '六月', '廿六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6046, '2036-07-20', '星期日', 2036, '六月', '廿七', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6047, '2036-07-21', '星期一', 2036, '六月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6048, '2036-07-22', '星期二', 2036, '六月', '廿九', '丙辰', '龙', NULL, 0, '', '', '大暑', '', 6);
INSERT INTO `base_data_holiday` VALUES (6049, '2036-07-23', '星期三', 2036, '闰六月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6050, '2036-07-24', '星期四', 2036, '闰六月', '初二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6051, '2036-07-25', '星期五', 2036, '闰六月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6052, '2036-07-26', '星期六', 2036, '闰六月', '初四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6053, '2036-07-27', '星期日', 2036, '闰六月', '初五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6054, '2036-07-28', '星期一', 2036, '闰六月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6055, '2036-07-29', '星期二', 2036, '闰六月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6056, '2036-07-30', '星期三', 2036, '闰六月', '初八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6057, '2036-07-31', '星期四', 2036, '闰六月', '初九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6058, '2036-08-01', '星期五', 2036, '闰六月', '初十 ', '丙辰', '龙', NULL, 0, '建军节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6059, '2036-08-02', '星期六', 2036, '闰六月', '十一', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6060, '2036-08-03', '星期日', 2036, '闰六月', '十二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6061, '2036-08-04', '星期一', 2036, '闰六月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6062, '2036-08-05', '星期二', 2036, '闰六月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6063, '2036-08-06', '星期三', 2036, '闰六月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6064, '2036-08-07', '星期四', 2036, '闰六月', '十六', '丙辰', '龙', NULL, 0, '', '', '立秋', '', 6);
INSERT INTO `base_data_holiday` VALUES (6065, '2036-08-08', '星期五', 2036, '闰六月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6066, '2036-08-09', '星期六', 2036, '闰六月', '十八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6067, '2036-08-10', '星期日', 2036, '闰六月', '十九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6068, '2036-08-11', '星期一', 2036, '闰六月', '二十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6069, '2036-08-12', '星期二', 2036, '闰六月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6070, '2036-08-13', '星期三', 2036, '闰六月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6071, '2036-08-14', '星期四', 2036, '闰六月', '廿三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6072, '2036-08-15', '星期五', 2036, '闰六月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6073, '2036-08-16', '星期六', 2036, '闰六月', '廿五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6074, '2036-08-17', '星期日', 2036, '闰六月', '廿六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6075, '2036-08-18', '星期一', 2036, '闰六月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6076, '2036-08-19', '星期二', 2036, '闰六月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6077, '2036-08-20', '星期三', 2036, '闰六月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6078, '2036-08-21', '星期四', 2036, '闰六月', '三十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6079, '2036-08-22', '星期五', 2036, '七月', '初一', '丙辰', '龙', NULL, 0, '', '', '处暑', '', 6);
INSERT INTO `base_data_holiday` VALUES (6080, '2036-08-23', '星期六', 2036, '七月', '初二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6081, '2036-08-24', '星期日', 2036, '七月', '初三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6082, '2036-08-25', '星期一', 2036, '七月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6083, '2036-08-26', '星期二', 2036, '七月', '初五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6084, '2036-08-27', '星期三', 2036, '七月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6085, '2036-08-28', '星期四', 2036, '七月', '初七', '丙辰', '龙', NULL, 0, '', '七夕', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6086, '2036-08-29', '星期五', 2036, '七月', '初八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6087, '2036-08-30', '星期六', 2036, '七月', '初九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6088, '2036-08-31', '星期日', 2036, '七月', '初十 ', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6089, '2036-09-01', '星期一', 2036, '七月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6090, '2036-09-02', '星期二', 2036, '七月', '十二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6091, '2036-09-03', '星期三', 2036, '七月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6092, '2036-09-04', '星期四', 2036, '七月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6093, '2036-09-05', '星期五', 2036, '七月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6094, '2036-09-06', '星期六', 2036, '七月', '十六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6095, '2036-09-07', '星期日', 2036, '七月', '十七', '丙辰', '龙', NULL, 1, '', '', '白露', '', 6);
INSERT INTO `base_data_holiday` VALUES (6096, '2036-09-08', '星期一', 2036, '七月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6097, '2036-09-09', '星期二', 2036, '七月', '十九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6098, '2036-09-10', '星期三', 2036, '七月', '二十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6099, '2036-09-11', '星期四', 2036, '七月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6100, '2036-09-12', '星期五', 2036, '七月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6101, '2036-09-13', '星期六', 2036, '七月', '廿三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6102, '2036-09-14', '星期日', 2036, '七月', '廿四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6103, '2036-09-15', '星期一', 2036, '七月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6104, '2036-09-16', '星期二', 2036, '七月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6105, '2036-09-17', '星期三', 2036, '七月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6106, '2036-09-18', '星期四', 2036, '七月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6107, '2036-09-19', '星期五', 2036, '七月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6108, '2036-09-20', '星期六', 2036, '八月', '初一', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6109, '2036-09-21', '星期日', 2036, '八月', '初二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6110, '2036-09-22', '星期一', 2036, '八月', '初三', '丙辰', '龙', NULL, 0, '农民丰收节', '', '秋分', '', 6);
INSERT INTO `base_data_holiday` VALUES (6111, '2036-09-23', '星期二', 2036, '八月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6112, '2036-09-24', '星期三', 2036, '八月', '初五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6113, '2036-09-25', '星期四', 2036, '八月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6114, '2036-09-26', '星期五', 2036, '八月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6115, '2036-09-27', '星期六', 2036, '八月', '初八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6116, '2036-09-28', '星期日', 2036, '八月', '初九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6117, '2036-09-29', '星期一', 2036, '八月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6118, '2036-09-30', '星期二', 2036, '八月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6119, '2036-10-01', '星期三', 2036, '八月', '十二', '丙辰', '龙', NULL, 0, '国庆节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6120, '2036-10-02', '星期四', 2036, '八月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6121, '2036-10-03', '星期五', 2036, '八月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6122, '2036-10-04', '星期六', 2036, '八月', '十五', '丙辰', '龙', NULL, 1, '', '中秋节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6123, '2036-10-05', '星期日', 2036, '八月', '十六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6124, '2036-10-06', '星期一', 2036, '八月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6125, '2036-10-07', '星期二', 2036, '八月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6126, '2036-10-08', '星期三', 2036, '八月', '十九', '丙辰', '龙', NULL, 0, '', '', '寒露', '', 6);
INSERT INTO `base_data_holiday` VALUES (6127, '2036-10-09', '星期四', 2036, '八月', '二十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6128, '2036-10-10', '星期五', 2036, '八月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6129, '2036-10-11', '星期六', 2036, '八月', '廿二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6130, '2036-10-12', '星期日', 2036, '八月', '廿三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6131, '2036-10-13', '星期一', 2036, '八月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6132, '2036-10-14', '星期二', 2036, '八月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6133, '2036-10-15', '星期三', 2036, '八月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6134, '2036-10-16', '星期四', 2036, '八月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6135, '2036-10-17', '星期五', 2036, '八月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6136, '2036-10-18', '星期六', 2036, '八月', '廿九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6137, '2036-10-19', '星期日', 2036, '九月', '初一', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6138, '2036-10-20', '星期一', 2036, '九月', '初二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6139, '2036-10-21', '星期二', 2036, '九月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6140, '2036-10-22', '星期三', 2036, '九月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6141, '2036-10-23', '星期四', 2036, '九月', '初五', '丙辰', '龙', NULL, 0, '', '', '霜降', '', 6);
INSERT INTO `base_data_holiday` VALUES (6142, '2036-10-24', '星期五', 2036, '九月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6143, '2036-10-25', '星期六', 2036, '九月', '初七', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6144, '2036-10-26', '星期日', 2036, '九月', '初八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6145, '2036-10-27', '星期一', 2036, '九月', '初九', '丙辰', '龙', NULL, 0, '', '重阳节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6146, '2036-10-28', '星期二', 2036, '九月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6147, '2036-10-29', '星期三', 2036, '九月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6148, '2036-10-30', '星期四', 2036, '九月', '十二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6149, '2036-10-31', '星期五', 2036, '九月', '十三', '丙辰', '龙', NULL, 0, '万圣节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6150, '2036-11-01', '星期六', 2036, '九月', '十四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6151, '2036-11-02', '星期日', 2036, '九月', '十五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6152, '2036-11-03', '星期一', 2036, '九月', '十六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6153, '2036-11-04', '星期二', 2036, '九月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6154, '2036-11-05', '星期三', 2036, '九月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6155, '2036-11-06', '星期四', 2036, '九月', '十九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6156, '2036-11-07', '星期五', 2036, '九月', '二十', '丙辰', '龙', NULL, 0, '', '', '立冬', '', 6);
INSERT INTO `base_data_holiday` VALUES (6157, '2036-11-08', '星期六', 2036, '九月', '廿一', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6158, '2036-11-09', '星期日', 2036, '九月', '廿二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6159, '2036-11-10', '星期一', 2036, '九月', '廿三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6160, '2036-11-11', '星期二', 2036, '九月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6161, '2036-11-12', '星期三', 2036, '九月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6162, '2036-11-13', '星期四', 2036, '九月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6163, '2036-11-14', '星期五', 2036, '九月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6164, '2036-11-15', '星期六', 2036, '九月', '廿八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6165, '2036-11-16', '星期日', 2036, '九月', '廿九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6166, '2036-11-17', '星期一', 2036, '九月', '三十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6167, '2036-11-18', '星期二', 2036, '十月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6168, '2036-11-19', '星期三', 2036, '十月', '初二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6169, '2036-11-20', '星期四', 2036, '十月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6170, '2036-11-21', '星期五', 2036, '十月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6171, '2036-11-22', '星期六', 2036, '十月', '初五', '丙辰', '龙', NULL, 1, '', '', '小雪', '', 6);
INSERT INTO `base_data_holiday` VALUES (6172, '2036-11-23', '星期日', 2036, '十月', '初六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6173, '2036-11-24', '星期一', 2036, '十月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6174, '2036-11-25', '星期二', 2036, '十月', '初八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6175, '2036-11-26', '星期三', 2036, '十月', '初九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6176, '2036-11-27', '星期四', 2036, '十月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6177, '2036-11-28', '星期五', 2036, '十月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6178, '2036-11-29', '星期六', 2036, '十月', '十二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6179, '2036-11-30', '星期日', 2036, '十月', '十三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6180, '2036-12-01', '星期一', 2036, '十月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6181, '2036-12-02', '星期二', 2036, '十月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6182, '2036-12-03', '星期三', 2036, '十月', '十六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6183, '2036-12-04', '星期四', 2036, '十月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6184, '2036-12-05', '星期五', 2036, '十月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6185, '2036-12-06', '星期六', 2036, '十月', '十九', '丙辰', '龙', NULL, 1, '', '', '大雪', '', 6);
INSERT INTO `base_data_holiday` VALUES (6186, '2036-12-07', '星期日', 2036, '十月', '二十', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6187, '2036-12-08', '星期一', 2036, '十月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6188, '2036-12-09', '星期二', 2036, '十月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6189, '2036-12-10', '星期三', 2036, '十月', '廿三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6190, '2036-12-11', '星期四', 2036, '十月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6191, '2036-12-12', '星期五', 2036, '十月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6192, '2036-12-13', '星期六', 2036, '十月', '廿六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6193, '2036-12-14', '星期日', 2036, '十月', '廿七', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6194, '2036-12-15', '星期一', 2036, '十月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6195, '2036-12-16', '星期二', 2036, '十月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6196, '2036-12-17', '星期三', 2036, '冬月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6197, '2036-12-18', '星期四', 2036, '冬月', '初二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6198, '2036-12-19', '星期五', 2036, '冬月', '初三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6199, '2036-12-20', '星期六', 2036, '冬月', '初四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6200, '2036-12-21', '星期日', 2036, '冬月', '初五', '丙辰', '龙', NULL, 1, '', '', '冬至', '', 6);
INSERT INTO `base_data_holiday` VALUES (6201, '2036-12-22', '星期一', 2036, '冬月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6202, '2036-12-23', '星期二', 2036, '冬月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6203, '2036-12-24', '星期三', 2036, '冬月', '初八', '丙辰', '龙', NULL, 0, '平安夜', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6204, '2036-12-25', '星期四', 2036, '冬月', '初九', '丙辰', '龙', NULL, 0, '圣诞节', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6205, '2036-12-26', '星期五', 2036, '冬月', '初十 ', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6206, '2036-12-27', '星期六', 2036, '冬月', '十一', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6207, '2036-12-28', '星期日', 2036, '冬月', '十二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6208, '2036-12-29', '星期一', 2036, '冬月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6209, '2036-12-30', '星期二', 2036, '冬月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6210, '2036-12-31', '星期三', 2036, '冬月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6211, '2037-01-01', '星期四', 2036, '冬月', '十六', '丙辰', '龙', NULL, 0, '元旦', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6212, '2037-01-02', '星期五', 2036, '冬月', '十七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6213, '2037-01-03', '星期六', 2036, '冬月', '十八', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6214, '2037-01-04', '星期日', 2036, '冬月', '十九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6215, '2037-01-05', '星期一', 2036, '冬月', '二十', '丙辰', '龙', NULL, 0, '', '', '小寒', '', 6);
INSERT INTO `base_data_holiday` VALUES (6216, '2037-01-06', '星期二', 2036, '冬月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6217, '2037-01-07', '星期三', 2036, '冬月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6218, '2037-01-08', '星期四', 2036, '冬月', '廿三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6219, '2037-01-09', '星期五', 2036, '冬月', '廿四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6220, '2037-01-10', '星期六', 2036, '冬月', '廿五', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6221, '2037-01-11', '星期日', 2036, '冬月', '廿六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6222, '2037-01-12', '星期一', 2036, '冬月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6223, '2037-01-13', '星期二', 2036, '冬月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6224, '2037-01-14', '星期三', 2036, '冬月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6225, '2037-01-15', '星期四', 2036, '冬月', '三十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6226, '2037-01-16', '星期五', 2036, '腊月', '初一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6227, '2037-01-17', '星期六', 2036, '腊月', '初二', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6228, '2037-01-18', '星期日', 2036, '腊月', '初三', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6229, '2037-01-19', '星期一', 2036, '腊月', '初四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6230, '2037-01-20', '星期二', 2036, '腊月', '初五', '丙辰', '龙', NULL, 0, '', '', '大寒', '', 6);
INSERT INTO `base_data_holiday` VALUES (6231, '2037-01-21', '星期三', 2036, '腊月', '初六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6232, '2037-01-22', '星期四', 2036, '腊月', '初七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6233, '2037-01-23', '星期五', 2036, '腊月', '初八', '丙辰', '龙', NULL, 0, '', '腊八节', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6234, '2037-01-24', '星期六', 2036, '腊月', '初九', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6235, '2037-01-25', '星期日', 2036, '腊月', '初十 ', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6236, '2037-01-26', '星期一', 2036, '腊月', '十一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6237, '2037-01-27', '星期二', 2036, '腊月', '十二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6238, '2037-01-28', '星期三', 2036, '腊月', '十三', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6239, '2037-01-29', '星期四', 2036, '腊月', '十四', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6240, '2037-01-30', '星期五', 2036, '腊月', '十五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6241, '2037-01-31', '星期六', 2036, '腊月', '十六', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6242, '2037-02-01', '星期日', 2036, '腊月', '十七', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6243, '2037-02-02', '星期一', 2036, '腊月', '十八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6244, '2037-02-03', '星期二', 2036, '腊月', '十九', '丙辰', '龙', NULL, 0, '', '', '立春', '', 6);
INSERT INTO `base_data_holiday` VALUES (6245, '2037-02-04', '星期三', 2036, '腊月', '二十', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6246, '2037-02-05', '星期四', 2036, '腊月', '廿一', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6247, '2037-02-06', '星期五', 2036, '腊月', '廿二', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6248, '2037-02-07', '星期六', 2036, '腊月', '廿三', '丙辰', '龙', NULL, 1, '', '小年', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6249, '2037-02-08', '星期日', 2036, '腊月', '廿四', '丙辰', '龙', NULL, 1, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6250, '2037-02-09', '星期一', 2036, '腊月', '廿五', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6251, '2037-02-10', '星期二', 2036, '腊月', '廿六', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6252, '2037-02-11', '星期三', 2036, '腊月', '廿七', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6253, '2037-02-12', '星期四', 2036, '腊月', '廿八', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6254, '2037-02-13', '星期五', 2036, '腊月', '廿九', '丙辰', '龙', NULL, 0, '', '', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6255, '2037-02-14', '星期六', 2036, '腊月', '三十', '丙辰', '龙', NULL, 1, '情人节', '除夕', '', '', 6);
INSERT INTO `base_data_holiday` VALUES (6256, '2037-02-15', '星期日', 2037, '正月', '初一', '丁巳', '蛇', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6257, '2037-02-16', '星期一', 2037, '正月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6258, '2037-02-17', '星期二', 2037, '正月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6259, '2037-02-18', '星期三', 2037, '正月', '初四', '丁巳', '蛇', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (6260, '2037-02-19', '星期四', 2037, '正月', '初五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6261, '2037-02-20', '星期五', 2037, '正月', '初六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6262, '2037-02-21', '星期六', 2037, '正月', '初七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6263, '2037-02-22', '星期日', 2037, '正月', '初八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6264, '2037-02-23', '星期一', 2037, '正月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6265, '2037-02-24', '星期二', 2037, '正月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6266, '2037-02-25', '星期三', 2037, '正月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6267, '2037-02-26', '星期四', 2037, '正月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6268, '2037-02-27', '星期五', 2037, '正月', '十三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6269, '2037-02-28', '星期六', 2037, '正月', '十四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6270, '2037-03-01', '星期日', 2037, '正月', '十五', '丁巳', '蛇', NULL, 1, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6271, '2037-03-02', '星期一', 2037, '正月', '十六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6272, '2037-03-03', '星期二', 2037, '正月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6273, '2037-03-04', '星期三', 2037, '正月', '十八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6274, '2037-03-05', '星期四', 2037, '正月', '十九', '丁巳', '蛇', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (6275, '2037-03-06', '星期五', 2037, '正月', '二十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6276, '2037-03-07', '星期六', 2037, '正月', '廿一', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6277, '2037-03-08', '星期日', 2037, '正月', '廿二', '丁巳', '蛇', NULL, 1, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6278, '2037-03-09', '星期一', 2037, '正月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6279, '2037-03-10', '星期二', 2037, '正月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6280, '2037-03-11', '星期三', 2037, '正月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6281, '2037-03-12', '星期四', 2037, '正月', '廿六', '丁巳', '蛇', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6282, '2037-03-13', '星期五', 2037, '正月', '廿七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6283, '2037-03-14', '星期六', 2037, '正月', '廿八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6284, '2037-03-15', '星期日', 2037, '正月', '廿九', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6285, '2037-03-16', '星期一', 2037, '正月', '三十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6286, '2037-03-17', '星期二', 2037, '二月', '初一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6287, '2037-03-18', '星期三', 2037, '二月', '初二', '丁巳', '蛇', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6288, '2037-03-19', '星期四', 2037, '二月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6289, '2037-03-20', '星期五', 2037, '二月', '初四', '丁巳', '蛇', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (6290, '2037-03-21', '星期六', 2037, '二月', '初五', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6291, '2037-03-22', '星期日', 2037, '二月', '初六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6292, '2037-03-23', '星期一', 2037, '二月', '初七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6293, '2037-03-24', '星期二', 2037, '二月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6294, '2037-03-25', '星期三', 2037, '二月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6295, '2037-03-26', '星期四', 2037, '二月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6296, '2037-03-27', '星期五', 2037, '二月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6297, '2037-03-28', '星期六', 2037, '二月', '十二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6298, '2037-03-29', '星期日', 2037, '二月', '十三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6299, '2037-03-30', '星期一', 2037, '二月', '十四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6300, '2037-03-31', '星期二', 2037, '二月', '十五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6301, '2037-04-01', '星期三', 2037, '二月', '十六', '丁巳', '蛇', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6302, '2037-04-02', '星期四', 2037, '二月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6303, '2037-04-03', '星期五', 2037, '二月', '十八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6304, '2037-04-04', '星期六', 2037, '二月', '十九', '丁巳', '蛇', NULL, 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (6305, '2037-04-05', '星期日', 2037, '二月', '二十', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6306, '2037-04-06', '星期一', 2037, '二月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6307, '2037-04-07', '星期二', 2037, '二月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6308, '2037-04-08', '星期三', 2037, '二月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6309, '2037-04-09', '星期四', 2037, '二月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6310, '2037-04-10', '星期五', 2037, '二月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6311, '2037-04-11', '星期六', 2037, '二月', '廿六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6312, '2037-04-12', '星期日', 2037, '二月', '廿七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6313, '2037-04-13', '星期一', 2037, '二月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6314, '2037-04-14', '星期二', 2037, '二月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6315, '2037-04-15', '星期三', 2037, '二月', '三十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6316, '2037-04-16', '星期四', 2037, '三月', '初一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6317, '2037-04-17', '星期五', 2037, '三月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6318, '2037-04-18', '星期六', 2037, '三月', '初三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6319, '2037-04-19', '星期日', 2037, '三月', '初四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6320, '2037-04-20', '星期一', 2037, '三月', '初五', '丁巳', '蛇', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (6321, '2037-04-21', '星期二', 2037, '三月', '初六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6322, '2037-04-22', '星期三', 2037, '三月', '初七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6323, '2037-04-23', '星期四', 2037, '三月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6324, '2037-04-24', '星期五', 2037, '三月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6325, '2037-04-25', '星期六', 2037, '三月', '初十 ', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6326, '2037-04-26', '星期日', 2037, '三月', '十一', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6327, '2037-04-27', '星期一', 2037, '三月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6328, '2037-04-28', '星期二', 2037, '三月', '十三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6329, '2037-04-29', '星期三', 2037, '三月', '十四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6330, '2037-04-30', '星期四', 2037, '三月', '十五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6331, '2037-05-01', '星期五', 2037, '三月', '十六', '丁巳', '蛇', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6332, '2037-05-02', '星期六', 2037, '三月', '十七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6333, '2037-05-03', '星期日', 2037, '三月', '十八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6334, '2037-05-04', '星期一', 2037, '三月', '十九', '丁巳', '蛇', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6335, '2037-05-05', '星期二', 2037, '三月', '二十', '丁巳', '蛇', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (6336, '2037-05-06', '星期三', 2037, '三月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6337, '2037-05-07', '星期四', 2037, '三月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6338, '2037-05-08', '星期五', 2037, '三月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6339, '2037-05-09', '星期六', 2037, '三月', '廿四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6340, '2037-05-10', '星期日', 2037, '三月', '廿五', '丁巳', '蛇', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (6341, '2037-05-11', '星期一', 2037, '三月', '廿六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6342, '2037-05-12', '星期二', 2037, '三月', '廿七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6343, '2037-05-13', '星期三', 2037, '三月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6344, '2037-05-14', '星期四', 2037, '三月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6345, '2037-05-15', '星期五', 2037, '四月', '初一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6346, '2037-05-16', '星期六', 2037, '四月', '初二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6347, '2037-05-17', '星期日', 2037, '四月', '初三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6348, '2037-05-18', '星期一', 2037, '四月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6349, '2037-05-19', '星期二', 2037, '四月', '初五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6350, '2037-05-20', '星期三', 2037, '四月', '初六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6351, '2037-05-21', '星期四', 2037, '四月', '初七', '丁巳', '蛇', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (6352, '2037-05-22', '星期五', 2037, '四月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6353, '2037-05-23', '星期六', 2037, '四月', '初九', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6354, '2037-05-24', '星期日', 2037, '四月', '初十 ', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6355, '2037-05-25', '星期一', 2037, '四月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6356, '2037-05-26', '星期二', 2037, '四月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6357, '2037-05-27', '星期三', 2037, '四月', '十三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6358, '2037-05-28', '星期四', 2037, '四月', '十四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6359, '2037-05-29', '星期五', 2037, '四月', '十五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6360, '2037-05-30', '星期六', 2037, '四月', '十六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6361, '2037-05-31', '星期日', 2037, '四月', '十七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6362, '2037-06-01', '星期一', 2037, '四月', '十八', '丁巳', '蛇', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6363, '2037-06-02', '星期二', 2037, '四月', '十九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6364, '2037-06-03', '星期三', 2037, '四月', '二十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6365, '2037-06-04', '星期四', 2037, '四月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6366, '2037-06-05', '星期五', 2037, '四月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (6367, '2037-06-06', '星期六', 2037, '四月', '廿三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6368, '2037-06-07', '星期日', 2037, '四月', '廿四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6369, '2037-06-08', '星期一', 2037, '四月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6370, '2037-06-09', '星期二', 2037, '四月', '廿六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6371, '2037-06-10', '星期三', 2037, '四月', '廿七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6372, '2037-06-11', '星期四', 2037, '四月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6373, '2037-06-12', '星期五', 2037, '四月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6374, '2037-06-13', '星期六', 2037, '四月', '三十', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6375, '2037-06-14', '星期日', 2037, '五月', '初一', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6376, '2037-06-15', '星期一', 2037, '五月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6377, '2037-06-16', '星期二', 2037, '五月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6378, '2037-06-17', '星期三', 2037, '五月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6379, '2037-06-18', '星期四', 2037, '五月', '初五', '丁巳', '蛇', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6380, '2037-06-19', '星期五', 2037, '五月', '初六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6381, '2037-06-20', '星期六', 2037, '五月', '初七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6382, '2037-06-21', '星期日', 2037, '五月', '初八', '丁巳', '蛇', NULL, 1, '', '', '夏至', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (6383, '2037-06-22', '星期一', 2037, '五月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6384, '2037-06-23', '星期二', 2037, '五月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6385, '2037-06-24', '星期三', 2037, '五月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6386, '2037-06-25', '星期四', 2037, '五月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6387, '2037-06-26', '星期五', 2037, '五月', '十三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6388, '2037-06-27', '星期六', 2037, '五月', '十四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6389, '2037-06-28', '星期日', 2037, '五月', '十五', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6390, '2037-06-29', '星期一', 2037, '五月', '十六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6391, '2037-06-30', '星期二', 2037, '五月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6392, '2037-07-01', '星期三', 2037, '五月', '十八', '丁巳', '蛇', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6393, '2037-07-02', '星期四', 2037, '五月', '十九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6394, '2037-07-03', '星期五', 2037, '五月', '二十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6395, '2037-07-04', '星期六', 2037, '五月', '廿一', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6396, '2037-07-05', '星期日', 2037, '五月', '廿二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6397, '2037-07-06', '星期一', 2037, '五月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6398, '2037-07-07', '星期二', 2037, '五月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (6399, '2037-07-08', '星期三', 2037, '五月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6400, '2037-07-09', '星期四', 2037, '五月', '廿六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6401, '2037-07-10', '星期五', 2037, '五月', '廿七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6402, '2037-07-11', '星期六', 2037, '五月', '廿八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6403, '2037-07-12', '星期日', 2037, '五月', '廿九', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6404, '2037-07-13', '星期一', 2037, '六月', '初一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6405, '2037-07-14', '星期二', 2037, '六月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6406, '2037-07-15', '星期三', 2037, '六月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6407, '2037-07-16', '星期四', 2037, '六月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6408, '2037-07-17', '星期五', 2037, '六月', '初五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6409, '2037-07-18', '星期六', 2037, '六月', '初六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6410, '2037-07-19', '星期日', 2037, '六月', '初七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6411, '2037-07-20', '星期一', 2037, '六月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6412, '2037-07-21', '星期二', 2037, '六月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6413, '2037-07-22', '星期三', 2037, '六月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (6414, '2037-07-23', '星期四', 2037, '六月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6415, '2037-07-24', '星期五', 2037, '六月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6416, '2037-07-25', '星期六', 2037, '六月', '十三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6417, '2037-07-26', '星期日', 2037, '六月', '十四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6418, '2037-07-27', '星期一', 2037, '六月', '十五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6419, '2037-07-28', '星期二', 2037, '六月', '十六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6420, '2037-07-29', '星期三', 2037, '六月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6421, '2037-07-30', '星期四', 2037, '六月', '十八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6422, '2037-07-31', '星期五', 2037, '六月', '十九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6423, '2037-08-01', '星期六', 2037, '六月', '二十', '丁巳', '蛇', NULL, 1, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6424, '2037-08-02', '星期日', 2037, '六月', '廿一', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6425, '2037-08-03', '星期一', 2037, '六月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6426, '2037-08-04', '星期二', 2037, '六月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6427, '2037-08-05', '星期三', 2037, '六月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6428, '2037-08-06', '星期四', 2037, '六月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6429, '2037-08-07', '星期五', 2037, '六月', '廿六', '丁巳', '蛇', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (6430, '2037-08-08', '星期六', 2037, '六月', '廿七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6431, '2037-08-09', '星期日', 2037, '六月', '廿八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6432, '2037-08-10', '星期一', 2037, '六月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6433, '2037-08-11', '星期二', 2037, '七月', '初一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6434, '2037-08-12', '星期三', 2037, '七月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6435, '2037-08-13', '星期四', 2037, '七月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6436, '2037-08-14', '星期五', 2037, '七月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6437, '2037-08-15', '星期六', 2037, '七月', '初五', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6438, '2037-08-16', '星期日', 2037, '七月', '初六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6439, '2037-08-17', '星期一', 2037, '七月', '初七', '丁巳', '蛇', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6440, '2037-08-18', '星期二', 2037, '七月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6441, '2037-08-19', '星期三', 2037, '七月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6442, '2037-08-20', '星期四', 2037, '七月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6443, '2037-08-21', '星期五', 2037, '七月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6444, '2037-08-22', '星期六', 2037, '七月', '十二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6445, '2037-08-23', '星期日', 2037, '七月', '十三', '丁巳', '蛇', NULL, 1, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (6446, '2037-08-24', '星期一', 2037, '七月', '十四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6447, '2037-08-25', '星期二', 2037, '七月', '十五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6448, '2037-08-26', '星期三', 2037, '七月', '十六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6449, '2037-08-27', '星期四', 2037, '七月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6450, '2037-08-28', '星期五', 2037, '七月', '十八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6451, '2037-08-29', '星期六', 2037, '七月', '十九', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6452, '2037-08-30', '星期日', 2037, '七月', '二十', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6453, '2037-08-31', '星期一', 2037, '七月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6454, '2037-09-01', '星期二', 2037, '七月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6455, '2037-09-02', '星期三', 2037, '七月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6456, '2037-09-03', '星期四', 2037, '七月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6457, '2037-09-04', '星期五', 2037, '七月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6458, '2037-09-05', '星期六', 2037, '七月', '廿六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6459, '2037-09-06', '星期日', 2037, '七月', '廿七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6460, '2037-09-07', '星期一', 2037, '七月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (6461, '2037-09-08', '星期二', 2037, '七月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6462, '2037-09-09', '星期三', 2037, '七月', '三十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6463, '2037-09-10', '星期四', 2037, '八月', '初一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6464, '2037-09-11', '星期五', 2037, '八月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6465, '2037-09-12', '星期六', 2037, '八月', '初三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6466, '2037-09-13', '星期日', 2037, '八月', '初四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6467, '2037-09-14', '星期一', 2037, '八月', '初五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6468, '2037-09-15', '星期二', 2037, '八月', '初六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6469, '2037-09-16', '星期三', 2037, '八月', '初七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6470, '2037-09-17', '星期四', 2037, '八月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6471, '2037-09-18', '星期五', 2037, '八月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6472, '2037-09-19', '星期六', 2037, '八月', '初十 ', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6473, '2037-09-20', '星期日', 2037, '八月', '十一', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6474, '2037-09-21', '星期一', 2037, '八月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6475, '2037-09-22', '星期二', 2037, '八月', '十三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6476, '2037-09-23', '星期三', 2037, '八月', '十四', '丁巳', '蛇', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (6477, '2037-09-24', '星期四', 2037, '八月', '十五', '丁巳', '蛇', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6478, '2037-09-25', '星期五', 2037, '八月', '十六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6479, '2037-09-26', '星期六', 2037, '八月', '十七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6480, '2037-09-27', '星期日', 2037, '八月', '十八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6481, '2037-09-28', '星期一', 2037, '八月', '十九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6482, '2037-09-29', '星期二', 2037, '八月', '二十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6483, '2037-09-30', '星期三', 2037, '八月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6484, '2037-10-01', '星期四', 2037, '八月', '廿二', '丁巳', '蛇', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6485, '2037-10-02', '星期五', 2037, '八月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6486, '2037-10-03', '星期六', 2037, '八月', '廿四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6487, '2037-10-04', '星期日', 2037, '八月', '廿五', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6488, '2037-10-05', '星期一', 2037, '八月', '廿六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6489, '2037-10-06', '星期二', 2037, '八月', '廿七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6490, '2037-10-07', '星期三', 2037, '八月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6491, '2037-10-08', '星期四', 2037, '八月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (6492, '2037-10-09', '星期五', 2037, '九月', '初一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6493, '2037-10-10', '星期六', 2037, '九月', '初二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6494, '2037-10-11', '星期日', 2037, '九月', '初三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6495, '2037-10-12', '星期一', 2037, '九月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6496, '2037-10-13', '星期二', 2037, '九月', '初五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6497, '2037-10-14', '星期三', 2037, '九月', '初六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6498, '2037-10-15', '星期四', 2037, '九月', '初七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6499, '2037-10-16', '星期五', 2037, '九月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6500, '2037-10-17', '星期六', 2037, '九月', '初九', '丁巳', '蛇', NULL, 1, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6501, '2037-10-18', '星期日', 2037, '九月', '初十 ', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6502, '2037-10-19', '星期一', 2037, '九月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6503, '2037-10-20', '星期二', 2037, '九月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6504, '2037-10-21', '星期三', 2037, '九月', '十三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6505, '2037-10-22', '星期四', 2037, '九月', '十四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6506, '2037-10-23', '星期五', 2037, '九月', '十五', '丁巳', '蛇', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (6507, '2037-10-24', '星期六', 2037, '九月', '十六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6508, '2037-10-25', '星期日', 2037, '九月', '十七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6509, '2037-10-26', '星期一', 2037, '九月', '十八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6510, '2037-10-27', '星期二', 2037, '九月', '十九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6511, '2037-10-28', '星期三', 2037, '九月', '二十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6512, '2037-10-29', '星期四', 2037, '九月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6513, '2037-10-30', '星期五', 2037, '九月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6514, '2037-10-31', '星期六', 2037, '九月', '廿三', '丁巳', '蛇', NULL, 1, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6515, '2037-11-01', '星期日', 2037, '九月', '廿四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6516, '2037-11-02', '星期一', 2037, '九月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6517, '2037-11-03', '星期二', 2037, '九月', '廿六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6518, '2037-11-04', '星期三', 2037, '九月', '廿七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6519, '2037-11-05', '星期四', 2037, '九月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6520, '2037-11-06', '星期五', 2037, '九月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6521, '2037-11-07', '星期六', 2037, '十月', '初一', '丁巳', '蛇', NULL, 1, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (6522, '2037-11-08', '星期日', 2037, '十月', '初二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6523, '2037-11-09', '星期一', 2037, '十月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6524, '2037-11-10', '星期二', 2037, '十月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6525, '2037-11-11', '星期三', 2037, '十月', '初五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6526, '2037-11-12', '星期四', 2037, '十月', '初六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6527, '2037-11-13', '星期五', 2037, '十月', '初七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6528, '2037-11-14', '星期六', 2037, '十月', '初八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6529, '2037-11-15', '星期日', 2037, '十月', '初九', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6530, '2037-11-16', '星期一', 2037, '十月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6531, '2037-11-17', '星期二', 2037, '十月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6532, '2037-11-18', '星期三', 2037, '十月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6533, '2037-11-19', '星期四', 2037, '十月', '十三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6534, '2037-11-20', '星期五', 2037, '十月', '十四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6535, '2037-11-21', '星期六', 2037, '十月', '十五', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6536, '2037-11-22', '星期日', 2037, '十月', '十六', '丁巳', '蛇', NULL, 1, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (6537, '2037-11-23', '星期一', 2037, '十月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6538, '2037-11-24', '星期二', 2037, '十月', '十八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6539, '2037-11-25', '星期三', 2037, '十月', '十九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6540, '2037-11-26', '星期四', 2037, '十月', '二十', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6541, '2037-11-27', '星期五', 2037, '十月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6542, '2037-11-28', '星期六', 2037, '十月', '廿二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6543, '2037-11-29', '星期日', 2037, '十月', '廿三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6544, '2037-11-30', '星期一', 2037, '十月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6545, '2037-12-01', '星期二', 2037, '十月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6546, '2037-12-02', '星期三', 2037, '十月', '廿六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6547, '2037-12-03', '星期四', 2037, '十月', '廿七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6548, '2037-12-04', '星期五', 2037, '十月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6549, '2037-12-05', '星期六', 2037, '十月', '廿九', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6550, '2037-12-06', '星期日', 2037, '十月', '三十', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6551, '2037-12-07', '星期一', 2037, '冬月', '初一', '丁巳', '蛇', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (6552, '2037-12-08', '星期二', 2037, '冬月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6553, '2037-12-09', '星期三', 2037, '冬月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6554, '2037-12-10', '星期四', 2037, '冬月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6555, '2037-12-11', '星期五', 2037, '冬月', '初五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6556, '2037-12-12', '星期六', 2037, '冬月', '初六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6557, '2037-12-13', '星期日', 2037, '冬月', '初七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6558, '2037-12-14', '星期一', 2037, '冬月', '初八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6559, '2037-12-15', '星期二', 2037, '冬月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6560, '2037-12-16', '星期三', 2037, '冬月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6561, '2037-12-17', '星期四', 2037, '冬月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6562, '2037-12-18', '星期五', 2037, '冬月', '十二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6563, '2037-12-19', '星期六', 2037, '冬月', '十三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6564, '2037-12-20', '星期日', 2037, '冬月', '十四', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6565, '2037-12-21', '星期一', 2037, '冬月', '十五', '丁巳', '蛇', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (6566, '2037-12-22', '星期二', 2037, '冬月', '十六', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6567, '2037-12-23', '星期三', 2037, '冬月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6568, '2037-12-24', '星期四', 2037, '冬月', '十八', '丁巳', '蛇', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6569, '2037-12-25', '星期五', 2037, '冬月', '十九', '丁巳', '蛇', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6570, '2037-12-26', '星期六', 2037, '冬月', '二十', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6571, '2037-12-27', '星期日', 2037, '冬月', '廿一', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6572, '2037-12-28', '星期一', 2037, '冬月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6573, '2037-12-29', '星期二', 2037, '冬月', '廿三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6574, '2037-12-30', '星期三', 2037, '冬月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6575, '2037-12-31', '星期四', 2037, '冬月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6576, '2038-01-16', '星期六', 2037, '腊月', '十二', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6577, '2038-01-17', '星期日', 2037, '腊月', '十三', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6578, '2038-02-21', '星期日', 2038, '正月', '十八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6579, '2038-02-22', '星期一', 2038, '正月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6580, '2038-02-10', '星期三', 2038, '正月', '初七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6581, '2038-02-11', '星期四', 2038, '正月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6582, '2038-02-16', '星期二', 2038, '正月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6583, '2038-02-17', '星期三', 2038, '正月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6584, '2038-02-18', '星期四', 2038, '正月', '十五', '戊午', '马', NULL, 0, '', '元宵节', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (6585, '2038-02-19', '星期五', 2038, '正月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6586, '2038-02-20', '星期六', 2038, '正月', '十七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6587, '2038-02-23', '星期二', 2038, '正月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6588, '2038-01-24', '星期日', 2037, '腊月', '二十', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6589, '2038-01-23', '星期六', 2037, '腊月', '十九', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6590, '2038-01-22', '星期五', 2037, '腊月', '十八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6591, '2038-01-21', '星期四', 2037, '腊月', '十七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6592, '2038-01-20', '星期三', 2037, '腊月', '十六', '丁巳', '蛇', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (6593, '2038-01-19', '星期二', 2037, '腊月', '十五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6594, '2038-01-18', '星期一', 2037, '腊月', '十四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6595, '2038-01-15', '星期五', 2037, '腊月', '十一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6596, '2038-01-14', '星期四', 2037, '腊月', '初十 ', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6597, '2038-01-13', '星期三', 2037, '腊月', '初九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6598, '2038-01-12', '星期二', 2037, '腊月', '初八', '丁巳', '蛇', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6599, '2038-01-11', '星期一', 2037, '腊月', '初七', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6600, '2038-01-10', '星期日', 2037, '腊月', '初六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6601, '2038-01-09', '星期六', 2037, '腊月', '初五', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6602, '2038-01-03', '星期日', 2037, '冬月', '廿八', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6603, '2038-01-02', '星期六', 2037, '冬月', '廿七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6604, '2038-01-01', '星期五', 2037, '冬月', '廿六', '丁巳', '蛇', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6605, '2038-03-04', '星期四', 2038, '正月', '廿九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6606, '2038-03-03', '星期三', 2038, '正月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6607, '2038-02-15', '星期一', 2038, '正月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6608, '2038-02-14', '星期日', 2038, '正月', '十一', '戊午', '马', NULL, 1, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6609, '2038-02-13', '星期六', 2038, '正月', '初十 ', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6610, '2038-02-12', '星期五', 2038, '正月', '初九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6611, '2038-02-09', '星期二', 2038, '正月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6612, '2038-02-08', '星期一', 2038, '正月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6613, '2038-02-04', '星期四', 2038, '正月', '初一', '戊午', '马', NULL, 0, '', '春节', '立春', '', 0);
INSERT INTO `base_data_holiday` VALUES (6614, '2038-02-01', '星期一', 2037, '腊月', '廿八', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6615, '2038-01-31', '星期日', 2037, '腊月', '廿七', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6616, '2038-01-30', '星期六', 2037, '腊月', '廿六', '丁巳', '蛇', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6617, '2038-01-27', '星期三', 2037, '腊月', '廿三', '丁巳', '蛇', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6618, '2038-03-02', '星期二', 2038, '正月', '廿七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6619, '2038-03-01', '星期一', 2038, '正月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6620, '2038-02-28', '星期日', 2038, '正月', '廿五', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6621, '2038-02-27', '星期六', 2038, '正月', '廿四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6622, '2038-02-26', '星期五', 2038, '正月', '廿三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6623, '2038-02-25', '星期四', 2038, '正月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6624, '2038-02-24', '星期三', 2038, '正月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6625, '2038-02-02', '星期二', 2037, '腊月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6626, '2038-01-25', '星期一', 2037, '腊月', '廿一', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6627, '2038-02-05', '星期五', 2038, '正月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6628, '2038-02-06', '星期六', 2038, '正月', '初三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6629, '2038-02-07', '星期日', 2038, '正月', '初四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6630, '2038-01-04', '星期一', 2037, '冬月', '廿九', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6631, '2038-01-05', '星期二', 2037, '腊月', '初一', '丁巳', '蛇', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (6632, '2038-01-06', '星期三', 2037, '腊月', '初二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6633, '2038-01-07', '星期四', 2037, '腊月', '初三', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6634, '2038-01-08', '星期五', 2037, '腊月', '初四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6635, '2038-02-03', '星期三', 2037, '腊月', '三十', '丁巳', '蛇', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6636, '2038-01-29', '星期五', 2037, '腊月', '廿五', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6637, '2038-01-28', '星期四', 2037, '腊月', '廿四', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6638, '2038-01-26', '星期二', 2037, '腊月', '廿二', '丁巳', '蛇', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6639, '2038-03-05', '星期五', 2038, '正月', '三十', '戊午', '马', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (6640, '2038-03-06', '星期六', 2038, '二月', '初一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6641, '2038-03-07', '星期日', 2038, '二月', '初二', '戊午', '马', NULL, 1, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6642, '2038-03-08', '星期一', 2038, '二月', '初三', '戊午', '马', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6643, '2038-03-09', '星期二', 2038, '二月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6644, '2038-03-10', '星期三', 2038, '二月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6645, '2038-03-11', '星期四', 2038, '二月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6646, '2038-03-12', '星期五', 2038, '二月', '初七', '戊午', '马', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6647, '2038-03-13', '星期六', 2038, '二月', '初八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6648, '2038-03-14', '星期日', 2038, '二月', '初九', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6649, '2038-03-15', '星期一', 2038, '二月', '初十 ', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6650, '2038-03-16', '星期二', 2038, '二月', '十一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6651, '2038-03-17', '星期三', 2038, '二月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6652, '2038-03-18', '星期四', 2038, '二月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6653, '2038-03-19', '星期五', 2038, '二月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6654, '2038-03-20', '星期六', 2038, '二月', '十五', '戊午', '马', NULL, 1, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (6655, '2038-03-21', '星期日', 2038, '二月', '十六', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6656, '2038-03-22', '星期一', 2038, '二月', '十七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6657, '2038-03-23', '星期二', 2038, '二月', '十八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6658, '2038-03-24', '星期三', 2038, '二月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6659, '2038-03-25', '星期四', 2038, '二月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6660, '2038-03-26', '星期五', 2038, '二月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6661, '2038-03-27', '星期六', 2038, '二月', '廿二', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6662, '2038-03-28', '星期日', 2038, '二月', '廿三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6663, '2038-03-29', '星期一', 2038, '二月', '廿四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6664, '2038-03-30', '星期二', 2038, '二月', '廿五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6665, '2038-03-31', '星期三', 2038, '二月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6666, '2038-04-01', '星期四', 2038, '二月', '廿七', '戊午', '马', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6667, '2038-04-02', '星期五', 2038, '二月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6668, '2038-04-03', '星期六', 2038, '二月', '廿九', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6669, '2038-04-04', '星期日', 2038, '二月', '三十', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6670, '2038-04-05', '星期一', 2038, '三月', '初一', '戊午', '马', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (6671, '2038-04-06', '星期二', 2038, '三月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6672, '2038-04-07', '星期三', 2038, '三月', '初三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6673, '2038-04-08', '星期四', 2038, '三月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6674, '2038-04-09', '星期五', 2038, '三月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6675, '2038-04-10', '星期六', 2038, '三月', '初六', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6676, '2038-04-11', '星期日', 2038, '三月', '初七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6677, '2038-04-12', '星期一', 2038, '三月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6678, '2038-04-13', '星期二', 2038, '三月', '初九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6679, '2038-04-14', '星期三', 2038, '三月', '初十 ', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6680, '2038-04-15', '星期四', 2038, '三月', '十一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6681, '2038-04-16', '星期五', 2038, '三月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6682, '2038-04-17', '星期六', 2038, '三月', '十三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6683, '2038-04-18', '星期日', 2038, '三月', '十四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6684, '2038-04-19', '星期一', 2038, '三月', '十五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6685, '2038-04-20', '星期二', 2038, '三月', '十六', '戊午', '马', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (6686, '2038-04-21', '星期三', 2038, '三月', '十七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6687, '2038-04-22', '星期四', 2038, '三月', '十八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6688, '2038-04-23', '星期五', 2038, '三月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6689, '2038-04-24', '星期六', 2038, '三月', '二十', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6690, '2038-04-25', '星期日', 2038, '三月', '廿一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6691, '2038-04-26', '星期一', 2038, '三月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6692, '2038-04-27', '星期二', 2038, '三月', '廿三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6693, '2038-04-28', '星期三', 2038, '三月', '廿四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6694, '2038-04-29', '星期四', 2038, '三月', '廿五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6695, '2038-04-30', '星期五', 2038, '三月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6696, '2038-05-01', '星期六', 2038, '三月', '廿七', '戊午', '马', NULL, 1, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6697, '2038-05-02', '星期日', 2038, '三月', '廿八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6698, '2038-05-03', '星期一', 2038, '三月', '廿九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6699, '2038-05-04', '星期二', 2038, '四月', '初一', '戊午', '马', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6700, '2038-05-05', '星期三', 2038, '四月', '初二', '戊午', '马', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (6701, '2038-05-06', '星期四', 2038, '四月', '初三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6702, '2038-05-07', '星期五', 2038, '四月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6703, '2038-05-08', '星期六', 2038, '四月', '初五', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6704, '2038-05-09', '星期日', 2038, '四月', '初六', '戊午', '马', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (6705, '2038-05-10', '星期一', 2038, '四月', '初七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6706, '2038-05-11', '星期二', 2038, '四月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6707, '2038-05-12', '星期三', 2038, '四月', '初九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6708, '2038-05-13', '星期四', 2038, '四月', '初十 ', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6709, '2038-05-14', '星期五', 2038, '四月', '十一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6710, '2038-05-15', '星期六', 2038, '四月', '十二', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6711, '2038-05-16', '星期日', 2038, '四月', '十三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6712, '2038-05-17', '星期一', 2038, '四月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6713, '2038-05-18', '星期二', 2038, '四月', '十五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6714, '2038-05-19', '星期三', 2038, '四月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6715, '2038-05-20', '星期四', 2038, '四月', '十七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6716, '2038-05-21', '星期五', 2038, '四月', '十八', '戊午', '马', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (6717, '2038-05-22', '星期六', 2038, '四月', '十九', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6718, '2038-05-23', '星期日', 2038, '四月', '二十', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6719, '2038-05-24', '星期一', 2038, '四月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6720, '2038-05-25', '星期二', 2038, '四月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6721, '2038-05-26', '星期三', 2038, '四月', '廿三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6722, '2038-05-27', '星期四', 2038, '四月', '廿四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6723, '2038-05-28', '星期五', 2038, '四月', '廿五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6724, '2038-05-29', '星期六', 2038, '四月', '廿六', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6725, '2038-05-30', '星期日', 2038, '四月', '廿七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6726, '2038-05-31', '星期一', 2038, '四月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6727, '2038-06-01', '星期二', 2038, '四月', '廿九', '戊午', '马', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6728, '2038-06-02', '星期三', 2038, '四月', '三十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6729, '2038-06-03', '星期四', 2038, '五月', '初一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6730, '2038-06-04', '星期五', 2038, '五月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6731, '2038-06-05', '星期六', 2038, '五月', '初三', '戊午', '马', NULL, 1, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (6732, '2038-06-06', '星期日', 2038, '五月', '初四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6733, '2038-06-07', '星期一', 2038, '五月', '初五', '戊午', '马', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6734, '2038-06-08', '星期二', 2038, '五月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6735, '2038-06-09', '星期三', 2038, '五月', '初七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6736, '2038-06-10', '星期四', 2038, '五月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6737, '2038-06-11', '星期五', 2038, '五月', '初九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6738, '2038-06-12', '星期六', 2038, '五月', '初十 ', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6739, '2038-06-13', '星期日', 2038, '五月', '十一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6740, '2038-06-14', '星期一', 2038, '五月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6741, '2038-06-15', '星期二', 2038, '五月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6742, '2038-06-16', '星期三', 2038, '五月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6743, '2038-06-17', '星期四', 2038, '五月', '十五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6744, '2038-06-18', '星期五', 2038, '五月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6745, '2038-06-19', '星期六', 2038, '五月', '十七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6746, '2038-06-20', '星期日', 2038, '五月', '十八', '戊午', '马', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (6747, '2038-06-21', '星期一', 2038, '五月', '十九', '戊午', '马', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (6748, '2038-06-22', '星期二', 2038, '五月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6749, '2038-06-23', '星期三', 2038, '五月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6750, '2038-06-24', '星期四', 2038, '五月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6751, '2038-06-25', '星期五', 2038, '五月', '廿三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6752, '2038-06-26', '星期六', 2038, '五月', '廿四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6753, '2038-06-27', '星期日', 2038, '五月', '廿五', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6754, '2038-06-28', '星期一', 2038, '五月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6755, '2038-06-29', '星期二', 2038, '五月', '廿七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6756, '2038-06-30', '星期三', 2038, '五月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6757, '2038-07-01', '星期四', 2038, '五月', '廿九', '戊午', '马', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6758, '2038-07-02', '星期五', 2038, '六月', '初一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6759, '2038-07-03', '星期六', 2038, '六月', '初二', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6760, '2038-07-04', '星期日', 2038, '六月', '初三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6761, '2038-07-05', '星期一', 2038, '六月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6762, '2038-07-06', '星期二', 2038, '六月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6763, '2038-07-07', '星期三', 2038, '六月', '初六', '戊午', '马', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (6764, '2038-07-08', '星期四', 2038, '六月', '初七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6765, '2038-07-09', '星期五', 2038, '六月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6766, '2038-07-10', '星期六', 2038, '六月', '初九', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6767, '2038-07-11', '星期日', 2038, '六月', '初十 ', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6768, '2038-07-12', '星期一', 2038, '六月', '十一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6769, '2038-07-13', '星期二', 2038, '六月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6770, '2038-07-14', '星期三', 2038, '六月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6771, '2038-07-15', '星期四', 2038, '六月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6772, '2038-07-16', '星期五', 2038, '六月', '十五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6773, '2038-07-17', '星期六', 2038, '六月', '十六', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6774, '2038-07-18', '星期日', 2038, '六月', '十七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6775, '2038-07-19', '星期一', 2038, '六月', '十八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6776, '2038-07-20', '星期二', 2038, '六月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6777, '2038-07-21', '星期三', 2038, '六月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6778, '2038-07-22', '星期四', 2038, '六月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6779, '2038-07-23', '星期五', 2038, '六月', '廿二', '戊午', '马', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (6780, '2038-07-24', '星期六', 2038, '六月', '廿三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6781, '2038-07-25', '星期日', 2038, '六月', '廿四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6782, '2038-07-26', '星期一', 2038, '六月', '廿五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6783, '2038-07-27', '星期二', 2038, '六月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6784, '2038-07-28', '星期三', 2038, '六月', '廿七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6785, '2038-07-29', '星期四', 2038, '六月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6786, '2038-07-30', '星期五', 2038, '六月', '廿九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6787, '2038-07-31', '星期六', 2038, '六月', '三十', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6788, '2038-08-01', '星期日', 2038, '七月', '初一', '戊午', '马', NULL, 1, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6789, '2038-08-02', '星期一', 2038, '七月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6790, '2038-08-03', '星期二', 2038, '七月', '初三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6791, '2038-08-04', '星期三', 2038, '七月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6792, '2038-08-05', '星期四', 2038, '七月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6793, '2038-08-06', '星期五', 2038, '七月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6794, '2038-08-07', '星期六', 2038, '七月', '初七', '戊午', '马', NULL, 1, '', '七夕', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (6795, '2038-08-08', '星期日', 2038, '七月', '初八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6796, '2038-08-09', '星期一', 2038, '七月', '初九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6797, '2038-08-10', '星期二', 2038, '七月', '初十 ', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6798, '2038-08-11', '星期三', 2038, '七月', '十一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6799, '2038-08-12', '星期四', 2038, '七月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6800, '2038-08-13', '星期五', 2038, '七月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6801, '2038-08-14', '星期六', 2038, '七月', '十四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6802, '2038-08-15', '星期日', 2038, '七月', '十五', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6803, '2038-08-16', '星期一', 2038, '七月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6804, '2038-08-17', '星期二', 2038, '七月', '十七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6805, '2038-08-18', '星期三', 2038, '七月', '十八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6806, '2038-08-19', '星期四', 2038, '七月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6807, '2038-08-20', '星期五', 2038, '七月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6808, '2038-08-21', '星期六', 2038, '七月', '廿一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6809, '2038-08-22', '星期日', 2038, '七月', '廿二', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6810, '2038-08-23', '星期一', 2038, '七月', '廿三', '戊午', '马', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (6811, '2038-08-24', '星期二', 2038, '七月', '廿四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6812, '2038-08-25', '星期三', 2038, '七月', '廿五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6813, '2038-08-26', '星期四', 2038, '七月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6814, '2038-08-27', '星期五', 2038, '七月', '廿七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6815, '2038-08-28', '星期六', 2038, '七月', '廿八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6816, '2038-08-29', '星期日', 2038, '七月', '廿九', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6817, '2038-08-30', '星期一', 2038, '八月', '初一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6818, '2038-08-31', '星期二', 2038, '八月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6819, '2038-09-01', '星期三', 2038, '八月', '初三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6820, '2038-09-02', '星期四', 2038, '八月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6821, '2038-09-03', '星期五', 2038, '八月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6822, '2038-09-04', '星期六', 2038, '八月', '初六', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6823, '2038-09-05', '星期日', 2038, '八月', '初七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6824, '2038-09-06', '星期一', 2038, '八月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6825, '2038-09-07', '星期二', 2038, '八月', '初九', '戊午', '马', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (6826, '2038-09-08', '星期三', 2038, '八月', '初十 ', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6827, '2038-09-09', '星期四', 2038, '八月', '十一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6828, '2038-09-10', '星期五', 2038, '八月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6829, '2038-09-11', '星期六', 2038, '八月', '十三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6830, '2038-09-12', '星期日', 2038, '八月', '十四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6831, '2038-09-13', '星期一', 2038, '八月', '十五', '戊午', '马', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6832, '2038-09-14', '星期二', 2038, '八月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6833, '2038-09-15', '星期三', 2038, '八月', '十七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6834, '2038-09-16', '星期四', 2038, '八月', '十八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6835, '2038-09-17', '星期五', 2038, '八月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6836, '2038-09-18', '星期六', 2038, '八月', '二十', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6837, '2038-09-19', '星期日', 2038, '八月', '廿一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6838, '2038-09-20', '星期一', 2038, '八月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6839, '2038-09-21', '星期二', 2038, '八月', '廿三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6840, '2038-09-22', '星期三', 2038, '八月', '廿四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6841, '2038-09-23', '星期四', 2038, '八月', '廿五', '戊午', '马', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (6842, '2038-09-24', '星期五', 2038, '八月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6843, '2038-09-25', '星期六', 2038, '八月', '廿七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6844, '2038-09-26', '星期日', 2038, '八月', '廿八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6845, '2038-09-27', '星期一', 2038, '八月', '廿九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6846, '2038-09-28', '星期二', 2038, '八月', '三十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6847, '2038-09-29', '星期三', 2038, '九月', '初一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6848, '2038-09-30', '星期四', 2038, '九月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6849, '2038-10-01', '星期五', 2038, '九月', '初三', '戊午', '马', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6850, '2038-10-02', '星期六', 2038, '九月', '初四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6851, '2038-10-03', '星期日', 2038, '九月', '初五', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6852, '2038-10-04', '星期一', 2038, '九月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6853, '2038-10-05', '星期二', 2038, '九月', '初七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6854, '2038-10-06', '星期三', 2038, '九月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6855, '2038-10-07', '星期四', 2038, '九月', '初九', '戊午', '马', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6856, '2038-10-08', '星期五', 2038, '九月', '初十 ', '戊午', '马', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (6857, '2038-10-09', '星期六', 2038, '九月', '十一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6858, '2038-10-10', '星期日', 2038, '九月', '十二', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6859, '2038-10-11', '星期一', 2038, '九月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6860, '2038-10-12', '星期二', 2038, '九月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6861, '2038-10-13', '星期三', 2038, '九月', '十五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6862, '2038-10-14', '星期四', 2038, '九月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6863, '2038-10-15', '星期五', 2038, '九月', '十七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6864, '2038-10-16', '星期六', 2038, '九月', '十八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6865, '2038-10-17', '星期日', 2038, '九月', '十九', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6866, '2038-10-18', '星期一', 2038, '九月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6867, '2038-10-19', '星期二', 2038, '九月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6868, '2038-10-20', '星期三', 2038, '九月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6869, '2038-10-21', '星期四', 2038, '九月', '廿三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6870, '2038-10-22', '星期五', 2038, '九月', '廿四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6871, '2038-10-23', '星期六', 2038, '九月', '廿五', '戊午', '马', NULL, 1, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (6872, '2038-10-24', '星期日', 2038, '九月', '廿六', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6873, '2038-10-25', '星期一', 2038, '九月', '廿七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6874, '2038-10-26', '星期二', 2038, '九月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6875, '2038-10-27', '星期三', 2038, '九月', '廿九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6876, '2038-10-28', '星期四', 2038, '十月', '初一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6877, '2038-10-29', '星期五', 2038, '十月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6878, '2038-10-30', '星期六', 2038, '十月', '初三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6879, '2038-10-31', '星期日', 2038, '十月', '初四', '戊午', '马', NULL, 1, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6880, '2038-11-01', '星期一', 2038, '十月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6881, '2038-11-02', '星期二', 2038, '十月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6882, '2038-11-03', '星期三', 2038, '十月', '初七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6883, '2038-11-04', '星期四', 2038, '十月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6884, '2038-11-05', '星期五', 2038, '十月', '初九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6885, '2038-11-06', '星期六', 2038, '十月', '初十 ', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6886, '2038-11-07', '星期日', 2038, '十月', '十一', '戊午', '马', NULL, 1, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (6887, '2038-11-08', '星期一', 2038, '十月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6888, '2038-11-09', '星期二', 2038, '十月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6889, '2038-11-10', '星期三', 2038, '十月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6890, '2038-11-11', '星期四', 2038, '十月', '十五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6891, '2038-11-12', '星期五', 2038, '十月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6892, '2038-11-13', '星期六', 2038, '十月', '十七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6893, '2038-11-14', '星期日', 2038, '十月', '十八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6894, '2038-11-15', '星期一', 2038, '十月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6895, '2038-11-16', '星期二', 2038, '十月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6896, '2038-11-17', '星期三', 2038, '十月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6897, '2038-11-18', '星期四', 2038, '十月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6898, '2038-11-19', '星期五', 2038, '十月', '廿三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6899, '2038-11-20', '星期六', 2038, '十月', '廿四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6900, '2038-11-21', '星期日', 2038, '十月', '廿五', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6901, '2038-11-22', '星期一', 2038, '十月', '廿六', '戊午', '马', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (6902, '2038-11-23', '星期二', 2038, '十月', '廿七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6903, '2038-11-24', '星期三', 2038, '十月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6904, '2038-11-25', '星期四', 2038, '十月', '廿九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6905, '2038-11-26', '星期五', 2038, '冬月', '初一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6906, '2038-11-27', '星期六', 2038, '冬月', '初二', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6907, '2038-11-28', '星期日', 2038, '冬月', '初三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6908, '2038-11-29', '星期一', 2038, '冬月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6909, '2038-11-30', '星期二', 2038, '冬月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6910, '2038-12-01', '星期三', 2038, '冬月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6911, '2038-12-02', '星期四', 2038, '冬月', '初七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6912, '2038-12-03', '星期五', 2038, '冬月', '初八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6913, '2038-12-04', '星期六', 2038, '冬月', '初九', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6914, '2038-12-05', '星期日', 2038, '冬月', '初十 ', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6915, '2038-12-06', '星期一', 2038, '冬月', '十一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6916, '2038-12-07', '星期二', 2038, '冬月', '十二', '戊午', '马', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (6917, '2038-12-08', '星期三', 2038, '冬月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6918, '2038-12-09', '星期四', 2038, '冬月', '十四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6919, '2038-12-10', '星期五', 2038, '冬月', '十五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6920, '2038-12-11', '星期六', 2038, '冬月', '十六', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6921, '2038-12-12', '星期日', 2038, '冬月', '十七', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6922, '2038-12-13', '星期一', 2038, '冬月', '十八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6923, '2038-12-14', '星期二', 2038, '冬月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6924, '2038-12-15', '星期三', 2038, '冬月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6925, '2038-12-16', '星期四', 2038, '冬月', '廿一', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6926, '2038-12-17', '星期五', 2038, '冬月', '廿二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6927, '2038-12-18', '星期六', 2038, '冬月', '廿三', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6928, '2038-12-19', '星期日', 2038, '冬月', '廿四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6929, '2038-12-20', '星期一', 2038, '冬月', '廿五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6930, '2038-12-21', '星期二', 2038, '冬月', '廿六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6931, '2038-12-22', '星期三', 2038, '冬月', '廿七', '戊午', '马', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (6932, '2038-12-23', '星期四', 2038, '冬月', '廿八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6933, '2038-12-24', '星期五', 2038, '冬月', '廿九', '戊午', '马', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6934, '2038-12-25', '星期六', 2038, '冬月', '三十', '戊午', '马', NULL, 1, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6935, '2038-12-26', '星期日', 2038, '腊月', '初一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6936, '2038-12-27', '星期一', 2038, '腊月', '初二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6937, '2038-12-28', '星期二', 2038, '腊月', '初三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6938, '2038-12-29', '星期三', 2038, '腊月', '初四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6939, '2038-12-30', '星期四', 2038, '腊月', '初五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6940, '2038-12-31', '星期五', 2038, '腊月', '初六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6941, '2039-01-01', '星期六', 2038, '腊月', '初七', '戊午', '马', NULL, 1, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6942, '2039-01-02', '星期日', 2038, '腊月', '初八', '戊午', '马', NULL, 1, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6943, '2039-01-03', '星期一', 2038, '腊月', '初九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6944, '2039-01-04', '星期二', 2038, '腊月', '初十 ', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6945, '2039-01-05', '星期三', 2038, '腊月', '十一', '戊午', '马', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (6946, '2039-01-06', '星期四', 2038, '腊月', '十二', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6947, '2039-01-07', '星期五', 2038, '腊月', '十三', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6948, '2039-01-08', '星期六', 2038, '腊月', '十四', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6949, '2039-01-09', '星期日', 2038, '腊月', '十五', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6950, '2039-01-10', '星期一', 2038, '腊月', '十六', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6951, '2039-01-11', '星期二', 2038, '腊月', '十七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6952, '2039-01-12', '星期三', 2038, '腊月', '十八', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6953, '2039-01-13', '星期四', 2038, '腊月', '十九', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6954, '2039-01-14', '星期五', 2038, '腊月', '二十', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6955, '2039-01-15', '星期六', 2038, '腊月', '廿一', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6956, '2039-01-16', '星期日', 2038, '腊月', '廿二', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6957, '2039-01-17', '星期一', 2038, '腊月', '廿三', '戊午', '马', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6958, '2039-01-18', '星期二', 2038, '腊月', '廿四', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6959, '2039-01-19', '星期三', 2038, '腊月', '廿五', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6960, '2039-01-20', '星期四', 2038, '腊月', '廿六', '戊午', '马', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (6961, '2039-01-21', '星期五', 2038, '腊月', '廿七', '戊午', '马', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6962, '2039-01-22', '星期六', 2038, '腊月', '廿八', '戊午', '马', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6963, '2039-01-23', '星期日', 2038, '腊月', '廿九', '戊午', '马', NULL, 1, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6964, '2039-01-24', '星期一', 2039, '正月', '初一', '己未', '羊', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (6965, '2039-01-25', '星期二', 2039, '正月', '初二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6966, '2039-01-26', '星期三', 2039, '正月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6967, '2039-01-27', '星期四', 2039, '正月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6968, '2039-01-28', '星期五', 2039, '正月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6969, '2039-01-29', '星期六', 2039, '正月', '初六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6970, '2039-01-30', '星期日', 2039, '正月', '初七', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6971, '2039-01-31', '星期一', 2039, '正月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6972, '2039-02-01', '星期二', 2039, '正月', '初九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6973, '2039-02-02', '星期三', 2039, '正月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6974, '2039-02-03', '星期四', 2039, '正月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6975, '2039-02-04', '星期五', 2039, '正月', '十二', '己未', '羊', NULL, 0, '', '', '立春', '', 5);
INSERT INTO `base_data_holiday` VALUES (6976, '2039-02-05', '星期六', 2039, '正月', '十三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6977, '2039-02-06', '星期日', 2039, '正月', '十四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6978, '2039-02-07', '星期一', 2039, '正月', '十五', '己未', '羊', NULL, 0, '', '元宵节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6979, '2039-02-08', '星期二', 2039, '正月', '十六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6980, '2039-02-09', '星期三', 2039, '正月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6981, '2039-02-10', '星期四', 2039, '正月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6982, '2039-02-11', '星期五', 2039, '正月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6983, '2039-02-12', '星期六', 2039, '正月', '二十', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6984, '2039-02-13', '星期日', 2039, '正月', '廿一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6985, '2039-02-14', '星期一', 2039, '正月', '廿二', '己未', '羊', NULL, 0, '情人节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6986, '2039-02-15', '星期二', 2039, '正月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6987, '2039-02-16', '星期三', 2039, '正月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6988, '2039-02-17', '星期四', 2039, '正月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6989, '2039-02-18', '星期五', 2039, '正月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6990, '2039-02-19', '星期六', 2039, '正月', '廿七', '己未', '羊', NULL, 1, '', '', '雨水', '', 5);
INSERT INTO `base_data_holiday` VALUES (6991, '2039-02-20', '星期日', 2039, '正月', '廿八', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6992, '2039-02-21', '星期一', 2039, '正月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6993, '2039-02-22', '星期二', 2039, '正月', '三十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6994, '2039-02-23', '星期三', 2039, '二月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6995, '2039-02-24', '星期四', 2039, '二月', '初二', '己未', '羊', NULL, 0, '', '龙抬头', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6996, '2039-02-25', '星期五', 2039, '二月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6997, '2039-02-26', '星期六', 2039, '二月', '初四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6998, '2039-02-27', '星期日', 2039, '二月', '初五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (6999, '2039-02-28', '星期一', 2039, '二月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7000, '2039-03-01', '星期二', 2039, '二月', '初七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7001, '2039-03-02', '星期三', 2039, '二月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7002, '2039-03-03', '星期四', 2039, '二月', '初九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7003, '2039-03-04', '星期五', 2039, '二月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7004, '2039-03-05', '星期六', 2039, '二月', '十一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7005, '2039-03-06', '星期日', 2039, '二月', '十二', '己未', '羊', NULL, 1, '', '', '惊蛰', '', 5);
INSERT INTO `base_data_holiday` VALUES (7006, '2039-03-07', '星期一', 2039, '二月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7007, '2039-03-08', '星期二', 2039, '二月', '十四', '己未', '羊', NULL, 0, '妇女节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7008, '2039-03-09', '星期三', 2039, '二月', '十五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7009, '2039-03-10', '星期四', 2039, '二月', '十六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7010, '2039-03-11', '星期五', 2039, '二月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7011, '2039-03-12', '星期六', 2039, '二月', '十八', '己未', '羊', NULL, 1, '植树节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7012, '2039-03-13', '星期日', 2039, '二月', '十九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7013, '2039-03-14', '星期一', 2039, '二月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7014, '2039-03-15', '星期二', 2039, '二月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7015, '2039-03-16', '星期三', 2039, '二月', '廿二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7016, '2039-03-17', '星期四', 2039, '二月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7017, '2039-03-18', '星期五', 2039, '二月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7018, '2039-03-19', '星期六', 2039, '二月', '廿五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7019, '2039-03-20', '星期日', 2039, '二月', '廿六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7020, '2039-03-21', '星期一', 2039, '二月', '廿七', '己未', '羊', NULL, 0, '', '', '春分', '', 5);
INSERT INTO `base_data_holiday` VALUES (7021, '2039-03-22', '星期二', 2039, '二月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7022, '2039-03-23', '星期三', 2039, '二月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7023, '2039-03-24', '星期四', 2039, '二月', '三十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7024, '2039-03-25', '星期五', 2039, '三月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7025, '2039-03-26', '星期六', 2039, '三月', '初二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7026, '2039-03-27', '星期日', 2039, '三月', '初三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7027, '2039-03-28', '星期一', 2039, '三月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7028, '2039-03-29', '星期二', 2039, '三月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7029, '2039-03-30', '星期三', 2039, '三月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7030, '2039-03-31', '星期四', 2039, '三月', '初七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7031, '2039-04-01', '星期五', 2039, '三月', '初八', '己未', '羊', NULL, 0, '愚人节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7032, '2039-04-02', '星期六', 2039, '三月', '初九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7033, '2039-04-03', '星期日', 2039, '三月', '初十 ', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7034, '2039-04-04', '星期一', 2039, '三月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7035, '2039-04-05', '星期二', 2039, '三月', '十二', '己未', '羊', NULL, 0, '', '', '清明', '', 5);
INSERT INTO `base_data_holiday` VALUES (7036, '2039-04-06', '星期三', 2039, '三月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7037, '2039-04-07', '星期四', 2039, '三月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7038, '2039-04-08', '星期五', 2039, '三月', '十五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7039, '2039-04-09', '星期六', 2039, '三月', '十六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7040, '2039-04-10', '星期日', 2039, '三月', '十七', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7041, '2039-04-11', '星期一', 2039, '三月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7042, '2039-04-12', '星期二', 2039, '三月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7043, '2039-04-13', '星期三', 2039, '三月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7044, '2039-04-14', '星期四', 2039, '三月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7045, '2039-04-15', '星期五', 2039, '三月', '廿二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7046, '2039-04-16', '星期六', 2039, '三月', '廿三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7047, '2039-04-17', '星期日', 2039, '三月', '廿四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7048, '2039-04-18', '星期一', 2039, '三月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7049, '2039-04-19', '星期二', 2039, '三月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7050, '2039-04-20', '星期三', 2039, '三月', '廿七', '己未', '羊', NULL, 0, '', '', '谷雨', '', 5);
INSERT INTO `base_data_holiday` VALUES (7051, '2039-04-21', '星期四', 2039, '三月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7052, '2039-04-22', '星期五', 2039, '三月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7053, '2039-04-23', '星期六', 2039, '四月', '初一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7054, '2039-04-24', '星期日', 2039, '四月', '初二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7055, '2039-04-25', '星期一', 2039, '四月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7056, '2039-04-26', '星期二', 2039, '四月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7057, '2039-04-27', '星期三', 2039, '四月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7058, '2039-04-28', '星期四', 2039, '四月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7059, '2039-04-29', '星期五', 2039, '四月', '初七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7060, '2039-04-30', '星期六', 2039, '四月', '初八', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7061, '2039-05-01', '星期日', 2039, '四月', '初九', '己未', '羊', NULL, 1, '劳动节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7062, '2039-05-02', '星期一', 2039, '四月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7063, '2039-05-03', '星期二', 2039, '四月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7064, '2039-05-04', '星期三', 2039, '四月', '十二', '己未', '羊', NULL, 0, '青年节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7065, '2039-05-05', '星期四', 2039, '四月', '十三', '己未', '羊', NULL, 0, '', '', '立夏', '', 5);
INSERT INTO `base_data_holiday` VALUES (7066, '2039-05-06', '星期五', 2039, '四月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7067, '2039-05-07', '星期六', 2039, '四月', '十五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7068, '2039-05-08', '星期日', 2039, '四月', '十六', '己未', '羊', NULL, 1, '', '', '', '母亲节', 5);
INSERT INTO `base_data_holiday` VALUES (7069, '2039-05-09', '星期一', 2039, '四月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7070, '2039-05-10', '星期二', 2039, '四月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7071, '2039-05-11', '星期三', 2039, '四月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7072, '2039-05-12', '星期四', 2039, '四月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7073, '2039-05-13', '星期五', 2039, '四月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7074, '2039-05-14', '星期六', 2039, '四月', '廿二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7075, '2039-05-15', '星期日', 2039, '四月', '廿三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7076, '2039-05-16', '星期一', 2039, '四月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7077, '2039-05-17', '星期二', 2039, '四月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7078, '2039-05-18', '星期三', 2039, '四月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7079, '2039-05-19', '星期四', 2039, '四月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7080, '2039-05-20', '星期五', 2039, '四月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7081, '2039-05-21', '星期六', 2039, '四月', '廿九', '己未', '羊', NULL, 1, '', '', '小满', '', 5);
INSERT INTO `base_data_holiday` VALUES (7082, '2039-05-22', '星期日', 2039, '四月', '三十', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7083, '2039-05-23', '星期一', 2039, '五月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7084, '2039-05-24', '星期二', 2039, '五月', '初二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7085, '2039-05-25', '星期三', 2039, '五月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7086, '2039-05-26', '星期四', 2039, '五月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7087, '2039-05-27', '星期五', 2039, '五月', '初五', '己未', '羊', NULL, 0, '', '端午节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7088, '2039-05-28', '星期六', 2039, '五月', '初六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7089, '2039-05-29', '星期日', 2039, '五月', '初七', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7090, '2039-05-30', '星期一', 2039, '五月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7091, '2039-05-31', '星期二', 2039, '五月', '初九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7092, '2039-06-01', '星期三', 2039, '五月', '初十 ', '己未', '羊', NULL, 0, '儿童节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7093, '2039-06-02', '星期四', 2039, '五月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7094, '2039-06-03', '星期五', 2039, '五月', '十二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7095, '2039-06-04', '星期六', 2039, '五月', '十三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7096, '2039-06-05', '星期日', 2039, '五月', '十四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7097, '2039-06-06', '星期一', 2039, '五月', '十五', '己未', '羊', NULL, 0, '', '', '芒种', '', 5);
INSERT INTO `base_data_holiday` VALUES (7098, '2039-06-07', '星期二', 2039, '五月', '十六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7099, '2039-06-08', '星期三', 2039, '五月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7100, '2039-06-09', '星期四', 2039, '五月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7101, '2039-06-10', '星期五', 2039, '五月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7102, '2039-06-11', '星期六', 2039, '五月', '二十', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7103, '2039-06-12', '星期日', 2039, '五月', '廿一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7104, '2039-06-13', '星期一', 2039, '五月', '廿二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7105, '2039-06-14', '星期二', 2039, '五月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7106, '2039-06-15', '星期三', 2039, '五月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7107, '2039-06-16', '星期四', 2039, '五月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7108, '2039-06-17', '星期五', 2039, '五月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7109, '2039-06-18', '星期六', 2039, '五月', '廿七', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7110, '2039-06-19', '星期日', 2039, '五月', '廿八', '己未', '羊', NULL, 1, '', '', '', '父亲节', 5);
INSERT INTO `base_data_holiday` VALUES (7111, '2039-06-20', '星期一', 2039, '五月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7112, '2039-06-21', '星期二', 2039, '五月', '三十', '己未', '羊', NULL, 0, '', '', '夏至', '', 5);
INSERT INTO `base_data_holiday` VALUES (7113, '2039-06-22', '星期三', 2039, '闰五月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7114, '2039-06-23', '星期四', 2039, '闰五月', '初二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7115, '2039-06-24', '星期五', 2039, '闰五月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7116, '2039-06-25', '星期六', 2039, '闰五月', '初四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7117, '2039-06-26', '星期日', 2039, '闰五月', '初五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7118, '2039-06-27', '星期一', 2039, '闰五月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7119, '2039-06-28', '星期二', 2039, '闰五月', '初七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7120, '2039-06-29', '星期三', 2039, '闰五月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7121, '2039-06-30', '星期四', 2039, '闰五月', '初九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7122, '2039-07-01', '星期五', 2039, '闰五月', '初十 ', '己未', '羊', NULL, 0, '建党节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7123, '2039-07-02', '星期六', 2039, '闰五月', '十一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7124, '2039-07-03', '星期日', 2039, '闰五月', '十二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7125, '2039-07-04', '星期一', 2039, '闰五月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7126, '2039-07-05', '星期二', 2039, '闰五月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7127, '2039-07-06', '星期三', 2039, '闰五月', '十五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7128, '2039-07-07', '星期四', 2039, '闰五月', '十六', '己未', '羊', NULL, 0, '', '', '小暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (7129, '2039-07-08', '星期五', 2039, '闰五月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7130, '2039-07-09', '星期六', 2039, '闰五月', '十八', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7131, '2039-07-10', '星期日', 2039, '闰五月', '十九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7132, '2039-07-11', '星期一', 2039, '闰五月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7133, '2039-07-12', '星期二', 2039, '闰五月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7134, '2039-07-13', '星期三', 2039, '闰五月', '廿二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7135, '2039-07-14', '星期四', 2039, '闰五月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7136, '2039-07-15', '星期五', 2039, '闰五月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7137, '2039-07-16', '星期六', 2039, '闰五月', '廿五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7138, '2039-07-17', '星期日', 2039, '闰五月', '廿六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7139, '2039-07-18', '星期一', 2039, '闰五月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7140, '2039-07-19', '星期二', 2039, '闰五月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7141, '2039-07-20', '星期三', 2039, '闰五月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7142, '2039-07-21', '星期四', 2039, '六月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7143, '2039-07-22', '星期五', 2039, '六月', '初二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7144, '2039-07-23', '星期六', 2039, '六月', '初三', '己未', '羊', NULL, 1, '', '', '大暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (7145, '2039-07-24', '星期日', 2039, '六月', '初四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7146, '2039-07-25', '星期一', 2039, '六月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7147, '2039-07-26', '星期二', 2039, '六月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7148, '2039-07-27', '星期三', 2039, '六月', '初七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7149, '2039-07-28', '星期四', 2039, '六月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7150, '2039-07-29', '星期五', 2039, '六月', '初九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7151, '2039-07-30', '星期六', 2039, '六月', '初十 ', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7152, '2039-07-31', '星期日', 2039, '六月', '十一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7153, '2039-08-01', '星期一', 2039, '六月', '十二', '己未', '羊', NULL, 0, '建军节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7154, '2039-08-02', '星期二', 2039, '六月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7155, '2039-08-03', '星期三', 2039, '六月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7156, '2039-08-04', '星期四', 2039, '六月', '十五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7157, '2039-08-05', '星期五', 2039, '六月', '十六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7158, '2039-08-06', '星期六', 2039, '六月', '十七', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7159, '2039-08-07', '星期日', 2039, '六月', '十八', '己未', '羊', NULL, 1, '', '', '立秋', '', 5);
INSERT INTO `base_data_holiday` VALUES (7160, '2039-08-08', '星期一', 2039, '六月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7161, '2039-08-09', '星期二', 2039, '六月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7162, '2039-08-10', '星期三', 2039, '六月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7163, '2039-08-11', '星期四', 2039, '六月', '廿二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7164, '2039-08-12', '星期五', 2039, '六月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7165, '2039-08-13', '星期六', 2039, '六月', '廿四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7166, '2039-08-14', '星期日', 2039, '六月', '廿五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7167, '2039-08-15', '星期一', 2039, '六月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7168, '2039-08-16', '星期二', 2039, '六月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7169, '2039-08-17', '星期三', 2039, '六月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7170, '2039-08-18', '星期四', 2039, '六月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7171, '2039-08-19', '星期五', 2039, '六月', '三十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7172, '2039-08-20', '星期六', 2039, '七月', '初一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7173, '2039-08-21', '星期日', 2039, '七月', '初二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7174, '2039-08-22', '星期一', 2039, '七月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7175, '2039-08-23', '星期二', 2039, '七月', '初四', '己未', '羊', NULL, 0, '', '', '处暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (7176, '2039-08-24', '星期三', 2039, '七月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7177, '2039-08-25', '星期四', 2039, '七月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7178, '2039-08-26', '星期五', 2039, '七月', '初七', '己未', '羊', NULL, 0, '', '七夕', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7179, '2039-08-27', '星期六', 2039, '七月', '初八', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7180, '2039-08-28', '星期日', 2039, '七月', '初九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7181, '2039-08-29', '星期一', 2039, '七月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7182, '2039-08-30', '星期二', 2039, '七月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7183, '2039-08-31', '星期三', 2039, '七月', '十二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7184, '2039-09-01', '星期四', 2039, '七月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7185, '2039-09-02', '星期五', 2039, '七月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7186, '2039-09-03', '星期六', 2039, '七月', '十五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7187, '2039-09-04', '星期日', 2039, '七月', '十六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7188, '2039-09-05', '星期一', 2039, '七月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7189, '2039-09-06', '星期二', 2039, '七月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7190, '2039-09-07', '星期三', 2039, '七月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7191, '2039-09-08', '星期四', 2039, '七月', '二十', '己未', '羊', NULL, 0, '', '', '白露', '', 5);
INSERT INTO `base_data_holiday` VALUES (7192, '2039-09-09', '星期五', 2039, '七月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7193, '2039-09-10', '星期六', 2039, '七月', '廿二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7194, '2039-09-11', '星期日', 2039, '七月', '廿三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7195, '2039-09-12', '星期一', 2039, '七月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7196, '2039-09-13', '星期二', 2039, '七月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7197, '2039-09-14', '星期三', 2039, '七月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7198, '2039-09-15', '星期四', 2039, '七月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7199, '2039-09-16', '星期五', 2039, '七月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7200, '2039-09-17', '星期六', 2039, '七月', '廿九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7201, '2039-09-18', '星期日', 2039, '八月', '初一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7202, '2039-09-19', '星期一', 2039, '八月', '初二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7203, '2039-09-20', '星期二', 2039, '八月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7204, '2039-09-21', '星期三', 2039, '八月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7205, '2039-09-22', '星期四', 2039, '八月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7206, '2039-09-23', '星期五', 2039, '八月', '初六', '己未', '羊', NULL, 0, '农民丰收节', '', '秋分', '', 5);
INSERT INTO `base_data_holiday` VALUES (7207, '2039-09-24', '星期六', 2039, '八月', '初七', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7208, '2039-09-25', '星期日', 2039, '八月', '初八', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7209, '2039-09-26', '星期一', 2039, '八月', '初九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7210, '2039-09-27', '星期二', 2039, '八月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7211, '2039-09-28', '星期三', 2039, '八月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7212, '2039-09-29', '星期四', 2039, '八月', '十二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7213, '2039-09-30', '星期五', 2039, '八月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7214, '2039-10-01', '星期六', 2039, '八月', '十四', '己未', '羊', NULL, 1, '国庆节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7215, '2039-10-02', '星期日', 2039, '八月', '十五', '己未', '羊', NULL, 1, '', '中秋节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7216, '2039-10-03', '星期一', 2039, '八月', '十六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7217, '2039-10-04', '星期二', 2039, '八月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7218, '2039-10-05', '星期三', 2039, '八月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7219, '2039-10-06', '星期四', 2039, '八月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7220, '2039-10-07', '星期五', 2039, '八月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7221, '2039-10-08', '星期六', 2039, '八月', '廿一', '己未', '羊', NULL, 1, '', '', '寒露', '', 5);
INSERT INTO `base_data_holiday` VALUES (7222, '2039-10-09', '星期日', 2039, '八月', '廿二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7223, '2039-10-10', '星期一', 2039, '八月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7224, '2039-10-11', '星期二', 2039, '八月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7225, '2039-10-12', '星期三', 2039, '八月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7226, '2039-10-13', '星期四', 2039, '八月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7227, '2039-10-14', '星期五', 2039, '八月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7228, '2039-10-15', '星期六', 2039, '八月', '廿八', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7229, '2039-10-16', '星期日', 2039, '八月', '廿九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7230, '2039-10-17', '星期一', 2039, '八月', '三十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7231, '2039-10-18', '星期二', 2039, '九月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7232, '2039-10-19', '星期三', 2039, '九月', '初二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7233, '2039-10-20', '星期四', 2039, '九月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7234, '2039-10-21', '星期五', 2039, '九月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7235, '2039-10-22', '星期六', 2039, '九月', '初五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7236, '2039-10-23', '星期日', 2039, '九月', '初六', '己未', '羊', NULL, 1, '', '', '霜降', '', 5);
INSERT INTO `base_data_holiday` VALUES (7237, '2039-10-24', '星期一', 2039, '九月', '初七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7238, '2039-10-25', '星期二', 2039, '九月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7239, '2039-10-26', '星期三', 2039, '九月', '初九', '己未', '羊', NULL, 0, '', '重阳节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7240, '2039-10-27', '星期四', 2039, '九月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7241, '2039-10-28', '星期五', 2039, '九月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7242, '2039-10-29', '星期六', 2039, '九月', '十二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7243, '2039-10-30', '星期日', 2039, '九月', '十三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7244, '2039-10-31', '星期一', 2039, '九月', '十四', '己未', '羊', NULL, 0, '万圣节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7245, '2039-11-01', '星期二', 2039, '九月', '十五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7246, '2039-11-02', '星期三', 2039, '九月', '十六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7247, '2039-11-03', '星期四', 2039, '九月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7248, '2039-11-04', '星期五', 2039, '九月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7249, '2039-11-05', '星期六', 2039, '九月', '十九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7250, '2039-11-06', '星期日', 2039, '九月', '二十', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7251, '2039-11-07', '星期一', 2039, '九月', '廿一', '己未', '羊', NULL, 0, '', '', '立冬', '', 5);
INSERT INTO `base_data_holiday` VALUES (7252, '2039-11-08', '星期二', 2039, '九月', '廿二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7253, '2039-11-09', '星期三', 2039, '九月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7254, '2039-11-10', '星期四', 2039, '九月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7255, '2039-11-11', '星期五', 2039, '九月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7256, '2039-11-12', '星期六', 2039, '九月', '廿六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7257, '2039-11-13', '星期日', 2039, '九月', '廿七', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7258, '2039-11-14', '星期一', 2039, '九月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7259, '2039-11-15', '星期二', 2039, '九月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7260, '2039-11-16', '星期三', 2039, '十月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7261, '2039-11-17', '星期四', 2039, '十月', '初二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7262, '2039-11-18', '星期五', 2039, '十月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7263, '2039-11-19', '星期六', 2039, '十月', '初四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7264, '2039-11-20', '星期日', 2039, '十月', '初五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7265, '2039-11-21', '星期一', 2039, '十月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7266, '2039-11-22', '星期二', 2039, '十月', '初七', '己未', '羊', NULL, 0, '', '', '小雪', '', 5);
INSERT INTO `base_data_holiday` VALUES (7267, '2039-11-23', '星期三', 2039, '十月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7268, '2039-11-24', '星期四', 2039, '十月', '初九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7269, '2039-11-25', '星期五', 2039, '十月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7270, '2039-11-26', '星期六', 2039, '十月', '十一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7271, '2039-11-27', '星期日', 2039, '十月', '十二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7272, '2039-11-28', '星期一', 2039, '十月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7273, '2039-11-29', '星期二', 2039, '十月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7274, '2039-11-30', '星期三', 2039, '十月', '十五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7275, '2039-12-01', '星期四', 2039, '十月', '十六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7276, '2039-12-02', '星期五', 2039, '十月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7277, '2039-12-03', '星期六', 2039, '十月', '十八', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7278, '2039-12-04', '星期日', 2039, '十月', '十九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7279, '2039-12-05', '星期一', 2039, '十月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7280, '2039-12-06', '星期二', 2039, '十月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7281, '2039-12-07', '星期三', 2039, '十月', '廿二', '己未', '羊', NULL, 0, '', '', '大雪', '', 5);
INSERT INTO `base_data_holiday` VALUES (7282, '2039-12-08', '星期四', 2039, '十月', '廿三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7283, '2039-12-09', '星期五', 2039, '十月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7284, '2039-12-10', '星期六', 2039, '十月', '廿五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7285, '2039-12-11', '星期日', 2039, '十月', '廿六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7286, '2039-12-12', '星期一', 2039, '十月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7287, '2039-12-13', '星期二', 2039, '十月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7288, '2039-12-14', '星期三', 2039, '十月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7289, '2039-12-15', '星期四', 2039, '十月', '三十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7290, '2039-12-16', '星期五', 2039, '冬月', '初一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7291, '2039-12-17', '星期六', 2039, '冬月', '初二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7292, '2039-12-18', '星期日', 2039, '冬月', '初三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7293, '2039-12-19', '星期一', 2039, '冬月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7294, '2039-12-20', '星期二', 2039, '冬月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7295, '2039-12-21', '星期三', 2039, '冬月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7296, '2039-12-22', '星期四', 2039, '冬月', '初七', '己未', '羊', NULL, 0, '', '', '冬至', '', 5);
INSERT INTO `base_data_holiday` VALUES (7297, '2039-12-23', '星期五', 2039, '冬月', '初八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7298, '2039-12-24', '星期六', 2039, '冬月', '初九', '己未', '羊', NULL, 1, '平安夜', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7299, '2039-12-25', '星期日', 2039, '冬月', '初十 ', '己未', '羊', NULL, 1, '圣诞节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7300, '2039-12-26', '星期一', 2039, '冬月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7301, '2039-12-27', '星期二', 2039, '冬月', '十二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7302, '2039-12-28', '星期三', 2039, '冬月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7303, '2039-12-29', '星期四', 2039, '冬月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7304, '2039-12-30', '星期五', 2039, '冬月', '十五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7305, '2039-12-31', '星期六', 2039, '冬月', '十六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7306, '2040-01-01', '星期日', 2039, '冬月', '十七', '己未', '羊', NULL, 1, '元旦', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7307, '2040-01-02', '星期一', 2039, '冬月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7308, '2040-01-03', '星期二', 2039, '冬月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7309, '2040-01-04', '星期三', 2039, '冬月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7310, '2040-01-05', '星期四', 2039, '冬月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7311, '2040-01-06', '星期五', 2039, '冬月', '廿二', '己未', '羊', NULL, 0, '', '', '小寒', '', 5);
INSERT INTO `base_data_holiday` VALUES (7312, '2040-01-07', '星期六', 2039, '冬月', '廿三', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7313, '2040-01-08', '星期日', 2039, '冬月', '廿四', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7314, '2040-01-09', '星期一', 2039, '冬月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7315, '2040-01-10', '星期二', 2039, '冬月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7316, '2040-01-11', '星期三', 2039, '冬月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7317, '2040-01-12', '星期四', 2039, '冬月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7318, '2040-01-13', '星期五', 2039, '冬月', '廿九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7319, '2040-01-14', '星期六', 2039, '腊月', '初一', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7320, '2040-01-15', '星期日', 2039, '腊月', '初二', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7321, '2040-01-16', '星期一', 2039, '腊月', '初三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7322, '2040-01-17', '星期二', 2039, '腊月', '初四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7323, '2040-01-18', '星期三', 2039, '腊月', '初五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7324, '2040-01-19', '星期四', 2039, '腊月', '初六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7325, '2040-01-20', '星期五', 2039, '腊月', '初七', '己未', '羊', NULL, 0, '', '', '大寒', '', 5);
INSERT INTO `base_data_holiday` VALUES (7326, '2040-01-21', '星期六', 2039, '腊月', '初八', '己未', '羊', NULL, 1, '', '腊八节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7327, '2040-01-22', '星期日', 2039, '腊月', '初九', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7328, '2040-01-23', '星期一', 2039, '腊月', '初十 ', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7329, '2040-01-24', '星期二', 2039, '腊月', '十一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7330, '2040-01-25', '星期三', 2039, '腊月', '十二', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7331, '2040-01-26', '星期四', 2039, '腊月', '十三', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7332, '2040-01-27', '星期五', 2039, '腊月', '十四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7333, '2040-01-28', '星期六', 2039, '腊月', '十五', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7334, '2040-01-29', '星期日', 2039, '腊月', '十六', '己未', '羊', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7335, '2040-01-30', '星期一', 2039, '腊月', '十七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7336, '2040-01-31', '星期二', 2039, '腊月', '十八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7337, '2040-02-01', '星期三', 2039, '腊月', '十九', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7338, '2040-02-02', '星期四', 2039, '腊月', '二十', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7339, '2040-02-03', '星期五', 2039, '腊月', '廿一', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7340, '2040-02-04', '星期六', 2039, '腊月', '廿二', '己未', '羊', NULL, 1, '', '', '立春', '', 5);
INSERT INTO `base_data_holiday` VALUES (7341, '2040-02-05', '星期日', 2039, '腊月', '廿三', '己未', '羊', NULL, 1, '', '小年', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7342, '2040-02-06', '星期一', 2039, '腊月', '廿四', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7343, '2040-02-07', '星期二', 2039, '腊月', '廿五', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7344, '2040-02-08', '星期三', 2039, '腊月', '廿六', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7345, '2040-02-09', '星期四', 2039, '腊月', '廿七', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7346, '2040-02-10', '星期五', 2039, '腊月', '廿八', '己未', '羊', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7347, '2040-02-11', '星期六', 2039, '腊月', '廿九', '己未', '羊', NULL, 1, '', '除夕', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (7348, '2040-02-12', '星期日', 2040, '正月', '初一', '庚申', '猴', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7349, '2040-02-13', '星期一', 2040, '正月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7350, '2040-02-14', '星期二', 2040, '正月', '初三', '庚申', '猴', NULL, 0, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7351, '2040-02-15', '星期三', 2040, '正月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7352, '2040-02-16', '星期四', 2040, '正月', '初五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7353, '2040-02-17', '星期五', 2040, '正月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7354, '2040-02-18', '星期六', 2040, '正月', '初七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7355, '2040-02-19', '星期日', 2040, '正月', '初八', '庚申', '猴', NULL, 1, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (7356, '2040-02-20', '星期一', 2040, '正月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7357, '2040-02-21', '星期二', 2040, '正月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7358, '2040-02-22', '星期三', 2040, '正月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7359, '2040-02-23', '星期四', 2040, '正月', '十二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7360, '2040-02-24', '星期五', 2040, '正月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7361, '2040-02-25', '星期六', 2040, '正月', '十四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7362, '2040-02-26', '星期日', 2040, '正月', '十五', '庚申', '猴', NULL, 1, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7363, '2040-02-27', '星期一', 2040, '正月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7364, '2040-02-28', '星期二', 2040, '正月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7365, '2040-02-29', '星期三', 2040, '正月', '十八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7366, '2040-03-01', '星期四', 2040, '正月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7367, '2040-03-02', '星期五', 2040, '正月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7368, '2040-03-03', '星期六', 2040, '正月', '廿一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7369, '2040-03-04', '星期日', 2040, '正月', '廿二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7370, '2040-03-05', '星期一', 2040, '正月', '廿三', '庚申', '猴', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (7371, '2040-03-06', '星期二', 2040, '正月', '廿四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7372, '2040-03-07', '星期三', 2040, '正月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7373, '2040-03-08', '星期四', 2040, '正月', '廿六', '庚申', '猴', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7374, '2040-03-09', '星期五', 2040, '正月', '廿七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7375, '2040-03-10', '星期六', 2040, '正月', '廿八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7376, '2040-03-11', '星期日', 2040, '正月', '廿九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7377, '2040-03-12', '星期一', 2040, '正月', '三十', '庚申', '猴', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7378, '2040-03-13', '星期二', 2040, '二月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7379, '2040-03-14', '星期三', 2040, '二月', '初二', '庚申', '猴', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7380, '2040-03-15', '星期四', 2040, '二月', '初三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7381, '2040-03-16', '星期五', 2040, '二月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7382, '2040-03-17', '星期六', 2040, '二月', '初五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7383, '2040-03-18', '星期日', 2040, '二月', '初六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7384, '2040-03-19', '星期一', 2040, '二月', '初七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7385, '2040-03-20', '星期二', 2040, '二月', '初八', '庚申', '猴', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (7386, '2040-03-21', '星期三', 2040, '二月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7387, '2040-03-22', '星期四', 2040, '二月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7388, '2040-03-23', '星期五', 2040, '二月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7389, '2040-03-24', '星期六', 2040, '二月', '十二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7390, '2040-03-25', '星期日', 2040, '二月', '十三', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7391, '2040-03-26', '星期一', 2040, '二月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7392, '2040-03-27', '星期二', 2040, '二月', '十五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7393, '2040-03-28', '星期三', 2040, '二月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7394, '2040-03-29', '星期四', 2040, '二月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7395, '2040-03-30', '星期五', 2040, '二月', '十八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7396, '2040-03-31', '星期六', 2040, '二月', '十九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7397, '2040-04-01', '星期日', 2040, '二月', '二十', '庚申', '猴', NULL, 1, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7398, '2040-04-02', '星期一', 2040, '二月', '廿一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7399, '2040-04-03', '星期二', 2040, '二月', '廿二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7400, '2040-04-04', '星期三', 2040, '二月', '廿三', '庚申', '猴', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (7401, '2040-04-05', '星期四', 2040, '二月', '廿四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7402, '2040-04-06', '星期五', 2040, '二月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7403, '2040-04-07', '星期六', 2040, '二月', '廿六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7404, '2040-04-08', '星期日', 2040, '二月', '廿七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7405, '2040-04-09', '星期一', 2040, '二月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7406, '2040-04-10', '星期二', 2040, '二月', '廿九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7407, '2040-04-11', '星期三', 2040, '三月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7408, '2040-04-12', '星期四', 2040, '三月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7409, '2040-04-13', '星期五', 2040, '三月', '初三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7410, '2040-04-14', '星期六', 2040, '三月', '初四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7411, '2040-04-15', '星期日', 2040, '三月', '初五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7412, '2040-04-16', '星期一', 2040, '三月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7413, '2040-04-17', '星期二', 2040, '三月', '初七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7414, '2040-04-18', '星期三', 2040, '三月', '初八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7415, '2040-04-19', '星期四', 2040, '三月', '初九', '庚申', '猴', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (7416, '2040-04-20', '星期五', 2040, '三月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7417, '2040-04-21', '星期六', 2040, '三月', '十一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7418, '2040-04-22', '星期日', 2040, '三月', '十二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7419, '2040-04-23', '星期一', 2040, '三月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7420, '2040-04-24', '星期二', 2040, '三月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7421, '2040-04-25', '星期三', 2040, '三月', '十五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7422, '2040-04-26', '星期四', 2040, '三月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7423, '2040-04-27', '星期五', 2040, '三月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7424, '2040-04-28', '星期六', 2040, '三月', '十八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7425, '2040-04-29', '星期日', 2040, '三月', '十九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7426, '2040-04-30', '星期一', 2040, '三月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7427, '2040-05-01', '星期二', 2040, '三月', '廿一', '庚申', '猴', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7428, '2040-05-02', '星期三', 2040, '三月', '廿二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7429, '2040-05-03', '星期四', 2040, '三月', '廿三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7430, '2040-05-04', '星期五', 2040, '三月', '廿四', '庚申', '猴', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7431, '2040-05-05', '星期六', 2040, '三月', '廿五', '庚申', '猴', NULL, 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (7432, '2040-05-06', '星期日', 2040, '三月', '廿六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7433, '2040-05-07', '星期一', 2040, '三月', '廿七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7434, '2040-05-08', '星期二', 2040, '三月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7435, '2040-05-09', '星期三', 2040, '三月', '廿九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7436, '2040-05-10', '星期四', 2040, '三月', '三十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7437, '2040-05-11', '星期五', 2040, '四月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7438, '2040-05-12', '星期六', 2040, '四月', '初二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7439, '2040-05-13', '星期日', 2040, '四月', '初三', '庚申', '猴', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (7440, '2040-05-14', '星期一', 2040, '四月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7441, '2040-05-15', '星期二', 2040, '四月', '初五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7442, '2040-05-16', '星期三', 2040, '四月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7443, '2040-05-17', '星期四', 2040, '四月', '初七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7444, '2040-05-18', '星期五', 2040, '四月', '初八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7445, '2040-05-19', '星期六', 2040, '四月', '初九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7446, '2040-05-20', '星期日', 2040, '四月', '初十 ', '庚申', '猴', NULL, 1, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (7447, '2040-05-21', '星期一', 2040, '四月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7448, '2040-05-22', '星期二', 2040, '四月', '十二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7449, '2040-05-23', '星期三', 2040, '四月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7450, '2040-05-24', '星期四', 2040, '四月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7451, '2040-05-25', '星期五', 2040, '四月', '十五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7452, '2040-05-26', '星期六', 2040, '四月', '十六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7453, '2040-05-27', '星期日', 2040, '四月', '十七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7454, '2040-05-28', '星期一', 2040, '四月', '十八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7455, '2040-05-29', '星期二', 2040, '四月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7456, '2040-05-30', '星期三', 2040, '四月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7457, '2040-05-31', '星期四', 2040, '四月', '廿一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7458, '2040-06-01', '星期五', 2040, '四月', '廿二', '庚申', '猴', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7459, '2040-06-02', '星期六', 2040, '四月', '廿三', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7460, '2040-06-03', '星期日', 2040, '四月', '廿四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7461, '2040-06-04', '星期一', 2040, '四月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7462, '2040-06-05', '星期二', 2040, '四月', '廿六', '庚申', '猴', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (7463, '2040-06-06', '星期三', 2040, '四月', '廿七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7464, '2040-06-07', '星期四', 2040, '四月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7465, '2040-06-08', '星期五', 2040, '四月', '廿九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7466, '2040-06-09', '星期六', 2040, '四月', '三十', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7467, '2040-06-10', '星期日', 2040, '五月', '初一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7468, '2040-06-11', '星期一', 2040, '五月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7469, '2040-06-12', '星期二', 2040, '五月', '初三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7470, '2040-06-13', '星期三', 2040, '五月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7471, '2040-06-14', '星期四', 2040, '五月', '初五', '庚申', '猴', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7472, '2040-06-15', '星期五', 2040, '五月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7473, '2040-06-16', '星期六', 2040, '五月', '初七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7474, '2040-06-17', '星期日', 2040, '五月', '初八', '庚申', '猴', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (7475, '2040-06-18', '星期一', 2040, '五月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7476, '2040-06-19', '星期二', 2040, '五月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7477, '2040-06-20', '星期三', 2040, '五月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7478, '2040-06-21', '星期四', 2040, '五月', '十二', '庚申', '猴', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (7479, '2040-06-22', '星期五', 2040, '五月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7480, '2040-06-23', '星期六', 2040, '五月', '十四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7481, '2040-06-24', '星期日', 2040, '五月', '十五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7482, '2040-06-25', '星期一', 2040, '五月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7483, '2040-06-26', '星期二', 2040, '五月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7484, '2040-06-27', '星期三', 2040, '五月', '十八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7485, '2040-06-28', '星期四', 2040, '五月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7486, '2040-06-29', '星期五', 2040, '五月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7487, '2040-06-30', '星期六', 2040, '五月', '廿一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7488, '2040-07-01', '星期日', 2040, '五月', '廿二', '庚申', '猴', NULL, 1, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7489, '2040-07-02', '星期一', 2040, '五月', '廿三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7490, '2040-07-03', '星期二', 2040, '五月', '廿四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7491, '2040-07-04', '星期三', 2040, '五月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7492, '2040-07-05', '星期四', 2040, '五月', '廿六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7493, '2040-07-06', '星期五', 2040, '五月', '廿七', '庚申', '猴', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (7494, '2040-07-07', '星期六', 2040, '五月', '廿八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7495, '2040-07-08', '星期日', 2040, '五月', '廿九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7496, '2040-07-09', '星期一', 2040, '六月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7497, '2040-07-10', '星期二', 2040, '六月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7498, '2040-07-11', '星期三', 2040, '六月', '初三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7499, '2040-07-12', '星期四', 2040, '六月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7500, '2040-07-13', '星期五', 2040, '六月', '初五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7501, '2040-07-14', '星期六', 2040, '六月', '初六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7502, '2040-07-15', '星期日', 2040, '六月', '初七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7503, '2040-07-16', '星期一', 2040, '六月', '初八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7504, '2040-07-17', '星期二', 2040, '六月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7505, '2040-07-18', '星期三', 2040, '六月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7506, '2040-07-19', '星期四', 2040, '六月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7507, '2040-07-20', '星期五', 2040, '六月', '十二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7508, '2040-07-21', '星期六', 2040, '六月', '十三', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7509, '2040-07-22', '星期日', 2040, '六月', '十四', '庚申', '猴', NULL, 1, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (7510, '2040-07-23', '星期一', 2040, '六月', '十五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7511, '2040-07-24', '星期二', 2040, '六月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7512, '2040-07-25', '星期三', 2040, '六月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7513, '2040-07-26', '星期四', 2040, '六月', '十八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7514, '2040-07-27', '星期五', 2040, '六月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7515, '2040-07-28', '星期六', 2040, '六月', '二十', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7516, '2040-07-29', '星期日', 2040, '六月', '廿一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7517, '2040-07-30', '星期一', 2040, '六月', '廿二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7518, '2040-07-31', '星期二', 2040, '六月', '廿三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7519, '2040-08-01', '星期三', 2040, '六月', '廿四', '庚申', '猴', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7520, '2040-08-02', '星期四', 2040, '六月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7521, '2040-08-03', '星期五', 2040, '六月', '廿六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7522, '2040-08-04', '星期六', 2040, '六月', '廿七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7523, '2040-08-05', '星期日', 2040, '六月', '廿八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7524, '2040-08-06', '星期一', 2040, '六月', '廿九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7525, '2040-08-07', '星期二', 2040, '六月', '三十', '庚申', '猴', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (7526, '2040-08-08', '星期三', 2040, '七月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7527, '2040-08-09', '星期四', 2040, '七月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7528, '2040-08-10', '星期五', 2040, '七月', '初三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7529, '2040-08-11', '星期六', 2040, '七月', '初四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7530, '2040-08-12', '星期日', 2040, '七月', '初五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7531, '2040-08-13', '星期一', 2040, '七月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7532, '2040-08-14', '星期二', 2040, '七月', '初七', '庚申', '猴', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7533, '2040-08-15', '星期三', 2040, '七月', '初八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7534, '2040-08-16', '星期四', 2040, '七月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7535, '2040-08-17', '星期五', 2040, '七月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7536, '2040-08-18', '星期六', 2040, '七月', '十一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7537, '2040-08-19', '星期日', 2040, '七月', '十二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7538, '2040-08-20', '星期一', 2040, '七月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7539, '2040-08-21', '星期二', 2040, '七月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7540, '2040-08-22', '星期三', 2040, '七月', '十五', '庚申', '猴', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (7541, '2040-08-23', '星期四', 2040, '七月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7542, '2040-08-24', '星期五', 2040, '七月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7543, '2040-08-25', '星期六', 2040, '七月', '十八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7544, '2040-08-26', '星期日', 2040, '七月', '十九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7545, '2040-08-27', '星期一', 2040, '七月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7546, '2040-08-28', '星期二', 2040, '七月', '廿一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7547, '2040-08-29', '星期三', 2040, '七月', '廿二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7548, '2040-08-30', '星期四', 2040, '七月', '廿三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7549, '2040-08-31', '星期五', 2040, '七月', '廿四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7550, '2040-09-01', '星期六', 2040, '七月', '廿五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7551, '2040-09-02', '星期日', 2040, '七月', '廿六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7552, '2040-09-03', '星期一', 2040, '七月', '廿七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7553, '2040-09-04', '星期二', 2040, '七月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7554, '2040-09-05', '星期三', 2040, '七月', '廿九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7555, '2040-09-06', '星期四', 2040, '八月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7556, '2040-09-07', '星期五', 2040, '八月', '初二', '庚申', '猴', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (7557, '2040-09-08', '星期六', 2040, '八月', '初三', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7558, '2040-09-09', '星期日', 2040, '八月', '初四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7559, '2040-09-10', '星期一', 2040, '八月', '初五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7560, '2040-09-11', '星期二', 2040, '八月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7561, '2040-09-12', '星期三', 2040, '八月', '初七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7562, '2040-09-13', '星期四', 2040, '八月', '初八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7563, '2040-09-14', '星期五', 2040, '八月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7564, '2040-09-15', '星期六', 2040, '八月', '初十 ', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7565, '2040-09-16', '星期日', 2040, '八月', '十一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7566, '2040-09-17', '星期一', 2040, '八月', '十二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7567, '2040-09-18', '星期二', 2040, '八月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7568, '2040-09-19', '星期三', 2040, '八月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7569, '2040-09-20', '星期四', 2040, '八月', '十五', '庚申', '猴', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7570, '2040-09-21', '星期五', 2040, '八月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7571, '2040-09-22', '星期六', 2040, '八月', '十七', '庚申', '猴', NULL, 1, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (7572, '2040-09-23', '星期日', 2040, '八月', '十八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7573, '2040-09-24', '星期一', 2040, '八月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7574, '2040-09-25', '星期二', 2040, '八月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7575, '2040-09-26', '星期三', 2040, '八月', '廿一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7576, '2040-09-27', '星期四', 2040, '八月', '廿二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7577, '2040-09-28', '星期五', 2040, '八月', '廿三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7578, '2040-09-29', '星期六', 2040, '八月', '廿四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7579, '2040-09-30', '星期日', 2040, '八月', '廿五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7580, '2040-10-01', '星期一', 2040, '八月', '廿六', '庚申', '猴', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7581, '2040-10-02', '星期二', 2040, '八月', '廿七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7582, '2040-10-03', '星期三', 2040, '八月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7583, '2040-10-04', '星期四', 2040, '八月', '廿九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7584, '2040-10-05', '星期五', 2040, '八月', '三十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7585, '2040-10-06', '星期六', 2040, '九月', '初一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7586, '2040-10-07', '星期日', 2040, '九月', '初二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7587, '2040-10-08', '星期一', 2040, '九月', '初三', '庚申', '猴', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (7588, '2040-10-09', '星期二', 2040, '九月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7589, '2040-10-10', '星期三', 2040, '九月', '初五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7590, '2040-10-11', '星期四', 2040, '九月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7591, '2040-10-12', '星期五', 2040, '九月', '初七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7592, '2040-10-13', '星期六', 2040, '九月', '初八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7593, '2040-10-14', '星期日', 2040, '九月', '初九', '庚申', '猴', NULL, 1, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7594, '2040-10-15', '星期一', 2040, '九月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7595, '2040-10-16', '星期二', 2040, '九月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7596, '2040-10-17', '星期三', 2040, '九月', '十二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7597, '2040-10-18', '星期四', 2040, '九月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7598, '2040-10-19', '星期五', 2040, '九月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7599, '2040-10-20', '星期六', 2040, '九月', '十五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7600, '2040-10-21', '星期日', 2040, '九月', '十六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7601, '2040-10-22', '星期一', 2040, '九月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7602, '2040-10-23', '星期二', 2040, '九月', '十八', '庚申', '猴', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (7603, '2040-10-24', '星期三', 2040, '九月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7604, '2040-10-25', '星期四', 2040, '九月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7605, '2040-10-26', '星期五', 2040, '九月', '廿一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7606, '2040-10-27', '星期六', 2040, '九月', '廿二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7607, '2040-10-28', '星期日', 2040, '九月', '廿三', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7608, '2040-10-29', '星期一', 2040, '九月', '廿四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7609, '2040-10-30', '星期二', 2040, '九月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7610, '2040-10-31', '星期三', 2040, '九月', '廿六', '庚申', '猴', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7611, '2040-11-01', '星期四', 2040, '九月', '廿七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7612, '2040-11-02', '星期五', 2040, '九月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7613, '2040-11-03', '星期六', 2040, '九月', '廿九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7614, '2040-11-04', '星期日', 2040, '九月', '三十', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7615, '2040-11-05', '星期一', 2040, '十月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7616, '2040-11-06', '星期二', 2040, '十月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7617, '2040-11-07', '星期三', 2040, '十月', '初三', '庚申', '猴', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (7618, '2040-11-08', '星期四', 2040, '十月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7619, '2040-11-09', '星期五', 2040, '十月', '初五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7620, '2040-11-10', '星期六', 2040, '十月', '初六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7621, '2040-11-11', '星期日', 2040, '十月', '初七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7622, '2040-11-12', '星期一', 2040, '十月', '初八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7623, '2040-11-13', '星期二', 2040, '十月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7624, '2040-11-14', '星期三', 2040, '十月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7625, '2040-11-15', '星期四', 2040, '十月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7626, '2040-11-16', '星期五', 2040, '十月', '十二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7627, '2040-11-17', '星期六', 2040, '十月', '十三', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7628, '2040-11-18', '星期日', 2040, '十月', '十四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7629, '2040-11-19', '星期一', 2040, '十月', '十五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7630, '2040-11-20', '星期二', 2040, '十月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7631, '2040-11-21', '星期三', 2040, '十月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7632, '2040-11-22', '星期四', 2040, '十月', '十八', '庚申', '猴', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (7633, '2040-11-23', '星期五', 2040, '十月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7634, '2040-11-24', '星期六', 2040, '十月', '二十', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7635, '2040-11-25', '星期日', 2040, '十月', '廿一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7636, '2040-11-26', '星期一', 2040, '十月', '廿二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7637, '2040-11-27', '星期二', 2040, '十月', '廿三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7638, '2040-11-28', '星期三', 2040, '十月', '廿四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7639, '2040-11-29', '星期四', 2040, '十月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7640, '2040-11-30', '星期五', 2040, '十月', '廿六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7641, '2040-12-01', '星期六', 2040, '十月', '廿七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7642, '2040-12-02', '星期日', 2040, '十月', '廿八', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7643, '2040-12-03', '星期一', 2040, '十月', '廿九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7644, '2040-12-04', '星期二', 2040, '冬月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7645, '2040-12-05', '星期三', 2040, '冬月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7646, '2040-12-06', '星期四', 2040, '冬月', '初三', '庚申', '猴', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (7647, '2040-12-07', '星期五', 2040, '冬月', '初四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7648, '2040-12-08', '星期六', 2040, '冬月', '初五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7649, '2040-12-09', '星期日', 2040, '冬月', '初六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7650, '2040-12-10', '星期一', 2040, '冬月', '初七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7651, '2040-12-11', '星期二', 2040, '冬月', '初八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7652, '2040-12-12', '星期三', 2040, '冬月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7653, '2040-12-13', '星期四', 2040, '冬月', '初十 ', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7654, '2040-12-14', '星期五', 2040, '冬月', '十一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7655, '2040-12-15', '星期六', 2040, '冬月', '十二', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7656, '2040-12-16', '星期日', 2040, '冬月', '十三', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7657, '2040-12-17', '星期一', 2040, '冬月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7658, '2040-12-18', '星期二', 2040, '冬月', '十五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7659, '2040-12-19', '星期三', 2040, '冬月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7660, '2040-12-20', '星期四', 2040, '冬月', '十七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7661, '2040-12-21', '星期五', 2040, '冬月', '十八', '庚申', '猴', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (7662, '2040-12-22', '星期六', 2040, '冬月', '十九', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7663, '2040-12-23', '星期日', 2040, '冬月', '二十', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7664, '2040-12-24', '星期一', 2040, '冬月', '廿一', '庚申', '猴', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7665, '2040-12-25', '星期二', 2040, '冬月', '廿二', '庚申', '猴', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7666, '2040-12-26', '星期三', 2040, '冬月', '廿三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7667, '2040-12-27', '星期四', 2040, '冬月', '廿四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7668, '2040-12-28', '星期五', 2040, '冬月', '廿五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7669, '2040-12-29', '星期六', 2040, '冬月', '廿六', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7670, '2040-12-30', '星期日', 2040, '冬月', '廿七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7671, '2040-12-31', '星期一', 2040, '冬月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7672, '2041-01-01', '星期二', 2040, '冬月', '廿九', '庚申', '猴', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7673, '2041-01-02', '星期三', 2040, '冬月', '三十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7674, '2041-01-03', '星期四', 2040, '腊月', '初一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7675, '2041-01-04', '星期五', 2040, '腊月', '初二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7676, '2041-01-05', '星期六', 2040, '腊月', '初三', '庚申', '猴', NULL, 1, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (7677, '2041-01-06', '星期日', 2040, '腊月', '初四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7678, '2041-01-07', '星期一', 2040, '腊月', '初五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7679, '2041-01-08', '星期二', 2040, '腊月', '初六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7680, '2041-01-09', '星期三', 2040, '腊月', '初七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7681, '2041-01-10', '星期四', 2040, '腊月', '初八', '庚申', '猴', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7682, '2041-01-11', '星期五', 2040, '腊月', '初九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7683, '2041-01-12', '星期六', 2040, '腊月', '初十 ', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7684, '2041-01-13', '星期日', 2040, '腊月', '十一', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7685, '2041-01-14', '星期一', 2040, '腊月', '十二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7686, '2041-01-15', '星期二', 2040, '腊月', '十三', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7687, '2041-01-16', '星期三', 2040, '腊月', '十四', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7688, '2041-01-17', '星期四', 2040, '腊月', '十五', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7689, '2041-01-18', '星期五', 2040, '腊月', '十六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7690, '2041-01-19', '星期六', 2040, '腊月', '十七', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7691, '2041-01-20', '星期日', 2040, '腊月', '十八', '庚申', '猴', NULL, 1, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (7692, '2041-01-21', '星期一', 2040, '腊月', '十九', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7693, '2041-01-22', '星期二', 2040, '腊月', '二十', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7694, '2041-01-23', '星期三', 2040, '腊月', '廿一', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7695, '2041-01-24', '星期四', 2040, '腊月', '廿二', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7696, '2041-01-25', '星期五', 2040, '腊月', '廿三', '庚申', '猴', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7697, '2041-01-26', '星期六', 2040, '腊月', '廿四', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7698, '2041-01-27', '星期日', 2040, '腊月', '廿五', '庚申', '猴', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7699, '2041-01-28', '星期一', 2040, '腊月', '廿六', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7700, '2041-01-29', '星期二', 2040, '腊月', '廿七', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7701, '2041-01-30', '星期三', 2040, '腊月', '廿八', '庚申', '猴', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7702, '2041-01-31', '星期四', 2040, '腊月', '廿九', '庚申', '猴', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7703, '2041-02-01', '星期五', 2041, '正月', '初一', '辛酉', '鸡', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7704, '2041-02-02', '星期六', 2041, '正月', '初二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7705, '2041-02-03', '星期日', 2041, '正月', '初三', '辛酉', '鸡', NULL, 1, '', '', '立春', '', 0);
INSERT INTO `base_data_holiday` VALUES (7706, '2041-02-04', '星期一', 2041, '正月', '初四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7707, '2041-02-05', '星期二', 2041, '正月', '初五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7708, '2041-02-06', '星期三', 2041, '正月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7709, '2041-02-07', '星期四', 2041, '正月', '初七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7710, '2041-02-08', '星期五', 2041, '正月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7711, '2041-02-09', '星期六', 2041, '正月', '初九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7712, '2041-02-10', '星期日', 2041, '正月', '初十 ', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7713, '2041-02-11', '星期一', 2041, '正月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7714, '2041-02-12', '星期二', 2041, '正月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7715, '2041-02-13', '星期三', 2041, '正月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7716, '2041-02-14', '星期四', 2041, '正月', '十四', '辛酉', '鸡', NULL, 0, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7717, '2041-02-15', '星期五', 2041, '正月', '十五', '辛酉', '鸡', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7718, '2041-02-16', '星期六', 2041, '正月', '十六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7719, '2041-02-17', '星期日', 2041, '正月', '十七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7720, '2041-02-18', '星期一', 2041, '正月', '十八', '辛酉', '鸡', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (7721, '2041-02-19', '星期二', 2041, '正月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7722, '2041-02-20', '星期三', 2041, '正月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7723, '2041-02-21', '星期四', 2041, '正月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7724, '2041-02-22', '星期五', 2041, '正月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7725, '2041-02-23', '星期六', 2041, '正月', '廿三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7726, '2041-02-24', '星期日', 2041, '正月', '廿四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7727, '2041-02-25', '星期一', 2041, '正月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7728, '2041-02-26', '星期二', 2041, '正月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7729, '2041-02-27', '星期三', 2041, '正月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7730, '2041-02-28', '星期四', 2041, '正月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7731, '2041-03-01', '星期五', 2041, '正月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7732, '2041-03-02', '星期六', 2041, '二月', '初一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7733, '2041-03-03', '星期日', 2041, '二月', '初二', '辛酉', '鸡', NULL, 1, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7734, '2041-03-04', '星期一', 2041, '二月', '初三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7735, '2041-03-05', '星期二', 2041, '二月', '初四', '辛酉', '鸡', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (7736, '2041-03-06', '星期三', 2041, '二月', '初五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7737, '2041-03-07', '星期四', 2041, '二月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7738, '2041-03-08', '星期五', 2041, '二月', '初七', '辛酉', '鸡', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7739, '2041-03-09', '星期六', 2041, '二月', '初八', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7740, '2041-03-10', '星期日', 2041, '二月', '初九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7741, '2041-03-11', '星期一', 2041, '二月', '初十 ', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7742, '2041-03-12', '星期二', 2041, '二月', '十一', '辛酉', '鸡', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7743, '2041-03-13', '星期三', 2041, '二月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7744, '2041-03-14', '星期四', 2041, '二月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7745, '2041-03-15', '星期五', 2041, '二月', '十四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7746, '2041-03-16', '星期六', 2041, '二月', '十五', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7747, '2041-03-17', '星期日', 2041, '二月', '十六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7748, '2041-03-18', '星期一', 2041, '二月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7749, '2041-03-19', '星期二', 2041, '二月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7750, '2041-03-20', '星期三', 2041, '二月', '十九', '辛酉', '鸡', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (7751, '2041-03-21', '星期四', 2041, '二月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7752, '2041-03-22', '星期五', 2041, '二月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7753, '2041-03-23', '星期六', 2041, '二月', '廿二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7754, '2041-03-24', '星期日', 2041, '二月', '廿三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7755, '2041-03-25', '星期一', 2041, '二月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7756, '2041-03-26', '星期二', 2041, '二月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7757, '2041-03-27', '星期三', 2041, '二月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7758, '2041-03-28', '星期四', 2041, '二月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7759, '2041-03-29', '星期五', 2041, '二月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7760, '2041-03-30', '星期六', 2041, '二月', '廿九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7761, '2041-03-31', '星期日', 2041, '二月', '三十', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7762, '2041-04-01', '星期一', 2041, '三月', '初一', '辛酉', '鸡', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7763, '2041-04-02', '星期二', 2041, '三月', '初二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7764, '2041-04-03', '星期三', 2041, '三月', '初三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7765, '2041-04-04', '星期四', 2041, '三月', '初四', '辛酉', '鸡', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (7766, '2041-04-05', '星期五', 2041, '三月', '初五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7767, '2041-04-06', '星期六', 2041, '三月', '初六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7768, '2041-04-07', '星期日', 2041, '三月', '初七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7769, '2041-04-08', '星期一', 2041, '三月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7770, '2041-04-09', '星期二', 2041, '三月', '初九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7771, '2041-04-10', '星期三', 2041, '三月', '初十 ', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7772, '2041-04-11', '星期四', 2041, '三月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7773, '2041-04-12', '星期五', 2041, '三月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7774, '2041-04-13', '星期六', 2041, '三月', '十三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7775, '2041-04-14', '星期日', 2041, '三月', '十四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7776, '2041-04-15', '星期一', 2041, '三月', '十五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7777, '2041-04-16', '星期二', 2041, '三月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7778, '2041-04-17', '星期三', 2041, '三月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7779, '2041-04-18', '星期四', 2041, '三月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7780, '2041-04-19', '星期五', 2041, '三月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7781, '2041-04-20', '星期六', 2041, '三月', '二十', '辛酉', '鸡', NULL, 1, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (7782, '2041-04-21', '星期日', 2041, '三月', '廿一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7783, '2041-04-22', '星期一', 2041, '三月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7784, '2041-04-23', '星期二', 2041, '三月', '廿三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7785, '2041-04-24', '星期三', 2041, '三月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7786, '2041-04-25', '星期四', 2041, '三月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7787, '2041-04-26', '星期五', 2041, '三月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7788, '2041-04-27', '星期六', 2041, '三月', '廿七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7789, '2041-04-28', '星期日', 2041, '三月', '廿八', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7790, '2041-04-29', '星期一', 2041, '三月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7791, '2041-04-30', '星期二', 2041, '四月', '初一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7792, '2041-05-01', '星期三', 2041, '四月', '初二', '辛酉', '鸡', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7793, '2041-05-02', '星期四', 2041, '四月', '初三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7794, '2041-05-03', '星期五', 2041, '四月', '初四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7795, '2041-05-04', '星期六', 2041, '四月', '初五', '辛酉', '鸡', NULL, 1, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7796, '2041-05-05', '星期日', 2041, '四月', '初六', '辛酉', '鸡', NULL, 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (7797, '2041-05-06', '星期一', 2041, '四月', '初七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7798, '2041-05-07', '星期二', 2041, '四月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7799, '2041-05-08', '星期三', 2041, '四月', '初九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7800, '2041-05-09', '星期四', 2041, '四月', '初十 ', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7801, '2041-05-10', '星期五', 2041, '四月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7802, '2041-05-11', '星期六', 2041, '四月', '十二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7803, '2041-05-12', '星期日', 2041, '四月', '十三', '辛酉', '鸡', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (7804, '2041-05-13', '星期一', 2041, '四月', '十四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7805, '2041-05-14', '星期二', 2041, '四月', '十五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7806, '2041-05-15', '星期三', 2041, '四月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7807, '2041-05-16', '星期四', 2041, '四月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7808, '2041-05-17', '星期五', 2041, '四月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7809, '2041-05-18', '星期六', 2041, '四月', '十九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7810, '2041-05-19', '星期日', 2041, '四月', '二十', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7811, '2041-05-20', '星期一', 2041, '四月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (7812, '2041-05-21', '星期二', 2041, '四月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7813, '2041-05-22', '星期三', 2041, '四月', '廿三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7814, '2041-05-23', '星期四', 2041, '四月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7815, '2041-05-24', '星期五', 2041, '四月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7816, '2041-05-25', '星期六', 2041, '四月', '廿六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7817, '2041-05-26', '星期日', 2041, '四月', '廿七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7818, '2041-05-27', '星期一', 2041, '四月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7819, '2041-05-28', '星期二', 2041, '四月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7820, '2041-05-29', '星期三', 2041, '四月', '三十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7821, '2041-05-30', '星期四', 2041, '五月', '初一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7822, '2041-05-31', '星期五', 2041, '五月', '初二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7823, '2041-06-01', '星期六', 2041, '五月', '初三', '辛酉', '鸡', NULL, 1, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7824, '2041-06-02', '星期日', 2041, '五月', '初四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7825, '2041-06-03', '星期一', 2041, '五月', '初五', '辛酉', '鸡', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7826, '2041-06-04', '星期二', 2041, '五月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7827, '2041-06-05', '星期三', 2041, '五月', '初七', '辛酉', '鸡', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (7828, '2041-06-06', '星期四', 2041, '五月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7829, '2041-06-07', '星期五', 2041, '五月', '初九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7830, '2041-06-08', '星期六', 2041, '五月', '初十 ', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7831, '2041-06-09', '星期日', 2041, '五月', '十一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7832, '2041-06-10', '星期一', 2041, '五月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7833, '2041-06-11', '星期二', 2041, '五月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7834, '2041-06-12', '星期三', 2041, '五月', '十四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7835, '2041-06-13', '星期四', 2041, '五月', '十五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7836, '2041-06-14', '星期五', 2041, '五月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7837, '2041-06-15', '星期六', 2041, '五月', '十七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7838, '2041-06-16', '星期日', 2041, '五月', '十八', '辛酉', '鸡', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (7839, '2041-06-17', '星期一', 2041, '五月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7840, '2041-06-18', '星期二', 2041, '五月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7841, '2041-06-19', '星期三', 2041, '五月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7842, '2041-06-20', '星期四', 2041, '五月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7843, '2041-06-21', '星期五', 2041, '五月', '廿三', '辛酉', '鸡', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (7844, '2041-06-22', '星期六', 2041, '五月', '廿四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7845, '2041-06-23', '星期日', 2041, '五月', '廿五', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7846, '2041-06-24', '星期一', 2041, '五月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7847, '2041-06-25', '星期二', 2041, '五月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7848, '2041-06-26', '星期三', 2041, '五月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7849, '2041-06-27', '星期四', 2041, '五月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7850, '2041-06-28', '星期五', 2041, '六月', '初一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7851, '2041-06-29', '星期六', 2041, '六月', '初二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7852, '2041-06-30', '星期日', 2041, '六月', '初三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7853, '2041-07-01', '星期一', 2041, '六月', '初四', '辛酉', '鸡', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7854, '2041-07-02', '星期二', 2041, '六月', '初五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7855, '2041-07-03', '星期三', 2041, '六月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7856, '2041-07-04', '星期四', 2041, '六月', '初七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7857, '2041-07-05', '星期五', 2041, '六月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7858, '2041-07-06', '星期六', 2041, '六月', '初九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7859, '2041-07-07', '星期日', 2041, '六月', '初十 ', '辛酉', '鸡', NULL, 1, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (7860, '2041-07-08', '星期一', 2041, '六月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7861, '2041-07-09', '星期二', 2041, '六月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7862, '2041-07-10', '星期三', 2041, '六月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7863, '2041-07-11', '星期四', 2041, '六月', '十四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7864, '2041-07-12', '星期五', 2041, '六月', '十五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7865, '2041-07-13', '星期六', 2041, '六月', '十六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7866, '2041-07-14', '星期日', 2041, '六月', '十七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7867, '2041-07-15', '星期一', 2041, '六月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7868, '2041-07-16', '星期二', 2041, '六月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7869, '2041-07-17', '星期三', 2041, '六月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7870, '2041-07-18', '星期四', 2041, '六月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7871, '2041-07-19', '星期五', 2041, '六月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7872, '2041-07-20', '星期六', 2041, '六月', '廿三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7873, '2041-07-21', '星期日', 2041, '六月', '廿四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7874, '2041-07-22', '星期一', 2041, '六月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (7875, '2041-07-23', '星期二', 2041, '六月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7876, '2041-07-24', '星期三', 2041, '六月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7877, '2041-07-25', '星期四', 2041, '六月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7878, '2041-07-26', '星期五', 2041, '六月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7879, '2041-07-27', '星期六', 2041, '六月', '三十', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7880, '2041-07-28', '星期日', 2041, '七月', '初一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7881, '2041-07-29', '星期一', 2041, '七月', '初二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7882, '2041-07-30', '星期二', 2041, '七月', '初三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7883, '2041-07-31', '星期三', 2041, '七月', '初四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7884, '2041-08-01', '星期四', 2041, '七月', '初五', '辛酉', '鸡', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7885, '2041-08-02', '星期五', 2041, '七月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7886, '2041-08-03', '星期六', 2041, '七月', '初七', '辛酉', '鸡', NULL, 1, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7887, '2041-08-04', '星期日', 2041, '七月', '初八', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7888, '2041-08-05', '星期一', 2041, '七月', '初九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7889, '2041-08-06', '星期二', 2041, '七月', '初十 ', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7890, '2041-08-07', '星期三', 2041, '七月', '十一', '辛酉', '鸡', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (7891, '2041-08-08', '星期四', 2041, '七月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7892, '2041-08-09', '星期五', 2041, '七月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7893, '2041-08-10', '星期六', 2041, '七月', '十四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7894, '2041-08-11', '星期日', 2041, '七月', '十五', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7895, '2041-08-12', '星期一', 2041, '七月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7896, '2041-08-13', '星期二', 2041, '七月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7897, '2041-08-14', '星期三', 2041, '七月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7898, '2041-08-15', '星期四', 2041, '七月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7899, '2041-08-16', '星期五', 2041, '七月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7900, '2041-08-17', '星期六', 2041, '七月', '廿一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7901, '2041-08-18', '星期日', 2041, '七月', '廿二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7902, '2041-08-19', '星期一', 2041, '七月', '廿三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7903, '2041-08-20', '星期二', 2041, '七月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7904, '2041-08-21', '星期三', 2041, '七月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7905, '2041-08-22', '星期四', 2041, '七月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7906, '2041-08-23', '星期五', 2041, '七月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (7907, '2041-08-24', '星期六', 2041, '七月', '廿八', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7908, '2041-08-25', '星期日', 2041, '七月', '廿九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7909, '2041-08-26', '星期一', 2041, '七月', '三十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7910, '2041-08-27', '星期二', 2041, '八月', '初一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7911, '2041-08-28', '星期三', 2041, '八月', '初二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7912, '2041-08-29', '星期四', 2041, '八月', '初三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7913, '2041-08-30', '星期五', 2041, '八月', '初四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7914, '2041-08-31', '星期六', 2041, '八月', '初五', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7915, '2041-09-01', '星期日', 2041, '八月', '初六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7916, '2041-09-02', '星期一', 2041, '八月', '初七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7917, '2041-09-03', '星期二', 2041, '八月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7918, '2041-09-04', '星期三', 2041, '八月', '初九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7919, '2041-09-05', '星期四', 2041, '八月', '初十 ', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7920, '2041-09-06', '星期五', 2041, '八月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7921, '2041-09-07', '星期六', 2041, '八月', '十二', '辛酉', '鸡', NULL, 1, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (7922, '2041-09-08', '星期日', 2041, '八月', '十三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7923, '2041-09-09', '星期一', 2041, '八月', '十四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7924, '2041-09-10', '星期二', 2041, '八月', '十五', '辛酉', '鸡', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7925, '2041-09-11', '星期三', 2041, '八月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7926, '2041-09-12', '星期四', 2041, '八月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7927, '2041-09-13', '星期五', 2041, '八月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7928, '2041-09-14', '星期六', 2041, '八月', '十九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7929, '2041-09-15', '星期日', 2041, '八月', '二十', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7930, '2041-09-16', '星期一', 2041, '八月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7931, '2041-09-17', '星期二', 2041, '八月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7932, '2041-09-18', '星期三', 2041, '八月', '廿三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7933, '2041-09-19', '星期四', 2041, '八月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7934, '2041-09-20', '星期五', 2041, '八月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7935, '2041-09-21', '星期六', 2041, '八月', '廿六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7936, '2041-09-22', '星期日', 2041, '八月', '廿七', '辛酉', '鸡', NULL, 1, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (7937, '2041-09-23', '星期一', 2041, '八月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7938, '2041-09-24', '星期二', 2041, '八月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7939, '2041-09-25', '星期三', 2041, '九月', '初一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7940, '2041-09-26', '星期四', 2041, '九月', '初二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7941, '2041-09-27', '星期五', 2041, '九月', '初三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7942, '2041-09-28', '星期六', 2041, '九月', '初四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7943, '2041-09-29', '星期日', 2041, '九月', '初五', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7944, '2041-09-30', '星期一', 2041, '九月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7945, '2041-10-01', '星期二', 2041, '九月', '初七', '辛酉', '鸡', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7946, '2041-10-02', '星期三', 2041, '九月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7947, '2041-10-03', '星期四', 2041, '九月', '初九', '辛酉', '鸡', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7948, '2041-10-04', '星期五', 2041, '九月', '初十 ', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7949, '2041-10-05', '星期六', 2041, '九月', '十一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7950, '2041-10-06', '星期日', 2041, '九月', '十二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7951, '2041-10-07', '星期一', 2041, '九月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7952, '2041-10-08', '星期二', 2041, '九月', '十四', '辛酉', '鸡', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (7953, '2041-10-09', '星期三', 2041, '九月', '十五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7954, '2041-10-10', '星期四', 2041, '九月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7955, '2041-10-11', '星期五', 2041, '九月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7956, '2041-10-12', '星期六', 2041, '九月', '十八', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7957, '2041-10-13', '星期日', 2041, '九月', '十九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7958, '2041-10-14', '星期一', 2041, '九月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7959, '2041-10-15', '星期二', 2041, '九月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7960, '2041-10-16', '星期三', 2041, '九月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7961, '2041-10-17', '星期四', 2041, '九月', '廿三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7962, '2041-10-18', '星期五', 2041, '九月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7963, '2041-10-19', '星期六', 2041, '九月', '廿五', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7964, '2041-10-20', '星期日', 2041, '九月', '廿六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7965, '2041-10-21', '星期一', 2041, '九月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7966, '2041-10-22', '星期二', 2041, '九月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7967, '2041-10-23', '星期三', 2041, '九月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (7968, '2041-10-24', '星期四', 2041, '九月', '三十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7969, '2041-10-25', '星期五', 2041, '十月', '初一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7970, '2041-10-26', '星期六', 2041, '十月', '初二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7971, '2041-10-27', '星期日', 2041, '十月', '初三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7972, '2041-10-28', '星期一', 2041, '十月', '初四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7973, '2041-10-29', '星期二', 2041, '十月', '初五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7974, '2041-10-30', '星期三', 2041, '十月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7975, '2041-10-31', '星期四', 2041, '十月', '初七', '辛酉', '鸡', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7976, '2041-11-01', '星期五', 2041, '十月', '初八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7977, '2041-11-02', '星期六', 2041, '十月', '初九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7978, '2041-11-03', '星期日', 2041, '十月', '初十 ', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7979, '2041-11-04', '星期一', 2041, '十月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7980, '2041-11-05', '星期二', 2041, '十月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7981, '2041-11-06', '星期三', 2041, '十月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7982, '2041-11-07', '星期四', 2041, '十月', '十四', '辛酉', '鸡', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (7983, '2041-11-08', '星期五', 2041, '十月', '十五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7984, '2041-11-09', '星期六', 2041, '十月', '十六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7985, '2041-11-10', '星期日', 2041, '十月', '十七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7986, '2041-11-11', '星期一', 2041, '十月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7987, '2041-11-12', '星期二', 2041, '十月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7988, '2041-11-13', '星期三', 2041, '十月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7989, '2041-11-14', '星期四', 2041, '十月', '廿一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7990, '2041-11-15', '星期五', 2041, '十月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7991, '2041-11-16', '星期六', 2041, '十月', '廿三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7992, '2041-11-17', '星期日', 2041, '十月', '廿四', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7993, '2041-11-18', '星期一', 2041, '十月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7994, '2041-11-19', '星期二', 2041, '十月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7995, '2041-11-20', '星期三', 2041, '十月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7996, '2041-11-21', '星期四', 2041, '十月', '廿八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7997, '2041-11-22', '星期五', 2041, '十月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (7998, '2041-11-23', '星期六', 2041, '十月', '三十', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (7999, '2041-11-24', '星期日', 2041, '冬月', '初一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8000, '2041-11-25', '星期一', 2041, '冬月', '初二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8001, '2041-11-26', '星期二', 2041, '冬月', '初三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8002, '2041-11-27', '星期三', 2041, '冬月', '初四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8003, '2041-11-28', '星期四', 2041, '冬月', '初五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8004, '2041-11-29', '星期五', 2041, '冬月', '初六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8005, '2041-11-30', '星期六', 2041, '冬月', '初七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8006, '2041-12-01', '星期日', 2041, '冬月', '初八', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8007, '2041-12-02', '星期一', 2041, '冬月', '初九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8008, '2041-12-03', '星期二', 2041, '冬月', '初十 ', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8009, '2041-12-04', '星期三', 2041, '冬月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8010, '2041-12-05', '星期四', 2041, '冬月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8011, '2041-12-06', '星期五', 2041, '冬月', '十三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8012, '2041-12-07', '星期六', 2041, '冬月', '十四', '辛酉', '鸡', NULL, 1, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (8013, '2041-12-08', '星期日', 2041, '冬月', '十五', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8014, '2041-12-09', '星期一', 2041, '冬月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8015, '2041-12-10', '星期二', 2041, '冬月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8016, '2041-12-11', '星期三', 2041, '冬月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8017, '2041-12-12', '星期四', 2041, '冬月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8018, '2041-12-13', '星期五', 2041, '冬月', '二十', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8019, '2041-12-14', '星期六', 2041, '冬月', '廿一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8020, '2041-12-15', '星期日', 2041, '冬月', '廿二', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8021, '2041-12-16', '星期一', 2041, '冬月', '廿三', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8022, '2041-12-17', '星期二', 2041, '冬月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8023, '2041-12-18', '星期三', 2041, '冬月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8024, '2041-12-19', '星期四', 2041, '冬月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8025, '2041-12-20', '星期五', 2041, '冬月', '廿七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8026, '2041-12-21', '星期六', 2041, '冬月', '廿八', '辛酉', '鸡', NULL, 1, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (8027, '2041-12-22', '星期日', 2041, '冬月', '廿九', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8028, '2041-12-23', '星期一', 2041, '腊月', '初一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8029, '2041-12-24', '星期二', 2041, '腊月', '初二', '辛酉', '鸡', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8030, '2041-12-25', '星期三', 2041, '腊月', '初三', '辛酉', '鸡', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8031, '2041-12-26', '星期四', 2041, '腊月', '初四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8032, '2041-12-27', '星期五', 2041, '腊月', '初五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8033, '2041-12-28', '星期六', 2041, '腊月', '初六', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8034, '2041-12-29', '星期日', 2041, '腊月', '初七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8035, '2041-12-30', '星期一', 2041, '腊月', '初八', '辛酉', '鸡', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8036, '2041-12-31', '星期二', 2041, '腊月', '初九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8037, '2042-01-01', '星期三', 2041, '腊月', '初十 ', '辛酉', '鸡', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8038, '2042-01-02', '星期四', 2041, '腊月', '十一', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8039, '2042-01-03', '星期五', 2041, '腊月', '十二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8040, '2042-01-04', '星期六', 2041, '腊月', '十三', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8041, '2042-01-05', '星期日', 2041, '腊月', '十四', '辛酉', '鸡', NULL, 1, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (8042, '2042-01-06', '星期一', 2041, '腊月', '十五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8043, '2042-01-07', '星期二', 2041, '腊月', '十六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8044, '2042-01-08', '星期三', 2041, '腊月', '十七', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8045, '2042-01-09', '星期四', 2041, '腊月', '十八', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8046, '2042-01-10', '星期五', 2041, '腊月', '十九', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8047, '2042-01-11', '星期六', 2041, '腊月', '二十', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8048, '2042-01-12', '星期日', 2041, '腊月', '廿一', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8049, '2042-01-13', '星期一', 2041, '腊月', '廿二', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8050, '2042-01-14', '星期二', 2041, '腊月', '廿三', '辛酉', '鸡', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8051, '2042-01-15', '星期三', 2041, '腊月', '廿四', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8052, '2042-01-16', '星期四', 2041, '腊月', '廿五', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8053, '2042-01-17', '星期五', 2041, '腊月', '廿六', '辛酉', '鸡', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8054, '2042-01-18', '星期六', 2041, '腊月', '廿七', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8055, '2042-01-19', '星期日', 2041, '腊月', '廿八', '辛酉', '鸡', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8056, '2042-01-20', '星期一', 2041, '腊月', '廿九', '辛酉', '鸡', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (8057, '2042-01-21', '星期二', 2041, '腊月', '三十', '辛酉', '鸡', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8058, '2042-01-22', '星期三', 2042, '正月', '初一', '壬戌', '狗', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8059, '2042-01-23', '星期四', 2042, '正月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8060, '2042-01-24', '星期五', 2042, '正月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8061, '2042-01-25', '星期六', 2042, '正月', '初四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8062, '2042-01-26', '星期日', 2042, '正月', '初五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8063, '2042-01-27', '星期一', 2042, '正月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8064, '2042-01-28', '星期二', 2042, '正月', '初七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8065, '2042-01-29', '星期三', 2042, '正月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8066, '2042-01-30', '星期四', 2042, '正月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8067, '2042-01-31', '星期五', 2042, '正月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8068, '2042-02-01', '星期六', 2042, '正月', '十一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8069, '2042-02-02', '星期日', 2042, '正月', '十二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8070, '2042-02-03', '星期一', 2042, '正月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8071, '2042-02-04', '星期二', 2042, '正月', '十四', '壬戌', '狗', NULL, 0, '', '', '立春', '', 2);
INSERT INTO `base_data_holiday` VALUES (8072, '2042-02-05', '星期三', 2042, '正月', '十五', '壬戌', '狗', NULL, 0, '', '元宵节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8073, '2042-02-06', '星期四', 2042, '正月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8074, '2042-02-07', '星期五', 2042, '正月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8075, '2042-02-08', '星期六', 2042, '正月', '十八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8076, '2042-02-09', '星期日', 2042, '正月', '十九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8077, '2042-02-10', '星期一', 2042, '正月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8078, '2042-02-11', '星期二', 2042, '正月', '廿一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8079, '2042-02-12', '星期三', 2042, '正月', '廿二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8080, '2042-02-13', '星期四', 2042, '正月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8081, '2042-02-14', '星期五', 2042, '正月', '廿四', '壬戌', '狗', NULL, 0, '情人节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8082, '2042-02-15', '星期六', 2042, '正月', '廿五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8083, '2042-02-16', '星期日', 2042, '正月', '廿六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8084, '2042-02-17', '星期一', 2042, '正月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8085, '2042-02-18', '星期二', 2042, '正月', '廿八', '壬戌', '狗', NULL, 0, '', '', '雨水', '', 2);
INSERT INTO `base_data_holiday` VALUES (8086, '2042-02-19', '星期三', 2042, '正月', '廿九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8087, '2042-02-20', '星期四', 2042, '二月', '初一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8088, '2042-02-21', '星期五', 2042, '二月', '初二', '壬戌', '狗', NULL, 0, '', '龙抬头', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8089, '2042-02-22', '星期六', 2042, '二月', '初三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8090, '2042-02-23', '星期日', 2042, '二月', '初四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8091, '2042-02-24', '星期一', 2042, '二月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8092, '2042-02-25', '星期二', 2042, '二月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8093, '2042-02-26', '星期三', 2042, '二月', '初七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8094, '2042-02-27', '星期四', 2042, '二月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8095, '2042-02-28', '星期五', 2042, '二月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8096, '2042-03-01', '星期六', 2042, '二月', '初十 ', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8097, '2042-03-02', '星期日', 2042, '二月', '十一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8098, '2042-03-03', '星期一', 2042, '二月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8099, '2042-03-04', '星期二', 2042, '二月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8100, '2042-03-05', '星期三', 2042, '二月', '十四', '壬戌', '狗', NULL, 0, '', '', '惊蛰', '', 2);
INSERT INTO `base_data_holiday` VALUES (8101, '2042-03-06', '星期四', 2042, '二月', '十五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8102, '2042-03-07', '星期五', 2042, '二月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8103, '2042-03-08', '星期六', 2042, '二月', '十七', '壬戌', '狗', NULL, 1, '妇女节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8104, '2042-03-09', '星期日', 2042, '二月', '十八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8105, '2042-03-10', '星期一', 2042, '二月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8106, '2042-03-11', '星期二', 2042, '二月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8107, '2042-03-12', '星期三', 2042, '二月', '廿一', '壬戌', '狗', NULL, 0, '植树节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8108, '2042-03-13', '星期四', 2042, '二月', '廿二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8109, '2042-03-14', '星期五', 2042, '二月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8110, '2042-03-15', '星期六', 2042, '二月', '廿四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8111, '2042-03-16', '星期日', 2042, '二月', '廿五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8112, '2042-03-17', '星期一', 2042, '二月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8113, '2042-03-18', '星期二', 2042, '二月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8114, '2042-03-19', '星期三', 2042, '二月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8115, '2042-03-20', '星期四', 2042, '二月', '廿九', '壬戌', '狗', NULL, 0, '', '', '春分', '', 2);
INSERT INTO `base_data_holiday` VALUES (8116, '2042-03-21', '星期五', 2042, '二月', '三十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8117, '2042-03-22', '星期六', 2042, '闰二月', '初一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8118, '2042-03-23', '星期日', 2042, '闰二月', '初二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8119, '2042-03-24', '星期一', 2042, '闰二月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8120, '2042-03-25', '星期二', 2042, '闰二月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8121, '2042-03-26', '星期三', 2042, '闰二月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8122, '2042-03-27', '星期四', 2042, '闰二月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8123, '2042-03-28', '星期五', 2042, '闰二月', '初七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8124, '2042-03-29', '星期六', 2042, '闰二月', '初八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8125, '2042-03-30', '星期日', 2042, '闰二月', '初九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8126, '2042-03-31', '星期一', 2042, '闰二月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8127, '2042-04-01', '星期二', 2042, '闰二月', '十一', '壬戌', '狗', NULL, 0, '愚人节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8128, '2042-04-02', '星期三', 2042, '闰二月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8129, '2042-04-03', '星期四', 2042, '闰二月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8130, '2042-04-04', '星期五', 2042, '闰二月', '十四', '壬戌', '狗', NULL, 0, '', '', '清明', '', 2);
INSERT INTO `base_data_holiday` VALUES (8131, '2042-04-05', '星期六', 2042, '闰二月', '十五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8132, '2042-04-06', '星期日', 2042, '闰二月', '十六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8133, '2042-04-07', '星期一', 2042, '闰二月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8134, '2042-04-08', '星期二', 2042, '闰二月', '十八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8135, '2042-04-09', '星期三', 2042, '闰二月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8136, '2042-04-10', '星期四', 2042, '闰二月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8137, '2042-04-11', '星期五', 2042, '闰二月', '廿一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8138, '2042-04-12', '星期六', 2042, '闰二月', '廿二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8139, '2042-04-13', '星期日', 2042, '闰二月', '廿三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8140, '2042-04-14', '星期一', 2042, '闰二月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8141, '2042-04-15', '星期二', 2042, '闰二月', '廿五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8142, '2042-04-16', '星期三', 2042, '闰二月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8143, '2042-04-17', '星期四', 2042, '闰二月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8144, '2042-04-18', '星期五', 2042, '闰二月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8145, '2042-04-19', '星期六', 2042, '闰二月', '廿九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8146, '2042-04-20', '星期日', 2042, '三月', '初一', '壬戌', '狗', NULL, 1, '', '', '谷雨', '', 2);
INSERT INTO `base_data_holiday` VALUES (8147, '2042-04-21', '星期一', 2042, '三月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8148, '2042-04-22', '星期二', 2042, '三月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8149, '2042-04-23', '星期三', 2042, '三月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8150, '2042-04-24', '星期四', 2042, '三月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8151, '2042-04-25', '星期五', 2042, '三月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8152, '2042-04-26', '星期六', 2042, '三月', '初七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8153, '2042-04-27', '星期日', 2042, '三月', '初八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8154, '2042-04-28', '星期一', 2042, '三月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8155, '2042-04-29', '星期二', 2042, '三月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8156, '2042-04-30', '星期三', 2042, '三月', '十一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8157, '2042-05-01', '星期四', 2042, '三月', '十二', '壬戌', '狗', NULL, 0, '劳动节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8158, '2042-05-02', '星期五', 2042, '三月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8159, '2042-05-03', '星期六', 2042, '三月', '十四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8160, '2042-05-04', '星期日', 2042, '三月', '十五', '壬戌', '狗', NULL, 1, '青年节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8161, '2042-05-05', '星期一', 2042, '三月', '十六', '壬戌', '狗', NULL, 0, '', '', '立夏', '', 2);
INSERT INTO `base_data_holiday` VALUES (8162, '2042-05-06', '星期二', 2042, '三月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8163, '2042-05-07', '星期三', 2042, '三月', '十八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8164, '2042-05-08', '星期四', 2042, '三月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8165, '2042-05-09', '星期五', 2042, '三月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8166, '2042-05-10', '星期六', 2042, '三月', '廿一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8167, '2042-05-11', '星期日', 2042, '三月', '廿二', '壬戌', '狗', NULL, 1, '', '', '', '母亲节', 2);
INSERT INTO `base_data_holiday` VALUES (8168, '2042-05-12', '星期一', 2042, '三月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8169, '2042-05-13', '星期二', 2042, '三月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8170, '2042-05-14', '星期三', 2042, '三月', '廿五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8171, '2042-05-15', '星期四', 2042, '三月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8172, '2042-05-16', '星期五', 2042, '三月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8173, '2042-05-17', '星期六', 2042, '三月', '廿八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8174, '2042-05-18', '星期日', 2042, '三月', '廿九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8175, '2042-05-19', '星期一', 2042, '四月', '初一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8176, '2042-05-20', '星期二', 2042, '四月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8177, '2042-05-21', '星期三', 2042, '四月', '初三', '壬戌', '狗', NULL, 0, '', '', '小满', '', 2);
INSERT INTO `base_data_holiday` VALUES (8178, '2042-05-22', '星期四', 2042, '四月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8179, '2042-05-23', '星期五', 2042, '四月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8180, '2042-05-24', '星期六', 2042, '四月', '初六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8181, '2042-05-25', '星期日', 2042, '四月', '初七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8182, '2042-05-26', '星期一', 2042, '四月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8183, '2042-05-27', '星期二', 2042, '四月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8184, '2042-05-28', '星期三', 2042, '四月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8185, '2042-05-29', '星期四', 2042, '四月', '十一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8186, '2042-05-30', '星期五', 2042, '四月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8187, '2042-05-31', '星期六', 2042, '四月', '十三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8188, '2042-06-01', '星期日', 2042, '四月', '十四', '壬戌', '狗', NULL, 1, '儿童节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8189, '2042-06-02', '星期一', 2042, '四月', '十五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8190, '2042-06-03', '星期二', 2042, '四月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8191, '2042-06-04', '星期三', 2042, '四月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8192, '2042-06-05', '星期四', 2042, '四月', '十八', '壬戌', '狗', NULL, 0, '', '', '芒种', '', 2);
INSERT INTO `base_data_holiday` VALUES (8193, '2042-06-06', '星期五', 2042, '四月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8194, '2042-06-07', '星期六', 2042, '四月', '二十', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8195, '2042-06-08', '星期日', 2042, '四月', '廿一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8196, '2042-06-09', '星期一', 2042, '四月', '廿二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8197, '2042-06-10', '星期二', 2042, '四月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8198, '2042-06-11', '星期三', 2042, '四月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8199, '2042-06-12', '星期四', 2042, '四月', '廿五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8200, '2042-06-13', '星期五', 2042, '四月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8201, '2042-06-14', '星期六', 2042, '四月', '廿七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8202, '2042-06-15', '星期日', 2042, '四月', '廿八', '壬戌', '狗', NULL, 1, '', '', '', '父亲节', 2);
INSERT INTO `base_data_holiday` VALUES (8203, '2042-06-16', '星期一', 2042, '四月', '廿九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8204, '2042-06-17', '星期二', 2042, '四月', '三十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8205, '2042-06-18', '星期三', 2042, '五月', '初一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8206, '2042-06-19', '星期四', 2042, '五月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8207, '2042-06-20', '星期五', 2042, '五月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8208, '2042-06-21', '星期六', 2042, '五月', '初四', '壬戌', '狗', NULL, 1, '', '', '夏至', '', 2);
INSERT INTO `base_data_holiday` VALUES (8209, '2042-06-22', '星期日', 2042, '五月', '初五', '壬戌', '狗', NULL, 1, '', '端午节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8210, '2042-06-23', '星期一', 2042, '五月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8211, '2042-06-24', '星期二', 2042, '五月', '初七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8212, '2042-06-25', '星期三', 2042, '五月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8213, '2042-06-26', '星期四', 2042, '五月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8214, '2042-06-27', '星期五', 2042, '五月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8215, '2042-06-28', '星期六', 2042, '五月', '十一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8216, '2042-06-29', '星期日', 2042, '五月', '十二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8217, '2042-06-30', '星期一', 2042, '五月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8218, '2042-07-01', '星期二', 2042, '五月', '十四', '壬戌', '狗', NULL, 0, '建党节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8219, '2042-07-02', '星期三', 2042, '五月', '十五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8220, '2042-07-03', '星期四', 2042, '五月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8221, '2042-07-04', '星期五', 2042, '五月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8222, '2042-07-05', '星期六', 2042, '五月', '十八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8223, '2042-07-06', '星期日', 2042, '五月', '十九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8224, '2042-07-07', '星期一', 2042, '五月', '二十', '壬戌', '狗', NULL, 0, '', '', '小暑', '', 2);
INSERT INTO `base_data_holiday` VALUES (8225, '2042-07-08', '星期二', 2042, '五月', '廿一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8226, '2042-07-09', '星期三', 2042, '五月', '廿二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8227, '2042-07-10', '星期四', 2042, '五月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8228, '2042-07-11', '星期五', 2042, '五月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8229, '2042-07-12', '星期六', 2042, '五月', '廿五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8230, '2042-07-13', '星期日', 2042, '五月', '廿六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8231, '2042-07-14', '星期一', 2042, '五月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8232, '2042-07-15', '星期二', 2042, '五月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8233, '2042-07-16', '星期三', 2042, '五月', '廿九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8234, '2042-07-17', '星期四', 2042, '六月', '初一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8235, '2042-07-18', '星期五', 2042, '六月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8236, '2042-07-19', '星期六', 2042, '六月', '初三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8237, '2042-07-20', '星期日', 2042, '六月', '初四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8238, '2042-07-21', '星期一', 2042, '六月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8239, '2042-07-22', '星期二', 2042, '六月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8240, '2042-07-23', '星期三', 2042, '六月', '初七', '壬戌', '狗', NULL, 0, '', '', '大暑', '', 2);
INSERT INTO `base_data_holiday` VALUES (8241, '2042-07-24', '星期四', 2042, '六月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8242, '2042-07-25', '星期五', 2042, '六月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8243, '2042-07-26', '星期六', 2042, '六月', '初十 ', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8244, '2042-07-27', '星期日', 2042, '六月', '十一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8245, '2042-07-28', '星期一', 2042, '六月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8246, '2042-07-29', '星期二', 2042, '六月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8247, '2042-07-30', '星期三', 2042, '六月', '十四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8248, '2042-07-31', '星期四', 2042, '六月', '十五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8249, '2042-08-01', '星期五', 2042, '六月', '十六', '壬戌', '狗', NULL, 0, '建军节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8250, '2042-08-02', '星期六', 2042, '六月', '十七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8251, '2042-08-03', '星期日', 2042, '六月', '十八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8252, '2042-08-04', '星期一', 2042, '六月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8253, '2042-08-05', '星期二', 2042, '六月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8254, '2042-08-06', '星期三', 2042, '六月', '廿一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8255, '2042-08-07', '星期四', 2042, '六月', '廿二', '壬戌', '狗', NULL, 0, '', '', '立秋', '', 2);
INSERT INTO `base_data_holiday` VALUES (8256, '2042-08-08', '星期五', 2042, '六月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8257, '2042-08-09', '星期六', 2042, '六月', '廿四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8258, '2042-08-10', '星期日', 2042, '六月', '廿五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8259, '2042-08-11', '星期一', 2042, '六月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8260, '2042-08-12', '星期二', 2042, '六月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8261, '2042-08-13', '星期三', 2042, '六月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8262, '2042-08-14', '星期四', 2042, '六月', '廿九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8263, '2042-08-15', '星期五', 2042, '六月', '三十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8264, '2042-08-16', '星期六', 2042, '七月', '初一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8265, '2042-08-17', '星期日', 2042, '七月', '初二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8266, '2042-08-18', '星期一', 2042, '七月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8267, '2042-08-19', '星期二', 2042, '七月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8268, '2042-08-20', '星期三', 2042, '七月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8269, '2042-08-21', '星期四', 2042, '七月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8270, '2042-08-22', '星期五', 2042, '七月', '初七', '壬戌', '狗', NULL, 0, '', '七夕', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8271, '2042-08-23', '星期六', 2042, '七月', '初八', '壬戌', '狗', NULL, 1, '', '', '处暑', '', 2);
INSERT INTO `base_data_holiday` VALUES (8272, '2042-08-24', '星期日', 2042, '七月', '初九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8273, '2042-08-25', '星期一', 2042, '七月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8274, '2042-08-26', '星期二', 2042, '七月', '十一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8275, '2042-08-27', '星期三', 2042, '七月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8276, '2042-08-28', '星期四', 2042, '七月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8277, '2042-08-29', '星期五', 2042, '七月', '十四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8278, '2042-08-30', '星期六', 2042, '七月', '十五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8279, '2042-08-31', '星期日', 2042, '七月', '十六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8280, '2042-09-01', '星期一', 2042, '七月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8281, '2042-09-02', '星期二', 2042, '七月', '十八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8282, '2042-09-03', '星期三', 2042, '七月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8283, '2042-09-04', '星期四', 2042, '七月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8284, '2042-09-05', '星期五', 2042, '七月', '廿一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8285, '2042-09-06', '星期六', 2042, '七月', '廿二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8286, '2042-09-07', '星期日', 2042, '七月', '廿三', '壬戌', '狗', NULL, 1, '', '', '白露', '', 2);
INSERT INTO `base_data_holiday` VALUES (8287, '2042-09-08', '星期一', 2042, '七月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8288, '2042-09-09', '星期二', 2042, '七月', '廿五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8289, '2042-09-10', '星期三', 2042, '七月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8290, '2042-09-11', '星期四', 2042, '七月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8291, '2042-09-12', '星期五', 2042, '七月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8292, '2042-09-13', '星期六', 2042, '七月', '廿九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8293, '2042-09-14', '星期日', 2042, '八月', '初一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8294, '2042-09-15', '星期一', 2042, '八月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8295, '2042-09-16', '星期二', 2042, '八月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8296, '2042-09-17', '星期三', 2042, '八月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8297, '2042-09-18', '星期四', 2042, '八月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8298, '2042-09-19', '星期五', 2042, '八月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8299, '2042-09-20', '星期六', 2042, '八月', '初七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8300, '2042-09-21', '星期日', 2042, '八月', '初八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8301, '2042-09-22', '星期一', 2042, '八月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8302, '2042-09-23', '星期二', 2042, '八月', '初十 ', '壬戌', '狗', NULL, 0, '农民丰收节', '', '秋分', '', 2);
INSERT INTO `base_data_holiday` VALUES (8303, '2042-09-24', '星期三', 2042, '八月', '十一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8304, '2042-09-25', '星期四', 2042, '八月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8305, '2042-09-26', '星期五', 2042, '八月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8306, '2042-09-27', '星期六', 2042, '八月', '十四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8307, '2042-09-28', '星期日', 2042, '八月', '十五', '壬戌', '狗', NULL, 1, '', '中秋节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8308, '2042-09-29', '星期一', 2042, '八月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8309, '2042-09-30', '星期二', 2042, '八月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8310, '2042-10-01', '星期三', 2042, '八月', '十八', '壬戌', '狗', NULL, 0, '国庆节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8311, '2042-10-02', '星期四', 2042, '八月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8312, '2042-10-03', '星期五', 2042, '八月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8313, '2042-10-04', '星期六', 2042, '八月', '廿一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8314, '2042-10-05', '星期日', 2042, '八月', '廿二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8315, '2042-10-06', '星期一', 2042, '八月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8316, '2042-10-07', '星期二', 2042, '八月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8317, '2042-10-08', '星期三', 2042, '八月', '廿五', '壬戌', '狗', NULL, 0, '', '', '寒露', '', 2);
INSERT INTO `base_data_holiday` VALUES (8318, '2042-10-09', '星期四', 2042, '八月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8319, '2042-10-10', '星期五', 2042, '八月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8320, '2042-10-11', '星期六', 2042, '八月', '廿八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8321, '2042-10-12', '星期日', 2042, '八月', '廿九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8322, '2042-10-13', '星期一', 2042, '八月', '三十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8323, '2042-10-14', '星期二', 2042, '九月', '初一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8324, '2042-10-15', '星期三', 2042, '九月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8325, '2042-10-16', '星期四', 2042, '九月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8326, '2042-10-17', '星期五', 2042, '九月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8327, '2042-10-18', '星期六', 2042, '九月', '初五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8328, '2042-10-19', '星期日', 2042, '九月', '初六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8329, '2042-10-20', '星期一', 2042, '九月', '初七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8330, '2042-10-21', '星期二', 2042, '九月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8331, '2042-10-22', '星期三', 2042, '九月', '初九', '壬戌', '狗', NULL, 0, '', '重阳节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8332, '2042-10-23', '星期四', 2042, '九月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '霜降', '', 2);
INSERT INTO `base_data_holiday` VALUES (8333, '2042-10-24', '星期五', 2042, '九月', '十一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8334, '2042-10-25', '星期六', 2042, '九月', '十二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8335, '2042-10-26', '星期日', 2042, '九月', '十三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8336, '2042-10-27', '星期一', 2042, '九月', '十四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8337, '2042-10-28', '星期二', 2042, '九月', '十五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8338, '2042-10-29', '星期三', 2042, '九月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8339, '2042-10-30', '星期四', 2042, '九月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8340, '2042-10-31', '星期五', 2042, '九月', '十八', '壬戌', '狗', NULL, 0, '万圣节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8341, '2042-11-01', '星期六', 2042, '九月', '十九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8342, '2042-11-02', '星期日', 2042, '九月', '二十', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8343, '2042-11-03', '星期一', 2042, '九月', '廿一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8344, '2042-11-04', '星期二', 2042, '九月', '廿二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8345, '2042-11-05', '星期三', 2042, '九月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8346, '2042-11-06', '星期四', 2042, '九月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8347, '2042-11-07', '星期五', 2042, '九月', '廿五', '壬戌', '狗', NULL, 0, '', '', '立冬', '', 2);
INSERT INTO `base_data_holiday` VALUES (8348, '2042-11-08', '星期六', 2042, '九月', '廿六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8349, '2042-11-09', '星期日', 2042, '九月', '廿七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8350, '2042-11-10', '星期一', 2042, '九月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8351, '2042-11-11', '星期二', 2042, '九月', '廿九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8352, '2042-11-12', '星期三', 2042, '九月', '三十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8353, '2042-11-13', '星期四', 2042, '十月', '初一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8354, '2042-11-14', '星期五', 2042, '十月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8355, '2042-11-15', '星期六', 2042, '十月', '初三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8356, '2042-11-16', '星期日', 2042, '十月', '初四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8357, '2042-11-17', '星期一', 2042, '十月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8358, '2042-11-18', '星期二', 2042, '十月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8359, '2042-11-19', '星期三', 2042, '十月', '初七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8360, '2042-11-20', '星期四', 2042, '十月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8361, '2042-11-21', '星期五', 2042, '十月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8362, '2042-11-22', '星期六', 2042, '十月', '初十 ', '壬戌', '狗', NULL, 1, '', '', '小雪', '', 2);
INSERT INTO `base_data_holiday` VALUES (8363, '2042-11-23', '星期日', 2042, '十月', '十一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8364, '2042-11-24', '星期一', 2042, '十月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8365, '2042-11-25', '星期二', 2042, '十月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8366, '2042-11-26', '星期三', 2042, '十月', '十四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8367, '2042-11-27', '星期四', 2042, '十月', '十五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8368, '2042-11-28', '星期五', 2042, '十月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8369, '2042-11-29', '星期六', 2042, '十月', '十七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8370, '2042-11-30', '星期日', 2042, '十月', '十八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8371, '2042-12-01', '星期一', 2042, '十月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8372, '2042-12-02', '星期二', 2042, '十月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8373, '2042-12-03', '星期三', 2042, '十月', '廿一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8374, '2042-12-04', '星期四', 2042, '十月', '廿二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8375, '2042-12-05', '星期五', 2042, '十月', '廿三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8376, '2042-12-06', '星期六', 2042, '十月', '廿四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8377, '2042-12-07', '星期日', 2042, '十月', '廿五', '壬戌', '狗', NULL, 1, '', '', '大雪', '', 2);
INSERT INTO `base_data_holiday` VALUES (8378, '2042-12-08', '星期一', 2042, '十月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8379, '2042-12-09', '星期二', 2042, '十月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8380, '2042-12-10', '星期三', 2042, '十月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8381, '2042-12-11', '星期四', 2042, '十月', '廿九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8382, '2042-12-12', '星期五', 2042, '冬月', '初一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8383, '2042-12-13', '星期六', 2042, '冬月', '初二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8384, '2042-12-14', '星期日', 2042, '冬月', '初三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8385, '2042-12-15', '星期一', 2042, '冬月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8386, '2042-12-16', '星期二', 2042, '冬月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8387, '2042-12-17', '星期三', 2042, '冬月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8388, '2042-12-18', '星期四', 2042, '冬月', '初七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8389, '2042-12-19', '星期五', 2042, '冬月', '初八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8390, '2042-12-20', '星期六', 2042, '冬月', '初九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8391, '2042-12-21', '星期日', 2042, '冬月', '初十 ', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8392, '2042-12-22', '星期一', 2042, '冬月', '十一', '壬戌', '狗', NULL, 0, '', '', '冬至', '', 2);
INSERT INTO `base_data_holiday` VALUES (8393, '2042-12-23', '星期二', 2042, '冬月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8394, '2042-12-24', '星期三', 2042, '冬月', '十三', '壬戌', '狗', NULL, 0, '平安夜', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8395, '2042-12-25', '星期四', 2042, '冬月', '十四', '壬戌', '狗', NULL, 0, '圣诞节', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8396, '2042-12-26', '星期五', 2042, '冬月', '十五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8397, '2042-12-27', '星期六', 2042, '冬月', '十六', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8398, '2042-12-28', '星期日', 2042, '冬月', '十七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8399, '2042-12-29', '星期一', 2042, '冬月', '十八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8400, '2042-12-30', '星期二', 2042, '冬月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8401, '2042-12-31', '星期三', 2042, '冬月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8402, '2043-01-01', '星期四', 2042, '冬月', '廿一', '壬戌', '狗', NULL, 0, '元旦', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8403, '2043-01-02', '星期五', 2042, '冬月', '廿二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8404, '2043-01-03', '星期六', 2042, '冬月', '廿三', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8405, '2043-01-04', '星期日', 2042, '冬月', '廿四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8406, '2043-01-05', '星期一', 2042, '冬月', '廿五', '壬戌', '狗', NULL, 0, '', '', '小寒', '', 2);
INSERT INTO `base_data_holiday` VALUES (8407, '2043-01-06', '星期二', 2042, '冬月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8408, '2043-01-07', '星期三', 2042, '冬月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8409, '2043-01-08', '星期四', 2042, '冬月', '廿八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8410, '2043-01-09', '星期五', 2042, '冬月', '廿九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8411, '2043-01-10', '星期六', 2042, '冬月', '三十', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8412, '2043-01-11', '星期日', 2042, '腊月', '初一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8413, '2043-01-12', '星期一', 2042, '腊月', '初二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8414, '2043-01-13', '星期二', 2042, '腊月', '初三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8415, '2043-01-14', '星期三', 2042, '腊月', '初四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8416, '2043-01-15', '星期四', 2042, '腊月', '初五', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8417, '2043-01-16', '星期五', 2042, '腊月', '初六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8418, '2043-01-17', '星期六', 2042, '腊月', '初七', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8419, '2043-01-18', '星期日', 2042, '腊月', '初八', '壬戌', '狗', NULL, 1, '', '腊八节', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8420, '2043-01-19', '星期一', 2042, '腊月', '初九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8421, '2043-01-20', '星期二', 2042, '腊月', '初十 ', '壬戌', '狗', NULL, 0, '', '', '大寒', '', 2);
INSERT INTO `base_data_holiday` VALUES (8422, '2043-01-21', '星期三', 2042, '腊月', '十一', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8423, '2043-01-22', '星期四', 2042, '腊月', '十二', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8424, '2043-01-23', '星期五', 2042, '腊月', '十三', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8425, '2043-01-24', '星期六', 2042, '腊月', '十四', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8426, '2043-01-25', '星期日', 2042, '腊月', '十五', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8427, '2043-01-26', '星期一', 2042, '腊月', '十六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8428, '2043-01-27', '星期二', 2042, '腊月', '十七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8429, '2043-01-28', '星期三', 2042, '腊月', '十八', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8430, '2043-01-29', '星期四', 2042, '腊月', '十九', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8431, '2043-01-30', '星期五', 2042, '腊月', '二十', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8432, '2043-01-31', '星期六', 2042, '腊月', '廿一', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8433, '2043-02-01', '星期日', 2042, '腊月', '廿二', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8434, '2043-02-02', '星期一', 2042, '腊月', '廿三', '壬戌', '狗', NULL, 0, '', '小年', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8435, '2043-02-03', '星期二', 2042, '腊月', '廿四', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8436, '2043-02-04', '星期三', 2042, '腊月', '廿五', '壬戌', '狗', NULL, 0, '', '', '立春', '', 2);
INSERT INTO `base_data_holiday` VALUES (8437, '2043-02-05', '星期四', 2042, '腊月', '廿六', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8438, '2043-02-06', '星期五', 2042, '腊月', '廿七', '壬戌', '狗', NULL, 0, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8439, '2043-02-07', '星期六', 2042, '腊月', '廿八', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8440, '2043-02-08', '星期日', 2042, '腊月', '廿九', '壬戌', '狗', NULL, 1, '', '', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8441, '2043-02-09', '星期一', 2042, '腊月', '三十', '壬戌', '狗', NULL, 0, '', '除夕', '', '', 2);
INSERT INTO `base_data_holiday` VALUES (8442, '2043-02-10', '星期二', 2043, '正月', '初一', '癸亥', '猪', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8443, '2043-02-11', '星期三', 2043, '正月', '初二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8444, '2043-02-12', '星期四', 2043, '正月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8445, '2043-02-13', '星期五', 2043, '正月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8446, '2043-02-14', '星期六', 2043, '正月', '初五', '癸亥', '猪', NULL, 1, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8447, '2043-02-15', '星期日', 2043, '正月', '初六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8448, '2043-02-16', '星期一', 2043, '正月', '初七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8449, '2043-02-17', '星期二', 2043, '正月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8450, '2043-02-18', '星期三', 2043, '正月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8451, '2043-02-19', '星期四', 2043, '正月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (8452, '2043-02-20', '星期五', 2043, '正月', '十一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8453, '2043-02-21', '星期六', 2043, '正月', '十二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8454, '2043-02-22', '星期日', 2043, '正月', '十三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8455, '2043-02-23', '星期一', 2043, '正月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8456, '2043-02-24', '星期二', 2043, '正月', '十五', '癸亥', '猪', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8457, '2043-02-25', '星期三', 2043, '正月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8458, '2043-02-26', '星期四', 2043, '正月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8459, '2043-02-27', '星期五', 2043, '正月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8460, '2043-02-28', '星期六', 2043, '正月', '十九', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8461, '2043-03-01', '星期日', 2043, '正月', '二十', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8462, '2043-03-02', '星期一', 2043, '正月', '廿一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8463, '2043-03-03', '星期二', 2043, '正月', '廿二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8464, '2043-03-04', '星期三', 2043, '正月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8465, '2043-03-05', '星期四', 2043, '正月', '廿四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8466, '2043-03-06', '星期五', 2043, '正月', '廿五', '癸亥', '猪', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (8467, '2043-03-07', '星期六', 2043, '正月', '廿六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8468, '2043-03-08', '星期日', 2043, '正月', '廿七', '癸亥', '猪', NULL, 1, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8469, '2043-03-09', '星期一', 2043, '正月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8470, '2043-03-10', '星期二', 2043, '正月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8471, '2043-03-11', '星期三', 2043, '二月', '初一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8472, '2043-03-12', '星期四', 2043, '二月', '初二', '癸亥', '猪', NULL, 0, '植树节', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8473, '2043-03-13', '星期五', 2043, '二月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8474, '2043-03-14', '星期六', 2043, '二月', '初四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8475, '2043-03-15', '星期日', 2043, '二月', '初五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8476, '2043-03-16', '星期一', 2043, '二月', '初六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8477, '2043-03-17', '星期二', 2043, '二月', '初七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8478, '2043-03-18', '星期三', 2043, '二月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8479, '2043-03-19', '星期四', 2043, '二月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8480, '2043-03-20', '星期五', 2043, '二月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8481, '2043-03-21', '星期六', 2043, '二月', '十一', '癸亥', '猪', NULL, 1, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (8482, '2043-03-22', '星期日', 2043, '二月', '十二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8483, '2043-03-23', '星期一', 2043, '二月', '十三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8484, '2043-03-24', '星期二', 2043, '二月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8485, '2043-03-25', '星期三', 2043, '二月', '十五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8486, '2043-03-26', '星期四', 2043, '二月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8487, '2043-03-27', '星期五', 2043, '二月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8488, '2043-03-28', '星期六', 2043, '二月', '十八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8489, '2043-03-29', '星期日', 2043, '二月', '十九', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8490, '2043-03-30', '星期一', 2043, '二月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8491, '2043-03-31', '星期二', 2043, '二月', '廿一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8492, '2043-04-01', '星期三', 2043, '二月', '廿二', '癸亥', '猪', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8493, '2043-04-02', '星期四', 2043, '二月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8494, '2043-04-03', '星期五', 2043, '二月', '廿四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8495, '2043-04-04', '星期六', 2043, '二月', '廿五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8496, '2043-04-05', '星期日', 2043, '二月', '廿六', '癸亥', '猪', NULL, 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (8497, '2043-04-06', '星期一', 2043, '二月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8498, '2043-04-07', '星期二', 2043, '二月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8499, '2043-04-08', '星期三', 2043, '二月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8500, '2043-04-09', '星期四', 2043, '二月', '三十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8501, '2043-04-10', '星期五', 2043, '三月', '初一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8502, '2043-04-11', '星期六', 2043, '三月', '初二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8503, '2043-04-12', '星期日', 2043, '三月', '初三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8504, '2043-04-13', '星期一', 2043, '三月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8505, '2043-04-14', '星期二', 2043, '三月', '初五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8506, '2043-04-15', '星期三', 2043, '三月', '初六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8507, '2043-04-16', '星期四', 2043, '三月', '初七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8508, '2043-04-17', '星期五', 2043, '三月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8509, '2043-04-18', '星期六', 2043, '三月', '初九', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8510, '2043-04-19', '星期日', 2043, '三月', '初十 ', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8511, '2043-04-20', '星期一', 2043, '三月', '十一', '癸亥', '猪', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (8512, '2043-04-21', '星期二', 2043, '三月', '十二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8513, '2043-04-22', '星期三', 2043, '三月', '十三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8514, '2043-04-23', '星期四', 2043, '三月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8515, '2043-04-24', '星期五', 2043, '三月', '十五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8516, '2043-04-25', '星期六', 2043, '三月', '十六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8517, '2043-04-26', '星期日', 2043, '三月', '十七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8518, '2043-04-27', '星期一', 2043, '三月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8519, '2043-04-28', '星期二', 2043, '三月', '十九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8520, '2043-04-29', '星期三', 2043, '三月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8521, '2043-04-30', '星期四', 2043, '三月', '廿一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8522, '2043-05-01', '星期五', 2043, '三月', '廿二', '癸亥', '猪', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8523, '2043-05-02', '星期六', 2043, '三月', '廿三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8524, '2043-05-03', '星期日', 2043, '三月', '廿四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8525, '2043-05-04', '星期一', 2043, '三月', '廿五', '癸亥', '猪', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8526, '2043-05-05', '星期二', 2043, '三月', '廿六', '癸亥', '猪', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (8527, '2043-05-06', '星期三', 2043, '三月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8528, '2043-05-07', '星期四', 2043, '三月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8529, '2043-05-08', '星期五', 2043, '三月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8530, '2043-05-09', '星期六', 2043, '四月', '初一', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8531, '2043-05-10', '星期日', 2043, '四月', '初二', '癸亥', '猪', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (8532, '2043-05-11', '星期一', 2043, '四月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8533, '2043-05-12', '星期二', 2043, '四月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8534, '2043-05-13', '星期三', 2043, '四月', '初五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8535, '2043-05-14', '星期四', 2043, '四月', '初六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8536, '2043-05-15', '星期五', 2043, '四月', '初七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8537, '2043-05-16', '星期六', 2043, '四月', '初八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8538, '2043-05-17', '星期日', 2043, '四月', '初九', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8539, '2043-05-18', '星期一', 2043, '四月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8540, '2043-05-19', '星期二', 2043, '四月', '十一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8541, '2043-05-20', '星期三', 2043, '四月', '十二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8542, '2043-05-21', '星期四', 2043, '四月', '十三', '癸亥', '猪', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (8543, '2043-05-22', '星期五', 2043, '四月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8544, '2043-05-23', '星期六', 2043, '四月', '十五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8545, '2043-05-24', '星期日', 2043, '四月', '十六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8546, '2043-05-25', '星期一', 2043, '四月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8547, '2043-05-26', '星期二', 2043, '四月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8548, '2043-05-27', '星期三', 2043, '四月', '十九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8549, '2043-05-28', '星期四', 2043, '四月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8550, '2043-05-29', '星期五', 2043, '四月', '廿一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8551, '2043-05-30', '星期六', 2043, '四月', '廿二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8552, '2043-05-31', '星期日', 2043, '四月', '廿三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8553, '2043-06-01', '星期一', 2043, '四月', '廿四', '癸亥', '猪', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8554, '2043-06-02', '星期二', 2043, '四月', '廿五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8555, '2043-06-03', '星期三', 2043, '四月', '廿六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8556, '2043-06-04', '星期四', 2043, '四月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8557, '2043-06-05', '星期五', 2043, '四月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8558, '2043-06-06', '星期六', 2043, '四月', '廿九', '癸亥', '猪', NULL, 1, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (8559, '2043-06-07', '星期日', 2043, '五月', '初一', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8560, '2043-06-08', '星期一', 2043, '五月', '初二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8561, '2043-06-09', '星期二', 2043, '五月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8562, '2043-06-10', '星期三', 2043, '五月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8563, '2043-06-11', '星期四', 2043, '五月', '初五', '癸亥', '猪', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8564, '2043-06-12', '星期五', 2043, '五月', '初六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8565, '2043-06-13', '星期六', 2043, '五月', '初七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8566, '2043-06-14', '星期日', 2043, '五月', '初八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8567, '2043-06-15', '星期一', 2043, '五月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8568, '2043-06-16', '星期二', 2043, '五月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8569, '2043-06-17', '星期三', 2043, '五月', '十一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8570, '2043-06-18', '星期四', 2043, '五月', '十二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8571, '2043-06-19', '星期五', 2043, '五月', '十三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8572, '2043-06-20', '星期六', 2043, '五月', '十四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8573, '2043-06-21', '星期日', 2043, '五月', '十五', '癸亥', '猪', NULL, 1, '', '', '夏至', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (8574, '2043-06-22', '星期一', 2043, '五月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8575, '2043-06-23', '星期二', 2043, '五月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8576, '2043-06-24', '星期三', 2043, '五月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8577, '2043-06-25', '星期四', 2043, '五月', '十九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8578, '2043-06-26', '星期五', 2043, '五月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8579, '2043-06-27', '星期六', 2043, '五月', '廿一', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8580, '2043-06-28', '星期日', 2043, '五月', '廿二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8581, '2043-06-29', '星期一', 2043, '五月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8582, '2043-06-30', '星期二', 2043, '五月', '廿四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8583, '2043-07-01', '星期三', 2043, '五月', '廿五', '癸亥', '猪', NULL, 0, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8584, '2043-07-02', '星期四', 2043, '五月', '廿六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8585, '2043-07-03', '星期五', 2043, '五月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8586, '2043-07-04', '星期六', 2043, '五月', '廿八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8587, '2043-07-05', '星期日', 2043, '五月', '廿九', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8588, '2043-07-06', '星期一', 2043, '五月', '三十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8589, '2043-07-07', '星期二', 2043, '六月', '初一', '癸亥', '猪', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (8590, '2043-07-08', '星期三', 2043, '六月', '初二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8591, '2043-07-09', '星期四', 2043, '六月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8592, '2043-07-10', '星期五', 2043, '六月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8593, '2043-07-11', '星期六', 2043, '六月', '初五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8594, '2043-07-12', '星期日', 2043, '六月', '初六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8595, '2043-07-13', '星期一', 2043, '六月', '初七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8596, '2043-07-14', '星期二', 2043, '六月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8597, '2043-07-15', '星期三', 2043, '六月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8598, '2043-07-16', '星期四', 2043, '六月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8599, '2043-07-17', '星期五', 2043, '六月', '十一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8600, '2043-07-18', '星期六', 2043, '六月', '十二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8601, '2043-07-19', '星期日', 2043, '六月', '十三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8602, '2043-07-20', '星期一', 2043, '六月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8603, '2043-07-21', '星期二', 2043, '六月', '十五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8604, '2043-07-22', '星期三', 2043, '六月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8605, '2043-07-23', '星期四', 2043, '六月', '十七', '癸亥', '猪', NULL, 0, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (8606, '2043-07-24', '星期五', 2043, '六月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8607, '2043-07-25', '星期六', 2043, '六月', '十九', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8608, '2043-07-26', '星期日', 2043, '六月', '二十', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8609, '2043-07-27', '星期一', 2043, '六月', '廿一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8610, '2043-07-28', '星期二', 2043, '六月', '廿二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8611, '2043-07-29', '星期三', 2043, '六月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8612, '2043-07-30', '星期四', 2043, '六月', '廿四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8613, '2043-07-31', '星期五', 2043, '六月', '廿五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8614, '2043-08-01', '星期六', 2043, '六月', '廿六', '癸亥', '猪', NULL, 1, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8615, '2043-08-02', '星期日', 2043, '六月', '廿七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8616, '2043-08-03', '星期一', 2043, '六月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8617, '2043-08-04', '星期二', 2043, '六月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8618, '2043-08-05', '星期三', 2043, '七月', '初一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8619, '2043-08-06', '星期四', 2043, '七月', '初二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8620, '2043-08-07', '星期五', 2043, '七月', '初三', '癸亥', '猪', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (8621, '2043-08-08', '星期六', 2043, '七月', '初四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8622, '2043-08-09', '星期日', 2043, '七月', '初五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8623, '2043-08-10', '星期一', 2043, '七月', '初六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8624, '2043-08-11', '星期二', 2043, '七月', '初七', '癸亥', '猪', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8625, '2043-08-12', '星期三', 2043, '七月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8626, '2043-08-13', '星期四', 2043, '七月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8627, '2043-08-14', '星期五', 2043, '七月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8628, '2043-08-15', '星期六', 2043, '七月', '十一', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8629, '2043-08-16', '星期日', 2043, '七月', '十二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8630, '2043-08-17', '星期一', 2043, '七月', '十三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8631, '2043-08-18', '星期二', 2043, '七月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8632, '2043-08-19', '星期三', 2043, '七月', '十五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8633, '2043-08-20', '星期四', 2043, '七月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8634, '2043-08-21', '星期五', 2043, '七月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8635, '2043-08-22', '星期六', 2043, '七月', '十八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8636, '2043-08-23', '星期日', 2043, '七月', '十九', '癸亥', '猪', NULL, 1, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (8637, '2043-08-24', '星期一', 2043, '七月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8638, '2043-08-25', '星期二', 2043, '七月', '廿一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8639, '2043-08-26', '星期三', 2043, '七月', '廿二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8640, '2043-08-27', '星期四', 2043, '七月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8641, '2043-08-28', '星期五', 2043, '七月', '廿四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8642, '2043-08-29', '星期六', 2043, '七月', '廿五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8643, '2043-08-30', '星期日', 2043, '七月', '廿六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8644, '2043-08-31', '星期一', 2043, '七月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8645, '2043-09-01', '星期二', 2043, '七月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8646, '2043-09-02', '星期三', 2043, '七月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8647, '2043-09-03', '星期四', 2043, '八月', '初一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8648, '2043-09-04', '星期五', 2043, '八月', '初二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8649, '2043-09-05', '星期六', 2043, '八月', '初三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8650, '2043-09-06', '星期日', 2043, '八月', '初四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8651, '2043-09-07', '星期一', 2043, '八月', '初五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8652, '2043-09-08', '星期二', 2043, '八月', '初六', '癸亥', '猪', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (8653, '2043-09-09', '星期三', 2043, '八月', '初七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8654, '2043-09-10', '星期四', 2043, '八月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8655, '2043-09-11', '星期五', 2043, '八月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8656, '2043-09-12', '星期六', 2043, '八月', '初十 ', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8657, '2043-09-13', '星期日', 2043, '八月', '十一', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8658, '2043-09-14', '星期一', 2043, '八月', '十二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8659, '2043-09-15', '星期二', 2043, '八月', '十三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8660, '2043-09-16', '星期三', 2043, '八月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8661, '2043-09-17', '星期四', 2043, '八月', '十五', '癸亥', '猪', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8662, '2043-09-18', '星期五', 2043, '八月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8663, '2043-09-19', '星期六', 2043, '八月', '十七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8664, '2043-09-20', '星期日', 2043, '八月', '十八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8665, '2043-09-21', '星期一', 2043, '八月', '十九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8666, '2043-09-22', '星期二', 2043, '八月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8667, '2043-09-23', '星期三', 2043, '八月', '廿一', '癸亥', '猪', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (8668, '2043-09-24', '星期四', 2043, '八月', '廿二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8669, '2043-09-25', '星期五', 2043, '八月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8670, '2043-09-26', '星期六', 2043, '八月', '廿四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8671, '2043-09-27', '星期日', 2043, '八月', '廿五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8672, '2043-09-28', '星期一', 2043, '八月', '廿六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8673, '2043-09-29', '星期二', 2043, '八月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8674, '2043-09-30', '星期三', 2043, '八月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8675, '2043-10-01', '星期四', 2043, '八月', '廿九', '癸亥', '猪', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8676, '2043-10-02', '星期五', 2043, '八月', '三十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8677, '2043-10-03', '星期六', 2043, '九月', '初一', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8678, '2043-10-04', '星期日', 2043, '九月', '初二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8679, '2043-10-05', '星期一', 2043, '九月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8680, '2043-10-06', '星期二', 2043, '九月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8681, '2043-10-07', '星期三', 2043, '九月', '初五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8682, '2043-10-08', '星期四', 2043, '九月', '初六', '癸亥', '猪', NULL, 0, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (8683, '2043-10-09', '星期五', 2043, '九月', '初七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8684, '2043-10-10', '星期六', 2043, '九月', '初八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8685, '2043-10-11', '星期日', 2043, '九月', '初九', '癸亥', '猪', NULL, 1, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8686, '2043-10-12', '星期一', 2043, '九月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8687, '2043-10-13', '星期二', 2043, '九月', '十一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8688, '2043-10-14', '星期三', 2043, '九月', '十二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8689, '2043-10-15', '星期四', 2043, '九月', '十三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8690, '2043-10-16', '星期五', 2043, '九月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8691, '2043-10-17', '星期六', 2043, '九月', '十五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8692, '2043-10-18', '星期日', 2043, '九月', '十六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8693, '2043-10-19', '星期一', 2043, '九月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8694, '2043-10-20', '星期二', 2043, '九月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8695, '2043-10-21', '星期三', 2043, '九月', '十九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8696, '2043-10-22', '星期四', 2043, '九月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8697, '2043-10-23', '星期五', 2043, '九月', '廿一', '癸亥', '猪', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (8698, '2043-10-24', '星期六', 2043, '九月', '廿二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8699, '2043-10-25', '星期日', 2043, '九月', '廿三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8700, '2043-10-26', '星期一', 2043, '九月', '廿四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8701, '2043-10-27', '星期二', 2043, '九月', '廿五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8702, '2043-10-28', '星期三', 2043, '九月', '廿六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8703, '2043-10-29', '星期四', 2043, '九月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8704, '2043-10-30', '星期五', 2043, '九月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8705, '2043-10-31', '星期六', 2043, '九月', '廿九', '癸亥', '猪', NULL, 1, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8706, '2043-11-01', '星期日', 2043, '九月', '三十', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8707, '2043-11-02', '星期一', 2043, '十月', '初一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8708, '2043-11-03', '星期二', 2043, '十月', '初二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8709, '2043-11-04', '星期三', 2043, '十月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8710, '2043-11-05', '星期四', 2043, '十月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8711, '2043-11-06', '星期五', 2043, '十月', '初五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8712, '2043-11-07', '星期六', 2043, '十月', '初六', '癸亥', '猪', NULL, 1, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (8713, '2043-11-08', '星期日', 2043, '十月', '初七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8714, '2043-11-09', '星期一', 2043, '十月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8715, '2043-11-10', '星期二', 2043, '十月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8716, '2043-11-11', '星期三', 2043, '十月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8717, '2043-11-12', '星期四', 2043, '十月', '十一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8718, '2043-11-13', '星期五', 2043, '十月', '十二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8719, '2043-11-14', '星期六', 2043, '十月', '十三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8720, '2043-11-15', '星期日', 2043, '十月', '十四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8721, '2043-11-16', '星期一', 2043, '十月', '十五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8722, '2043-11-17', '星期二', 2043, '十月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8723, '2043-11-18', '星期三', 2043, '十月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8724, '2043-11-19', '星期四', 2043, '十月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8725, '2043-11-20', '星期五', 2043, '十月', '十九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8726, '2043-11-21', '星期六', 2043, '十月', '二十', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8727, '2043-11-22', '星期日', 2043, '十月', '廿一', '癸亥', '猪', NULL, 1, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (8728, '2043-11-23', '星期一', 2043, '十月', '廿二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8729, '2043-11-24', '星期二', 2043, '十月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8730, '2043-11-25', '星期三', 2043, '十月', '廿四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8731, '2043-11-26', '星期四', 2043, '十月', '廿五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8732, '2043-11-27', '星期五', 2043, '十月', '廿六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8733, '2043-11-28', '星期六', 2043, '十月', '廿七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8734, '2043-11-29', '星期日', 2043, '十月', '廿八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8735, '2043-11-30', '星期一', 2043, '十月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8736, '2043-12-01', '星期二', 2043, '冬月', '初一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8737, '2043-12-02', '星期三', 2043, '冬月', '初二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8738, '2043-12-03', '星期四', 2043, '冬月', '初三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8739, '2043-12-04', '星期五', 2043, '冬月', '初四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8740, '2043-12-05', '星期六', 2043, '冬月', '初五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8741, '2043-12-06', '星期日', 2043, '冬月', '初六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8742, '2043-12-07', '星期一', 2043, '冬月', '初七', '癸亥', '猪', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (8743, '2043-12-08', '星期二', 2043, '冬月', '初八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8744, '2043-12-09', '星期三', 2043, '冬月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8745, '2043-12-10', '星期四', 2043, '冬月', '初十 ', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8746, '2043-12-11', '星期五', 2043, '冬月', '十一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8747, '2043-12-12', '星期六', 2043, '冬月', '十二', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8748, '2043-12-13', '星期日', 2043, '冬月', '十三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8749, '2043-12-14', '星期一', 2043, '冬月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8750, '2043-12-15', '星期二', 2043, '冬月', '十五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8751, '2043-12-16', '星期三', 2043, '冬月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8752, '2043-12-17', '星期四', 2043, '冬月', '十七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8753, '2043-12-18', '星期五', 2043, '冬月', '十八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8754, '2043-12-19', '星期六', 2043, '冬月', '十九', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8755, '2043-12-20', '星期日', 2043, '冬月', '二十', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8756, '2043-12-21', '星期一', 2043, '冬月', '廿一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8757, '2043-12-22', '星期二', 2043, '冬月', '廿二', '癸亥', '猪', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (8758, '2043-12-23', '星期三', 2043, '冬月', '廿三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8759, '2043-12-24', '星期四', 2043, '冬月', '廿四', '癸亥', '猪', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8760, '2043-12-25', '星期五', 2043, '冬月', '廿五', '癸亥', '猪', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8761, '2043-12-26', '星期六', 2043, '冬月', '廿六', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8762, '2043-12-27', '星期日', 2043, '冬月', '廿七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8763, '2043-12-28', '星期一', 2043, '冬月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8764, '2043-12-29', '星期二', 2043, '冬月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8765, '2043-12-30', '星期三', 2043, '冬月', '三十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8766, '2043-12-31', '星期四', 2043, '腊月', '初一', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8767, '2044-01-01', '星期五', 2043, '腊月', '初二', '癸亥', '猪', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8768, '2044-01-02', '星期六', 2043, '腊月', '初三', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8769, '2044-01-03', '星期日', 2043, '腊月', '初四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8770, '2044-01-04', '星期一', 2043, '腊月', '初五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8771, '2044-01-05', '星期二', 2043, '腊月', '初六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8772, '2044-01-06', '星期三', 2043, '腊月', '初七', '癸亥', '猪', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (8773, '2044-01-07', '星期四', 2043, '腊月', '初八', '癸亥', '猪', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8774, '2044-01-08', '星期五', 2043, '腊月', '初九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8775, '2044-01-09', '星期六', 2043, '腊月', '初十 ', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8776, '2044-01-10', '星期日', 2043, '腊月', '十一', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8777, '2044-01-11', '星期一', 2043, '腊月', '十二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8778, '2044-01-12', '星期二', 2043, '腊月', '十三', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8779, '2044-01-13', '星期三', 2043, '腊月', '十四', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8780, '2044-01-14', '星期四', 2043, '腊月', '十五', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8781, '2044-01-15', '星期五', 2043, '腊月', '十六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8782, '2044-01-16', '星期六', 2043, '腊月', '十七', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8783, '2044-01-17', '星期日', 2043, '腊月', '十八', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8784, '2044-01-18', '星期一', 2043, '腊月', '十九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8785, '2044-01-19', '星期二', 2043, '腊月', '二十', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8786, '2044-01-20', '星期三', 2043, '腊月', '廿一', '癸亥', '猪', NULL, 0, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (8787, '2044-01-21', '星期四', 2043, '腊月', '廿二', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8788, '2044-01-22', '星期五', 2043, '腊月', '廿三', '癸亥', '猪', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8789, '2044-01-23', '星期六', 2043, '腊月', '廿四', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8790, '2044-01-24', '星期日', 2043, '腊月', '廿五', '癸亥', '猪', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8791, '2044-01-25', '星期一', 2043, '腊月', '廿六', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8792, '2044-01-26', '星期二', 2043, '腊月', '廿七', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8793, '2044-01-27', '星期三', 2043, '腊月', '廿八', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8794, '2044-01-28', '星期四', 2043, '腊月', '廿九', '癸亥', '猪', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8795, '2044-01-29', '星期五', 2043, '腊月', '三十', '癸亥', '猪', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8796, '2044-01-30', '星期六', 2044, '正月', '初一', '甲子', '鼠', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (8797, '2044-01-31', '星期日', 2044, '正月', '初二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8798, '2044-02-01', '星期一', 2044, '正月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8799, '2044-02-02', '星期二', 2044, '正月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8800, '2044-02-03', '星期三', 2044, '正月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8801, '2044-02-04', '星期四', 2044, '正月', '初六', '甲子', '鼠', NULL, 0, '', '', '立春', '', 7);
INSERT INTO `base_data_holiday` VALUES (8802, '2044-02-05', '星期五', 2044, '正月', '初七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8803, '2044-02-06', '星期六', 2044, '正月', '初八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8804, '2044-02-07', '星期日', 2044, '正月', '初九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8805, '2044-02-08', '星期一', 2044, '正月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8806, '2044-02-09', '星期二', 2044, '正月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8807, '2044-02-10', '星期三', 2044, '正月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8808, '2044-02-11', '星期四', 2044, '正月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8809, '2044-02-12', '星期五', 2044, '正月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8810, '2044-02-13', '星期六', 2044, '正月', '十五', '甲子', '鼠', NULL, 1, '', '元宵节', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8811, '2044-02-14', '星期日', 2044, '正月', '十六', '甲子', '鼠', NULL, 1, '情人节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8812, '2044-02-15', '星期一', 2044, '正月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8813, '2044-02-16', '星期二', 2044, '正月', '十八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8814, '2044-02-17', '星期三', 2044, '正月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8815, '2044-02-18', '星期四', 2044, '正月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8816, '2044-02-19', '星期五', 2044, '正月', '廿一', '甲子', '鼠', NULL, 0, '', '', '雨水', '', 7);
INSERT INTO `base_data_holiday` VALUES (8817, '2044-02-20', '星期六', 2044, '正月', '廿二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8818, '2044-02-21', '星期日', 2044, '正月', '廿三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8819, '2044-02-22', '星期一', 2044, '正月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8820, '2044-02-23', '星期二', 2044, '正月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8821, '2044-02-24', '星期三', 2044, '正月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8822, '2044-02-25', '星期四', 2044, '正月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8823, '2044-02-26', '星期五', 2044, '正月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8824, '2044-02-27', '星期六', 2044, '正月', '廿九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8825, '2044-02-28', '星期日', 2044, '正月', '三十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8826, '2044-02-29', '星期一', 2044, '二月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8827, '2044-03-01', '星期二', 2044, '二月', '初二', '甲子', '鼠', NULL, 0, '', '龙抬头', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8828, '2044-03-02', '星期三', 2044, '二月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8829, '2044-03-03', '星期四', 2044, '二月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8830, '2044-03-04', '星期五', 2044, '二月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8831, '2044-03-05', '星期六', 2044, '二月', '初六', '甲子', '鼠', NULL, 1, '', '', '惊蛰', '', 7);
INSERT INTO `base_data_holiday` VALUES (8832, '2044-03-06', '星期日', 2044, '二月', '初七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8833, '2044-03-07', '星期一', 2044, '二月', '初八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8834, '2044-03-08', '星期二', 2044, '二月', '初九', '甲子', '鼠', NULL, 0, '妇女节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8835, '2044-03-09', '星期三', 2044, '二月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8836, '2044-03-10', '星期四', 2044, '二月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8837, '2044-03-11', '星期五', 2044, '二月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8838, '2044-03-12', '星期六', 2044, '二月', '十三', '甲子', '鼠', NULL, 1, '植树节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8839, '2044-03-13', '星期日', 2044, '二月', '十四', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8840, '2044-03-14', '星期一', 2044, '二月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8841, '2044-03-15', '星期二', 2044, '二月', '十六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8842, '2044-03-16', '星期三', 2044, '二月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8843, '2044-03-17', '星期四', 2044, '二月', '十八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8844, '2044-03-18', '星期五', 2044, '二月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8845, '2044-03-19', '星期六', 2044, '二月', '二十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8846, '2044-03-20', '星期日', 2044, '二月', '廿一', '甲子', '鼠', NULL, 1, '', '', '春分', '', 7);
INSERT INTO `base_data_holiday` VALUES (8847, '2044-03-21', '星期一', 2044, '二月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8848, '2044-03-22', '星期二', 2044, '二月', '廿三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8849, '2044-03-23', '星期三', 2044, '二月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8850, '2044-03-24', '星期四', 2044, '二月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8851, '2044-03-25', '星期五', 2044, '二月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8852, '2044-03-26', '星期六', 2044, '二月', '廿七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8853, '2044-03-27', '星期日', 2044, '二月', '廿八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8854, '2044-03-28', '星期一', 2044, '二月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8855, '2044-03-29', '星期二', 2044, '三月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8856, '2044-03-30', '星期三', 2044, '三月', '初二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8857, '2044-03-31', '星期四', 2044, '三月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8858, '2044-04-01', '星期五', 2044, '三月', '初四', '甲子', '鼠', NULL, 0, '愚人节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8859, '2044-04-02', '星期六', 2044, '三月', '初五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8860, '2044-04-03', '星期日', 2044, '三月', '初六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8861, '2044-04-04', '星期一', 2044, '三月', '初七', '甲子', '鼠', NULL, 0, '', '', '清明', '', 7);
INSERT INTO `base_data_holiday` VALUES (8862, '2044-04-05', '星期二', 2044, '三月', '初八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8863, '2044-04-06', '星期三', 2044, '三月', '初九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8864, '2044-04-07', '星期四', 2044, '三月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8865, '2044-04-08', '星期五', 2044, '三月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8866, '2044-04-09', '星期六', 2044, '三月', '十二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8867, '2044-04-10', '星期日', 2044, '三月', '十三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8868, '2044-04-11', '星期一', 2044, '三月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8869, '2044-04-12', '星期二', 2044, '三月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8870, '2044-04-13', '星期三', 2044, '三月', '十六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8871, '2044-04-14', '星期四', 2044, '三月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8872, '2044-04-15', '星期五', 2044, '三月', '十八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8873, '2044-04-16', '星期六', 2044, '三月', '十九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8874, '2044-04-17', '星期日', 2044, '三月', '二十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8875, '2044-04-18', '星期一', 2044, '三月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8876, '2044-04-19', '星期二', 2044, '三月', '廿二', '甲子', '鼠', NULL, 0, '', '', '谷雨', '', 7);
INSERT INTO `base_data_holiday` VALUES (8877, '2044-04-20', '星期三', 2044, '三月', '廿三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8878, '2044-04-21', '星期四', 2044, '三月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8879, '2044-04-22', '星期五', 2044, '三月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8880, '2044-04-23', '星期六', 2044, '三月', '廿六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8881, '2044-04-24', '星期日', 2044, '三月', '廿七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8882, '2044-04-25', '星期一', 2044, '三月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8883, '2044-04-26', '星期二', 2044, '三月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8884, '2044-04-27', '星期三', 2044, '三月', '三十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8885, '2044-04-28', '星期四', 2044, '四月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8886, '2044-04-29', '星期五', 2044, '四月', '初二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8887, '2044-04-30', '星期六', 2044, '四月', '初三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8888, '2044-05-01', '星期日', 2044, '四月', '初四', '甲子', '鼠', NULL, 1, '劳动节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8889, '2044-05-02', '星期一', 2044, '四月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8890, '2044-05-03', '星期二', 2044, '四月', '初六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8891, '2044-05-04', '星期三', 2044, '四月', '初七', '甲子', '鼠', NULL, 0, '青年节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8892, '2044-05-05', '星期四', 2044, '四月', '初八', '甲子', '鼠', NULL, 0, '', '', '立夏', '', 7);
INSERT INTO `base_data_holiday` VALUES (8893, '2044-05-06', '星期五', 2044, '四月', '初九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8894, '2044-05-07', '星期六', 2044, '四月', '初十 ', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8895, '2044-05-08', '星期日', 2044, '四月', '十一', '甲子', '鼠', NULL, 1, '', '', '', '母亲节', 7);
INSERT INTO `base_data_holiday` VALUES (8896, '2044-05-09', '星期一', 2044, '四月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8897, '2044-05-10', '星期二', 2044, '四月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8898, '2044-05-11', '星期三', 2044, '四月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8899, '2044-05-12', '星期四', 2044, '四月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8900, '2044-05-13', '星期五', 2044, '四月', '十六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8901, '2044-05-14', '星期六', 2044, '四月', '十七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8902, '2044-05-15', '星期日', 2044, '四月', '十八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8903, '2044-05-16', '星期一', 2044, '四月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8904, '2044-05-17', '星期二', 2044, '四月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8905, '2044-05-18', '星期三', 2044, '四月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8906, '2044-05-19', '星期四', 2044, '四月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8907, '2044-05-20', '星期五', 2044, '四月', '廿三', '甲子', '鼠', NULL, 0, '', '', '小满', '', 7);
INSERT INTO `base_data_holiday` VALUES (8908, '2044-05-21', '星期六', 2044, '四月', '廿四', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8909, '2044-05-22', '星期日', 2044, '四月', '廿五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8910, '2044-05-23', '星期一', 2044, '四月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8911, '2044-05-24', '星期二', 2044, '四月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8912, '2044-05-25', '星期三', 2044, '四月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8913, '2044-05-26', '星期四', 2044, '四月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8914, '2044-05-27', '星期五', 2044, '五月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8915, '2044-05-28', '星期六', 2044, '五月', '初二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8916, '2044-05-29', '星期日', 2044, '五月', '初三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8917, '2044-05-30', '星期一', 2044, '五月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8918, '2044-05-31', '星期二', 2044, '五月', '初五', '甲子', '鼠', NULL, 0, '', '端午节', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8919, '2044-06-01', '星期三', 2044, '五月', '初六', '甲子', '鼠', NULL, 0, '儿童节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8920, '2044-06-02', '星期四', 2044, '五月', '初七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8921, '2044-06-03', '星期五', 2044, '五月', '初八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8922, '2044-06-04', '星期六', 2044, '五月', '初九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8923, '2044-06-05', '星期日', 2044, '五月', '初十 ', '甲子', '鼠', NULL, 1, '', '', '芒种', '', 7);
INSERT INTO `base_data_holiday` VALUES (8924, '2044-06-06', '星期一', 2044, '五月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8925, '2044-06-07', '星期二', 2044, '五月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8926, '2044-06-08', '星期三', 2044, '五月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8927, '2044-06-09', '星期四', 2044, '五月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8928, '2044-06-10', '星期五', 2044, '五月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8929, '2044-06-11', '星期六', 2044, '五月', '十六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8930, '2044-06-12', '星期日', 2044, '五月', '十七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8931, '2044-06-13', '星期一', 2044, '五月', '十八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8932, '2044-06-14', '星期二', 2044, '五月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8933, '2044-06-15', '星期三', 2044, '五月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8934, '2044-06-16', '星期四', 2044, '五月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8935, '2044-06-17', '星期五', 2044, '五月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8936, '2044-06-18', '星期六', 2044, '五月', '廿三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8937, '2044-06-19', '星期日', 2044, '五月', '廿四', '甲子', '鼠', NULL, 1, '', '', '', '父亲节', 7);
INSERT INTO `base_data_holiday` VALUES (8938, '2044-06-20', '星期一', 2044, '五月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8939, '2044-06-21', '星期二', 2044, '五月', '廿六', '甲子', '鼠', NULL, 0, '', '', '夏至', '', 7);
INSERT INTO `base_data_holiday` VALUES (8940, '2044-06-22', '星期三', 2044, '五月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8941, '2044-06-23', '星期四', 2044, '五月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8942, '2044-06-24', '星期五', 2044, '五月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8943, '2044-06-25', '星期六', 2044, '六月', '初一', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8944, '2044-06-26', '星期日', 2044, '六月', '初二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8945, '2044-06-27', '星期一', 2044, '六月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8946, '2044-06-28', '星期二', 2044, '六月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8947, '2044-06-29', '星期三', 2044, '六月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8948, '2044-06-30', '星期四', 2044, '六月', '初六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8949, '2044-07-01', '星期五', 2044, '六月', '初七', '甲子', '鼠', NULL, 0, '建党节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8950, '2044-07-02', '星期六', 2044, '六月', '初八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8951, '2044-07-03', '星期日', 2044, '六月', '初九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8952, '2044-07-04', '星期一', 2044, '六月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8953, '2044-07-05', '星期二', 2044, '六月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8954, '2044-07-06', '星期三', 2044, '六月', '十二', '甲子', '鼠', NULL, 0, '', '', '小暑', '', 7);
INSERT INTO `base_data_holiday` VALUES (8955, '2044-07-07', '星期四', 2044, '六月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8956, '2044-07-08', '星期五', 2044, '六月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8957, '2044-07-09', '星期六', 2044, '六月', '十五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8958, '2044-07-10', '星期日', 2044, '六月', '十六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8959, '2044-07-11', '星期一', 2044, '六月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8960, '2044-07-12', '星期二', 2044, '六月', '十八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8961, '2044-07-13', '星期三', 2044, '六月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8962, '2044-07-14', '星期四', 2044, '六月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8963, '2044-07-15', '星期五', 2044, '六月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8964, '2044-07-16', '星期六', 2044, '六月', '廿二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8965, '2044-07-17', '星期日', 2044, '六月', '廿三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8966, '2044-07-18', '星期一', 2044, '六月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8967, '2044-07-19', '星期二', 2044, '六月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8968, '2044-07-20', '星期三', 2044, '六月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8969, '2044-07-21', '星期四', 2044, '六月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8970, '2044-07-22', '星期五', 2044, '六月', '廿八', '甲子', '鼠', NULL, 0, '', '', '大暑', '', 7);
INSERT INTO `base_data_holiday` VALUES (8971, '2044-07-23', '星期六', 2044, '六月', '廿九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8972, '2044-07-24', '星期日', 2044, '六月', '三十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8973, '2044-07-25', '星期一', 2044, '七月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8974, '2044-07-26', '星期二', 2044, '七月', '初二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8975, '2044-07-27', '星期三', 2044, '七月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8976, '2044-07-28', '星期四', 2044, '七月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8977, '2044-07-29', '星期五', 2044, '七月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8978, '2044-07-30', '星期六', 2044, '七月', '初六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8979, '2044-07-31', '星期日', 2044, '七月', '初七', '甲子', '鼠', NULL, 1, '', '七夕', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8980, '2044-08-01', '星期一', 2044, '七月', '初八', '甲子', '鼠', NULL, 0, '建军节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8981, '2044-08-02', '星期二', 2044, '七月', '初九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8982, '2044-08-03', '星期三', 2044, '七月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8983, '2044-08-04', '星期四', 2044, '七月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8984, '2044-08-05', '星期五', 2044, '七月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8985, '2044-08-06', '星期六', 2044, '七月', '十三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8986, '2044-08-07', '星期日', 2044, '七月', '十四', '甲子', '鼠', NULL, 1, '', '', '立秋', '', 7);
INSERT INTO `base_data_holiday` VALUES (8987, '2044-08-08', '星期一', 2044, '七月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8988, '2044-08-09', '星期二', 2044, '七月', '十六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8989, '2044-08-10', '星期三', 2044, '七月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8990, '2044-08-11', '星期四', 2044, '七月', '十八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8991, '2044-08-12', '星期五', 2044, '七月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8992, '2044-08-13', '星期六', 2044, '七月', '二十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8993, '2044-08-14', '星期日', 2044, '七月', '廿一', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8994, '2044-08-15', '星期一', 2044, '七月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8995, '2044-08-16', '星期二', 2044, '七月', '廿三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8996, '2044-08-17', '星期三', 2044, '七月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8997, '2044-08-18', '星期四', 2044, '七月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8998, '2044-08-19', '星期五', 2044, '七月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (8999, '2044-08-20', '星期六', 2044, '七月', '廿七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9000, '2044-08-21', '星期日', 2044, '七月', '廿八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9001, '2044-08-22', '星期一', 2044, '七月', '廿九', '甲子', '鼠', NULL, 0, '', '', '处暑', '', 7);
INSERT INTO `base_data_holiday` VALUES (9002, '2044-08-23', '星期二', 2044, '闰七月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9003, '2044-08-24', '星期三', 2044, '闰七月', '初二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9004, '2044-08-25', '星期四', 2044, '闰七月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9005, '2044-08-26', '星期五', 2044, '闰七月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9006, '2044-08-27', '星期六', 2044, '闰七月', '初五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9007, '2044-08-28', '星期日', 2044, '闰七月', '初六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9008, '2044-08-29', '星期一', 2044, '闰七月', '初七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9009, '2044-08-30', '星期二', 2044, '闰七月', '初八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9010, '2044-08-31', '星期三', 2044, '闰七月', '初九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9011, '2044-09-01', '星期四', 2044, '闰七月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9012, '2044-09-02', '星期五', 2044, '闰七月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9013, '2044-09-03', '星期六', 2044, '闰七月', '十二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9014, '2044-09-04', '星期日', 2044, '闰七月', '十三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9015, '2044-09-05', '星期一', 2044, '闰七月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9016, '2044-09-06', '星期二', 2044, '闰七月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9017, '2044-09-07', '星期三', 2044, '闰七月', '十六', '甲子', '鼠', NULL, 0, '', '', '白露', '', 7);
INSERT INTO `base_data_holiday` VALUES (9018, '2044-09-08', '星期四', 2044, '闰七月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9019, '2044-09-09', '星期五', 2044, '闰七月', '十八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9020, '2044-09-10', '星期六', 2044, '闰七月', '十九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9021, '2044-09-11', '星期日', 2044, '闰七月', '二十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9022, '2044-09-12', '星期一', 2044, '闰七月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9023, '2044-09-13', '星期二', 2044, '闰七月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9024, '2044-09-14', '星期三', 2044, '闰七月', '廿三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9025, '2044-09-15', '星期四', 2044, '闰七月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9026, '2044-09-16', '星期五', 2044, '闰七月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9027, '2044-09-17', '星期六', 2044, '闰七月', '廿六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9028, '2044-09-18', '星期日', 2044, '闰七月', '廿七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9029, '2044-09-19', '星期一', 2044, '闰七月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9030, '2044-09-20', '星期二', 2044, '闰七月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9031, '2044-09-21', '星期三', 2044, '八月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9032, '2044-09-22', '星期四', 2044, '八月', '初二', '甲子', '鼠', NULL, 0, '农民丰收节', '', '秋分', '', 7);
INSERT INTO `base_data_holiday` VALUES (9033, '2044-09-23', '星期五', 2044, '八月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9034, '2044-09-24', '星期六', 2044, '八月', '初四', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9035, '2044-09-25', '星期日', 2044, '八月', '初五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9036, '2044-09-26', '星期一', 2044, '八月', '初六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9037, '2044-09-27', '星期二', 2044, '八月', '初七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9038, '2044-09-28', '星期三', 2044, '八月', '初八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9039, '2044-09-29', '星期四', 2044, '八月', '初九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9040, '2044-09-30', '星期五', 2044, '八月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9041, '2044-10-01', '星期六', 2044, '八月', '十一', '甲子', '鼠', NULL, 1, '国庆节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9042, '2044-10-02', '星期日', 2044, '八月', '十二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9043, '2044-10-03', '星期一', 2044, '八月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9044, '2044-10-04', '星期二', 2044, '八月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9045, '2044-10-05', '星期三', 2044, '八月', '十五', '甲子', '鼠', NULL, 0, '', '中秋节', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9046, '2044-10-06', '星期四', 2044, '八月', '十六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9047, '2044-10-07', '星期五', 2044, '八月', '十七', '甲子', '鼠', NULL, 0, '', '', '寒露', '', 7);
INSERT INTO `base_data_holiday` VALUES (9048, '2044-10-08', '星期六', 2044, '八月', '十八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9049, '2044-10-09', '星期日', 2044, '八月', '十九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9050, '2044-10-10', '星期一', 2044, '八月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9051, '2044-10-11', '星期二', 2044, '八月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9052, '2044-10-12', '星期三', 2044, '八月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9053, '2044-10-13', '星期四', 2044, '八月', '廿三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9054, '2044-10-14', '星期五', 2044, '八月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9055, '2044-10-15', '星期六', 2044, '八月', '廿五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9056, '2044-10-16', '星期日', 2044, '八月', '廿六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9057, '2044-10-17', '星期一', 2044, '八月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9058, '2044-10-18', '星期二', 2044, '八月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9059, '2044-10-19', '星期三', 2044, '八月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9060, '2044-10-20', '星期四', 2044, '八月', '三十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9061, '2044-10-21', '星期五', 2044, '九月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9062, '2044-10-22', '星期六', 2044, '九月', '初二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9063, '2044-10-23', '星期日', 2044, '九月', '初三', '甲子', '鼠', NULL, 1, '', '', '霜降', '', 7);
INSERT INTO `base_data_holiday` VALUES (9064, '2044-10-24', '星期一', 2044, '九月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9065, '2044-10-25', '星期二', 2044, '九月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9066, '2044-10-26', '星期三', 2044, '九月', '初六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9067, '2044-10-27', '星期四', 2044, '九月', '初七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9068, '2044-10-28', '星期五', 2044, '九月', '初八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9069, '2044-10-29', '星期六', 2044, '九月', '初九', '甲子', '鼠', NULL, 1, '', '重阳节', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9070, '2044-10-30', '星期日', 2044, '九月', '初十 ', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9071, '2044-10-31', '星期一', 2044, '九月', '十一', '甲子', '鼠', NULL, 0, '万圣节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9072, '2044-11-01', '星期二', 2044, '九月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9073, '2044-11-02', '星期三', 2044, '九月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9074, '2044-11-03', '星期四', 2044, '九月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9075, '2044-11-04', '星期五', 2044, '九月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9076, '2044-11-05', '星期六', 2044, '九月', '十六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9077, '2044-11-06', '星期日', 2044, '九月', '十七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9078, '2044-11-07', '星期一', 2044, '九月', '十八', '甲子', '鼠', NULL, 0, '', '', '立冬', '', 7);
INSERT INTO `base_data_holiday` VALUES (9079, '2044-11-08', '星期二', 2044, '九月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9080, '2044-11-09', '星期三', 2044, '九月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9081, '2044-11-10', '星期四', 2044, '九月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9082, '2044-11-11', '星期五', 2044, '九月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9083, '2044-11-12', '星期六', 2044, '九月', '廿三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9084, '2044-11-13', '星期日', 2044, '九月', '廿四', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9085, '2044-11-14', '星期一', 2044, '九月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9086, '2044-11-15', '星期二', 2044, '九月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9087, '2044-11-16', '星期三', 2044, '九月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9088, '2044-11-17', '星期四', 2044, '九月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9089, '2044-11-18', '星期五', 2044, '九月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9090, '2044-11-19', '星期六', 2044, '十月', '初一', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9091, '2044-11-20', '星期日', 2044, '十月', '初二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9092, '2044-11-21', '星期一', 2044, '十月', '初三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9093, '2044-11-22', '星期二', 2044, '十月', '初四', '甲子', '鼠', NULL, 0, '', '', '小雪', '', 7);
INSERT INTO `base_data_holiday` VALUES (9094, '2044-11-23', '星期三', 2044, '十月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9095, '2044-11-24', '星期四', 2044, '十月', '初六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9096, '2044-11-25', '星期五', 2044, '十月', '初七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9097, '2044-11-26', '星期六', 2044, '十月', '初八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9098, '2044-11-27', '星期日', 2044, '十月', '初九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9099, '2044-11-28', '星期一', 2044, '十月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9100, '2044-11-29', '星期二', 2044, '十月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9101, '2044-11-30', '星期三', 2044, '十月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9102, '2044-12-01', '星期四', 2044, '十月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9103, '2044-12-02', '星期五', 2044, '十月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9104, '2044-12-03', '星期六', 2044, '十月', '十五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9105, '2044-12-04', '星期日', 2044, '十月', '十六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9106, '2044-12-05', '星期一', 2044, '十月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9107, '2044-12-06', '星期二', 2044, '十月', '十八', '甲子', '鼠', NULL, 0, '', '', '大雪', '', 7);
INSERT INTO `base_data_holiday` VALUES (9108, '2044-12-07', '星期三', 2044, '十月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9109, '2044-12-08', '星期四', 2044, '十月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9110, '2044-12-09', '星期五', 2044, '十月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9111, '2044-12-10', '星期六', 2044, '十月', '廿二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9112, '2044-12-11', '星期日', 2044, '十月', '廿三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9113, '2044-12-12', '星期一', 2044, '十月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9114, '2044-12-13', '星期二', 2044, '十月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9115, '2044-12-14', '星期三', 2044, '十月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9116, '2044-12-15', '星期四', 2044, '十月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9117, '2044-12-16', '星期五', 2044, '十月', '廿八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9118, '2044-12-17', '星期六', 2044, '十月', '廿九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9119, '2044-12-18', '星期日', 2044, '十月', '三十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9120, '2044-12-19', '星期一', 2044, '冬月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9121, '2044-12-20', '星期二', 2044, '冬月', '初二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9122, '2044-12-21', '星期三', 2044, '冬月', '初三', '甲子', '鼠', NULL, 0, '', '', '冬至', '', 7);
INSERT INTO `base_data_holiday` VALUES (9123, '2044-12-22', '星期四', 2044, '冬月', '初四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9124, '2044-12-23', '星期五', 2044, '冬月', '初五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9125, '2044-12-24', '星期六', 2044, '冬月', '初六', '甲子', '鼠', NULL, 1, '平安夜', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9126, '2044-12-25', '星期日', 2044, '冬月', '初七', '甲子', '鼠', NULL, 1, '圣诞节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9127, '2044-12-26', '星期一', 2044, '冬月', '初八', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9128, '2044-12-27', '星期二', 2044, '冬月', '初九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9129, '2044-12-28', '星期三', 2044, '冬月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9130, '2044-12-29', '星期四', 2044, '冬月', '十一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9131, '2044-12-30', '星期五', 2044, '冬月', '十二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9132, '2044-12-31', '星期六', 2044, '冬月', '十三', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9133, '2045-01-01', '星期日', 2044, '冬月', '十四', '甲子', '鼠', NULL, 1, '元旦', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9134, '2045-01-02', '星期一', 2044, '冬月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9135, '2045-01-03', '星期二', 2044, '冬月', '十六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9136, '2045-01-04', '星期三', 2044, '冬月', '十七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9137, '2045-01-05', '星期四', 2044, '冬月', '十八', '甲子', '鼠', NULL, 0, '', '', '小寒', '', 7);
INSERT INTO `base_data_holiday` VALUES (9138, '2045-01-06', '星期五', 2044, '冬月', '十九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9139, '2045-01-07', '星期六', 2044, '冬月', '二十', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9140, '2045-01-08', '星期日', 2044, '冬月', '廿一', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9141, '2045-01-09', '星期一', 2044, '冬月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9142, '2045-01-10', '星期二', 2044, '冬月', '廿三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9143, '2045-01-11', '星期三', 2044, '冬月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9144, '2045-01-12', '星期四', 2044, '冬月', '廿五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9145, '2045-01-13', '星期五', 2044, '冬月', '廿六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9146, '2045-01-14', '星期六', 2044, '冬月', '廿七', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9147, '2045-01-15', '星期日', 2044, '冬月', '廿八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9148, '2045-01-16', '星期一', 2044, '冬月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9149, '2045-01-17', '星期二', 2044, '冬月', '三十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9150, '2045-01-18', '星期三', 2044, '腊月', '初一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9151, '2045-01-19', '星期四', 2044, '腊月', '初二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9152, '2045-01-20', '星期五', 2044, '腊月', '初三', '甲子', '鼠', NULL, 0, '', '', '大寒', '', 7);
INSERT INTO `base_data_holiday` VALUES (9153, '2045-01-21', '星期六', 2044, '腊月', '初四', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9154, '2045-01-22', '星期日', 2044, '腊月', '初五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9155, '2045-01-23', '星期一', 2044, '腊月', '初六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9156, '2045-01-24', '星期二', 2044, '腊月', '初七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9157, '2045-01-25', '星期三', 2044, '腊月', '初八', '甲子', '鼠', NULL, 0, '', '腊八节', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9158, '2045-01-26', '星期四', 2044, '腊月', '初九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9159, '2045-01-27', '星期五', 2044, '腊月', '初十 ', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9160, '2045-01-28', '星期六', 2044, '腊月', '十一', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9161, '2045-01-29', '星期日', 2044, '腊月', '十二', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9162, '2045-01-30', '星期一', 2044, '腊月', '十三', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9163, '2045-01-31', '星期二', 2044, '腊月', '十四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9164, '2045-02-01', '星期三', 2044, '腊月', '十五', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9165, '2045-02-02', '星期四', 2044, '腊月', '十六', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9166, '2045-02-03', '星期五', 2044, '腊月', '十七', '甲子', '鼠', NULL, 0, '', '', '立春', '', 7);
INSERT INTO `base_data_holiday` VALUES (9167, '2045-02-04', '星期六', 2044, '腊月', '十八', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9168, '2045-02-05', '星期日', 2044, '腊月', '十九', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9169, '2045-02-06', '星期一', 2044, '腊月', '二十', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9170, '2045-02-07', '星期二', 2044, '腊月', '廿一', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9171, '2045-02-08', '星期三', 2044, '腊月', '廿二', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9172, '2045-02-09', '星期四', 2044, '腊月', '廿三', '甲子', '鼠', NULL, 0, '', '小年', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9173, '2045-02-10', '星期五', 2044, '腊月', '廿四', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9174, '2045-02-11', '星期六', 2044, '腊月', '廿五', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9175, '2045-02-12', '星期日', 2044, '腊月', '廿六', '甲子', '鼠', NULL, 1, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9176, '2045-02-13', '星期一', 2044, '腊月', '廿七', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9177, '2045-02-14', '星期二', 2044, '腊月', '廿八', '甲子', '鼠', NULL, 0, '情人节', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9178, '2045-02-15', '星期三', 2044, '腊月', '廿九', '甲子', '鼠', NULL, 0, '', '', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9179, '2045-02-16', '星期四', 2044, '腊月', '三十', '甲子', '鼠', NULL, 0, '', '除夕', '', '', 7);
INSERT INTO `base_data_holiday` VALUES (9180, '2045-02-17', '星期五', 2045, '正月', '初一', '乙丑', '牛', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9181, '2045-02-18', '星期六', 2045, '正月', '初二', '乙丑', '牛', NULL, 1, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (9182, '2045-02-19', '星期日', 2045, '正月', '初三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9183, '2045-02-20', '星期一', 2045, '正月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9184, '2045-02-21', '星期二', 2045, '正月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9185, '2045-02-22', '星期三', 2045, '正月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9186, '2045-02-23', '星期四', 2045, '正月', '初七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9187, '2045-02-24', '星期五', 2045, '正月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9188, '2045-02-25', '星期六', 2045, '正月', '初九', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9189, '2045-02-26', '星期日', 2045, '正月', '初十 ', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9190, '2045-02-27', '星期一', 2045, '正月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9191, '2045-02-28', '星期二', 2045, '正月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9192, '2045-03-01', '星期三', 2045, '正月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9193, '2045-03-02', '星期四', 2045, '正月', '十四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9194, '2045-03-03', '星期五', 2045, '正月', '十五', '乙丑', '牛', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9195, '2045-03-04', '星期六', 2045, '正月', '十六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9196, '2045-03-05', '星期日', 2045, '正月', '十七', '乙丑', '牛', NULL, 1, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (9197, '2045-03-06', '星期一', 2045, '正月', '十八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9198, '2045-03-07', '星期二', 2045, '正月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9199, '2045-03-08', '星期三', 2045, '正月', '二十', '乙丑', '牛', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9200, '2045-03-09', '星期四', 2045, '正月', '廿一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9201, '2045-03-10', '星期五', 2045, '正月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9202, '2045-03-11', '星期六', 2045, '正月', '廿三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9203, '2045-03-12', '星期日', 2045, '正月', '廿四', '乙丑', '牛', NULL, 1, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9204, '2045-03-13', '星期一', 2045, '正月', '廿五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9205, '2045-03-14', '星期二', 2045, '正月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9206, '2045-03-15', '星期三', 2045, '正月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9207, '2045-03-16', '星期四', 2045, '正月', '廿八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9208, '2045-03-17', '星期五', 2045, '正月', '廿九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9209, '2045-03-18', '星期六', 2045, '正月', '三十', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9210, '2045-03-19', '星期日', 2045, '二月', '初一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9211, '2045-03-20', '星期一', 2045, '二月', '初二', '乙丑', '牛', NULL, 0, '', '龙抬头', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (9212, '2045-03-21', '星期二', 2045, '二月', '初三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9213, '2045-03-22', '星期三', 2045, '二月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9214, '2045-03-23', '星期四', 2045, '二月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9215, '2045-03-24', '星期五', 2045, '二月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9216, '2045-03-25', '星期六', 2045, '二月', '初七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9217, '2045-03-26', '星期日', 2045, '二月', '初八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9218, '2045-03-27', '星期一', 2045, '二月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9219, '2045-03-28', '星期二', 2045, '二月', '初十 ', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9220, '2045-03-29', '星期三', 2045, '二月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9221, '2045-03-30', '星期四', 2045, '二月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9222, '2045-03-31', '星期五', 2045, '二月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9223, '2045-04-01', '星期六', 2045, '二月', '十四', '乙丑', '牛', NULL, 1, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9224, '2045-04-02', '星期日', 2045, '二月', '十五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9225, '2045-04-03', '星期一', 2045, '二月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9226, '2045-04-04', '星期二', 2045, '二月', '十七', '乙丑', '牛', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (9227, '2045-04-05', '星期三', 2045, '二月', '十八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9228, '2045-04-06', '星期四', 2045, '二月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9229, '2045-04-07', '星期五', 2045, '二月', '二十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9230, '2045-04-08', '星期六', 2045, '二月', '廿一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9231, '2045-04-09', '星期日', 2045, '二月', '廿二', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9232, '2045-04-10', '星期一', 2045, '二月', '廿三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9233, '2045-04-11', '星期二', 2045, '二月', '廿四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9234, '2045-04-12', '星期三', 2045, '二月', '廿五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9235, '2045-04-13', '星期四', 2045, '二月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9236, '2045-04-14', '星期五', 2045, '二月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9237, '2045-04-15', '星期六', 2045, '二月', '廿八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9238, '2045-04-16', '星期日', 2045, '二月', '廿九', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9239, '2045-04-17', '星期一', 2045, '三月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9240, '2045-04-18', '星期二', 2045, '三月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9241, '2045-04-19', '星期三', 2045, '三月', '初三', '乙丑', '牛', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (9242, '2045-04-20', '星期四', 2045, '三月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9243, '2045-04-21', '星期五', 2045, '三月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9244, '2045-04-22', '星期六', 2045, '三月', '初六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9245, '2045-04-23', '星期日', 2045, '三月', '初七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9246, '2045-04-24', '星期一', 2045, '三月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9247, '2045-04-25', '星期二', 2045, '三月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9248, '2045-04-26', '星期三', 2045, '三月', '初十 ', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9249, '2045-04-27', '星期四', 2045, '三月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9250, '2045-04-28', '星期五', 2045, '三月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9251, '2045-04-29', '星期六', 2045, '三月', '十三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9252, '2045-04-30', '星期日', 2045, '三月', '十四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9253, '2045-05-01', '星期一', 2045, '三月', '十五', '乙丑', '牛', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9254, '2045-05-02', '星期二', 2045, '三月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9255, '2045-05-03', '星期三', 2045, '三月', '十七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9256, '2045-05-04', '星期四', 2045, '三月', '十八', '乙丑', '牛', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9257, '2045-05-05', '星期五', 2045, '三月', '十九', '乙丑', '牛', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (9258, '2045-05-06', '星期六', 2045, '三月', '二十', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9259, '2045-05-07', '星期日', 2045, '三月', '廿一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9260, '2045-05-08', '星期一', 2045, '三月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9261, '2045-05-09', '星期二', 2045, '三月', '廿三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9262, '2045-05-10', '星期三', 2045, '三月', '廿四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9263, '2045-05-11', '星期四', 2045, '三月', '廿五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9264, '2045-05-12', '星期五', 2045, '三月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9265, '2045-05-13', '星期六', 2045, '三月', '廿七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9266, '2045-05-14', '星期日', 2045, '三月', '廿八', '乙丑', '牛', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (9267, '2045-05-15', '星期一', 2045, '三月', '廿九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9268, '2045-05-16', '星期二', 2045, '三月', '三十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9269, '2045-05-17', '星期三', 2045, '四月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9270, '2045-05-18', '星期四', 2045, '四月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9271, '2045-05-19', '星期五', 2045, '四月', '初三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9272, '2045-05-20', '星期六', 2045, '四月', '初四', '乙丑', '牛', NULL, 1, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (9273, '2045-05-21', '星期日', 2045, '四月', '初五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9274, '2045-05-22', '星期一', 2045, '四月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9275, '2045-05-23', '星期二', 2045, '四月', '初七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9276, '2045-05-24', '星期三', 2045, '四月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9277, '2045-05-25', '星期四', 2045, '四月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9278, '2045-05-26', '星期五', 2045, '四月', '初十 ', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9279, '2045-05-27', '星期六', 2045, '四月', '十一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9280, '2045-05-28', '星期日', 2045, '四月', '十二', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9281, '2045-05-29', '星期一', 2045, '四月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9282, '2045-05-30', '星期二', 2045, '四月', '十四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9283, '2045-05-31', '星期三', 2045, '四月', '十五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9284, '2045-06-01', '星期四', 2045, '四月', '十六', '乙丑', '牛', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9285, '2045-06-02', '星期五', 2045, '四月', '十七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9286, '2045-06-03', '星期六', 2045, '四月', '十八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9287, '2045-06-04', '星期日', 2045, '四月', '十九', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9288, '2045-06-05', '星期一', 2045, '四月', '二十', '乙丑', '牛', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (9289, '2045-06-06', '星期二', 2045, '四月', '廿一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9290, '2045-06-07', '星期三', 2045, '四月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9291, '2045-06-08', '星期四', 2045, '四月', '廿三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9292, '2045-06-09', '星期五', 2045, '四月', '廿四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9293, '2045-06-10', '星期六', 2045, '四月', '廿五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9294, '2045-06-11', '星期日', 2045, '四月', '廿六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9295, '2045-06-12', '星期一', 2045, '四月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9296, '2045-06-13', '星期二', 2045, '四月', '廿八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9297, '2045-06-14', '星期三', 2045, '四月', '廿九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9298, '2045-06-15', '星期四', 2045, '五月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9299, '2045-06-16', '星期五', 2045, '五月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9300, '2045-06-17', '星期六', 2045, '五月', '初三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9301, '2045-06-18', '星期日', 2045, '五月', '初四', '乙丑', '牛', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (9302, '2045-06-19', '星期一', 2045, '五月', '初五', '乙丑', '牛', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9303, '2045-06-20', '星期二', 2045, '五月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9304, '2045-06-21', '星期三', 2045, '五月', '初七', '乙丑', '牛', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (9305, '2045-06-22', '星期四', 2045, '五月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9306, '2045-06-23', '星期五', 2045, '五月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9307, '2045-06-24', '星期六', 2045, '五月', '初十 ', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9308, '2045-06-25', '星期日', 2045, '五月', '十一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9309, '2045-06-26', '星期一', 2045, '五月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9310, '2045-06-27', '星期二', 2045, '五月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9311, '2045-06-28', '星期三', 2045, '五月', '十四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9312, '2045-06-29', '星期四', 2045, '五月', '十五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9313, '2045-06-30', '星期五', 2045, '五月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9314, '2045-07-01', '星期六', 2045, '五月', '十七', '乙丑', '牛', NULL, 1, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9315, '2045-07-02', '星期日', 2045, '五月', '十八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9316, '2045-07-03', '星期一', 2045, '五月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9317, '2045-07-04', '星期二', 2045, '五月', '二十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9318, '2045-07-05', '星期三', 2045, '五月', '廿一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9319, '2045-07-06', '星期四', 2045, '五月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9320, '2045-07-07', '星期五', 2045, '五月', '廿三', '乙丑', '牛', NULL, 0, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (9321, '2045-07-08', '星期六', 2045, '五月', '廿四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9322, '2045-07-09', '星期日', 2045, '五月', '廿五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9323, '2045-07-10', '星期一', 2045, '五月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9324, '2045-07-11', '星期二', 2045, '五月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9325, '2045-07-12', '星期三', 2045, '五月', '廿八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9326, '2045-07-13', '星期四', 2045, '五月', '廿九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9327, '2045-07-14', '星期五', 2045, '六月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9328, '2045-07-15', '星期六', 2045, '六月', '初二', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9329, '2045-07-16', '星期日', 2045, '六月', '初三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9330, '2045-07-17', '星期一', 2045, '六月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9331, '2045-07-18', '星期二', 2045, '六月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9332, '2045-07-19', '星期三', 2045, '六月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9333, '2045-07-20', '星期四', 2045, '六月', '初七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9334, '2045-07-21', '星期五', 2045, '六月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9335, '2045-07-22', '星期六', 2045, '六月', '初九', '乙丑', '牛', NULL, 1, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (9336, '2045-07-23', '星期日', 2045, '六月', '初十 ', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9337, '2045-07-24', '星期一', 2045, '六月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9338, '2045-07-25', '星期二', 2045, '六月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9339, '2045-07-26', '星期三', 2045, '六月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9340, '2045-07-27', '星期四', 2045, '六月', '十四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9341, '2045-07-28', '星期五', 2045, '六月', '十五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9342, '2045-07-29', '星期六', 2045, '六月', '十六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9343, '2045-07-30', '星期日', 2045, '六月', '十七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9344, '2045-07-31', '星期一', 2045, '六月', '十八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9345, '2045-08-01', '星期二', 2045, '六月', '十九', '乙丑', '牛', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9346, '2045-08-02', '星期三', 2045, '六月', '二十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9347, '2045-08-03', '星期四', 2045, '六月', '廿一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9348, '2045-08-04', '星期五', 2045, '六月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9349, '2045-08-05', '星期六', 2045, '六月', '廿三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9350, '2045-08-06', '星期日', 2045, '六月', '廿四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9351, '2045-08-07', '星期一', 2045, '六月', '廿五', '乙丑', '牛', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (9352, '2045-08-08', '星期二', 2045, '六月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9353, '2045-08-09', '星期三', 2045, '六月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9354, '2045-08-10', '星期四', 2045, '六月', '廿八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9355, '2045-08-11', '星期五', 2045, '六月', '廿九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9356, '2045-08-12', '星期六', 2045, '六月', '三十', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9357, '2045-08-13', '星期日', 2045, '七月', '初一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9358, '2045-08-14', '星期一', 2045, '七月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9359, '2045-08-15', '星期二', 2045, '七月', '初三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9360, '2045-08-16', '星期三', 2045, '七月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9361, '2045-08-17', '星期四', 2045, '七月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9362, '2045-08-18', '星期五', 2045, '七月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9363, '2045-08-19', '星期六', 2045, '七月', '初七', '乙丑', '牛', NULL, 1, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9364, '2045-08-20', '星期日', 2045, '七月', '初八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9365, '2045-08-21', '星期一', 2045, '七月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9366, '2045-08-22', '星期二', 2045, '七月', '初十 ', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9367, '2045-08-23', '星期三', 2045, '七月', '十一', '乙丑', '牛', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (9368, '2045-08-24', '星期四', 2045, '七月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9369, '2045-08-25', '星期五', 2045, '七月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9370, '2045-08-26', '星期六', 2045, '七月', '十四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9371, '2045-08-27', '星期日', 2045, '七月', '十五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9372, '2045-08-28', '星期一', 2045, '七月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9373, '2045-08-29', '星期二', 2045, '七月', '十七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9374, '2045-08-30', '星期三', 2045, '七月', '十八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9375, '2045-08-31', '星期四', 2045, '七月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9376, '2045-09-01', '星期五', 2045, '七月', '二十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9377, '2045-09-02', '星期六', 2045, '七月', '廿一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9378, '2045-09-03', '星期日', 2045, '七月', '廿二', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9379, '2045-09-04', '星期一', 2045, '七月', '廿三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9380, '2045-09-05', '星期二', 2045, '七月', '廿四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9381, '2045-09-06', '星期三', 2045, '七月', '廿五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9382, '2045-09-07', '星期四', 2045, '七月', '廿六', '乙丑', '牛', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (9383, '2045-09-08', '星期五', 2045, '七月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9384, '2045-09-09', '星期六', 2045, '七月', '廿八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9385, '2045-09-10', '星期日', 2045, '七月', '廿九', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9386, '2045-09-11', '星期一', 2045, '八月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9387, '2045-09-12', '星期二', 2045, '八月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9388, '2045-09-13', '星期三', 2045, '八月', '初三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9389, '2045-09-14', '星期四', 2045, '八月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9390, '2045-09-15', '星期五', 2045, '八月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9391, '2045-09-16', '星期六', 2045, '八月', '初六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9392, '2045-09-17', '星期日', 2045, '八月', '初七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9393, '2045-09-18', '星期一', 2045, '八月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9394, '2045-09-19', '星期二', 2045, '八月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9395, '2045-09-20', '星期三', 2045, '八月', '初十 ', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9396, '2045-09-21', '星期四', 2045, '八月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9397, '2045-09-22', '星期五', 2045, '八月', '十二', '乙丑', '牛', NULL, 0, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (9398, '2045-09-23', '星期六', 2045, '八月', '十三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9399, '2045-09-24', '星期日', 2045, '八月', '十四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9400, '2045-09-25', '星期一', 2045, '八月', '十五', '乙丑', '牛', NULL, 0, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9401, '2045-09-26', '星期二', 2045, '八月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9402, '2045-09-27', '星期三', 2045, '八月', '十七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9403, '2045-09-28', '星期四', 2045, '八月', '十八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9404, '2045-09-29', '星期五', 2045, '八月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9405, '2045-09-30', '星期六', 2045, '八月', '二十', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9406, '2045-10-01', '星期日', 2045, '八月', '廿一', '乙丑', '牛', NULL, 1, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9407, '2045-10-02', '星期一', 2045, '八月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9408, '2045-10-03', '星期二', 2045, '八月', '廿三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9409, '2045-10-04', '星期三', 2045, '八月', '廿四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9410, '2045-10-05', '星期四', 2045, '八月', '廿五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9411, '2045-10-06', '星期五', 2045, '八月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9412, '2045-10-07', '星期六', 2045, '八月', '廿七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9413, '2045-10-08', '星期日', 2045, '八月', '廿八', '乙丑', '牛', NULL, 1, '', '', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (9414, '2045-10-09', '星期一', 2045, '八月', '廿九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9415, '2045-10-10', '星期二', 2045, '九月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9416, '2045-10-11', '星期三', 2045, '九月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9417, '2045-10-12', '星期四', 2045, '九月', '初三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9418, '2045-10-13', '星期五', 2045, '九月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9419, '2045-10-14', '星期六', 2045, '九月', '初五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9420, '2045-10-15', '星期日', 2045, '九月', '初六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9421, '2045-10-16', '星期一', 2045, '九月', '初七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9422, '2045-10-17', '星期二', 2045, '九月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9423, '2045-10-18', '星期三', 2045, '九月', '初九', '乙丑', '牛', NULL, 0, '', '重阳节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9424, '2045-10-19', '星期四', 2045, '九月', '初十 ', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9425, '2045-10-20', '星期五', 2045, '九月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9426, '2045-10-21', '星期六', 2045, '九月', '十二', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9427, '2045-10-22', '星期日', 2045, '九月', '十三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9428, '2045-10-23', '星期一', 2045, '九月', '十四', '乙丑', '牛', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (9429, '2045-10-24', '星期二', 2045, '九月', '十五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9430, '2045-10-25', '星期三', 2045, '九月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9431, '2045-10-26', '星期四', 2045, '九月', '十七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9432, '2045-10-27', '星期五', 2045, '九月', '十八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9433, '2045-10-28', '星期六', 2045, '九月', '十九', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9434, '2045-10-29', '星期日', 2045, '九月', '二十', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9435, '2045-10-30', '星期一', 2045, '九月', '廿一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9436, '2045-10-31', '星期二', 2045, '九月', '廿二', '乙丑', '牛', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9437, '2045-11-01', '星期三', 2045, '九月', '廿三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9438, '2045-11-02', '星期四', 2045, '九月', '廿四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9439, '2045-11-03', '星期五', 2045, '九月', '廿五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9440, '2045-11-04', '星期六', 2045, '九月', '廿六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9441, '2045-11-05', '星期日', 2045, '九月', '廿七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9442, '2045-11-06', '星期一', 2045, '九月', '廿八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9443, '2045-11-07', '星期二', 2045, '九月', '廿九', '乙丑', '牛', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (9444, '2045-11-08', '星期三', 2045, '九月', '三十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9445, '2045-11-09', '星期四', 2045, '十月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9446, '2045-11-10', '星期五', 2045, '十月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9447, '2045-11-11', '星期六', 2045, '十月', '初三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9448, '2045-11-12', '星期日', 2045, '十月', '初四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9449, '2045-11-13', '星期一', 2045, '十月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9450, '2045-11-14', '星期二', 2045, '十月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9451, '2045-11-15', '星期三', 2045, '十月', '初七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9452, '2045-11-16', '星期四', 2045, '十月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9453, '2045-11-17', '星期五', 2045, '十月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9454, '2045-11-18', '星期六', 2045, '十月', '初十 ', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9455, '2045-11-19', '星期日', 2045, '十月', '十一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9456, '2045-11-20', '星期一', 2045, '十月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9457, '2045-11-21', '星期二', 2045, '十月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9458, '2045-11-22', '星期三', 2045, '十月', '十四', '乙丑', '牛', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (9459, '2045-11-23', '星期四', 2045, '十月', '十五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9460, '2045-11-24', '星期五', 2045, '十月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9461, '2045-11-25', '星期六', 2045, '十月', '十七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9462, '2045-11-26', '星期日', 2045, '十月', '十八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9463, '2045-11-27', '星期一', 2045, '十月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9464, '2045-11-28', '星期二', 2045, '十月', '二十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9465, '2045-11-29', '星期三', 2045, '十月', '廿一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9466, '2045-11-30', '星期四', 2045, '十月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9467, '2045-12-01', '星期五', 2045, '十月', '廿三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9468, '2045-12-02', '星期六', 2045, '十月', '廿四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9469, '2045-12-03', '星期日', 2045, '十月', '廿五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9470, '2045-12-04', '星期一', 2045, '十月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9471, '2045-12-05', '星期二', 2045, '十月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9472, '2045-12-06', '星期三', 2045, '十月', '廿八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9473, '2045-12-07', '星期四', 2045, '十月', '廿九', '乙丑', '牛', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (9474, '2045-12-08', '星期五', 2045, '冬月', '初一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9475, '2045-12-09', '星期六', 2045, '冬月', '初二', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9476, '2045-12-10', '星期日', 2045, '冬月', '初三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9477, '2045-12-11', '星期一', 2045, '冬月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9478, '2045-12-12', '星期二', 2045, '冬月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9479, '2045-12-13', '星期三', 2045, '冬月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9480, '2045-12-14', '星期四', 2045, '冬月', '初七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9481, '2045-12-15', '星期五', 2045, '冬月', '初八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9482, '2045-12-16', '星期六', 2045, '冬月', '初九', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9483, '2045-12-17', '星期日', 2045, '冬月', '初十 ', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9484, '2045-12-18', '星期一', 2045, '冬月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9485, '2045-12-19', '星期二', 2045, '冬月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9486, '2045-12-20', '星期三', 2045, '冬月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9487, '2045-12-21', '星期四', 2045, '冬月', '十四', '乙丑', '牛', NULL, 0, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (9488, '2045-12-22', '星期五', 2045, '冬月', '十五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9489, '2045-12-23', '星期六', 2045, '冬月', '十六', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9490, '2045-12-24', '星期日', 2045, '冬月', '十七', '乙丑', '牛', NULL, 1, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9491, '2045-12-25', '星期一', 2045, '冬月', '十八', '乙丑', '牛', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9492, '2045-12-26', '星期二', 2045, '冬月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9493, '2045-12-27', '星期三', 2045, '冬月', '二十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9494, '2045-12-28', '星期四', 2045, '冬月', '廿一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9495, '2045-12-29', '星期五', 2045, '冬月', '廿二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9496, '2045-12-30', '星期六', 2045, '冬月', '廿三', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9497, '2045-12-31', '星期日', 2045, '冬月', '廿四', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9498, '2046-01-01', '星期一', 2045, '冬月', '廿五', '乙丑', '牛', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9499, '2046-01-02', '星期二', 2045, '冬月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9500, '2046-01-03', '星期三', 2045, '冬月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9501, '2046-01-04', '星期四', 2045, '冬月', '廿八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9502, '2046-01-05', '星期五', 2045, '冬月', '廿九', '乙丑', '牛', NULL, 0, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (9503, '2046-01-06', '星期六', 2045, '冬月', '三十', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9504, '2046-01-07', '星期日', 2045, '腊月', '初一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9505, '2046-01-08', '星期一', 2045, '腊月', '初二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9506, '2046-01-09', '星期二', 2045, '腊月', '初三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9507, '2046-01-10', '星期三', 2045, '腊月', '初四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9508, '2046-01-11', '星期四', 2045, '腊月', '初五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9509, '2046-01-12', '星期五', 2045, '腊月', '初六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9510, '2046-01-13', '星期六', 2045, '腊月', '初七', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9511, '2046-01-14', '星期日', 2045, '腊月', '初八', '乙丑', '牛', NULL, 1, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9512, '2046-01-15', '星期一', 2045, '腊月', '初九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9513, '2046-01-16', '星期二', 2045, '腊月', '初十 ', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9514, '2046-01-17', '星期三', 2045, '腊月', '十一', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9515, '2046-01-18', '星期四', 2045, '腊月', '十二', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9516, '2046-01-19', '星期五', 2045, '腊月', '十三', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9517, '2046-01-20', '星期六', 2045, '腊月', '十四', '乙丑', '牛', NULL, 1, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (9518, '2046-01-21', '星期日', 2045, '腊月', '十五', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9519, '2046-01-22', '星期一', 2045, '腊月', '十六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9520, '2046-01-23', '星期二', 2045, '腊月', '十七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9521, '2046-01-24', '星期三', 2045, '腊月', '十八', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9522, '2046-01-25', '星期四', 2045, '腊月', '十九', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9523, '2046-01-26', '星期五', 2045, '腊月', '二十', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9524, '2046-01-27', '星期六', 2045, '腊月', '廿一', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9525, '2046-01-28', '星期日', 2045, '腊月', '廿二', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9526, '2046-01-29', '星期一', 2045, '腊月', '廿三', '乙丑', '牛', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9527, '2046-01-30', '星期二', 2045, '腊月', '廿四', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9528, '2046-01-31', '星期三', 2045, '腊月', '廿五', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9529, '2046-02-01', '星期四', 2045, '腊月', '廿六', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9530, '2046-02-02', '星期五', 2045, '腊月', '廿七', '乙丑', '牛', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9531, '2046-02-03', '星期六', 2045, '腊月', '廿八', '乙丑', '牛', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9532, '2046-02-04', '星期日', 2045, '腊月', '廿九', '乙丑', '牛', NULL, 1, '', '', '立春', '', 0);
INSERT INTO `base_data_holiday` VALUES (9533, '2046-02-05', '星期一', 2045, '腊月', '三十', '乙丑', '牛', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9534, '2046-02-06', '星期二', 2046, '正月', '初一', '丙寅', '虎', NULL, 0, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9535, '2046-02-07', '星期三', 2046, '正月', '初二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9536, '2046-02-08', '星期四', 2046, '正月', '初三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9537, '2046-02-09', '星期五', 2046, '正月', '初四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9538, '2046-02-10', '星期六', 2046, '正月', '初五', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9539, '2046-02-11', '星期日', 2046, '正月', '初六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9540, '2046-02-12', '星期一', 2046, '正月', '初七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9541, '2046-02-13', '星期二', 2046, '正月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9542, '2046-02-14', '星期三', 2046, '正月', '初九', '丙寅', '虎', NULL, 0, '情人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9543, '2046-02-15', '星期四', 2046, '正月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9544, '2046-02-16', '星期五', 2046, '正月', '十一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9545, '2046-02-17', '星期六', 2046, '正月', '十二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9546, '2046-02-18', '星期日', 2046, '正月', '十三', '丙寅', '虎', NULL, 1, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (9547, '2046-02-19', '星期一', 2046, '正月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9548, '2046-02-20', '星期二', 2046, '正月', '十五', '丙寅', '虎', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9549, '2046-02-21', '星期三', 2046, '正月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9550, '2046-02-22', '星期四', 2046, '正月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9551, '2046-02-23', '星期五', 2046, '正月', '十八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9552, '2046-02-24', '星期六', 2046, '正月', '十九', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9553, '2046-02-25', '星期日', 2046, '正月', '二十', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9554, '2046-02-26', '星期一', 2046, '正月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9555, '2046-02-27', '星期二', 2046, '正月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9556, '2046-02-28', '星期三', 2046, '正月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9557, '2046-03-01', '星期四', 2046, '正月', '廿四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9558, '2046-03-02', '星期五', 2046, '正月', '廿五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9559, '2046-03-03', '星期六', 2046, '正月', '廿六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9560, '2046-03-04', '星期日', 2046, '正月', '廿七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9561, '2046-03-05', '星期一', 2046, '正月', '廿八', '丙寅', '虎', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (9562, '2046-03-06', '星期二', 2046, '正月', '廿九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9563, '2046-03-07', '星期三', 2046, '正月', '三十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9564, '2046-03-08', '星期四', 2046, '二月', '初一', '丙寅', '虎', NULL, 0, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9565, '2046-03-09', '星期五', 2046, '二月', '初二', '丙寅', '虎', NULL, 0, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9566, '2046-03-10', '星期六', 2046, '二月', '初三', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9567, '2046-03-11', '星期日', 2046, '二月', '初四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9568, '2046-03-12', '星期一', 2046, '二月', '初五', '丙寅', '虎', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9569, '2046-03-13', '星期二', 2046, '二月', '初六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9570, '2046-03-14', '星期三', 2046, '二月', '初七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9571, '2046-03-15', '星期四', 2046, '二月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9572, '2046-03-16', '星期五', 2046, '二月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9573, '2046-03-17', '星期六', 2046, '二月', '初十 ', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9574, '2046-03-18', '星期日', 2046, '二月', '十一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9575, '2046-03-19', '星期一', 2046, '二月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9576, '2046-03-20', '星期二', 2046, '二月', '十三', '丙寅', '虎', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (9577, '2046-03-21', '星期三', 2046, '二月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9578, '2046-03-22', '星期四', 2046, '二月', '十五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9579, '2046-03-23', '星期五', 2046, '二月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9580, '2046-03-24', '星期六', 2046, '二月', '十七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9581, '2046-03-25', '星期日', 2046, '二月', '十八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9582, '2046-03-26', '星期一', 2046, '二月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9583, '2046-03-27', '星期二', 2046, '二月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9584, '2046-03-28', '星期三', 2046, '二月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9585, '2046-03-29', '星期四', 2046, '二月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9586, '2046-03-30', '星期五', 2046, '二月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9587, '2046-03-31', '星期六', 2046, '二月', '廿四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9588, '2046-04-01', '星期日', 2046, '二月', '廿五', '丙寅', '虎', NULL, 1, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9589, '2046-04-02', '星期一', 2046, '二月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9590, '2046-04-03', '星期二', 2046, '二月', '廿七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9591, '2046-04-04', '星期三', 2046, '二月', '廿八', '丙寅', '虎', NULL, 0, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (9592, '2046-04-05', '星期四', 2046, '二月', '廿九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9593, '2046-04-06', '星期五', 2046, '三月', '初一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9594, '2046-04-07', '星期六', 2046, '三月', '初二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9595, '2046-04-08', '星期日', 2046, '三月', '初三', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9596, '2046-04-09', '星期一', 2046, '三月', '初四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9597, '2046-04-10', '星期二', 2046, '三月', '初五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9598, '2046-04-11', '星期三', 2046, '三月', '初六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9599, '2046-04-12', '星期四', 2046, '三月', '初七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9600, '2046-04-13', '星期五', 2046, '三月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9601, '2046-04-14', '星期六', 2046, '三月', '初九', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9602, '2046-04-15', '星期日', 2046, '三月', '初十 ', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9603, '2046-04-16', '星期一', 2046, '三月', '十一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9604, '2046-04-17', '星期二', 2046, '三月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9605, '2046-04-18', '星期三', 2046, '三月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9606, '2046-04-19', '星期四', 2046, '三月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9607, '2046-04-20', '星期五', 2046, '三月', '十五', '丙寅', '虎', NULL, 0, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (9608, '2046-04-21', '星期六', 2046, '三月', '十六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9609, '2046-04-22', '星期日', 2046, '三月', '十七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9610, '2046-04-23', '星期一', 2046, '三月', '十八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9611, '2046-04-24', '星期二', 2046, '三月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9612, '2046-04-25', '星期三', 2046, '三月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9613, '2046-04-26', '星期四', 2046, '三月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9614, '2046-04-27', '星期五', 2046, '三月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9615, '2046-04-28', '星期六', 2046, '三月', '廿三', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9616, '2046-04-29', '星期日', 2046, '三月', '廿四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9617, '2046-04-30', '星期一', 2046, '三月', '廿五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9618, '2046-05-01', '星期二', 2046, '三月', '廿六', '丙寅', '虎', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9619, '2046-05-02', '星期三', 2046, '三月', '廿七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9620, '2046-05-03', '星期四', 2046, '三月', '廿八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9621, '2046-05-04', '星期五', 2046, '三月', '廿九', '丙寅', '虎', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9622, '2046-05-05', '星期六', 2046, '三月', '三十', '丙寅', '虎', NULL, 1, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (9623, '2046-05-06', '星期日', 2046, '四月', '初一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9624, '2046-05-07', '星期一', 2046, '四月', '初二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9625, '2046-05-08', '星期二', 2046, '四月', '初三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9626, '2046-05-09', '星期三', 2046, '四月', '初四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9627, '2046-05-10', '星期四', 2046, '四月', '初五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9628, '2046-05-11', '星期五', 2046, '四月', '初六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9629, '2046-05-12', '星期六', 2046, '四月', '初七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9630, '2046-05-13', '星期日', 2046, '四月', '初八', '丙寅', '虎', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (9631, '2046-05-14', '星期一', 2046, '四月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9632, '2046-05-15', '星期二', 2046, '四月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9633, '2046-05-16', '星期三', 2046, '四月', '十一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9634, '2046-05-17', '星期四', 2046, '四月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9635, '2046-05-18', '星期五', 2046, '四月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9636, '2046-05-19', '星期六', 2046, '四月', '十四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9637, '2046-05-20', '星期日', 2046, '四月', '十五', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9638, '2046-05-21', '星期一', 2046, '四月', '十六', '丙寅', '虎', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (9639, '2046-05-22', '星期二', 2046, '四月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9640, '2046-05-23', '星期三', 2046, '四月', '十八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9641, '2046-05-24', '星期四', 2046, '四月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9642, '2046-05-25', '星期五', 2046, '四月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9643, '2046-05-26', '星期六', 2046, '四月', '廿一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9644, '2046-05-27', '星期日', 2046, '四月', '廿二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9645, '2046-05-28', '星期一', 2046, '四月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9646, '2046-05-29', '星期二', 2046, '四月', '廿四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9647, '2046-05-30', '星期三', 2046, '四月', '廿五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9648, '2046-05-31', '星期四', 2046, '四月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9649, '2046-06-01', '星期五', 2046, '四月', '廿七', '丙寅', '虎', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9650, '2046-06-02', '星期六', 2046, '四月', '廿八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9651, '2046-06-03', '星期日', 2046, '四月', '廿九', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9652, '2046-06-04', '星期一', 2046, '五月', '初一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9653, '2046-06-05', '星期二', 2046, '五月', '初二', '丙寅', '虎', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (9654, '2046-06-06', '星期三', 2046, '五月', '初三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9655, '2046-06-07', '星期四', 2046, '五月', '初四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9656, '2046-06-08', '星期五', 2046, '五月', '初五', '丙寅', '虎', NULL, 0, '', '端午节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9657, '2046-06-09', '星期六', 2046, '五月', '初六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9658, '2046-06-10', '星期日', 2046, '五月', '初七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9659, '2046-06-11', '星期一', 2046, '五月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9660, '2046-06-12', '星期二', 2046, '五月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9661, '2046-06-13', '星期三', 2046, '五月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9662, '2046-06-14', '星期四', 2046, '五月', '十一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9663, '2046-06-15', '星期五', 2046, '五月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9664, '2046-06-16', '星期六', 2046, '五月', '十三', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9665, '2046-06-17', '星期日', 2046, '五月', '十四', '丙寅', '虎', NULL, 1, '', '', '', '父亲节', 0);
INSERT INTO `base_data_holiday` VALUES (9666, '2046-06-18', '星期一', 2046, '五月', '十五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9667, '2046-06-19', '星期二', 2046, '五月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9668, '2046-06-20', '星期三', 2046, '五月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9669, '2046-06-21', '星期四', 2046, '五月', '十八', '丙寅', '虎', NULL, 0, '', '', '夏至', '', 0);
INSERT INTO `base_data_holiday` VALUES (9670, '2046-06-22', '星期五', 2046, '五月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9671, '2046-06-23', '星期六', 2046, '五月', '二十', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9672, '2046-06-24', '星期日', 2046, '五月', '廿一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9673, '2046-06-25', '星期一', 2046, '五月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9674, '2046-06-26', '星期二', 2046, '五月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9675, '2046-06-27', '星期三', 2046, '五月', '廿四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9676, '2046-06-28', '星期四', 2046, '五月', '廿五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9677, '2046-06-29', '星期五', 2046, '五月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9678, '2046-06-30', '星期六', 2046, '五月', '廿七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9679, '2046-07-01', '星期日', 2046, '五月', '廿八', '丙寅', '虎', NULL, 1, '建党节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9680, '2046-07-02', '星期一', 2046, '五月', '廿九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9681, '2046-07-03', '星期二', 2046, '五月', '三十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9682, '2046-07-04', '星期三', 2046, '六月', '初一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9683, '2046-07-05', '星期四', 2046, '六月', '初二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9684, '2046-07-06', '星期五', 2046, '六月', '初三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9685, '2046-07-07', '星期六', 2046, '六月', '初四', '丙寅', '虎', NULL, 1, '', '', '小暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (9686, '2046-07-08', '星期日', 2046, '六月', '初五', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9687, '2046-07-09', '星期一', 2046, '六月', '初六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9688, '2046-07-10', '星期二', 2046, '六月', '初七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9689, '2046-07-11', '星期三', 2046, '六月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9690, '2046-07-12', '星期四', 2046, '六月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9691, '2046-07-13', '星期五', 2046, '六月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9692, '2046-07-14', '星期六', 2046, '六月', '十一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9693, '2046-07-15', '星期日', 2046, '六月', '十二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9694, '2046-07-16', '星期一', 2046, '六月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9695, '2046-07-17', '星期二', 2046, '六月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9696, '2046-07-18', '星期三', 2046, '六月', '十五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9697, '2046-07-19', '星期四', 2046, '六月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9698, '2046-07-20', '星期五', 2046, '六月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9699, '2046-07-21', '星期六', 2046, '六月', '十八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9700, '2046-07-22', '星期日', 2046, '六月', '十九', '丙寅', '虎', NULL, 1, '', '', '大暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (9701, '2046-07-23', '星期一', 2046, '六月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9702, '2046-07-24', '星期二', 2046, '六月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9703, '2046-07-25', '星期三', 2046, '六月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9704, '2046-07-26', '星期四', 2046, '六月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9705, '2046-07-27', '星期五', 2046, '六月', '廿四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9706, '2046-07-28', '星期六', 2046, '六月', '廿五', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9707, '2046-07-29', '星期日', 2046, '六月', '廿六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9708, '2046-07-30', '星期一', 2046, '六月', '廿七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9709, '2046-07-31', '星期二', 2046, '六月', '廿八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9710, '2046-08-01', '星期三', 2046, '六月', '廿九', '丙寅', '虎', NULL, 0, '建军节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9711, '2046-08-02', '星期四', 2046, '七月', '初一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9712, '2046-08-03', '星期五', 2046, '七月', '初二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9713, '2046-08-04', '星期六', 2046, '七月', '初三', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9714, '2046-08-05', '星期日', 2046, '七月', '初四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9715, '2046-08-06', '星期一', 2046, '七月', '初五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9716, '2046-08-07', '星期二', 2046, '七月', '初六', '丙寅', '虎', NULL, 0, '', '', '立秋', '', 0);
INSERT INTO `base_data_holiday` VALUES (9717, '2046-08-08', '星期三', 2046, '七月', '初七', '丙寅', '虎', NULL, 0, '', '七夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9718, '2046-08-09', '星期四', 2046, '七月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9719, '2046-08-10', '星期五', 2046, '七月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9720, '2046-08-11', '星期六', 2046, '七月', '初十 ', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9721, '2046-08-12', '星期日', 2046, '七月', '十一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9722, '2046-08-13', '星期一', 2046, '七月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9723, '2046-08-14', '星期二', 2046, '七月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9724, '2046-08-15', '星期三', 2046, '七月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9725, '2046-08-16', '星期四', 2046, '七月', '十五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9726, '2046-08-17', '星期五', 2046, '七月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9727, '2046-08-18', '星期六', 2046, '七月', '十七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9728, '2046-08-19', '星期日', 2046, '七月', '十八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9729, '2046-08-20', '星期一', 2046, '七月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9730, '2046-08-21', '星期二', 2046, '七月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9731, '2046-08-22', '星期三', 2046, '七月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9732, '2046-08-23', '星期四', 2046, '七月', '廿二', '丙寅', '虎', NULL, 0, '', '', '处暑', '', 0);
INSERT INTO `base_data_holiday` VALUES (9733, '2046-08-24', '星期五', 2046, '七月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9734, '2046-08-25', '星期六', 2046, '七月', '廿四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9735, '2046-08-26', '星期日', 2046, '七月', '廿五', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9736, '2046-08-27', '星期一', 2046, '七月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9737, '2046-08-28', '星期二', 2046, '七月', '廿七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9738, '2046-08-29', '星期三', 2046, '七月', '廿八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9739, '2046-08-30', '星期四', 2046, '七月', '廿九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9740, '2046-08-31', '星期五', 2046, '七月', '三十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9741, '2046-09-01', '星期六', 2046, '八月', '初一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9742, '2046-09-02', '星期日', 2046, '八月', '初二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9743, '2046-09-03', '星期一', 2046, '八月', '初三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9744, '2046-09-04', '星期二', 2046, '八月', '初四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9745, '2046-09-05', '星期三', 2046, '八月', '初五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9746, '2046-09-06', '星期四', 2046, '八月', '初六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9747, '2046-09-07', '星期五', 2046, '八月', '初七', '丙寅', '虎', NULL, 0, '', '', '白露', '', 0);
INSERT INTO `base_data_holiday` VALUES (9748, '2046-09-08', '星期六', 2046, '八月', '初八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9749, '2046-09-09', '星期日', 2046, '八月', '初九', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9750, '2046-09-10', '星期一', 2046, '八月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9751, '2046-09-11', '星期二', 2046, '八月', '十一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9752, '2046-09-12', '星期三', 2046, '八月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9753, '2046-09-13', '星期四', 2046, '八月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9754, '2046-09-14', '星期五', 2046, '八月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9755, '2046-09-15', '星期六', 2046, '八月', '十五', '丙寅', '虎', NULL, 1, '', '中秋节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9756, '2046-09-16', '星期日', 2046, '八月', '十六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9757, '2046-09-17', '星期一', 2046, '八月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9758, '2046-09-18', '星期二', 2046, '八月', '十八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9759, '2046-09-19', '星期三', 2046, '八月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9760, '2046-09-20', '星期四', 2046, '八月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9761, '2046-09-21', '星期五', 2046, '八月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9762, '2046-09-22', '星期六', 2046, '八月', '廿二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9763, '2046-09-23', '星期日', 2046, '八月', '廿三', '丙寅', '虎', NULL, 1, '农民丰收节', '', '秋分', '', 0);
INSERT INTO `base_data_holiday` VALUES (9764, '2046-09-24', '星期一', 2046, '八月', '廿四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9765, '2046-09-25', '星期二', 2046, '八月', '廿五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9766, '2046-09-26', '星期三', 2046, '八月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9767, '2046-09-27', '星期四', 2046, '八月', '廿七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9768, '2046-09-28', '星期五', 2046, '八月', '廿八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9769, '2046-09-29', '星期六', 2046, '八月', '廿九', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9770, '2046-09-30', '星期日', 2046, '九月', '初一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9771, '2046-10-01', '星期一', 2046, '九月', '初二', '丙寅', '虎', NULL, 0, '国庆节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9772, '2046-10-02', '星期二', 2046, '九月', '初三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9773, '2046-10-03', '星期三', 2046, '九月', '初四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9774, '2046-10-04', '星期四', 2046, '九月', '初五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9775, '2046-10-05', '星期五', 2046, '九月', '初六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9776, '2046-10-06', '星期六', 2046, '九月', '初七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9777, '2046-10-07', '星期日', 2046, '九月', '初八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9778, '2046-10-08', '星期一', 2046, '九月', '初九', '丙寅', '虎', NULL, 0, '', '重阳节', '寒露', '', 0);
INSERT INTO `base_data_holiday` VALUES (9779, '2046-10-09', '星期二', 2046, '九月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9780, '2046-10-10', '星期三', 2046, '九月', '十一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9781, '2046-10-11', '星期四', 2046, '九月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9782, '2046-10-12', '星期五', 2046, '九月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9783, '2046-10-13', '星期六', 2046, '九月', '十四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9784, '2046-10-14', '星期日', 2046, '九月', '十五', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9785, '2046-10-15', '星期一', 2046, '九月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9786, '2046-10-16', '星期二', 2046, '九月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9787, '2046-10-17', '星期三', 2046, '九月', '十八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9788, '2046-10-18', '星期四', 2046, '九月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9789, '2046-10-19', '星期五', 2046, '九月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9790, '2046-10-20', '星期六', 2046, '九月', '廿一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9791, '2046-10-21', '星期日', 2046, '九月', '廿二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9792, '2046-10-22', '星期一', 2046, '九月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9793, '2046-10-23', '星期二', 2046, '九月', '廿四', '丙寅', '虎', NULL, 0, '', '', '霜降', '', 0);
INSERT INTO `base_data_holiday` VALUES (9794, '2046-10-24', '星期三', 2046, '九月', '廿五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9795, '2046-10-25', '星期四', 2046, '九月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9796, '2046-10-26', '星期五', 2046, '九月', '廿七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9797, '2046-10-27', '星期六', 2046, '九月', '廿八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9798, '2046-10-28', '星期日', 2046, '九月', '廿九', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9799, '2046-10-29', '星期一', 2046, '十月', '初一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9800, '2046-10-30', '星期二', 2046, '十月', '初二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9801, '2046-10-31', '星期三', 2046, '十月', '初三', '丙寅', '虎', NULL, 0, '万圣节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9802, '2046-11-01', '星期四', 2046, '十月', '初四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9803, '2046-11-02', '星期五', 2046, '十月', '初五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9804, '2046-11-03', '星期六', 2046, '十月', '初六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9805, '2046-11-04', '星期日', 2046, '十月', '初七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9806, '2046-11-05', '星期一', 2046, '十月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9807, '2046-11-06', '星期二', 2046, '十月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9808, '2046-11-07', '星期三', 2046, '十月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '立冬', '', 0);
INSERT INTO `base_data_holiday` VALUES (9809, '2046-11-08', '星期四', 2046, '十月', '十一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9810, '2046-11-09', '星期五', 2046, '十月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9811, '2046-11-10', '星期六', 2046, '十月', '十三', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9812, '2046-11-11', '星期日', 2046, '十月', '十四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9813, '2046-11-12', '星期一', 2046, '十月', '十五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9814, '2046-11-13', '星期二', 2046, '十月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9815, '2046-11-14', '星期三', 2046, '十月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9816, '2046-11-15', '星期四', 2046, '十月', '十八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9817, '2046-11-16', '星期五', 2046, '十月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9818, '2046-11-17', '星期六', 2046, '十月', '二十', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9819, '2046-11-18', '星期日', 2046, '十月', '廿一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9820, '2046-11-19', '星期一', 2046, '十月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9821, '2046-11-20', '星期二', 2046, '十月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9822, '2046-11-21', '星期三', 2046, '十月', '廿四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9823, '2046-11-22', '星期四', 2046, '十月', '廿五', '丙寅', '虎', NULL, 0, '', '', '小雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (9824, '2046-11-23', '星期五', 2046, '十月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9825, '2046-11-24', '星期六', 2046, '十月', '廿七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9826, '2046-11-25', '星期日', 2046, '十月', '廿八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9827, '2046-11-26', '星期一', 2046, '十月', '廿九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9828, '2046-11-27', '星期二', 2046, '十月', '三十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9829, '2046-11-28', '星期三', 2046, '冬月', '初一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9830, '2046-11-29', '星期四', 2046, '冬月', '初二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9831, '2046-11-30', '星期五', 2046, '冬月', '初三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9832, '2046-12-01', '星期六', 2046, '冬月', '初四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9833, '2046-12-02', '星期日', 2046, '冬月', '初五', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9834, '2046-12-03', '星期一', 2046, '冬月', '初六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9835, '2046-12-04', '星期二', 2046, '冬月', '初七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9836, '2046-12-05', '星期三', 2046, '冬月', '初八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9837, '2046-12-06', '星期四', 2046, '冬月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9838, '2046-12-07', '星期五', 2046, '冬月', '初十 ', '丙寅', '虎', NULL, 0, '', '', '大雪', '', 0);
INSERT INTO `base_data_holiday` VALUES (9839, '2046-12-08', '星期六', 2046, '冬月', '十一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9840, '2046-12-09', '星期日', 2046, '冬月', '十二', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9841, '2046-12-10', '星期一', 2046, '冬月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9842, '2046-12-11', '星期二', 2046, '冬月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9843, '2046-12-12', '星期三', 2046, '冬月', '十五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9844, '2046-12-13', '星期四', 2046, '冬月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9845, '2046-12-14', '星期五', 2046, '冬月', '十七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9846, '2046-12-15', '星期六', 2046, '冬月', '十八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9847, '2046-12-16', '星期日', 2046, '冬月', '十九', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9848, '2046-12-17', '星期一', 2046, '冬月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9849, '2046-12-18', '星期二', 2046, '冬月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9850, '2046-12-19', '星期三', 2046, '冬月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9851, '2046-12-20', '星期四', 2046, '冬月', '廿三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9852, '2046-12-21', '星期五', 2046, '冬月', '廿四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9853, '2046-12-22', '星期六', 2046, '冬月', '廿五', '丙寅', '虎', NULL, 1, '', '', '冬至', '', 0);
INSERT INTO `base_data_holiday` VALUES (9854, '2046-12-23', '星期日', 2046, '冬月', '廿六', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9855, '2046-12-24', '星期一', 2046, '冬月', '廿七', '丙寅', '虎', NULL, 0, '平安夜', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9856, '2046-12-25', '星期二', 2046, '冬月', '廿八', '丙寅', '虎', NULL, 0, '圣诞节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9857, '2046-12-26', '星期三', 2046, '冬月', '廿九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9858, '2046-12-27', '星期四', 2046, '腊月', '初一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9859, '2046-12-28', '星期五', 2046, '腊月', '初二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9860, '2046-12-29', '星期六', 2046, '腊月', '初三', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9861, '2046-12-30', '星期日', 2046, '腊月', '初四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9862, '2046-12-31', '星期一', 2046, '腊月', '初五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9863, '2047-01-01', '星期二', 2046, '腊月', '初六', '丙寅', '虎', NULL, 0, '元旦', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9864, '2047-01-02', '星期三', 2046, '腊月', '初七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9865, '2047-01-03', '星期四', 2046, '腊月', '初八', '丙寅', '虎', NULL, 0, '', '腊八节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9866, '2047-01-04', '星期五', 2046, '腊月', '初九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9867, '2047-01-05', '星期六', 2046, '腊月', '初十 ', '丙寅', '虎', NULL, 1, '', '', '小寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (9868, '2047-01-06', '星期日', 2046, '腊月', '十一', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9869, '2047-01-07', '星期一', 2046, '腊月', '十二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9870, '2047-01-08', '星期二', 2046, '腊月', '十三', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9871, '2047-01-09', '星期三', 2046, '腊月', '十四', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9872, '2047-01-10', '星期四', 2046, '腊月', '十五', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9873, '2047-01-11', '星期五', 2046, '腊月', '十六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9874, '2047-01-12', '星期六', 2046, '腊月', '十七', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9875, '2047-01-13', '星期日', 2046, '腊月', '十八', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9876, '2047-01-14', '星期一', 2046, '腊月', '十九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9877, '2047-01-15', '星期二', 2046, '腊月', '二十', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9878, '2047-01-16', '星期三', 2046, '腊月', '廿一', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9879, '2047-01-17', '星期四', 2046, '腊月', '廿二', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9880, '2047-01-18', '星期五', 2046, '腊月', '廿三', '丙寅', '虎', NULL, 0, '', '小年', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9881, '2047-01-19', '星期六', 2046, '腊月', '廿四', '丙寅', '虎', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9882, '2047-01-20', '星期日', 2046, '腊月', '廿五', '丙寅', '虎', NULL, 1, '', '', '大寒', '', 0);
INSERT INTO `base_data_holiday` VALUES (9883, '2047-01-21', '星期一', 2046, '腊月', '廿六', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9884, '2047-01-22', '星期二', 2046, '腊月', '廿七', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9885, '2047-01-23', '星期三', 2046, '腊月', '廿八', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9886, '2047-01-24', '星期四', 2046, '腊月', '廿九', '丙寅', '虎', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9887, '2047-01-25', '星期五', 2046, '腊月', '三十', '丙寅', '虎', NULL, 0, '', '除夕', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9888, '2047-01-26', '星期六', 2047, '正月', '初一', '丁卯', '兔', NULL, 1, '', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (9889, '2047-01-27', '星期日', 2047, '正月', '初二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9890, '2047-01-28', '星期一', 2047, '正月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9891, '2047-01-29', '星期二', 2047, '正月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9892, '2047-01-30', '星期三', 2047, '正月', '初五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9893, '2047-01-31', '星期四', 2047, '正月', '初六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9894, '2047-02-01', '星期五', 2047, '正月', '初七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9895, '2047-02-02', '星期六', 2047, '正月', '初八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9896, '2047-02-03', '星期日', 2047, '正月', '初九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9897, '2047-02-04', '星期一', 2047, '正月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '立春', '', 5);
INSERT INTO `base_data_holiday` VALUES (9898, '2047-02-05', '星期二', 2047, '正月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9899, '2047-02-06', '星期三', 2047, '正月', '十二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9900, '2047-02-07', '星期四', 2047, '正月', '十三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9901, '2047-02-08', '星期五', 2047, '正月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9902, '2047-02-09', '星期六', 2047, '正月', '十五', '丁卯', '兔', NULL, 1, '', '元宵节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9903, '2047-02-10', '星期日', 2047, '正月', '十六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9904, '2047-02-11', '星期一', 2047, '正月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9905, '2047-02-12', '星期二', 2047, '正月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9906, '2047-02-13', '星期三', 2047, '正月', '十九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9907, '2047-02-14', '星期四', 2047, '正月', '二十', '丁卯', '兔', NULL, 0, '情人节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9908, '2047-02-15', '星期五', 2047, '正月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9909, '2047-02-16', '星期六', 2047, '正月', '廿二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9910, '2047-02-17', '星期日', 2047, '正月', '廿三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9911, '2047-02-18', '星期一', 2047, '正月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9912, '2047-02-19', '星期二', 2047, '正月', '廿五', '丁卯', '兔', NULL, 0, '', '', '雨水', '', 5);
INSERT INTO `base_data_holiday` VALUES (9913, '2047-02-20', '星期三', 2047, '正月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9914, '2047-02-21', '星期四', 2047, '正月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9915, '2047-02-22', '星期五', 2047, '正月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9916, '2047-02-23', '星期六', 2047, '正月', '廿九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9917, '2047-02-24', '星期日', 2047, '正月', '三十', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9918, '2047-02-25', '星期一', 2047, '二月', '初一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9919, '2047-02-26', '星期二', 2047, '二月', '初二', '丁卯', '兔', NULL, 0, '', '龙抬头', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9920, '2047-02-27', '星期三', 2047, '二月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9921, '2047-02-28', '星期四', 2047, '二月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9922, '2047-03-01', '星期五', 2047, '二月', '初五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9923, '2047-03-02', '星期六', 2047, '二月', '初六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9924, '2047-03-03', '星期日', 2047, '二月', '初七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9925, '2047-03-04', '星期一', 2047, '二月', '初八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9926, '2047-03-05', '星期二', 2047, '二月', '初九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9927, '2047-03-06', '星期三', 2047, '二月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '惊蛰', '', 5);
INSERT INTO `base_data_holiday` VALUES (9928, '2047-03-07', '星期四', 2047, '二月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9929, '2047-03-08', '星期五', 2047, '二月', '十二', '丁卯', '兔', NULL, 0, '妇女节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9930, '2047-03-09', '星期六', 2047, '二月', '十三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9931, '2047-03-10', '星期日', 2047, '二月', '十四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9932, '2047-03-11', '星期一', 2047, '二月', '十五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9933, '2047-03-12', '星期二', 2047, '二月', '十六', '丁卯', '兔', NULL, 0, '植树节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9934, '2047-03-13', '星期三', 2047, '二月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9935, '2047-03-14', '星期四', 2047, '二月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9936, '2047-03-15', '星期五', 2047, '二月', '十九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9937, '2047-03-16', '星期六', 2047, '二月', '二十', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9938, '2047-03-17', '星期日', 2047, '二月', '廿一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9939, '2047-03-18', '星期一', 2047, '二月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9940, '2047-03-19', '星期二', 2047, '二月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9941, '2047-03-20', '星期三', 2047, '二月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9942, '2047-03-21', '星期四', 2047, '二月', '廿五', '丁卯', '兔', NULL, 0, '', '', '春分', '', 5);
INSERT INTO `base_data_holiday` VALUES (9943, '2047-03-22', '星期五', 2047, '二月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9944, '2047-03-23', '星期六', 2047, '二月', '廿七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9945, '2047-03-24', '星期日', 2047, '二月', '廿八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9946, '2047-03-25', '星期一', 2047, '二月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9947, '2047-03-26', '星期二', 2047, '三月', '初一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9948, '2047-03-27', '星期三', 2047, '三月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9949, '2047-03-28', '星期四', 2047, '三月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9950, '2047-03-29', '星期五', 2047, '三月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9951, '2047-03-30', '星期六', 2047, '三月', '初五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9952, '2047-03-31', '星期日', 2047, '三月', '初六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9953, '2047-04-01', '星期一', 2047, '三月', '初七', '丁卯', '兔', NULL, 0, '愚人节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9954, '2047-04-02', '星期二', 2047, '三月', '初八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9955, '2047-04-03', '星期三', 2047, '三月', '初九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9956, '2047-04-04', '星期四', 2047, '三月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9957, '2047-04-05', '星期五', 2047, '三月', '十一', '丁卯', '兔', NULL, 0, '', '', '清明', '', 5);
INSERT INTO `base_data_holiday` VALUES (9958, '2047-04-06', '星期六', 2047, '三月', '十二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9959, '2047-04-07', '星期日', 2047, '三月', '十三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9960, '2047-04-08', '星期一', 2047, '三月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9961, '2047-04-09', '星期二', 2047, '三月', '十五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9962, '2047-04-10', '星期三', 2047, '三月', '十六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9963, '2047-04-11', '星期四', 2047, '三月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9964, '2047-04-12', '星期五', 2047, '三月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9965, '2047-04-13', '星期六', 2047, '三月', '十九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9966, '2047-04-14', '星期日', 2047, '三月', '二十', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9967, '2047-04-15', '星期一', 2047, '三月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9968, '2047-04-16', '星期二', 2047, '三月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9969, '2047-04-17', '星期三', 2047, '三月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9970, '2047-04-18', '星期四', 2047, '三月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9971, '2047-04-19', '星期五', 2047, '三月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9972, '2047-04-20', '星期六', 2047, '三月', '廿六', '丁卯', '兔', NULL, 1, '', '', '谷雨', '', 5);
INSERT INTO `base_data_holiday` VALUES (9973, '2047-04-21', '星期日', 2047, '三月', '廿七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9974, '2047-04-22', '星期一', 2047, '三月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9975, '2047-04-23', '星期二', 2047, '三月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9976, '2047-04-24', '星期三', 2047, '三月', '三十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9977, '2047-04-25', '星期四', 2047, '四月', '初一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9978, '2047-04-26', '星期五', 2047, '四月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9979, '2047-04-27', '星期六', 2047, '四月', '初三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9980, '2047-04-28', '星期日', 2047, '四月', '初四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9981, '2047-04-29', '星期一', 2047, '四月', '初五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9982, '2047-04-30', '星期二', 2047, '四月', '初六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9983, '2047-05-01', '星期三', 2047, '四月', '初七', '丁卯', '兔', NULL, 0, '劳动节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9984, '2047-05-02', '星期四', 2047, '四月', '初八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9985, '2047-05-03', '星期五', 2047, '四月', '初九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9986, '2047-05-04', '星期六', 2047, '四月', '初十 ', '丁卯', '兔', NULL, 1, '青年节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9987, '2047-05-05', '星期日', 2047, '四月', '十一', '丁卯', '兔', NULL, 1, '', '', '立夏', '', 5);
INSERT INTO `base_data_holiday` VALUES (9988, '2047-05-06', '星期一', 2047, '四月', '十二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9989, '2047-05-07', '星期二', 2047, '四月', '十三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9990, '2047-05-08', '星期三', 2047, '四月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9991, '2047-05-09', '星期四', 2047, '四月', '十五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9992, '2047-05-10', '星期五', 2047, '四月', '十六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9993, '2047-05-11', '星期六', 2047, '四月', '十七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9994, '2047-05-12', '星期日', 2047, '四月', '十八', '丁卯', '兔', NULL, 1, '', '', '', '母亲节', 5);
INSERT INTO `base_data_holiday` VALUES (9995, '2047-05-13', '星期一', 2047, '四月', '十九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9996, '2047-05-14', '星期二', 2047, '四月', '二十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9997, '2047-05-15', '星期三', 2047, '四月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9998, '2047-05-16', '星期四', 2047, '四月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (9999, '2047-05-17', '星期五', 2047, '四月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10000, '2047-05-18', '星期六', 2047, '四月', '廿四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10001, '2047-05-19', '星期日', 2047, '四月', '廿五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10002, '2047-05-20', '星期一', 2047, '四月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10003, '2047-05-21', '星期二', 2047, '四月', '廿七', '丁卯', '兔', NULL, 0, '', '', '小满', '', 5);
INSERT INTO `base_data_holiday` VALUES (10004, '2047-05-22', '星期三', 2047, '四月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10005, '2047-05-23', '星期四', 2047, '四月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10006, '2047-05-24', '星期五', 2047, '四月', '三十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10007, '2047-05-25', '星期六', 2047, '五月', '初一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10008, '2047-05-26', '星期日', 2047, '五月', '初二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10009, '2047-05-27', '星期一', 2047, '五月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10010, '2047-05-28', '星期二', 2047, '五月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10011, '2047-05-29', '星期三', 2047, '五月', '初五', '丁卯', '兔', NULL, 0, '', '端午节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10012, '2047-05-30', '星期四', 2047, '五月', '初六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10013, '2047-05-31', '星期五', 2047, '五月', '初七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10014, '2047-06-01', '星期六', 2047, '五月', '初八', '丁卯', '兔', NULL, 1, '儿童节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10015, '2047-06-02', '星期日', 2047, '五月', '初九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10016, '2047-06-03', '星期一', 2047, '五月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10017, '2047-06-04', '星期二', 2047, '五月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10018, '2047-06-05', '星期三', 2047, '五月', '十二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10019, '2047-06-06', '星期四', 2047, '五月', '十三', '丁卯', '兔', NULL, 0, '', '', '芒种', '', 5);
INSERT INTO `base_data_holiday` VALUES (10020, '2047-06-07', '星期五', 2047, '五月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10021, '2047-06-08', '星期六', 2047, '五月', '十五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10022, '2047-06-09', '星期日', 2047, '五月', '十六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10023, '2047-06-10', '星期一', 2047, '五月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10024, '2047-06-11', '星期二', 2047, '五月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10025, '2047-06-12', '星期三', 2047, '五月', '十九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10026, '2047-06-13', '星期四', 2047, '五月', '二十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10027, '2047-06-14', '星期五', 2047, '五月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10028, '2047-06-15', '星期六', 2047, '五月', '廿二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10029, '2047-06-16', '星期日', 2047, '五月', '廿三', '丁卯', '兔', NULL, 1, '', '', '', '父亲节', 5);
INSERT INTO `base_data_holiday` VALUES (10030, '2047-06-17', '星期一', 2047, '五月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10031, '2047-06-18', '星期二', 2047, '五月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10032, '2047-06-19', '星期三', 2047, '五月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10033, '2047-06-20', '星期四', 2047, '五月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10034, '2047-06-21', '星期五', 2047, '五月', '廿八', '丁卯', '兔', NULL, 0, '', '', '夏至', '', 5);
INSERT INTO `base_data_holiday` VALUES (10035, '2047-06-22', '星期六', 2047, '五月', '廿九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10036, '2047-06-23', '星期日', 2047, '闰五月', '初一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10037, '2047-06-24', '星期一', 2047, '闰五月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10038, '2047-06-25', '星期二', 2047, '闰五月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10039, '2047-06-26', '星期三', 2047, '闰五月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10040, '2047-06-27', '星期四', 2047, '闰五月', '初五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10041, '2047-06-28', '星期五', 2047, '闰五月', '初六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10042, '2047-06-29', '星期六', 2047, '闰五月', '初七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10043, '2047-06-30', '星期日', 2047, '闰五月', '初八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10044, '2047-07-01', '星期一', 2047, '闰五月', '初九', '丁卯', '兔', NULL, 0, '建党节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10045, '2047-07-02', '星期二', 2047, '闰五月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10046, '2047-07-03', '星期三', 2047, '闰五月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10047, '2047-07-04', '星期四', 2047, '闰五月', '十二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10048, '2047-07-05', '星期五', 2047, '闰五月', '十三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10049, '2047-07-06', '星期六', 2047, '闰五月', '十四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10050, '2047-07-07', '星期日', 2047, '闰五月', '十五', '丁卯', '兔', NULL, 1, '', '', '小暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (10051, '2047-07-08', '星期一', 2047, '闰五月', '十六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10052, '2047-07-09', '星期二', 2047, '闰五月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10053, '2047-07-10', '星期三', 2047, '闰五月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10054, '2047-07-11', '星期四', 2047, '闰五月', '十九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10055, '2047-07-12', '星期五', 2047, '闰五月', '二十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10056, '2047-07-13', '星期六', 2047, '闰五月', '廿一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10057, '2047-07-14', '星期日', 2047, '闰五月', '廿二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10058, '2047-07-15', '星期一', 2047, '闰五月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10059, '2047-07-16', '星期二', 2047, '闰五月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10060, '2047-07-17', '星期三', 2047, '闰五月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10061, '2047-07-18', '星期四', 2047, '闰五月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10062, '2047-07-19', '星期五', 2047, '闰五月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10063, '2047-07-20', '星期六', 2047, '闰五月', '廿八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10064, '2047-07-21', '星期日', 2047, '闰五月', '廿九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10065, '2047-07-22', '星期一', 2047, '闰五月', '三十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10066, '2047-07-23', '星期二', 2047, '六月', '初一', '丁卯', '兔', NULL, 0, '', '', '大暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (10067, '2047-07-24', '星期三', 2047, '六月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10068, '2047-07-25', '星期四', 2047, '六月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10069, '2047-07-26', '星期五', 2047, '六月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10070, '2047-07-27', '星期六', 2047, '六月', '初五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10071, '2047-07-28', '星期日', 2047, '六月', '初六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10072, '2047-07-29', '星期一', 2047, '六月', '初七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10073, '2047-07-30', '星期二', 2047, '六月', '初八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10074, '2047-07-31', '星期三', 2047, '六月', '初九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10075, '2047-08-01', '星期四', 2047, '六月', '初十 ', '丁卯', '兔', NULL, 0, '建军节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10076, '2047-08-02', '星期五', 2047, '六月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10077, '2047-08-03', '星期六', 2047, '六月', '十二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10078, '2047-08-04', '星期日', 2047, '六月', '十三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10079, '2047-08-05', '星期一', 2047, '六月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10080, '2047-08-06', '星期二', 2047, '六月', '十五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10081, '2047-08-07', '星期三', 2047, '六月', '十六', '丁卯', '兔', NULL, 0, '', '', '立秋', '', 5);
INSERT INTO `base_data_holiday` VALUES (10082, '2047-08-08', '星期四', 2047, '六月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10083, '2047-08-09', '星期五', 2047, '六月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10084, '2047-08-10', '星期六', 2047, '六月', '十九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10085, '2047-08-11', '星期日', 2047, '六月', '二十', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10086, '2047-08-12', '星期一', 2047, '六月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10087, '2047-08-13', '星期二', 2047, '六月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10088, '2047-08-14', '星期三', 2047, '六月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10089, '2047-08-15', '星期四', 2047, '六月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10090, '2047-08-16', '星期五', 2047, '六月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10091, '2047-08-17', '星期六', 2047, '六月', '廿六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10092, '2047-08-18', '星期日', 2047, '六月', '廿七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10093, '2047-08-19', '星期一', 2047, '六月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10094, '2047-08-20', '星期二', 2047, '六月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10095, '2047-08-21', '星期三', 2047, '七月', '初一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10096, '2047-08-22', '星期四', 2047, '七月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10097, '2047-08-23', '星期五', 2047, '七月', '初三', '丁卯', '兔', NULL, 0, '', '', '处暑', '', 5);
INSERT INTO `base_data_holiday` VALUES (10098, '2047-08-24', '星期六', 2047, '七月', '初四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10099, '2047-08-25', '星期日', 2047, '七月', '初五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10100, '2047-08-26', '星期一', 2047, '七月', '初六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10101, '2047-08-27', '星期二', 2047, '七月', '初七', '丁卯', '兔', NULL, 0, '', '七夕', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10102, '2047-08-28', '星期三', 2047, '七月', '初八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10103, '2047-08-29', '星期四', 2047, '七月', '初九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10104, '2047-08-30', '星期五', 2047, '七月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10105, '2047-08-31', '星期六', 2047, '七月', '十一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10106, '2047-09-01', '星期日', 2047, '七月', '十二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10107, '2047-09-02', '星期一', 2047, '七月', '十三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10108, '2047-09-03', '星期二', 2047, '七月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10109, '2047-09-04', '星期三', 2047, '七月', '十五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10110, '2047-09-05', '星期四', 2047, '七月', '十六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10111, '2047-09-06', '星期五', 2047, '七月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10112, '2047-09-07', '星期六', 2047, '七月', '十八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10113, '2047-09-08', '星期日', 2047, '七月', '十九', '丁卯', '兔', NULL, 1, '', '', '白露', '', 5);
INSERT INTO `base_data_holiday` VALUES (10114, '2047-09-09', '星期一', 2047, '七月', '二十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10115, '2047-09-10', '星期二', 2047, '七月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10116, '2047-09-11', '星期三', 2047, '七月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10117, '2047-09-12', '星期四', 2047, '七月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10118, '2047-09-13', '星期五', 2047, '七月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10119, '2047-09-14', '星期六', 2047, '七月', '廿五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10120, '2047-09-15', '星期日', 2047, '七月', '廿六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10121, '2047-09-16', '星期一', 2047, '七月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10122, '2047-09-17', '星期二', 2047, '七月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10123, '2047-09-18', '星期三', 2047, '七月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10124, '2047-09-19', '星期四', 2047, '七月', '三十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10125, '2047-09-20', '星期五', 2047, '八月', '初一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10126, '2047-09-21', '星期六', 2047, '八月', '初二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10127, '2047-09-22', '星期日', 2047, '八月', '初三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10128, '2047-09-23', '星期一', 2047, '八月', '初四', '丁卯', '兔', NULL, 0, '农民丰收节', '', '秋分', '', 5);
INSERT INTO `base_data_holiday` VALUES (10129, '2047-09-24', '星期二', 2047, '八月', '初五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10130, '2047-09-25', '星期三', 2047, '八月', '初六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10131, '2047-09-26', '星期四', 2047, '八月', '初七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10132, '2047-09-27', '星期五', 2047, '八月', '初八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10133, '2047-09-28', '星期六', 2047, '八月', '初九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10134, '2047-09-29', '星期日', 2047, '八月', '初十 ', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10135, '2047-09-30', '星期一', 2047, '八月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10136, '2047-10-01', '星期二', 2047, '八月', '十二', '丁卯', '兔', NULL, 0, '国庆节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10137, '2047-10-02', '星期三', 2047, '八月', '十三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10138, '2047-10-03', '星期四', 2047, '八月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10139, '2047-10-04', '星期五', 2047, '八月', '十五', '丁卯', '兔', NULL, 0, '', '中秋节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10140, '2047-10-05', '星期六', 2047, '八月', '十六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10141, '2047-10-06', '星期日', 2047, '八月', '十七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10142, '2047-10-07', '星期一', 2047, '八月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10143, '2047-10-08', '星期二', 2047, '八月', '十九', '丁卯', '兔', NULL, 0, '', '', '寒露', '', 5);
INSERT INTO `base_data_holiday` VALUES (10144, '2047-10-09', '星期三', 2047, '八月', '二十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10145, '2047-10-10', '星期四', 2047, '八月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10146, '2047-10-11', '星期五', 2047, '八月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10147, '2047-10-12', '星期六', 2047, '八月', '廿三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10148, '2047-10-13', '星期日', 2047, '八月', '廿四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10149, '2047-10-14', '星期一', 2047, '八月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10150, '2047-10-15', '星期二', 2047, '八月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10151, '2047-10-16', '星期三', 2047, '八月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10152, '2047-10-17', '星期四', 2047, '八月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10153, '2047-10-18', '星期五', 2047, '八月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10154, '2047-10-19', '星期六', 2047, '九月', '初一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10155, '2047-10-20', '星期日', 2047, '九月', '初二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10156, '2047-10-21', '星期一', 2047, '九月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10157, '2047-10-22', '星期二', 2047, '九月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10158, '2047-10-23', '星期三', 2047, '九月', '初五', '丁卯', '兔', NULL, 0, '', '', '霜降', '', 5);
INSERT INTO `base_data_holiday` VALUES (10159, '2047-10-24', '星期四', 2047, '九月', '初六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10160, '2047-10-25', '星期五', 2047, '九月', '初七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10161, '2047-10-26', '星期六', 2047, '九月', '初八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10162, '2047-10-27', '星期日', 2047, '九月', '初九', '丁卯', '兔', NULL, 1, '', '重阳节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10163, '2047-10-28', '星期一', 2047, '九月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10164, '2047-10-29', '星期二', 2047, '九月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10165, '2047-10-30', '星期三', 2047, '九月', '十二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10166, '2047-10-31', '星期四', 2047, '九月', '十三', '丁卯', '兔', NULL, 0, '万圣节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10167, '2047-11-01', '星期五', 2047, '九月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10168, '2047-11-02', '星期六', 2047, '九月', '十五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10169, '2047-11-03', '星期日', 2047, '九月', '十六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10170, '2047-11-04', '星期一', 2047, '九月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10171, '2047-11-05', '星期二', 2047, '九月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10172, '2047-11-06', '星期三', 2047, '九月', '十九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10173, '2047-11-07', '星期四', 2047, '九月', '二十', '丁卯', '兔', NULL, 0, '', '', '立冬', '', 5);
INSERT INTO `base_data_holiday` VALUES (10174, '2047-11-08', '星期五', 2047, '九月', '廿一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10175, '2047-11-09', '星期六', 2047, '九月', '廿二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10176, '2047-11-10', '星期日', 2047, '九月', '廿三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10177, '2047-11-11', '星期一', 2047, '九月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10178, '2047-11-12', '星期二', 2047, '九月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10179, '2047-11-13', '星期三', 2047, '九月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10180, '2047-11-14', '星期四', 2047, '九月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10181, '2047-11-15', '星期五', 2047, '九月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10182, '2047-11-16', '星期六', 2047, '九月', '廿九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10183, '2047-11-17', '星期日', 2047, '十月', '初一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10184, '2047-11-18', '星期一', 2047, '十月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10185, '2047-11-19', '星期二', 2047, '十月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10186, '2047-11-20', '星期三', 2047, '十月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10187, '2047-11-21', '星期四', 2047, '十月', '初五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10188, '2047-11-22', '星期五', 2047, '十月', '初六', '丁卯', '兔', NULL, 0, '', '', '小雪', '', 5);
INSERT INTO `base_data_holiday` VALUES (10189, '2047-11-23', '星期六', 2047, '十月', '初七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10190, '2047-11-24', '星期日', 2047, '十月', '初八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10191, '2047-11-25', '星期一', 2047, '十月', '初九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10192, '2047-11-26', '星期二', 2047, '十月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10193, '2047-11-27', '星期三', 2047, '十月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10194, '2047-11-28', '星期四', 2047, '十月', '十二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10195, '2047-11-29', '星期五', 2047, '十月', '十三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10196, '2047-11-30', '星期六', 2047, '十月', '十四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10197, '2047-12-01', '星期日', 2047, '十月', '十五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10198, '2047-12-02', '星期一', 2047, '十月', '十六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10199, '2047-12-03', '星期二', 2047, '十月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10200, '2047-12-04', '星期三', 2047, '十月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10201, '2047-12-05', '星期四', 2047, '十月', '十九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10202, '2047-12-06', '星期五', 2047, '十月', '二十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10203, '2047-12-07', '星期六', 2047, '十月', '廿一', '丁卯', '兔', NULL, 1, '', '', '大雪', '', 5);
INSERT INTO `base_data_holiday` VALUES (10204, '2047-12-08', '星期日', 2047, '十月', '廿二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10205, '2047-12-09', '星期一', 2047, '十月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10206, '2047-12-10', '星期二', 2047, '十月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10207, '2047-12-11', '星期三', 2047, '十月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10208, '2047-12-12', '星期四', 2047, '十月', '廿六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10209, '2047-12-13', '星期五', 2047, '十月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10210, '2047-12-14', '星期六', 2047, '十月', '廿八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10211, '2047-12-15', '星期日', 2047, '十月', '廿九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10212, '2047-12-16', '星期一', 2047, '十月', '三十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10213, '2047-12-17', '星期二', 2047, '冬月', '初一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10214, '2047-12-18', '星期三', 2047, '冬月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10215, '2047-12-19', '星期四', 2047, '冬月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10216, '2047-12-20', '星期五', 2047, '冬月', '初四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10217, '2047-12-21', '星期六', 2047, '冬月', '初五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10218, '2047-12-22', '星期日', 2047, '冬月', '初六', '丁卯', '兔', NULL, 1, '', '', '冬至', '', 5);
INSERT INTO `base_data_holiday` VALUES (10219, '2047-12-23', '星期一', 2047, '冬月', '初七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10220, '2047-12-24', '星期二', 2047, '冬月', '初八', '丁卯', '兔', NULL, 0, '平安夜', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10221, '2047-12-25', '星期三', 2047, '冬月', '初九', '丁卯', '兔', NULL, 0, '圣诞节', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10222, '2047-12-26', '星期四', 2047, '冬月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10223, '2047-12-27', '星期五', 2047, '冬月', '十一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10224, '2047-12-28', '星期六', 2047, '冬月', '十二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10225, '2047-12-29', '星期日', 2047, '冬月', '十三', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10226, '2047-12-30', '星期一', 2047, '冬月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10227, '2047-12-31', '星期二', 2047, '冬月', '十五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10228, '2048-01-01', '星期三', 2047, '冬月', '十六', '丁卯', '兔', NULL, 0, '元旦', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10229, '2048-01-02', '星期四', 2047, '冬月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10230, '2048-01-03', '星期五', 2047, '冬月', '十八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10231, '2048-01-04', '星期六', 2047, '冬月', '十九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10232, '2048-01-05', '星期日', 2047, '冬月', '二十', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10233, '2048-01-06', '星期一', 2047, '冬月', '廿一', '丁卯', '兔', NULL, 0, '', '', '小寒', '', 5);
INSERT INTO `base_data_holiday` VALUES (10234, '2048-01-07', '星期二', 2047, '冬月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10235, '2048-01-08', '星期三', 2047, '冬月', '廿三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10236, '2048-01-09', '星期四', 2047, '冬月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10237, '2048-01-10', '星期五', 2047, '冬月', '廿五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10238, '2048-01-11', '星期六', 2047, '冬月', '廿六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10239, '2048-01-12', '星期日', 2047, '冬月', '廿七', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10240, '2048-01-13', '星期一', 2047, '冬月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10241, '2048-01-14', '星期二', 2047, '冬月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10242, '2048-01-15', '星期三', 2047, '腊月', '初一', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10243, '2048-01-16', '星期四', 2047, '腊月', '初二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10244, '2048-01-17', '星期五', 2047, '腊月', '初三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10245, '2048-01-18', '星期六', 2047, '腊月', '初四', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10246, '2048-01-19', '星期日', 2047, '腊月', '初五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10247, '2048-01-20', '星期一', 2047, '腊月', '初六', '丁卯', '兔', NULL, 0, '', '', '大寒', '', 5);
INSERT INTO `base_data_holiday` VALUES (10248, '2048-01-21', '星期二', 2047, '腊月', '初七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10249, '2048-01-22', '星期三', 2047, '腊月', '初八', '丁卯', '兔', NULL, 0, '', '腊八节', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10250, '2048-01-23', '星期四', 2047, '腊月', '初九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10251, '2048-01-24', '星期五', 2047, '腊月', '初十 ', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10252, '2048-01-25', '星期六', 2047, '腊月', '十一', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10253, '2048-01-26', '星期日', 2047, '腊月', '十二', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10254, '2048-01-27', '星期一', 2047, '腊月', '十三', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10255, '2048-01-28', '星期二', 2047, '腊月', '十四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10256, '2048-01-29', '星期三', 2047, '腊月', '十五', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10257, '2048-01-30', '星期四', 2047, '腊月', '十六', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10258, '2048-01-31', '星期五', 2047, '腊月', '十七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10259, '2048-02-01', '星期六', 2047, '腊月', '十八', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10260, '2048-02-02', '星期日', 2047, '腊月', '十九', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10261, '2048-02-03', '星期一', 2047, '腊月', '二十', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10262, '2048-02-04', '星期二', 2047, '腊月', '廿一', '丁卯', '兔', NULL, 0, '', '', '立春', '', 5);
INSERT INTO `base_data_holiday` VALUES (10263, '2048-02-05', '星期三', 2047, '腊月', '廿二', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10264, '2048-02-06', '星期四', 2047, '腊月', '廿三', '丁卯', '兔', NULL, 0, '', '小年', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10265, '2048-02-07', '星期五', 2047, '腊月', '廿四', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10266, '2048-02-08', '星期六', 2047, '腊月', '廿五', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10267, '2048-02-09', '星期日', 2047, '腊月', '廿六', '丁卯', '兔', NULL, 1, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10268, '2048-02-10', '星期一', 2047, '腊月', '廿七', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10269, '2048-02-11', '星期二', 2047, '腊月', '廿八', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10270, '2048-02-12', '星期三', 2047, '腊月', '廿九', '丁卯', '兔', NULL, 0, '', '', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10271, '2048-02-13', '星期四', 2047, '腊月', '三十', '丁卯', '兔', NULL, 0, '', '除夕', '', '', 5);
INSERT INTO `base_data_holiday` VALUES (10272, '2048-02-14', '星期五', 2048, '正月', '初一', '戊辰', '龙', NULL, 0, '情人节', '春节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10273, '2048-02-15', '星期六', 2048, '正月', '初二', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10274, '2048-02-16', '星期日', 2048, '正月', '初三', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10275, '2048-02-17', '星期一', 2048, '正月', '初四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10276, '2048-02-18', '星期二', 2048, '正月', '初五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10277, '2048-02-19', '星期三', 2048, '正月', '初六', '戊辰', '龙', NULL, 0, '', '', '雨水', '', 0);
INSERT INTO `base_data_holiday` VALUES (10278, '2048-02-20', '星期四', 2048, '正月', '初七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10279, '2048-02-21', '星期五', 2048, '正月', '初八', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10280, '2048-02-22', '星期六', 2048, '正月', '初九', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10281, '2048-02-23', '星期日', 2048, '正月', '初十 ', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10282, '2048-02-24', '星期一', 2048, '正月', '十一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10283, '2048-02-25', '星期二', 2048, '正月', '十二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10284, '2048-02-26', '星期三', 2048, '正月', '十三', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10285, '2048-02-27', '星期四', 2048, '正月', '十四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10286, '2048-02-28', '星期五', 2048, '正月', '十五', '戊辰', '龙', NULL, 0, '', '元宵节', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10287, '2048-02-29', '星期六', 2048, '正月', '十六', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10288, '2048-03-01', '星期日', 2048, '正月', '十七', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10289, '2048-03-02', '星期一', 2048, '正月', '十八', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10290, '2048-03-03', '星期二', 2048, '正月', '十九', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10291, '2048-03-04', '星期三', 2048, '正月', '二十', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10292, '2048-03-05', '星期四', 2048, '正月', '廿一', '戊辰', '龙', NULL, 0, '', '', '惊蛰', '', 0);
INSERT INTO `base_data_holiday` VALUES (10293, '2048-03-06', '星期五', 2048, '正月', '廿二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10294, '2048-03-07', '星期六', 2048, '正月', '廿三', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10295, '2048-03-08', '星期日', 2048, '正月', '廿四', '戊辰', '龙', NULL, 1, '妇女节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10296, '2048-03-09', '星期一', 2048, '正月', '廿五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10297, '2048-03-10', '星期二', 2048, '正月', '廿六', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10298, '2048-03-11', '星期三', 2048, '正月', '廿七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10299, '2048-03-12', '星期四', 2048, '正月', '廿八', '戊辰', '龙', NULL, 0, '植树节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10300, '2048-03-13', '星期五', 2048, '正月', '廿九', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10301, '2048-03-14', '星期六', 2048, '二月', '初一', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10302, '2048-03-15', '星期日', 2048, '二月', '初二', '戊辰', '龙', NULL, 1, '', '龙抬头', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10303, '2048-03-16', '星期一', 2048, '二月', '初三', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10304, '2048-03-17', '星期二', 2048, '二月', '初四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10305, '2048-03-18', '星期三', 2048, '二月', '初五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10306, '2048-03-19', '星期四', 2048, '二月', '初六', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10307, '2048-03-20', '星期五', 2048, '二月', '初七', '戊辰', '龙', NULL, 0, '', '', '春分', '', 0);
INSERT INTO `base_data_holiday` VALUES (10308, '2048-03-21', '星期六', 2048, '二月', '初八', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10309, '2048-03-22', '星期日', 2048, '二月', '初九', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10310, '2048-03-23', '星期一', 2048, '二月', '初十 ', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10311, '2048-03-24', '星期二', 2048, '二月', '十一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10312, '2048-03-25', '星期三', 2048, '二月', '十二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10313, '2048-03-26', '星期四', 2048, '二月', '十三', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10314, '2048-03-27', '星期五', 2048, '二月', '十四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10315, '2048-03-28', '星期六', 2048, '二月', '十五', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10316, '2048-03-29', '星期日', 2048, '二月', '十六', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10317, '2048-03-30', '星期一', 2048, '二月', '十七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10318, '2048-03-31', '星期二', 2048, '二月', '十八', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10319, '2048-04-01', '星期三', 2048, '二月', '十九', '戊辰', '龙', NULL, 0, '愚人节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10320, '2048-04-02', '星期四', 2048, '二月', '二十', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10321, '2048-04-03', '星期五', 2048, '二月', '廿一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10322, '2048-04-04', '星期六', 2048, '二月', '廿二', '戊辰', '龙', NULL, 1, '', '', '清明', '', 0);
INSERT INTO `base_data_holiday` VALUES (10323, '2048-04-05', '星期日', 2048, '二月', '廿三', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10324, '2048-04-06', '星期一', 2048, '二月', '廿四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10325, '2048-04-07', '星期二', 2048, '二月', '廿五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10326, '2048-04-08', '星期三', 2048, '二月', '廿六', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10327, '2048-04-09', '星期四', 2048, '二月', '廿七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10328, '2048-04-10', '星期五', 2048, '二月', '廿八', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10329, '2048-04-11', '星期六', 2048, '二月', '廿九', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10330, '2048-04-12', '星期日', 2048, '二月', '三十', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10331, '2048-04-13', '星期一', 2048, '三月', '初一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10332, '2048-04-14', '星期二', 2048, '三月', '初二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10333, '2048-04-15', '星期三', 2048, '三月', '初三', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10334, '2048-04-16', '星期四', 2048, '三月', '初四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10335, '2048-04-17', '星期五', 2048, '三月', '初五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10336, '2048-04-18', '星期六', 2048, '三月', '初六', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10337, '2048-04-19', '星期日', 2048, '三月', '初七', '戊辰', '龙', NULL, 1, '', '', '谷雨', '', 0);
INSERT INTO `base_data_holiday` VALUES (10338, '2048-04-20', '星期一', 2048, '三月', '初八', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10339, '2048-04-21', '星期二', 2048, '三月', '初九', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10340, '2048-04-22', '星期三', 2048, '三月', '初十 ', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10341, '2048-04-23', '星期四', 2048, '三月', '十一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10342, '2048-04-24', '星期五', 2048, '三月', '十二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10343, '2048-04-25', '星期六', 2048, '三月', '十三', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10344, '2048-04-26', '星期日', 2048, '三月', '十四', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10345, '2048-04-27', '星期一', 2048, '三月', '十五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10346, '2048-04-28', '星期二', 2048, '三月', '十六', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10347, '2048-04-29', '星期三', 2048, '三月', '十七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10348, '2048-04-30', '星期四', 2048, '三月', '十八', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10349, '2048-05-01', '星期五', 2048, '三月', '十九', '戊辰', '龙', NULL, 0, '劳动节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10350, '2048-05-02', '星期六', 2048, '三月', '二十', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10351, '2048-05-03', '星期日', 2048, '三月', '廿一', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10352, '2048-05-04', '星期一', 2048, '三月', '廿二', '戊辰', '龙', NULL, 0, '青年节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10353, '2048-05-05', '星期二', 2048, '三月', '廿三', '戊辰', '龙', NULL, 0, '', '', '立夏', '', 0);
INSERT INTO `base_data_holiday` VALUES (10354, '2048-05-06', '星期三', 2048, '三月', '廿四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10355, '2048-05-07', '星期四', 2048, '三月', '廿五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10356, '2048-05-08', '星期五', 2048, '三月', '廿六', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10357, '2048-05-09', '星期六', 2048, '三月', '廿七', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10358, '2048-05-10', '星期日', 2048, '三月', '廿八', '戊辰', '龙', NULL, 1, '', '', '', '母亲节', 0);
INSERT INTO `base_data_holiday` VALUES (10359, '2048-05-11', '星期一', 2048, '三月', '廿九', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10360, '2048-05-12', '星期二', 2048, '三月', '三十', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10361, '2048-05-13', '星期三', 2048, '四月', '初一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10362, '2048-05-14', '星期四', 2048, '四月', '初二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10363, '2048-05-15', '星期五', 2048, '四月', '初三', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10364, '2048-05-16', '星期六', 2048, '四月', '初四', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10365, '2048-05-17', '星期日', 2048, '四月', '初五', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10366, '2048-05-18', '星期一', 2048, '四月', '初六', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10367, '2048-05-19', '星期二', 2048, '四月', '初七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10368, '2048-05-20', '星期三', 2048, '四月', '初八', '戊辰', '龙', NULL, 0, '', '', '小满', '', 0);
INSERT INTO `base_data_holiday` VALUES (10369, '2048-05-21', '星期四', 2048, '四月', '初九', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10370, '2048-05-22', '星期五', 2048, '四月', '初十 ', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10371, '2048-05-23', '星期六', 2048, '四月', '十一', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10372, '2048-05-24', '星期日', 2048, '四月', '十二', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10373, '2048-05-25', '星期一', 2048, '四月', '十三', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10374, '2048-05-26', '星期二', 2048, '四月', '十四', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10375, '2048-05-27', '星期三', 2048, '四月', '十五', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10376, '2048-05-28', '星期四', 2048, '四月', '十六', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10377, '2048-05-29', '星期五', 2048, '四月', '十七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10378, '2048-05-30', '星期六', 2048, '四月', '十八', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10379, '2048-05-31', '星期日', 2048, '四月', '十九', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10380, '2048-06-01', '星期一', 2048, '四月', '二十', '戊辰', '龙', NULL, 0, '儿童节', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10381, '2048-06-02', '星期二', 2048, '四月', '廿一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10382, '2048-06-03', '星期三', 2048, '四月', '廿二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10383, '2048-06-04', '星期四', 2048, '四月', '廿三', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10384, '2048-06-05', '星期五', 2048, '四月', '廿四', '戊辰', '龙', NULL, 0, '', '', '芒种', '', 0);
INSERT INTO `base_data_holiday` VALUES (10385, '2048-06-06', '星期六', 2048, '四月', '廿五', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10386, '2048-06-07', '星期日', 2048, '四月', '廿六', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10387, '2048-06-08', '星期一', 2048, '四月', '廿七', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10388, '2048-06-09', '星期二', 2048, '四月', '廿八', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10389, '2048-06-10', '星期三', 2048, '四月', '廿九', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10390, '2048-06-11', '星期四', 2048, '五月', '初一', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10391, '2048-06-12', '星期五', 2048, '五月', '初二', '戊辰', '龙', NULL, 0, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10392, '2048-06-13', '星期六', 2048, '五月', '初三', '戊辰', '龙', NULL, 1, '', '', '', '', 0);
INSERT INTO `base_data_holiday` VALUES (10393, '2048-06-14', '星期日', 2048, '五月', '初四', '戊辰', '龙', NULL, 1, '', '', '', '', 0);

-- ----------------------------
-- Table structure for base_dic
-- ----------------------------
DROP TABLE IF EXISTS `base_dic`;
CREATE TABLE `base_dic`  (
                             `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键',
                             `type_code` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '类型编码',
                             `code` int(10) NULL DEFAULT NULL COMMENT '编码',
                             `name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '名称',
                             `parenet_code` int(10) NULL DEFAULT NULL COMMENT '父编码',
                             `tree_code` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '树编码',
                             `order` int(11) NULL DEFAULT NULL COMMENT '排序（正序）',
                             `level` int(11) NULL DEFAULT NULL COMMENT '级别',
                             `business_value` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '业务数据',
                             `filter_item` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '过滤项',
                             `creator_uid` bigint(20) NULL DEFAULT NULL COMMENT '创建者用户id',
                             `create_time` datetime NULL DEFAULT NULL COMMENT '记录创建时间',
                             `operator_uid` bigint(20) NULL DEFAULT NULL COMMENT '更新人用户id',
                             `update_time` datetime NULL DEFAULT NULL COMMENT '记录更新时间',
                             `delete_flag` tinyint(2) NULL DEFAULT NULL COMMENT '是否删除标识位(0未删除，1已删除)',
                             `is_enable` int(11) NULL DEFAULT NULL COMMENT '是否启用',
                             `app_id` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '多应用的应用id',
                             `namespace_id` int(20) NULL DEFAULT NULL COMMENT '域空间id',
                             PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '字典表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of base_dic
-- ----------------------------

-- ----------------------------
-- Table structure for base_dic_type
-- ----------------------------
DROP TABLE IF EXISTS `base_dic_type`;
CREATE TABLE `base_dic_type`  (
                                  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键',
                                  `type_code` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '类型编码',
                                  `type_name` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '名称',
                                  `order` int(11) NULL DEFAULT NULL COMMENT '排序',
                                  `creator_uid` bigint(20) NULL DEFAULT NULL COMMENT '创建者用户id',
                                  `create_time` datetime NULL DEFAULT NULL COMMENT '记录创建时间',
                                  `operator_uid` bigint(20) NULL DEFAULT NULL COMMENT '更新人用户id',
                                  `update_time` datetime NULL DEFAULT NULL COMMENT '记录更新时间',
                                  `delete_flag` tinyint(2) NULL DEFAULT NULL COMMENT '是否删除标识位(0未删除，1已删除)',
                                  `app_id` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '多应用的应用id',
                                  `namespace_id` int(20) NULL DEFAULT NULL COMMENT '域空间id',
                                  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci COMMENT = '字典类型表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of base_dic_type
-- ----------------------------

SET FOREIGN_KEY_CHECKS = 1;
